unit UDirDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, Udefinitions, ImgList;

type
  TFormDirDialog = class(TForm)
    Panel1: TPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    CBShow: TCheckBox;
    TV: TTreeView;
    CBSys: TComboBox;
    Label1: TLabel;
    procedure BBCancelClick(Sender: TObject);
    procedure BBOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBShowClick(Sender: TObject);
    procedure CBSysChange(Sender: TObject);
    procedure TVExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TVCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    rj: RJob;
    //Root: IDRec;
  public
    { Public declarations }
    Execute: boolean;
    fname,fpath: string;
    TD: TEdit;
    rd: IDRec;
  end;

var
  FormDirDialog: TFormDirDialog;

implementation

uses Uglobal, ULog;


{$R *.dfm}

procedure TFormDirDialog.BBCancelClick(Sender: TObject);
begin
Close;
end;

procedure TFormDirDialog.BBOkClick(Sender: TObject);
begin
try
if(TV.Selected<>nil)then
begin
Execute:=true;
rd:=IDRec(TV.Selected.Data);
//fpath:=GetTreePath(rd);
fpath:=rd.ilabel;
if(TD<>nil)then TD.Text:=fpath;
end;
Close;
except
//
end;
end;

procedure TFormDirDialog.FormCreate(Sender: TObject);
var
i: integer;
rr: RJob;
LRoot: IDRec;
tr: TTreeNode;
begin
try
Execute:=false;
TD:=nil;
rd:=nil;
rj:=RJob(TwinList.Items[0]);
rr:=RJob(TwinList.Items[1]);
//TV.Items.Assign(rj.TTree.Items);
rj.TTree:=TV;
rj.ReadSystem;
CBSys.Items.AddObject(rj.Save.sysname,rj);
for i:=2 to TwinList.Count-1 do
begin
rr:=RJob(TwinList.Items[i]);
CBSys.Items.AddObject(rr.Save.sysname,rr);
end;
CBSys.ItemIndex:=0;
if(rj.LItems.Count>0)then
  begin
    LRoot:=IDRec(rj.LItems.Items[0]);
    tr:=TV.Items.Add(nil,LRoot.iname);
    tr.Data:=LRoot;
    LRoot.trr:=tr;
    rj.trr:=tr;
    tr.ImageIndex:=6;
    tr.SelectedIndex:=6;
    rj.ExpandTreeNode(tr);
    tr.Expand(false);
  end;
//TV.Items.Item[0].Expand(false);
except
//
end;
end;

procedure TFormDirDialog.CBShowClick(Sender: TObject);
begin
try
CheckTreeNodes(IDRec(rj.LItems.Items[0]),TV,CBShow.Checked);
except
//
end;
end;

procedure TFormDirDialog.CBSysChange(Sender: TObject);
begin
  try
    if(rj <> RJob(CBSys.Items.Objects[CBSys.ItemIndex]))then
    begin
      rj:=RJob(CBSys.Items.Objects[CBSys.ItemIndex]);
      TV.Items.Clear;
      TV.Items.Assign(rj.TTree.Items);
      TV.Refresh;
    end;
  except
  //
  end;
end;

procedure TFormDirDialog.TVExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
try
  Node.MakeVisible;
  if(Node.Data = nil)or(not(IDRec(Node.Data).rj.complete))then exit;
  IDRec(Node.Data).rj.ExpandTreeNode(Node);
  AllowExpansion:=true;
except
//
end;
end;

procedure TFormDirDialog.TVCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
try
  if(not IDRec(Node.Data).rj.complete)then exit;
  if(Node.Data<>nil)then
  begin
    IDRec(Node.Data).rj.CollapseNode(Node);
    IDRec(Node.Data).explored:=false;
  end;
  AllowCollapse:=true;
except
//
end;
end;

procedure TFormDirDialog.FormShow(Sender: TObject);
begin
Execute:=false;
end;

end.
