unit UEvents;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, StdCtrls, Buttons, ExtCtrls,Udefinitions,
  ImgList, Spin,Math,StrUtils, Menus;

type
  TFormEvents = class(TForm)
    GBEvents: TGroupBox;
    Label9: TLabel;
    Label25: TLabel;
    Label13: TLabel;
    Label10: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label30: TLabel;
    EWhere: TEdit;
    EMess: TEdit;
    CBUnit: TComboBox;
    ToolBarActions: TToolBar;
    TBDelA: TToolButton;
    TBOkA: TToolButton;
    TBTestA: TToolButton;
    LVEvents: TListView;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    CBEAction: TComboBoxEx;
    CBEWhat: TComboBoxEx;
    SBOpen: TSpeedButton;
    ILEvents: TImageList;
    TBExit: TToolButton;
    EValue: TEdit;
    EJobName: TEdit;
    EOper: TComboBox;
    SBOpen2: TSpeedButton;
    CBPar: TCheckBox;
    ToolBar1: TToolBar;
    TBFirst: TToolButton;
    TBBBack: TToolButton;
    TBNNext: TToolButton;
    TBLast: TToolButton;
    procedure TBDelAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBOkAClick(Sender: TObject);
    procedure TBTestAClick(Sender: TObject);
    procedure TBExitClick(Sender: TObject);
    procedure CBEActionChange(Sender: TObject);
    procedure LVEventsClick(Sender: TObject);
    procedure EValueChange(Sender: TObject);
    procedure EValueKeyPress(Sender: TObject; var Key: Char);
    procedure SBOpenClick(Sender: TObject);
    procedure SBOpen2Click(Sender: TObject);
    procedure FrameMoveBar1TBFirstClick(Sender: TObject);
    procedure FrameMoveBar1TBLastClick(Sender: TObject);
    procedure FrameMoveBar1TBBBackClick(Sender: TObject);
    procedure FrameMoveBar1TBNNextClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    rj: RJob;
  end;

var
  FormEvents: TFormEvents;
  wrongchar: boolean;
  rightstr: string;

implementation

uses ULog, Uglobal, UDirDialog;

{$R *.dfm}

procedure TFormEvents.TBDelAClick(Sender: TObject);
var
hh: HistAct;
begin
if MessageDlg(mmAskDestroy+mmRecord,
mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
try
if(LVEvents.Selected<>nil)then
begin
hh:=HistAct(LVEvents.Selected.Data);
rj.LActions.Delete(rj.LActions.IndexOf(hh));
Dispose(hh);
ShowActions(rj,LVEvents);
rj.changed_job:=true;
end;
{
SEND MAIL
BEEP
EXECUTE
RUN SYNC
PLAY SOUND
SHUT DOWN
aiMoveToRecycle  = 1;
aiDelete         = 2;
aiCopyTo         = 3;
aiMoveTo         = 4;
aiRenameTo       = 5;
aiEmpty          = 6;
aiEmptyToRecycle = 7;
aiMoveContentTo  = 8;

MIN FREE
MAX BUSY
MAX SIZE
CHANGE
COMPLETION
APPEAR
DISAPPEAR
SUCCESS
FAILURE
}
except
//
end;
end;

procedure TFormEvents.FormCreate(Sender: TObject);
begin
self.FreeOnRelease;
CBEAction.ItemIndex:=0;
CBEWhat.ItemIndex:=4;
CBUnit.ItemIndex:=2;
end;

procedure TFormEvents.FormShow(Sender: TObject);
begin
try
ShowActions(rj,LVEvents);
EJobName.Text:=rj.Save.jobname;
except
//
end;
end;

procedure TFormEvents.TBOkAClick(Sender: TObject);
var
hh: HistAct;
begin
try
  hh:=nil;
    if(LVEvents.Selected<>nil)then
    hh:=HistAct(LVEvents.Selected.Data);
    if(hh = nil)then
    begin
    New(hh);
    rj.LActions.Add(hh);
    end;
    hh.what:=CBEWhat.ItemIndex;
    hh.units:=CBUnit.ItemIndex;
    try
    case hh.units of
    ubytes: hh.value:=StrToFloat(EValue.Text);
    uKb:    hh.value:=StrToFloat(EValue.Text)*1024;
    uMb:    hh.value:=StrToFloat(EValue.Text)*1024*1024;
    uGb:    hh.value:=StrToFloat(EValue.Text)*1024*1024*1024;
    end;
    except
    MessageDlg(mmErrConvert, mtError,[mbOk], 0);
    end;
    hh.action:=CBEAction.ItemIndex;
    hh.where:=EWhere.Text;
    hh.operation:=EOper.Text;
    hh.mess:=EMess.Text;
    rj.changed_job:=true;
    ShowActions(rj,LVEvents);
except
//
end;
end;

procedure TFormEvents.TBTestAClick(Sender: TObject);
begin
FormLog.RunAction(CBEAction.ItemIndex,EOper.Text,EMess.Text,rj);
end;

procedure TFormEvents.TBExitClick(Sender: TObject);
begin
close;
end;

procedure TFormEvents.CBEActionChange(Sender: TObject);
var
i: integer;
rr: RJob;
begin
try
if(CBEAction.ItemIndex = 3)then
begin
  EOper.Items.Clear;
  for i:=0 to GRList.Count-1 do
  begin
    rr:=RJob(GRList.Items[i]);
    EOper.Items.Add(rr.Save.jobname);
  end;
  if(EOper.Items.Count>0)then
  EOper.ItemIndex:=0;
end else
EOper.Items.Clear;
except
//
end;
end;

procedure TFormEvents.LVEventsClick(Sender: TObject);
var
LL: TListItem;
hh: HistAct;
begin
try
LL:=LVEvents.Selected;
  if(LL<>nil)then
  begin
  hh:=HistAct(LL.Data);
  CBEWhat.ItemIndex:=hh.what;
  try
  case hh.units of
  ubytes: EValue.Text:=IntToStr(Round(hh.value));
  uKb:    EValue.Text:=FloatToStr(RoundTo(hh.value/1024,-3));
  uMb:    EValue.Text:=FloatToStr(RoundTo(hh.value/1024/1024,-3));
  uGb:    EValue.Text:=FloatToStr(RoundTo(hh.value/1024/1024/1024,-2));
  end;
  except
  MessageDlg(mmErrConvert, mtError,[mbOk], 0);
  end;
  CBUnit.ItemIndex:=hh.units;
  CBEAction.ItemIndex:=hh.action;
  EWhere.Text:=hh.where;
  EOper.Text:=hh.operation;
  EMess.Text:=hh.mess;
  end;
  except
//
end;
end;

procedure TFormEvents.EValueChange(Sender: TObject);
begin
if((EValue.Modified)and(wrongchar))then
begin
EValue.Text:=rightstr;
wrongchar:=false;
end;
end;

procedure TFormEvents.EValueKeyPress(Sender: TObject; var Key: Char);
begin
try
rightstr:=EValue.Text;
if
(Key in eNumericTypes)and
(not((Key = DecimalSeparator)and(LastDelimiter(DecimalSeparator,rightstr)>0)and(Length(rightstr)>0)))or
((Ord(Key) = VK_BACK)or(Ord(Key) = VK_DELETE))
then
wrongchar:=false
else
wrongchar:=true;
except
//
end;
end;

procedure TFormEvents.SBOpenClick(Sender: TObject);
var
dest: string;
begin
try
dest:=InvokeDirDialog(nil,false,true);
if(dest<>'')then
begin
if(CBPar.Checked)and(Length(EOper.Text)>0)and(not(AnsiContainsStr(EOper.Text,pComposer)))then
EOper.Text:=EOper.Text+pComposer+dest
else
EOper.Text:=dest;
end;
except
//
end;
end;

procedure TFormEvents.SBOpen2Click(Sender: TObject);
var
dest: string;
begin
try
dest:=InvokeDirDialog(nil,false,true);
if(dest<>'')then
EWhere.Text:=dest;
except
//
end;
end;

procedure TFormEvents.FrameMoveBar1TBFirstClick(Sender: TObject);
var
hh: HistAct;
begin
  if(LVEvents.Selected<>nil)then
  begin
    hh:=HistAct(LVEvents.Selected.Data);
    rj.LActions.Move(rj.LActions.IndexOf(hh),0);
  end;
  ShowActions(rj,LVEvents);
end;

procedure TFormEvents.FrameMoveBar1TBLastClick(Sender: TObject);
var
hh: HistAct;
begin
  if(LVEvents.Selected<>nil)then
  begin
    hh:=HistAct(LVEvents.Selected.Data);
    rj.LActions.Move(rj.LActions.IndexOf(hh),rj.LActions.Count-1);
  end;
  ShowActions(rj,LVEvents);
end;

procedure TFormEvents.FrameMoveBar1TBBBackClick(Sender: TObject);
var
hh: HistAct;
ind: integer;
begin
  if(LVEvents.Selected<>nil)then
  begin
    hh:=HistAct(LVEvents.Selected.Data);
    ind:=rj.LActions.IndexOf(hh);
    if(ind>0)then
    rj.LActions.Move(ind,ind-1);
  end;
  ShowActions(rj,LVEvents);
end;

procedure TFormEvents.FrameMoveBar1TBNNextClick(Sender: TObject);
var
hh: HistAct;
ind: integer;
begin
  if(LVEvents.Selected<>nil)then
  begin
    hh:=HistAct(LVEvents.Selected.Data);
    ind:=rj.LActions.IndexOf(hh);
    if(ind<(rj.LActions.Count-1))then
    rj.LActions.Move(ind,ind+1);
  end;
  ShowActions(rj,LVEvents);
end;

end.
