unit UFormRen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ToolWin, Spin, Menus;

type
  TFormRen = class(TForm)
    Panel1: TPanel;
    LV: TListView;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    BHelp: TButton;
    BCancel: TButton;
    BOk: TButton;
    BPrev: TButton;
    BCancelPrev: TButton;
    GroupBox4: TGroupBox;
    TBMasks: TToolBar;
    TBMaster: TToolButton;
    ToolBar1: TToolBar;
    TBFirst: TToolButton;
    TBBBack: TToolButton;
    TBNNext: TToolButton;
    TBLast: TToolButton;
    ERen: TEdit;
    procedure BCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BPrevClick(Sender: TObject);
    procedure BCancelPrevClick(Sender: TObject);
    procedure BHelpClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LVKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBRenMaskKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TBFirstClick(Sender: TObject);
    procedure TBLastClick(Sender: TObject);
    procedure TBBBackClick(Sender: TObject);
    procedure TBNNextClick(Sender: TObject);
    procedure LVColumnClick(Sender: TObject; Column: TListColumn);
    procedure TBMasterClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Execute: boolean;
    RenList,ParL: TList;
    procedure ShowItems;
    procedure SortList;
  end;

var
  FormRen: TFormRen;

implementation

uses Udefinitions, Uglobal, ULog;

{$R *.dfm}

procedure TFormRen.BCancelClick(Sender: TObject);
begin
Close;
end;

procedure TFormRen.FormCreate(Sender: TObject);
begin
Execute:=false;
self.FreeOnRelease;
ParL:= TList.Create;
end;

procedure TFormRen.BOkClick(Sender: TObject);
var
i: integer;
rr: IDRec;
kk: TListItem;
begin
//  BPrevClick(nil);
  Execute:=true;
  for i:=0 to LV.Items.Count-1 do
  begin
    kk:=LV.Items.Item[i];
    rr:= IDRec(kk.Data);
    if(kk.Checked)then
    rr.ifs:=kk.Caption;
  end;
  
Close;
end;

procedure TFormRen.FormShow(Sender: TObject);
begin
ShowItems;
end;

procedure TFormRen.BPrevClick(Sender: TObject);
var
i,nn: integer;
kk: TListItem;
rr: IDRec;
tname: TStringList;
ddir: string;
begin
  nn:=0;
  tname:= TStringList.Create;
  tname.Sorted:=true;
  tname.Duplicates:=dupIgnore;
  try
  for i:=0 to LV.Items.Count-1 do
  begin
    kk:=LV.Items.Item[i];
    rr:= IDRec(kk.Data);
    ddir:=RenameMask(kk.Caption,ERen.Text,i,rr.ntype,rcRenAll,rr);
    while(tname.IndexOf(ddir)>=0)do
    begin
      ddir:=RenameMask(kk.Caption,ERen.Text,nn,rr.ntype,rcIsExists,rr);
      Inc(nn);
      if(nn >= MaxRenNum)then
      begin
      ddir:=mmImpossibleFindName;
      break;
      end;
    end;
    kk.Caption:=ddir;
    tname.Add(ddir);
  end;
  finally
  tname.Free;
  end;
end;

procedure TFormRen.BCancelPrevClick(Sender: TObject);
var
i: integer;
kk: TListItem;
rr: IDRec;
begin
  for i:=0 to LV.Items.Count-1 do
  begin
    kk:=LV.Items.Item[i];
    rr:= IDRec(kk.Data);
    kk.Caption:=rr.ilabel;
  end;
end;

procedure TFormRen.BHelpClick(Sender: TObject);
begin
InvokeHelp(self.Handle,hfRename);
end;

procedure TFormRen.FormDestroy(Sender: TObject);
begin
ParL.Free;
end;

procedure TFormRen.LVKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = VK_ESCAPE)then CLOSE;
end;

procedure TFormRen.CBRenMaskKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = VK_ESCAPE)then CLOSE;
end;

procedure TFormRen.TBFirstClick(Sender: TObject);
begin
  if(LV.Selected<>nil)then
  begin
    RenList.Move(LV.Selected.Index,0);
    ShowItems;
  end;
end;

procedure TFormRen.ShowItems;
var
i: integer;
rr: IDRec;
kk: TListItem;
begin
  LV.Clear;
  if(RenList = nil)then exit;
  for i:=0 to RenList.Count-1 do
  begin
    rr:= IDRec(RenList.Items[i]);
    kk:=LV.Items.Add;
    kk.Caption:=rr.ilabel;
    kk.Data:=rr;
    kk.Checked:=true;
    kk.ImageIndex:=rr.ntype;
    kk.SubItems.Add('');
    kk.SubItems.Add('');
    kk.SubItems.Add('');
    kk.SubItems.Add('');
    kk.SubItems.Strings[0]:=SizeString(rr.isize);
    if(rr.ntype = ntFile)then
    begin
    kk.SubItems.Strings[1]:=DateToStr(rr.timewrite);
    kk.SubItems.Strings[2]:=TimeToStr(rr.timewrite);
    end else
    if(rr.ntype = ntDir)then
    begin
    kk.SubItems.Strings[1]:=DateToStr(rr.timecreate);
    kk.SubItems.Strings[2]:=TimeToStr(rr.timecreate);
    end;
    kk.SubItems.Strings[3]:= IntToStr(i+1);
  end;
end;

procedure TFormRen.TBLastClick(Sender: TObject);
begin
  if(LV.Selected<>nil)then
  begin
    RenList.Move(LV.Selected.Index,(RenList.Count-1));
    ShowItems;
  end;
end;

procedure TFormRen.TBBBackClick(Sender: TObject);
begin
  if(LV.Selected<>nil)and(LV.Selected.Index>0)then
  begin
    RenList.Move(LV.Selected.Index,LV.Selected.Index-1);
    ShowItems;
  end;
end;

procedure TFormRen.TBNNextClick(Sender: TObject);
begin
  if(LV.Selected<>nil)and(LV.Selected.Index < (RenList.Count-1))then
  begin
    RenList.Move(LV.Selected.Index,LV.Selected.Index+1);
    ShowItems;
  end;
end;

procedure TFormRen.LVColumnClick(Sender: TObject; Column: TListColumn);
var
ss: SPar;
i: integer;
ex: boolean;
begin
  try
    if(Column.Index = 4)then exit;
    Column.ImageIndex:=20+Column.Tag;
    Column.Tag:=Column.Tag+1;
    if(Column.Tag = 2)then Column.Tag:=-1;
    ////////////////
    ex:=false;
  for i:=0 to ParL.Count-1 do
  if(SPar(ParL.Items[i]).Column = Column.ID)then
  begin
    ss:=SPar(ParL.Items[i]);
    ex:=true;
    if(Column.Tag = 0)then
    begin
      //Finalize(ss^);
      Dispose(ss);
      ParL.Delete(i);
    end else
    begin
      ss.Tag:=Column.Tag;
      ss.Sind:=AssignColumns(Column.Index,IDRec(RenList.Items[0]).rj);
    end;
  end;
  if(not ex)then
  begin
    New(ss);
    ss.Column:=Column.ID;
    ss.Tag:=Column.Tag;
    ss.Sind:=AssignColumns(Column.Index,IDRec(RenList.Items[0]).rj);
    ParL.Add(ss);
  end;
    ////////////////
    SortList;
    ShowItems;
  except
  //
  end;
end;
{
*     
*[9]   -   -    
*[6-9]   -   -    

*[d]  
*[dd] 
*[m] 
*[y] 
*[t]  

*[dw]     
*[ddw] 
*[mw] 
*[yw] 
*[tw]  

*[d]    

[.exe] - changing all extensions of files
[^]  
[sdfg#5475687]  
[a-z$3]   
 *    
}
procedure TFormRen.SortList;
function CompPrev(PLL: TList;fr,dr: IDrec): integer;       
var
h: integer;
ev: CompFunc;
begin
  Result:=0;
  for h:=0 to PLL.Count-1 do
  begin
    ev:=CompFunc(PLL.Items[h]);
    Result:=Result+Abs(ev(fr,dr));
  end;
end;
var
LL1,RL,PL,SL: TList;
cc: CompFunc;
i,j,k: integer;
sorted: boolean;
rr,first: IDRec;
ss: SPar;
begin
LL1:=RenList;
RL:= TList.Create;
PL:= TList.Create;
SL:= TList.Create;
try
  cc:=nil;
  sorted:=false;
  for i:=0 to ParL.Count-1 do
  begin
    ss:= SPar(ParL.Items[i]);
    if(ss = nil)then continue;
      if(@cc<>nil)then
      SL.Add(@cc);
      case ss.Sind of
        psName   : cc:=DirSort;//CompNames; 0
        psLabel  : cc:=CompLabel;          //1
        psIfs    : cc:=CompIfs;            //2
        psSize   : cc:=CompTop1;           //3
        psDateCr : cc:=CompDateCreate;     //4
        psTimeCr : cc:=CompTimeCreate;     //5
        psDateAc : cc:=CompDateAccess;     //6
        psTimeAc : cc:=CompTimeAccess;     //7
        psDateWr : cc:=CompDateWrite;      //8
        psTimeWr : cc:=CompTimeWrite;      //9
        psCommon : cc:=DirSort;            //10
        psEachOwnDate: cc:=CompEachOwnDate;//11
        psEachOwnTime: cc:=CompEachOwnTime;//12
        //psFrom   : cc:=CompFrom;
        //psTo     : cc:=CompTo;
      end;
      if(not sorted)then
      begin
        LL1.Sort(cc);
        sorted:=true;
        if(ss.Tag>0)then
        begin
          for j:=0 to LL1.Count-1 do
          RL.Add(LL1.Items[LL1.Count-j-1]);
          LL1.Clear;
          LL1.Assign(RL);
          RL.Clear;
        end;
      end else
      begin
        first:=nil;
        RL.Clear;
        if(PL.Count>0)then
        begin
          LL1.Clear;
          LL1.Assign(PL);
          PL.Clear;
        end;
        if(LL1.Count>0)then first:=IDRec(LL1.Items[0]);
        for k:=0 to LL1.Count-1 do
        begin
          rr:= IDRec(LL1.Items[k]);
          if(CompPrev(SL,first,rr) <> 0)or(k = LL1.Count-1)then
          begin
            if(RL.Count>0)then
            begin
              RL.Sort(cc);
              if(ss.Tag>0)then
              begin
                for j:=0 to RL.Count-1 do
                PL.Add(RL.Items[RL.Count-j-1]);
              end else
              begin
                for j:=0 to RL.Count-1 do
                PL.Add(RL.Items[j]);
              end;
            end;
            first:=rr;
            RL.Clear;
            RL.Add(rr);
            if(k = LL1.Count-1)and(first = rr)then
            PL.Add(rr);
          end else
          RL.Add(rr);
        end;
      end;
  end;
  if(PL.Count>0)then
  begin
    LL1.Clear;
    LL1.Assign(PL);
  end else
    if(not sorted)then
    LL1.Sort(@DirSort);
finally
RL.Free;
PL.Free;
SL.Free;
end;
end;

procedure TFormRen.TBMasterClick(Sender: TObject);
begin
ERen.Text:=InvokeRenMaster(ERen.Text);
end;

end.
