unit ULog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, ToolWin,
  Math,Masks,Udefinitions,DateUtils,StrUtils, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdMessageClient, IdSMTP, Menus, IdMessage,IDSocks,
  IdEMailAddress,MMSystem;

type
  TFormLog = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    LVLog: TListView;
    ILLog: TImageList;
    GroupBox1: TGroupBox;
    CBFilter: TComboBoxEx;
    Label1: TLabel;
    CBDate: TComboBox;
    Label2: TLabel;
    CBTime: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    CBUser: TComboBox;
    Label5: TLabel;
    EMask: TEdit;
    Label6: TLabel;
    CBRes: TComboBoxEx;
    GroupBox2: TGroupBox;
    ETotal: TEdit;
    Label7: TLabel;
    Label10: TLabel;
    ESize: TEdit;
    ImageList2: TImageList;
    ToolBar1: TToolBar;
    TBFirst: TToolButton;
    TBBack: TToolButton;
    TBNext: TToolButton;
    TBLast: TToolButton;
    TBPrevI: TToolButton;
    TBNextI: TToolButton;
    Label12: TLabel;
    EFiltered: TEdit;
    SaveDialog1: TSaveDialog;
    MMM: TIdSMTP;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Log1: TMenuItem;
    Refresh1: TMenuItem;
    Default1: TMenuItem;
    Move1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    First1: TMenuItem;
    BigBack1: TMenuItem;
    Back1: TMenuItem;
    Next1: TMenuItem;
    BigNext1: TMenuItem;
    Last1: TMenuItem;
    ClearAll1: TMenuItem;
    ShowAll1: TMenuItem;
    ClearSelected1: TMenuItem;
    MSS: TIdMessage;
    ToolBar2: TToolBar;
    TBClearAll: TToolButton;
    TBClearSel: TToolButton;
    TBShowAll: TToolButton;
    TBExit: TToolButton;
    ToolBar3: TToolBar;
    TBRefresh: TToolButton;
    TBDefault: TToolButton;
    TBSaveAs: TToolButton;
    Label8: TLabel;
    TBLoad: TToolButton;
    OpenDialog1: TOpenDialog;
    TBSelectAll: TToolButton;
    TBInvertSel: TToolButton;
    TBShowAllF: TToolButton;
    ILCommon: TImageList;
    ILBComm: TImageList;
    ImageListTop: TImageList;
    ILTwin: TImageList;
    IListTop: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBFirstClick(Sender: TObject);
    procedure TBBackClick(Sender: TObject);
    procedure TBNextClick(Sender: TObject);
    procedure TBLastClick(Sender: TObject);
    procedure TBPrevIClick(Sender: TObject);
    procedure TBNextIClick(Sender: TObject);
    procedure CBFilterChange(Sender: TObject);
    procedure CBDateChange(Sender: TObject);
    procedure CBTimeChange(Sender: TObject);
    procedure CBUserChange(Sender: TObject);
    procedure EMaskChange(Sender: TObject);
    procedure CBResChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure TBClearAllClick(Sender: TObject);
    procedure TBClearSelClick(Sender: TObject);
    procedure TBShowAllClick(Sender: TObject);
    procedure TBRefreshClick(Sender: TObject);
    procedure TBDefaultClick(Sender: TObject);
    procedure TBSaveAsClick(Sender: TObject);
    procedure TBLoadClick(Sender: TObject);
    procedure TBExitClick(Sender: TObject);
    procedure TBSelectAllClick(Sender: TObject);
    procedure TBInvertSelClick(Sender: TObject);
    procedure TBShowAllFClick(Sender: TObject);
    procedure LVLogClick(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  public
    RLog,FLog: TList;
    isadd,isfiltchange: boolean;
    tim,iFrom,iTo: integer;
    ctime,cdate: string;
    procedure RecEvent(dirname,devent: string);
    procedure RecGrSync(gname,ifrom,ito,mresult: string);
    procedure RecCopy(asdir,addir,arepresult: string);
    procedure RecMove(asdir,addir,arepresult: string);
    procedure RecDel(asdir,arepresult: string);
    procedure RecError(errstr: string);
    procedure RecMessage(mstr: string);
    procedure GetUser;
    procedure ShowRecords(tto: integer);
    procedure AnalyzeLog;
    procedure FilterLog;
    procedure AddFiltered(rr: TLRec);
    procedure SaveLog(fname: string);
    procedure RemoveOldRec;
    procedure Service;
    procedure SendMail(addr,mess: string);
    procedure Beeper(addr,mess: string);
    procedure Execute(addr,mess: string);
    procedure PSound(addr,mess: string);
    procedure LoadLog(fname: string);
    function  GetExtColor(exstr: string):TColor;
    procedure RunAction(iAction: integer;Oper,Mess: string;rj: RJob;dmess: string='');
  end;

var
  FormLog: TFormLog;


implementation

uses Ucustomize, UlogTh, UMain, Uglobal;

var
THL: LogTh;
{$R *.dfm}

{ TFormLog }
procedure TFormLog.RunAction(iAction: integer;Oper,Mess: string;rj: RJob;dmess: string='');
begin
try
  case iAction of
  acSEND_MAIL : SendMail(Oper,Mess+dmess);
  acBEEP      : Beeper(Oper,Mess);
  acEXECUTE   : Execute(Oper,Mess);
  acRUN_SYNC  : ExecJobName(Oper);
  acPLAY_SOUND: PSound(Oper,Mess);
  acSHUT_DOWN :
                begin
                Service;
                RecMessage(mmSystemShutDown);
                bShutDownComp:=true;
                end;
  acMoveToRecycle : rj.MoveToRecycle(Oper);
  acDelete        : rj.DeleteI(Oper);
  acCopy          : rj.CopyI(Oper);
  acMove          : rj.MoveI(Oper);
  acRename        : rj.RenameI(Oper);
  acEmpty         : rj.EmptyI(Oper);
  acEmptyToRecycle: rj.EmptyToRecycle(Oper);
  acMoveContent   : rj.MoveContentI(Oper);
  end;
except
//
end;
end;

procedure TFormLog.GetUser;
var
len: Cardinal;
bb: Array[0..16] of char;
begin
try
//FillChar(bb,16,0);
//len:=0;
if(GetUserName(bb,len))then
UserName:=bb
else
UserName:='?';
cdate:=DateToStr(Date);
ctime:=TimeToStr(Time);
except
//
end;
end;

procedure TFormLog.RecCopy(asdir,addir,arepresult: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltCopy;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=asdir+' -- '+addir;
rr.ruser:=UserName;
rr.res:=arepresult;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecDel(asdir, arepresult: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltDelete;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=asdir;
rr.ruser:=UserName;
rr.res:=arepresult;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecError(errstr: string);
var
rr: TLRec;
begin
try
if(bBeepOnError)then
windows.Beep(3000,150);
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltError;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=errstr;
rr.ruser:=UserName;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecEvent(dirname, devent: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltDirEvent;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=dirname+'--'+devent;
rr.ruser:=UserName;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecGrSync(gname,ifrom,ito, mresult: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltGSync;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=gname+'--'+ifrom+'--'+ito;
rr.ruser:=UserName;
rr.res:=mresult;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecMessage(mstr: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltMess;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=mstr;
rr.ruser:=UserName;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.RecMove(asdir, addir, arepresult: string);
var
rr: TLRec;
begin
try
New(rr);
FillChar(rr^,sizeof(rr^),#0);
rr.rtype:=ltMove;
rr.rdate:=cdate;
rr.rtime:=ctime;
rr.rdescr:=asdir+'--'+addir;
rr.ruser:=UserName;
rr.res:=arepresult;
FLog.Add(rr);
AddFiltered(rr);
isadd:=true;
except
//
end;
end;

procedure TFormLog.FormCreate(Sender: TObject);
begin
try

CBFilter.ItemIndex:=0;
CBRes.ItemIndex:=0;
RLog:=TList.Create;
FLog:=TList.Create;
GetUser;
isadd:=true;
isfiltchange:=true;
tim:=0;
iFrom:=0;
ITo:=0;
THL:= LogTh.Create(false);
except
//
end;
end;

procedure TFormLog.FormDestroy(Sender: TObject);
var
i: integer;
begin
RemoveOldRec;
SaveLog(FormCust.ELogName.Text);
for i:=0 to FLog.Count-1 do
begin
Dispose(TLRec(FLog.Items[i]));
end;
RLog.Free;
FLog.Free;
THL.Terminate;
end;

procedure TFormLog.Service;
var
ssize: real;
dd: logrec;
begin
  if(bShutDownAll)then exit;
  try
    dd.rtype:='tt';
    if(isadd)then
    AnalyzeLog;
    if(self.Visible)then
    begin
      if(isfiltchange)then
      begin
        FilterLog;
        if(self.Visible)then
        ShowRecords(slcLast);
      end else
        if(((LVLog.Items.Count = 0)and(RLog.Count>0))or
      ((LVLog.VisibleRowCount>LVLog.Items.Count)and(RLog.Count>LVLog.Items.Count)))then
      ShowRecords(slcLast);
      dd.rtype:=dd.rtype+'2';
      if(FLog.Count>0)then ETotal.Text:=IntToStr(FLog.Count) else ETotal.Text:='0';
      if(RLog.Count>0)then  EFiltered.Text:=IntToStr(RLog.Count) else EFiltered.Text:='0';
      ssize:=RoundTo(((FLog.Count)*sizeof(dd))/1024,-3);
      if(ssize>0)then ESize.Text:=FloatToStr(ssize) else ESize.Text:='0';
    end;
    if(tim>=(FormCust.SESaveTime.Value*60))then
    begin
      tim:=0;
      RemoveOldRec;
      SaveLog(FormCust.ELogName.Text);
    end;
    tim:=tim+1;
  except
    FormLog.RecError('4002');
  end;
end;

procedure TFormLog.ShowRecords(tto: integer);
var
i,sss,ddd: integer;
LL: TListItem;
rr: TLRec;
begin
try
LVLog.Clear;
sss:=LVLog.VisibleRowCount-1;
ddd:=RLog.Count-1;
case tto of
  slcFirst:
  begin
    iFrom:=0;
    if(sss<=ddd)then iTo:=sss else iTo:=ddd;
  end;
  slcBBack:
  begin
    if(iFrom-sss>0)then iFrom:=iFrom - sss else iFrom:=0;
    if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
  end;
  slcBack:
  begin
    if(iFrom-1>0)then iFrom:=iFrom - 1 else iFrom:=0;
    if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
  end;
  slcNext:
  begin
    if(iTo+1<=ddd)then iTo:=iTo+1 else iTo:=ddd;
    if(iTo-sss>0)then iFrom:=iTo-sss else iFrom:=0;
  end;
  slcNNext:
  begin
    if(iTo+sss<=ddd)then iTo:=iTo+sss else iTo:=ddd;
    if(iTo-sss<0)then iFrom:=0 else iFrom:=iTo - sss;
  end;
  slcLast:
  begin
    if(sss<=ddd)then iFrom:=ddd-sss else iFrom:=0;
    iTo:=ddd;
  end;
  slcAll:
  begin
    TBDefaultClick(nil);
    FilterLog;
    iFrom:=0;
    iTo:=RLog.Count-1;
  end;
  slcFiltered:
  begin
    iFrom:=0;
    iTo:=ddd;
  end;
end;

LL:=nil;
  for i:=iFrom to iTo do
  begin
    rr:=TLRec(RLog.Items[i]);
    LL:=LVLog.Items.Add;
    LL.Caption:=rr.rtype;
    LL.SubItems.Add(rr.rdate);
    LL.SubItems.Add(rr.rtime);
    LL.SubItems.Add(rr.rdescr);
    LL.SubItems.Add(rr.ruser);
    LL.SubItems.Add(IntToStr(i+1));
    LL.Data:=rr;
    if(rr.rtype = ltError)then LL.ImageIndex:=0;
    if(rr.rtype = ltDirEvent)then LL.ImageIndex:=1;
    if(rr.rtype = ltGSync)then LL.ImageIndex:=2;
    if(rr.rtype = ltCopy)then LL.ImageIndex:=3;
    if(rr.rtype = ltMove)then LL.ImageIndex:=4;
    if(rr.rtype = ltDelete)then LL.ImageIndex:=5;
    if(rr.rtype = ltMess)then LL.ImageIndex:=6;

    if(rr.res = rrSuccess)then LL.SubItemImages[2]:=7;
    if(rr.res = rrFailure)then LL.SubItemImages[2]:=8;
  end;
if(LL<>nil)then
LL.MakeVisible(false);
except
//
end;
end;

procedure TFormLog.FormShow(Sender: TObject);
begin
ShowRecords(slcLast);
end;

procedure TFormLog.TBFirstClick(Sender: TObject);
begin
ShowRecords(slcFirst);
end;

procedure TFormLog.TBBackClick(Sender: TObject);
begin
ShowRecords(slcBBack);
end;

procedure TFormLog.TBNextClick(Sender: TObject);
begin
ShowRecords(slcNNext);
end;

procedure TFormLog.TBLastClick(Sender: TObject);
begin
ShowRecords(slcLast);
end;

procedure TFormLog.TBPrevIClick(Sender: TObject);
begin
ShowRecords(slcBack);
end;

procedure TFormLog.TBNextIClick(Sender: TObject);
begin
ShowRecords(slcNext);
end;

procedure TFormLog.AnalyzeLog;
var
i,j: integer;
rr: TLRec;
isexists: boolean;
aa,ss,dd: TStringList;
begin
try
aa:=TStringList.Create;
ss:=TStringList.Create;
dd:=TStringList.Create;
try
for i:=0 to FLog.Count-1 do
begin
  rr:=TLRec(FLog.Items[i]);
    isexists:=false;
  for j:=0 to aa.Count-1 do
  if(rr.rdate = aa.Strings[j])then isexists:=true;
  if(not isexists)then aa.Add(rr.rdate);
    isexists:=false;
  for j:=0 to ss.Count-1 do
  if(rr.rtime = ss.Strings[j])then isexists:=true;
  if(not isexists)then ss.Add(rr.rtime);
    isexists:=false;
  for j:=0 to dd.Count-1 do
  if(rr.ruser = dd.Strings[j])then isexists:=true;
  if(not isexists)then dd.Add(rr.ruser);
end;
CBDate.Clear;
CBTime.Clear;
CBUser.Clear;
CBDate.Items.Assign(aa);
CBTime.Items.Assign(ss);
CBUser.Items.Assign(dd);
CBDate.Items.Insert(0,'Any');
CBTime.Items.Insert(0,'Any');
CBUser.Items.Insert(0,'Any');
CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBUser.ItemIndex:=0;
isadd:=false;
finally
aa.Free;
ss.Free;
dd.Free;
end;
except
//
end;
end;

procedure TFormLog.FilterLog;
var
i: integer;
rr: TLRec;
isadd: integer;
begin
try
RLog.Clear;
for i:=0 to FLog.Count-1 do
begin
  rr:=TLRec(FLog.Items[i]);
  isadd:=0;
  if((CBFilter.Text = 'Any')or(CBFilter.Text = rr.rtype))then
  isadd:=isadd+1;
  if((CBDate.Text = 'Any')or(CBDate.Text = rr.rdate))then
  isadd:=isadd+1;
  if((CBTime.Text = 'Any')or(MatchesMask(rr.rtime,CBTime.Text)))then
  isadd:=isadd+1;
  if((CBUser.Text = 'Any')or(CBUser.Text = rr.ruser))then
  isadd:=isadd+1;
  if((CBRes.Text = 'Any')or(CBRes.Text = rr.res))then
  isadd:=isadd+1;
  if((EMask.Text = '*')or(MatchesMask(rr.rdescr,EMask.Text)))then
  isadd:=isadd+1;
  if(isadd = 6)then
  begin
    RLog.Add(rr);
  end;
end;
isfiltchange:=false;
except
//
end;
end;

procedure TFormLog.AddFiltered(rr: TLRec);
var
isadd: integer;
begin
try
  isadd:=0;
  if((CBFilter.Text = 'Any')or(CBFilter.Text = rr.rtype))then
  isadd:=isadd+1;
  if((CBDate.Text = 'Any')or(CBDate.Text = rr.rdate))then
  isadd:=isadd+1;
  if((CBTime.Text = 'Any')or(MatchesMask(rr.rtime,CBTime.Text)))then
  isadd:=isadd+1;
  if((CBUser.Text = 'Any')or(CBUser.Text = rr.ruser))then
  isadd:=isadd+1;
  if((CBRes.Text = 'Any')or(CBRes.Text = rr.res))then
  isadd:=isadd+1;
  if((EMask.Text = '*')or(MatchesMask(rr.rdescr,EMask.Text)))then
  isadd:=isadd+1;
  if(isadd = 6)then
  begin
    RLog.Add(rr);
  end;
except
//
end;
end;

procedure TFormLog.CBFilterChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.CBDateChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.CBTimeChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.CBUserChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.EMaskChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.CBResChange(Sender: TObject);
begin
isfiltchange:=true;
end;

procedure TFormLog.SaveLog(fname: string);
var
i: integer;
rr: TLRec;
ss: string;
fs: TFileStream;
st: TStringStream;
kk: logrec;
begin
fs:=TFileStream.Create(fname,fmCreate);
st:=TStringStream.Create(ss);
FillChar(kk,sizeof(kk),#0);
try
{
kk.rtype:='Type';
kk.rdate:='Date';
kk.rtime:='Time';
kk.rdescr:='Description';
kk.ruser:='User';
kk.res:='Result';
  kk.rtype[0]:=Chr(32);
  kk.rdate[0]:=Chr(32);
  kk.rtime[0]:=Chr(32);
  kk.rdescr[0]:=Chr(32);
  kk.ruser[0]:=Chr(32);
st.Write(kk,sizeof(kk));
st.WriteString(#13#10);  }
try
for i:=0 to FLog.Count-1 do
begin
  rr:=TLRec(FLog.Items[i]);
  move(rr^,kk,sizeof(kk));
  kk.rtype[0]:=Chr(32);
  kk.rdate[0]:=Chr(32);
  kk.rtime[0]:=Chr(32);
  kk.rdescr[0]:=Chr(32);
  kk.ruser[0]:=Chr(32);
  st.Write(kk,sizeof(kk));
  st.WriteString(#13#10);
end;
st.Seek(0,soFromBeginning);
fs.CopyFrom(st,st.Size);
finally
fs.Free;
st.Free;
end;
except
FormLog.RecError('4003');
end;
end;

procedure TFormLog.RemoveOldRec;
var
i: integer;
ind2: integer;
rr: TLRec;
dd: TDateTime;
LL: TListItem;
begin
try
dd:=IncDay(Date,-FormCust.SEAfterDay.Value);
for i:=0 to FLog.Count-1 do
begin
  rr:=TLRec(FLog.Items[i]);
  if(StrToDate(rr.rdate)<dd)then
  begin
    LL:=LVLog.FindData(0,rr,true,false);
    if(LL<>nil)then LL.Delete;
    ind2:= RLog.IndexOf(rr);
    if(ind2>=0)then
    RLog.Items[ind2]:=nil;
    Dispose(rr);
    FLog.Items[i]:=nil;
  end;
end;
FLog.Pack;
FLog.Pack;
except
FormLog.RecError('4004');
end;
end;

procedure TFormLog.SendMail(addr, mess: string);
var
p1: integer;
aa: string;
begin
try
  MMM.Host:=FormCust.EMailHost.Text;
  MMM.Port:=FormCust.SEMailPort.Value;
  MMM.Password:=FormCust.EMailPass.Text;
  MMM.UserId:=FormCust.EMailLogin.Text;
  MMM.UseNagle:=FormCust.CBMailNagle.Checked;
  MMM.BoundIP:=FormCust.EMailIP.Text;
  if(FormCust.CBMailAuth.Checked)then
  MMM.AuthenticationType:=atLogin
  else
  MMM.AuthenticationType:=atNone;
  if(FormCust.CBProxyAuth.Checked)then
  begin
    MMM.SocksInfo.Authentication:=saUsernamePassword;
    MMM.SocksInfo.Host:=FormCust.EProxyHost.Text;
    MMM.SocksInfo.Password:=FormCust.EProxyPass.Text;
    MMM.SocksInfo.Port:=FormCust.SEProxyPort.Value;
    MMM.SocksInfo.UserID:=FormCust.EProxyLogin.Text;
    MMM.SocksInfo.Version:=TSocksVersion(FormCust.CBProxyVersion.ItemIndex);
  end else
  begin
    MMM.SocksInfo.Authentication:=saNoAuthentication;
  end;
  MMM.Connect;
  p1:=Pos('|',addr);
  while p1>0 do
  begin
    aa:=Trim(MidStr(addr,0,p1-1));
    addr:=MidStr(addr,p1+1,Length(addr)-p1);
    p1:=Pos('|',addr);
    try
    MMM.QuickSend(FormCust.EMailHost.Text,FormCust.EMailSubject.Text,aa,FormCust.EMailFrom.Text,mess);
    except
    self.RecError('Error on send Mail to '+aa);
    end;
  end;
  MMM.Disconnect;
except
RecError('Error on Send Mail: '+addr+'--'+mess);
end;
end;

procedure TFormLog.Beeper(addr, mess: string);
var
p1,p2,len,ff,dr: integer;
ss: string;
begin
//beepstring: freq/duration-...
//1000/2000-4000/500-...
ss:=Trim(addr);
p1:=Pos('-',ss);
try
while p1>0 do
begin
p2:=Pos('/',ss);
ff:=StrToInt(MidStr(ss,0,p2-1));
dr:=StrToInt(MidStr(ss,p2+1,p1-p2-1));
windows.Beep(ff,dr);
len:=Length(ss);
ss:=RightStr(ss,len-p1);
p1:=Pos('-',ss);
end;
except
RecError('Error on Beeper : '+addr+'--'+mess);
end;
end;

procedure TFormLog.Execute(addr, mess: string);
begin
try
WinExec(PChar(addr),SW_RESTORE);
except
//
end;
end;

procedure TFormLog.Exit1Click(Sender: TObject);
begin
Hide;
end;

procedure TFormLog.PSound(addr, mess: string);
begin
try
PlaySound(PChar(addr),0,SND_ASYNC);
except
//
end;
end;

procedure TFormLog.TBClearAllClick(Sender: TObject);
var
i: integer;
begin
try
for i:=0 to FLog.Count-1 do
begin
Dispose(TLRec(FLog.Items[i]));
end;
FLog.Clear;
RLog.Clear;
LVLog.Clear;
ETotal.Text:='0';
ESize.Text:='0';
isadd:=true;
except
//
end;
end;

procedure TFormLog.TBClearSelClick(Sender: TObject);
var
ind1,ind2: integer;
rr: TLRec;
LL: TListItem;
begin
  try
    while LVLog.SelCount>0 do
    begin
      LL:=LVLog.Selected;
      rr:=TLRec(LL.Data);
      ind1:= FLog.IndexOf(rr);
      ind2:= RLog.IndexOf(rr);
      if(ind1>=0)then
      FLog.Delete(ind1);
      if(ind2>=0)then
      RLog.Delete(ind2);
      if(ind1>=0)then
      Dispose(rr);
      LL.Delete;
    end;
    TBDefaultClick(nil);
  except
  FormLog.RecError('4005');
  end;
end;

procedure TFormLog.TBShowAllClick(Sender: TObject);
begin
ShowRecords(slcAll);
end;

procedure TFormLog.TBRefreshClick(Sender: TObject);
begin
FilterLog;
ShowRecords(slcLast);
end;

procedure TFormLog.TBDefaultClick(Sender: TObject);
begin
try
CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBUser.ItemIndex:=0;
CBFilter.ItemIndex:=0;
CBRes.ItemIndex:=0;
EMask.Text:='*';
FilterLog;
TBLastClick(nil);
except
//
end;
end;

procedure TFormLog.TBSaveAsClick(Sender: TObject);
begin
try
SaveDialog1.InitialDir:=AppPath;
if(SaveDialog1.Execute)then SaveLog(SaveDialog1.FileName);
except
//
end;
end;

procedure TFormLog.TBLoadClick(Sender: TObject);
begin
try
OpenDialog1.InitialDir:=AppPath;
if(OpenDialog1.Execute)then LoadLog(OpenDialog1.FileName);
except
//
end;
end;

procedure TFormLog.LoadLog(fname: string);
var
rr: TLRec;
ss: string;
ms: TMemoryStream;
st: TStringStream;
pp,sz: real;
begin
try
  if(not FileExists(fname))then exit;
  ms:=TMemoryStream.Create;
  st:=TStringStream.Create(ss);
  try
    ms.LoadFromFile(fname);
    ms.Seek(0,soFromBeginning);
    st.CopyFrom(ms,ms.Size);
    st.Seek(0,soFromBeginning);
    pp:=st.Position;
    sz:=st.Size;
    while(pp<sz)do
    begin
      New(rr);
      rr.rtype:=Trim(st.ReadString(10));
      st.Seek(1,soFromCurrent);
      rr.rdate:=Trim(st.ReadString(12));
      st.Seek(1,soFromCurrent);
      rr.rtime:=Trim(st.ReadString(10));
      st.Seek(1,soFromCurrent);
      rr.rdescr:=Trim(st.ReadString(255));
      st.Seek(1,soFromCurrent);
      rr.ruser:=Trim(st.ReadString(25));
      st.Seek(1,soFromCurrent);
      rr.res:=Trim(st.ReadString(8));
      st.Seek(3,soFromCurrent);

      FLog.Add(rr);
      AddFiltered(rr);
      pp:=st.Position;
      sz:=st.Size;
    end;
    isadd:=true;
    ShowRecords(slcLast);
  finally
  ms.Free;
  st.Free;
  end;
except
//
end;
end;

procedure TFormLog.TBExitClick(Sender: TObject);
begin
Close;
end;

procedure TFormLog.TBSelectAllClick(Sender: TObject);
var
i: integer;
begin
try
  for i:=0 to LVLog.Items.Count-1 do
  begin
    LVLog.Items.Item[i].Selected:=true;
  end;
  LVLog.SetFocus;
except
//
end;
end;

procedure TFormLog.TBInvertSelClick(Sender: TObject);
var
i: integer;
begin
try
  for i:=0 to LVLog.Items.Count-1 do
  begin
    LVLog.Items.Item[i].Selected:=not LVLog.Items.Item[i].Selected;
  end;
except
//
end;
end;

procedure TFormLog.TBShowAllFClick(Sender: TObject);
begin
ShowRecords(slcFiltered);
end;

procedure TFormLog.LVLogClick(Sender: TObject);
begin
try
if(LVLog.Selected<>nil)then
StatusBar1.Panels.Items[0].Text:='   '+(LVLog.Selected).SubItems.Strings[2];
except
//
end;
end;

function TFormLog.GetExtColor(exstr: string): TColor;
var
KK: TListItem;
begin
  Result:=clBlack;
  try
  KK:=FormCust.LVExt.FindCaption(0,exstr,false,true,true);
  if(KK<>nil)then
  Result:=StringToColor(KK.SubItems.Strings[0]);
except
//
end;
end;


procedure TFormLog.WMSysCommand(var Msg: TWMSysCommand);
begin
if(Msg.CmdType = 61472)then Hide else inherited;
end;

procedure TFormLog.Help2Click(Sender: TObject);
begin
InvokeHelp(self.Handle,hfLog);
end;

procedure TFormLog.About1Click(Sender: TObject);
begin
InvokeAbout;
end;

procedure TFormLog.Timer1Timer(Sender: TObject);
begin
//GetUser;
//self.Caption:=fcLog;//+TimerSTimer;
end;

end.
