unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, ExtCtrls, StdCtrls,Udefinitions,DateUtils,
  ComObj,  activex, ShellApi, shlobj, registry,StrUtils;

type TCallBackProc  = procedure(wPar: WPARAM ;lPar: LPARAM);

const
WM_MYICONNOTIFY = WM_USER + 123;

type
  TMainForm = class(TForm)
    ToolBar1: TToolBar;
    TBSync: TToolButton;
    ImageList1: TImageList;
    TBClose: TToolButton;
    Timer2: TTimer;
    Timer1: TTimer;
    TBLock: TToolButton;
    TBOptions: TToolButton;
    TBReport: TToolButton;
    TBTwin: TToolButton;
    TBChart: TToolButton;
    Timer3: TTimer;
    procedure TBSyncClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBSyncMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure TBLockClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMHotKey(var a: TWMHotKey);message WM_HOTKEY;
  public
    { Public declarations }
    FList: TList;
    ads,bds,mds: integer;
    procedure WMICON(var msg: TMessage); message WM_MYICONNOTIFY;
    procedure CreateTrayIcon(n:Integer);
    procedure DeleteTrayIcon(n:Integer);
    procedure ModifIcon(n:Integer);
    procedure BGen;
    procedure MSShow(timers: boolean=true);
    procedure MoveForm;
    procedure LoadOptions(loader: integer = 0);
    procedure MSTimers(timers: boolean=true);
    procedure ShowMod(mind: integer);
    procedure ShowForms(ff: TForm);
    procedure RegKeys(firsttime: boolean=false);
  end;
//procedure GetKeys(wPar: WPARAM ;lPar: LPARAM);
//function StartKey(pp: TCallBackProc): boolean; external 'HookKey.dll';
//procedure RemoveHookKey; external 'HookKey.dll';

var
  MainForm: TMainForm;
  LastForm: TForm;
  ion,msleft,mswidth,mssign,indentX,indentY,movedelta,Ldelta,Ldelay: integer;
  ishide,timeout: boolean;
  ii: TIcon;
  pabd: AppBarData;
  border: TFormBorderStyle;

implementation

uses Usync, Umansync, ULog, Uchart,Ucustomize, Uglobal,
  UMultiComp, Ugrsync, Upass;

{$R *.dfm}
/////////////////////////////////////////////////////////////

{
procedure GetKeys(wPar: WPARAM ;lPar: LPARAM);
begin
if(lPar<0)then exit;
    if((wPar>=47)and(wPar<=122))then
    begin
    
    FormMultiComp.Memo1.Lines.Add(Chr(wPar)+' -- '+IntToStr(lpar));
      if(Length(FormMultiComp.EComm.Text)>=6)then
      begin
      FormMultiComp.EComm.Text:=RightStr(FormMultiComp.EComm.Text,5);
      end;
      FormMultiComp.EComm.Text:=FormMultiComp.EComm.Text+Chr(wPar);

    end else
    begin
      if(wPar = VK_SPACE)then
      begin
        FormMultiComp.ExecActions(FormMultiComp.EComm.Text);
        FormMultiComp.EComm.Text:='';
      end;
      if(wPar = VK_RETURN)then FormMultiComp.EComm.Text:='';
      //if(wPar = VK_SHIFT)then
      //if(wPar = VK_CONTROL)then
      //if(wPar = VK_MENU)then
    end;

    ////////////////////////////////
end;

}
procedure TMainForm.ShowMod(mind: integer);
begin
  case mind of
  mpShSync: Form1.Show;
  mpShChart: FormChart.Show;
  mpShTwin  : FormMultiComp.Show;
  mpShLog   : FormLog.Show;
  mpShCust  : FormCust.Show;
  mpShMain  : self.Show;
  end;
end;

procedure TMainForm.WMICON(var msg: TMessage);
begin
if(not Glastformcreate)then exit;
 case msg.LParam of
 WM_MOUSEMOVE:      MoveForm;
 WM_LBUTTONDBLCLK : MoveForm;
 WM_LBUTTONDOWN :   MoveForm;
 end;
end;

procedure TMainForm.CreateTrayIcon(n:Integer);
var nidata : TNotifyIconData;
begin
try
 with nidata do
  begin
   cbSize := SizeOf(TNotifyIconData);
   Wnd := Self.Handle;
   uID := 1;
   uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
   uCallBackMessage := WM_MYICONNOTIFY;
   hIcon := Application.Icon.Handle;
   StrPCopy(szTip,Application.Title);
  end;
  Shell_NotifyIcon(NIM_ADD, @nidata);
except
//
end;
end;

procedure TMainForm.ModifIcon(n:Integer);
var nidata : TNotifyIconData;
begin
try
 with nidata do
  begin
   cbSize := SizeOf(TNotifyIconData);
   Wnd := Self.Handle;
   uID := 1;
   uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
   uCallBackMessage := WM_MYICONNOTIFY;
   //ImageList2.GetIcon(n,ii);
   hIcon :=ii.Handle;
  // hIcon := Application.Icon.Handle;
   StrPCopy(szTip,Application.Title);
  end;
  Shell_NotifyIcon(NIM_MODIFY, @nidata);
 except
//
end;
end;

procedure TMainForm.DeleteTrayIcon(n:Integer);
var nidata : TNotifyIconData;
begin
try
 with nidata do
  begin
   cbSize := SizeOf(TNotifyIconData);
   Wnd := Self.Handle;
   uID := 1;
  end;
  Shell_NotifyIcon(NIM_DELETE, @nidata);
except
//
end;
end;
/////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
procedure TMainForm.TBSyncClick(Sender: TObject);
begin
  case TToolButton(Sender).Index of
    0: ShowForms(Form1);
    1: ShowForms(FormChart);
    2: ShowForms(FormMultiComp);
    3: ShowForms(FormLog);
    4: ShowForms(FormCust);
    5: ShowForms(FormPurse);
  end;
end;

procedure TMainForm.ShowForms(ff: TForm);
begin
  try
  if(ff.Visible)then
  begin
    if(LastForm = ff)then
      ff.Hide
    else
    begin
      ff.BringToFront;
      //SetForegroundWindow(ff.Handle);
      //BringWindowToTop(ff.Handle);
      //ff.SetFocus;
    end;
  end else
  begin
    ff.Show;
    //ff.SetFocus;
  end;
  LastForm:=ff;
  except
//
end;
end;

procedure TMainForm.TBCloseClick(Sender: TObject);
begin
Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
try
LocalBufSz:=1024;
RemoteBufSz:=1024;
Butt1:=-1;
CCRS.Rc:= 1;
bShutDownAll:=false;
bShutDownComp:=false;
//********************
CCenterAMS:=0;
GSyncAMS:=0;
TwinExAMS:=0;
LogAMS:=0;
CustAMS:=0;
SyncAMS:=0;
MainAMS:=0;
ManSyncAMS:=0;
GlobalAMS:=0;
DefAMS:=0;
PropAMS:=0;
CommonAMS:=0;
//********************
Glastformcreate:=false;
AppPath:=ExtractFilePath(Application.ExeName)+'DirSyncData\';
if(not DirectoryExists(AppPath))then ForceDirectories(AppPath);
if(not DirectoryExists(AppPath+'GroupSync\'))then ForceDirectories(AppPath+'GroupSync\');
if(not DirectoryExists(AppPath+'History\'))then ForceDirectories(AppPath+'History\');
CreateGlobalCriticalSection;
//windows.GetUserName(bb,len);
//UserName:=bb;

FList:=TList.Create;
JList:=TList.Create;
GRList:=TList.Create;
LSystem:= TList.Create;
TwinList:=TList.Create;
TempJobList:= TList.Create;
GrSyncFormList:= TList.Create;
ThreadList:= TList.Create;
MainForm.Left:= Screen.Width-MainForm.Width;
MainForm.Top:= Screen.Height;
ion:=0;
msleft:=0;
indentX:=0;
indentY:=0;
ishide:=false;
movedelta:=2;
Ldelta:=3;
Ldelay:=1;
timeout:=false;
Gstartlabels:=false;
border:=self.BorderStyle;
//CreateTrayIcon(1);
//if(not StartKey(@GetKeys))then
//FormLog.RecMessage('Hook Not Created!');
//ShowMessage('Hook Not Created!');
except
//
end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
i: integer;
begin
try
//RemoveHookKey;
FormMultiComp.SaveTwinHist();
AbortA;
bShutDownAll:=true;
FormCust.Hide;
FormCust.SaveAppData;
Application.ProcessMessages; //TMainForm.FormClose
DeleteTrayIcon(1);

for i:=0 to GrSyncFormList.Count-1 do
TFormGrSync(GrSyncFormList.Items[i]).Free;
GrSyncFormList.Free;
AbortA;
for i:=0 to FList.Count-1 do
TFormMSync(FList.Items[i]).Free;
FList.Free;

for i:=0 to GRList.Count-1 do
RJob(GRList.Items[i]).Free;

for i:=0 to LSystem.Count-1 do
Dispose(LSystem.Items[i]);

for i:=0 to TwinList.Count-1 do
RJob(TwinList.Items[i]).Free;

for i:=0 to TempJobList.Count-1 do
RJob(TempJobList.Items[i]).Free;
TempJobList.Clear;
TempJobList.Free;
TempJobList:=nil;
GRList.Free;
JList.Free;
ThreadList.Free;
FreeGlobalCriticalSection;
LSystem.Free;
TwinList.Free;
except
//
end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=false;
timeout:=true;
Gstartlabels:=true;
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
var
ppp: TPoint;
begin
if(bShutDownAll)then
begin
Timer2.Enabled:=false;
exit;
end;
try
if((self.BorderStyle = bsSingle)or(TBLock.Down))then
begin
Timer2.Enabled:=false;
exit;
end;
  windows.GetCursorPos(ppp);
  if((ppp.X<Left)or(ppp.Y<Top)or
  (ppp.X>(Left+Width))or(ppp.Y>(Top+Height)))then
  begin
    if(timeout)then
    begin
      if(((Top<Screen.Height)and(mssign = 1))or((Top>(-Height))and(mssign = -1)))then
      begin
        Top:=Top+movedelta*mssign;
        ion:=ion-2;
      end else
      begin
        ion:=0;
        Timer2.Enabled:=false;
        timeout:=false;
      end;
    end else
    begin
      Gstartlabels:=true;
      Timer1.Enabled:=true;
    end;
  end else
  begin
    if(ion <> 1)then
    MoveForm;
    timeout:=false;
    Gstartlabels:=false;

  end;
except
FormLog.RecError('0002'+ mmFatalError);
Timer2.Enabled:=false;
end;
end;

procedure TMainForm.MoveForm;
var
top,left,i: integer;
ms: TFormMSync;
begin
try
//if(ion = 1)then exit;
top:=0;
left:=0;
mssign:=-1;
ads:=1;
bds:=1;
mds:=1;
SHAppBarMessage(ABM_GETTASKBARPOS, pabd);
  case pabd.uEdge of
    ABE_BOTTOM :
    begin
    top:=pabd.rc.Top-MainForm.Height;
    left:=pabd.rc.Right-MainForm.Width;
    mssign:=1;
    msleft:=pabd.rc.Right-mswidth;
    end;
    ABE_LEFT   :
    begin
    top:=pabd.rc.Bottom-MainForm.Height;
    left:=pabd.rc.Right;
    msleft:=pabd.rc.Right;
    ads:=-1;
    mssign:=1;
    mds:=-1;
    end;
    ABE_RIGHT  :
    begin
    top:=pabd.rc.Bottom-MainForm.Height;
    left:=pabd.rc.Left-MainForm.Width;
    msleft:=pabd.rc.Left-mswidth;
    mssign:=1;
    end;
    ABE_TOP    :
    begin
    top:=pabd.rc.Bottom;
    left:=pabd.rc.Right-MainForm.Width;
    msleft:=pabd.rc.Right-mswidth;
    bds:=-1;
    end;
  end;
  MainForm.Show;
  SetForegroundWindow(MainForm.Handle);
  BringWindowToTop(MainForm.Handle);
  top:=top - mssign*indentY;
  if((self.BorderStyle = bsNone)or(border <> self.BorderStyle))then
  begin
    MainForm.Top:=top;
    MainForm.Left:=left - mds*indentX;
    border := self.BorderStyle;
  end;
  msleft:=msleft - ads*indentX;
  for i:=0 to FList.Count-1 do
  begin
    ms:=TFormMSync(FList.Items[i]);
    ms.Visible:=true;
    ms.Top:=Top-40*(i+1)*bds;
    ms.msleft:=msleft;
    ms.mssign:=ads;
    ms.delta:=Ldelta;
    ms.hhide:=false;
  end;
  ion:=1;
  timeout:=false;
  Timer2.Enabled:=true;
except
//
end;
end;


procedure TMainForm.TBSyncMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
MoveForm;
MSShow;
end;

procedure TMainForm.BGen;
var
i,maxlen,len,ww,ngroup,del: integer;
ss: string;
ms: TFormMSync;
//rr: RJob;
begin
try
ngroup:=GRList.Count;
del:=FList.Count-ngroup+1;
if(del>0)then
begin
  while FList.Count>(ngroup+1) do
  begin
  ms:=TFormMSync(FList.Items[FList.Count-1]);
  ms.Free;
  FList.Delete(FList.Count-1);
  end;
  FList.Pack;
end else
begin
  del:=del*(-1);
  for i:=0 to del do
  begin
  Application.CreateForm(TFormMSync,ms);
  FList.Add(ms);
  end;
end;
maxlen:=0;
for i:=0 to ngroup-1 do
begin
  ss:=RJob(GRList.Items[i]).Save.jobname;
  len:=Length(ss);
    if(len>maxlen)then
    maxlen:=len;
end;
for i:=0 to ngroup-1 do
begin
  ss:= RJob(GRList.Items[i]).Save.jobname;
  ms:=TFormMSync(FList.Items[i]);
  ms.rr:=RJob(GRList.Items[i]);
  ms.Panel1.Caption:=' '+ss+'  ';
  ms.PB.Position:=0;
  ww:=maxlen*(-ms.Panel1.Font.Height);
  ms.Width:=ww+40;
  mswidth:=ms.Width;
  ms.Visible:=true;
  ms.Enabled:=true;
  if(MainForm.Top > Screen.Height)then
  ms.Top:=Screen.Height-50-40*(i+1)
  else
  ms.Top:=MainForm.Top -40*(i+1)*bds;
end;
except
//
end;
end;

procedure TMainForm.MSShow(timers: boolean=true);
var
i: integer;
ms: TFormMSync;
begin
try
  for i:=0 to FList.Count-1 do
  begin
    ms:=TFormMSync(FList.Items[i]);
    ms.Visible:=true;
    ms.Left:=msleft;
    ms.hhide:=false;
    ms.Timer2.Enabled:=false;
    ms.Timer1.Interval:=Ldelay;
  end;
  except
//
end;
end;

procedure TMainForm.MSTimers(timers: boolean=true);
var
i: integer;
ms: TFormMSync;
begin
try
  for i:=0 to FList.Count-1 do
  begin
    ms:=TFormMSync(FList.Items[i]);
    ms.Timer1.Interval:=Ldelay;
    ms.Timer2.Enabled:=false;
    if(timers)then
    begin
      if(not ms.Timer1.Enabled)then
      ms.Timer1.Enabled:=true;
    end else
    ms.Timer1.Enabled:=false;
  end;
  except
//
end;
end;

procedure TMainForm.Timer3Timer(Sender: TObject);
begin
try
if(bShutDownAll)then
begin
Timer3.Enabled:=false;
exit;
end;
if(not ishide)then
begin
ishide:=true;
ShowWindow(application.Handle,SW_HIDE);
end;
except
//
end;
end;

procedure TMainForm.LoadOptions(loader: integer = 0);
begin
try
if(not FormCust.CBMainBorder.Checked)then
begin
  self.BorderStyle:=bsNone;
  Timer2.Enabled:=true;
  ishide:=false;
end else
begin
  self.BorderStyle:=bsSingle;
  Timer2.Enabled:=false;
  Gstartlabels:=true;
  ion:=0;
  if((FormCust.SEMainXPos.Value <> 0)and(FormCust.SEMainYPos.Value <> 0))then
  begin
    self.Left:=FormCust.SEMainXPos.Value;
    self.Top:=FormCust.SEMainYPos.Value;
  end;
end;
if((self.BorderStyle <> bsNone)or(border <> self.BorderStyle)or(loader <> 1))then
begin
CreateTrayIcon(1);
end;
indentX:=FormCust.SEMainXIndent.Value;
indentY:=FormCust.SEMainYIndent.Value;
Timer1.Interval:=FormCust.SEMainDelay.Value*1000;
movedelta:=FormCust.SEMainSpeed.Value;
Ldelta:=FormCust.SEMainLSpeed.Value;
Ldelay:=FormCust.SEMainLDelay.Value*1000;
except
//
end;
end;

procedure TMainForm.TBLockClick(Sender: TObject);
begin
if((self.BorderStyle = bsNone))then
begin
  if(TBLock.Down)then
  begin
  Timer2.Enabled:=false;
  TBLock.ImageIndex:=8;
  end else
  begin
  Timer2.Enabled:=true;
  TBLock.ImageIndex:=6;
  end;
end;
end;

procedure TMainForm.WMHotKey(var a: TWMHotKey);
begin
    if(CCRS.Rc > 1000000)and(CCRS.Rc < 2000000)then //TreeSizeFinderPro
    begin
      case a.HotKey of
      0: ShowForms(FormChart);
      1: ShowForms(FormCust);
      end;
    end else
    if(CCRS.Rc > 2000000)and(CCRS.Rc < 3000000)then //SUSynchronizerPro
    begin
      case a.HotKey of
      0: ShowForms(Form1);
      1: ShowForms(FormLog);
      2: ShowForms(FormCust);
      end;
    end else
    begin
      case a.HotKey of
      0: ShowForms(Form1);
      1: ShowForms(FormChart);
      2: ShowForms(FormMultiComp);
      3: ShowForms(FormLog);
      4: ShowForms(FormCust);
      end;
    end;
end;

procedure TMainForm.RegKeys(firsttime: boolean=false);
var
i,j,k,ind: integer;
LL: TListItem;
modif: Cardinal;
keystr: string;
lett: char;
begin
try
  if(FormCust.CBEnKeys.Checked)then
  begin
    for i:=0 to FormCust.LVKeys.Items.Count-1 do
    begin
      LL:=FormCust.LVKeys.Items.Item[i];
      LL.SubItemImages[0]:=6;
      if(LL.SubItems.Strings[0] = '')then
      continue;
      keystr:=LL.SubItems.Strings[0];
      lett:=keystr[Length(keystr)];
      modif:=0;
      for k:=0 to 1 do
      begin
        ind:=-1;
        for j:=0 to 3 do
        if(Pos(KeysStr[j],keystr)>0)then
        begin
          ind:=j;
          break;
        end;
        if(ind > -1)then
        begin
          modif:=modif or Cardinal(KeysNum[ind]);
          Delete(keystr,ind,Length(KeysStr[ind]));
        end;
      end;
      if(RegisterHotKey(handle,i,modif,ord(lett)))then
      LL.SubItemImages[0]:=5;
    end;
  end else
  begin
    if(not firsttime)then
    for i:=0 to FormCust.LVKeys.Items.Count-1 do
    begin
      LL:=FormCust.LVKeys.Items.Item[i];
      LL.SubItemImages[0]:=6;
      if(LL.SubItems.Strings[0] = '')then
      continue;
      UnregisterHotKey(handle,i);
    end;
  end;
  except
//
end;
end;

end.
