unit UMask;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, StdCtrls, Spin, ExtCtrls,StrUtils;

type
  TFormMask = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label4: TLabel;
    CBMask: TComboBox;
    GroupBox5: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ESFrom: TEdit;
    ESTo: TEdit;
    CBCFrom: TComboBox;
    CBCTo: TComboBox;
    GroupBox4: TGroupBox;
    Panel3: TPanel;
    BHelp: TButton;
    BCancel: TButton;
    BOk: TButton;
    Label5: TLabel;
    EDel: TEdit;
    Label1: TLabel;
    CBMoment: TComboBox;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    SEStart: TSpinEdit;
    SEStep: TSpinEdit;
    SEDigits: TSpinEdit;
    GroupBox2: TGroupBox;
    CBCaseKind: TComboBox;
    CBCase: TComboBox;
    Label11: TLabel;
    EExt: TEdit;
    BAdd: TButton;
    BDefault: TButton;
    CBRenMask: TComboBox;
    TBMasks: TToolBar;
    TBDel: TToolButton;
    TBClear: TToolButton;
    TBOpen: TToolButton;
    TBSaveAs: TToolButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BOkClick(Sender: TObject);
    procedure BCancelClick(Sender: TObject);
    procedure BHelpClick(Sender: TObject);
    procedure BAddClick(Sender: TObject);
    procedure BDefaultClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBClearClick(Sender: TObject);
    procedure TBOpenClick(Sender: TObject);
    procedure TBSaveAsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Executed: boolean;
    Mask: string;
    masks: TStringList;
  end;

var
  FormMask: TFormMask;

implementation

uses Uglobal, Udefinitions;

{$R *.dfm}

procedure TFormMask.FormShow(Sender: TObject);
begin
  CBRenMask.Text:=Mask;
end;

procedure TFormMask.FormCreate(Sender: TObject);
begin
  Executed:=false;
  self.FreeOnRelease;
  masks:= TStringList.Create;
masks.Sorted:=true;
masks.Duplicates:=dupIgnore;
if(FileExists(AppPath+'Masks.txt'))then
masks.LoadFromFile(AppPath+'Masks.txt');
CBRenMask.Items.Assign(masks);
end;

procedure TFormMask.BOkClick(Sender: TObject);
begin
try
  Mask:=CBRenMask.Text;
  masks.Add(CBRenMask.Text);
  //CBRenMask.Items.Assign(masks);
  masks.SaveToFile(AppPath+'Masks.txt');
  Executed:=true;
  Close;
except
Close;
end;
end;

procedure TFormMask.BCancelClick(Sender: TObject);
begin
  Executed:=false;
  Close;
end;

procedure TFormMask.BHelpClick(Sender: TObject);
begin
  InvokeHelp(self.Handle,hfMaskMaster);
end;

procedure TFormMask.BAddClick(Sender: TObject);
var
mm,mom,cc,ck: string;
begin
  mm:=CBMask.Text;
  case CBMoment.ItemIndex of
    0: mom:='';
    1: mom:='w';
    2: mom:='c';
  end;
  case CBCase.ItemIndex of
    0: cc:='U';
    1: cc:='L';
  end;
  case CBCaseKind.ItemIndex of
    0: ck:='';
    1: ck:='1';
    2: ck:='11';
  end;
  case CBMask.ItemIndex of
    1: mm:=AnsiReplaceStr(mm,'Counter','9');
    2: mm:=AnsiReplaceStr(mm,'Digits-Counter',IntToStr(SEDigits.Value)+'-9');
    3: mm:=AnsiReplaceStr(mm,'Digits-Counter+Start+Step',IntToStr(SEDigits.Value)+'-9+'+
    IntToStr(SEStart.Value)+'+'+IntToStr(SEStep.Value));
    4: mm:=AnsiReplaceStr(mm,'Date of Moment','d'+mom);
    5: mm:=AnsiReplaceStr(mm,'Day of Momentt','dd'+mom);
    6: mm:=AnsiReplaceStr(mm,'Month of Moment','m'+mom);
    7: mm:=AnsiReplaceStr(mm,'Year of Moment','y'+mom);
    8: mm:=AnsiReplaceStr(mm,'Time of Moment','t'+mom);
    9: mm:=AnsiReplaceStr(mm,'Extension',EExt.Text);
    10: mm:=AnsiReplaceStr(mm,'What Delete',EDel.Text);
    11: mm:=AnsiReplaceStr(mm,'String From # String To',ESFrom.Text+'#'+ESTo.Text);
    12: mm:=AnsiReplaceStr(mm,'Char From - CharTo $ StringTo',CBCFrom.Text+'-'+
    CBCTo.Text+'$'+ESTo.Text);
    13: mm:=AnsiReplaceStr(mm,'Case',cc+ck);
  end;
  CBRenMask.Text:=CBRenMask.Text+mm;
end;

procedure TFormMask.BDefaultClick(Sender: TObject);
begin
  CBRenMask.Text:='*';
end;

procedure TFormMask.TBDelClick(Sender: TObject);
begin
  CBRenMask.Items.Delete(CBRenMask.ItemIndex);
  masks.Delete(CBRenMask.ItemIndex);
  CBRenMask.ItemIndex:=0;
end;

procedure TFormMask.TBClearClick(Sender: TObject);
begin
  masks.Clear;
  masks.Add('*[9]');
  CBRenMask.Items.Clear;
  CBRenMask.Items.Add('*[9]');
  CBRenMask.ItemIndex:=0;
end;

procedure TFormMask.TBOpenClick(Sender: TObject);
begin
OpenDialog1.InitialDir:=AppPath;
if(OpenDialog1.Execute)then
begin
masks.LoadFromFile(OpenDialog1.FileName);
CBRenMask.Items.Assign(masks);
end;
end;

procedure TFormMask.TBSaveAsClick(Sender: TObject);
begin
SaveDialog1.InitialDir:=AppPath;
if(SaveDialog1.Execute)then
begin
masks.SaveToFile(SaveDialog1.FileName);
end;
end;

procedure TFormMask.FormDestroy(Sender: TObject);
begin
try
masks.SaveToFile(AppPath+'Masks.txt');
masks.Free;
except
//
end;
end;

end.
