unit Ufilter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Gauges,Udefinitions,Masks,
  ImgList, ToolWin;

type
  TFormFilter = class(TForm)
    PanelFilter: TPanel;
    GBFilter: TGroupBox;
    CBDate: TComboBox;
    CBFrom: TComboBox;
    CBTo: TComboBox;
    CBMask: TComboBox;
    CBExt: TComboBox;
    CBTime: TComboBox;
    CBFAction: TComboBoxEx;
    CBFActionRes: TComboBoxEx;
    CBTop: TComboBox;
    CBType: TComboBoxEx;
    CBHide: TComboBox;
    Timer1: TTimer;
    ToolBar1: TToolBar;
    TBDefault: TToolButton;
    TBAnalyze: TToolButton;
    ILFilter: TImageList;
    TBStart: TToolButton;
    TBExec: TToolButton;
    TBNotExec: TToolButton;
    TBAll: TToolButton;
    TBSuccess: TToolButton;
    TBFailed: TToolButton;
    TBAborted: TToolButton;
    TBAuto: TToolButton;
    ToolButton12: TToolButton;
    TBAbort: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    Gauge1: TGauge;
    TBExists: TToolButton;
    TBNotExists: TToolButton;
    ToolButton1: TToolButton;
    procedure FormShow(Sender: TObject);
    procedure BCloseClick(Sender: TObject);
    procedure BDefaultClick(Sender: TObject);
    procedure BStartClick(Sender: TObject);
    procedure BAnalyzeClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BAbortClick(Sender: TObject);
    procedure CBTypeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TBExecClick(Sender: TObject);
    procedure TBNotExecClick(Sender: TObject);
    procedure TBAllClick(Sender: TObject);
    procedure TBExistsClick(Sender: TObject);
    procedure TBNotExistsClick(Sender: TObject);
    procedure TBSuccessClick(Sender: TObject);
    procedure TBFailedClick(Sender: TObject);
    procedure TBAbortedClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    rj: RJob;
    LG: integer;
    LV: TListView;
    TBShowAllF,TBIco: TToolButton;
    showmode: integer;
    procedure AssignFilters;
    procedure LoadLists1;
    procedure LoadData;
    procedure FilterSync;
    procedure AnalyzeSync;
    procedure StartWork(oop: integer);
  end;

type
  AnalyzeTh = class(TThread)
  protected
    procedure Execute; override;
  public
    fff: TFormFilter;
    op: integer;
end;

var
  FormFilter: TFormFilter;
  aaa: AnalyzeTh;

implementation

uses ULog, Uglobal, Ugrsync;

{$R *.dfm}

procedure AnalyzeTh.Execute;
begin
try
try
  self.FreeOnTerminate:=true;
  if(not fff.rj.complete)then exit else fff.rj.complete:=false;
  if(op = 0)then
  begin
    case fff.LG of
      lnLTop: fff.rj.AnalyzeItemList(fff.rj.LTop);
      lnLView:fff.rj.AnalyzeItemList(fff.rj.LView);
      lnLTemp:fff.AnalyzeSync;
    end;
    fff.LoadData;
  end else
  if(op = 1)then
  begin
    case fff.LG of
      lnLTop:
      begin
        fff.rj.FilterTop;
        ShowRecords(fff.TBShowAllF.Down,fff.TBIco.Down,slcFirst,fff.rj,fff.LV);
      end;
      lnLView:
      begin
        fff.rj.FilterView;
        fff.rj.ShowNodeRecords(fff.TBShowAllF.Down,fff.TBIco.Down,slcFirst)
      end;
      lnLTemp:
      begin
        fff.FilterSync;
        if(fff.TBShowAllF.Down)then
        ShowSyncRecords(slcFiltered)
        else
        ShowSyncRecords(slcFirst);
      end;
    end;
  end;
  fff.rj.complete:=true;
finally
  fff.rj.babort:=false;
  fff.rj.maxval:=10;
  fff.rj.position:=0;
  aaa:=nil;
end;
except
fff.rj.complete:=true;
end;
end;

procedure TFormFilter.LoadData;
begin
CBExt.Clear;
CBDate.Clear;
CBTime.Clear;
CBMask.Clear;

CBExt.Items.Assign(rj.LAExt);
CBDate.Items.Assign(rj.LADate);
CBTime.Items.Assign(rj.LATime);
CBMask.Items.Assign(rj.LAPath);

CBExt.Items.Insert(0,fsExtension);
CBDate.Items.Insert(0,fsDate);
CBTime.Items.Insert(0,fsTime);
CBMask.Items.Insert(0,'*');

CBExt.ItemIndex:=0;
CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBMask.ItemIndex:=0;
end;

procedure TFormFilter.FormShow(Sender: TObject);
begin
LoadData;
self.Caption := self.Caption+'  '+self.rj.Save.jobname;
end;

procedure TFormFilter.BCloseClick(Sender: TObject);
begin
rj.CheckDefaultFilters;
Close;
end;

procedure TFormFilter.BDefaultClick(Sender: TObject);
begin
CBType.ItemIndex:=0;
CBFrom.ItemIndex:=0;
CBTo.ItemIndex:=0;

CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBMask.ItemIndex:=0;

CBTop.ItemIndex:=0;
CBFAction.ItemIndex:=0;
CBFActionRes.ItemIndex:=0;

CBExt.ItemIndex:=0;
CBHide.ItemIndex:=0;

AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.AssignFilters;
begin
try
rj.TP.sTime:=    CBTime.Text;
rj.TP.sDate:=    CBDate.Text;
rj.TP.iType:=    CBType.ItemIndex;
rj.TP.sMask:=    CBMask.Text;
rj.TP.sExt:=     CBExt.Text;
rj.TP.iAction:=  CBFAction.ItemIndex;
rj.TP.iResult:=  CBFActionRes.ItemIndex;
rj.TP.iExec:=    CBHide.ItemIndex;
rj.TP.iDateType:=CBTop.ItemIndex;
rj.TP.sFrom:=    CBFrom.Text;
rj.TP.sTo:=      CBTo.Text;
rj.CheckDefaultFilters;
except
//
end;
end;

procedure TFormFilter.BStartClick(Sender: TObject);
begin
AssignFilters;
StartWork(1);
end;

procedure TFormFilter.LoadLists1;
begin
 if(rj<>nil)then
  begin
    //CBTime.Items.CommaText:=rj.TP.asTime;
    //CBDate.Items.CommaText:=rj.TP.asDate;
    //CBExt.Items.CommaText:= rj.TP.asExt;
    CBFrom.Items.CommaText:= rj.TP.asFrom;
    CBTo.Items.CommaText:= rj.TP.asTo;
    CBFrom.Items.Insert(0,fsFrom);
    CBTo.Items.Insert(0,fsTo);

    rj.position:=0;
    rj.maxval:=3;
    CBExt.Items.Assign(rj.LAExt);
    rj.position:=rj.position+1;
    CBDate.Items.Assign(rj.LADate);
    rj.position:=rj.position+1;
    CBTime.Items.Assign(rj.LATime);
    rj.position:=rj.position+1;
    rj.position:=0;
    
    CBExt.ItemIndex:=0;
    CBDate.ItemIndex:=0;
    CBTime.ItemIndex:=0;
    CBFrom.ItemIndex:=0;
    CBTo.ItemIndex:=0;
  end;
end;

procedure TFormFilter.BAnalyzeClick(Sender: TObject);
begin
StartWork(0);
end;

procedure TFormFilter.Timer1Timer(Sender: TObject);
begin
try
if(rj.maxval>=0)then
Gauge1.MaxValue:=rj.maxval
else
Gauge1.MaxValue:=10;
if(rj.position>=0)then
Gauge1.Progress:=rj.position
else
Gauge1.Progress:=0;
except
//
end;
end;

procedure TFormFilter.BAbortClick(Sender: TObject);
begin
rj.babort:=true;
end;

procedure TFormFilter.FilterSync;
var
i: integer;
dd: IDRec;
cc: CompData;
isadd: integer;
PL: string;
begin
try
  rj.LFTop.Clear;
  for i:=0 to rj.LTop.Count-1 do
  begin
    cc:=CompData(rj.LTop.Items[i]);
    dd:=IDRec(cc.idd);
    isadd:=0;
    if(dd.ntype = ntFile)then
    begin
      case rj.TP.iDateType of
        0:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        1:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
          isadd:=isadd+1;
        end;
        2:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timeaccess) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timeaccess)))then
          isadd:=isadd+1;
        end;
        3:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        4:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
          isadd:=isadd+1;
        end;
      end;
    end else
    begin
      if(rj.TP.iDateType = 4)then
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
        isadd:=isadd+1;
      end else
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
        isadd:=isadd+1;
      end;
    end;
      case rj.TP.iType of
      0: isadd:=isadd+1;
      1: if(dd.ntype = ntFile)then isadd:=isadd+1;
      2: if(dd.ntype = ntDir)then isadd:=isadd+1;
      3: if(dd.ntype = ntFileDel)then isadd:=isadd+1;
      4: if(dd.ntype = ntFileNew)then isadd:=isadd+1;
      5: if(dd.ntype = ntFileChg)then isadd:=isadd+1;
      6: if(dd.ntype = ntDirNew)then isadd:=isadd+1;
      7: if(dd.ntype = ntDirDel)then isadd:=isadd+1;
      end;
      PL:=dd.iname;

    if((rj.TP.sMask = '*')or(MatchesMask(PL,rj.TP.sMask)))then
    isadd:=isadd+1;
    if((rj.TP.sExt = fsExtension)or(ExtractFileExt(dd.iname) = rj.TP.sExt))then
    isadd:=isadd+1;
    //**********************************
    if((rj.TP.iAction = 0)or(rj.TP.iAction-1 = cc.istate))then
    isadd:=isadd+1;
    if((rj.TP.iResult = 0)or(rj.TP.iResult+9 = cc.iResult)or(rj.TP.iResult+21 = cc.iResult))then
    isadd:=isadd+1;
    //**********************************
    if(rj.TP.sFrom = gsFrom)or(rj.TP.sFrom = cc.dirfrom.dname)then
    isadd:=isadd+1;
    if(rj.TP.sTo = gsTo)or(rj.TP.sTo = cc.dirto.dname)then
    isadd:=isadd+1;
    
    if(isadd = 9)then
    begin
      rj.LFTop.Add(cc);
    end;
  end;
rj.filterchange:=false;
except
//
end;
end;

procedure TFormFilter.AnalyzeSync;
var
i: integer;
LVI: TDList;
rr: IDRec;
begin
try
rj.LAExt.Clear;
rj.LADate.Clear;
rj.LATime.Clear;
rj.LAPath.Clear;

try
CBFrom.Clear;
CBTo.Clear;
for i:=0 to rj.LItems.Count-1 do
begin
  LVI:=TDList(rj.LItems.Items[i]);
  rj.LAExt.Add(LVI.DPar.dname);
end;

CBFrom.Items.Assign(rj.LAExt);
CBTo.Items.Assign(rj.LAExt);

CBFrom.Items.Insert(0,gsFrom);
CBTo.Items.Insert(0,gsTo);

CBFrom.ItemIndex:=0;
CBTo.ItemIndex:=0;

rj.LAExt.Clear;
rj.position:=0;
rj.maxval:=rj.LTop.Count;

for i:=0 to rj.LTop.Count-1 do
begin
  rj.position:=rj.position+1;
  if(rj.babort)then exit;
  rr:=CompData(rj.LTop.Items[i]).idd;
  if(rr.ntype = ntFile)then
  begin
  rj.LAExt.Add(ExtractFileExt(rr.iname));
  rj.LADate.Add(DateToStr(rr.timeaccess));
  rj.LADate.Add(DateToStr(rr.timewrite));
  rj.LATime.Add(TimeToStr(rr.timeaccess));
  rj.LATime.Add(TimeToStr(rr.timewrite));
  end;
  rj.LADate.Add(DateToStr(rr.timecreate));
  rj.LATime.Add(TimeToStr(rr.timecreate));
  rj.LAPath.Add(ExtractFilePath(rr.ilabel)+'*');
end;

CBExt.Clear;
CBDate.Clear;
CBTime.Clear;
CBMask.Clear;

rj.position:=0;
rj.maxval:=4;
CBExt.Items.Assign(rj.LAExt);
rj.position:=rj.position+1;
CBDate.Items.Assign(rj.LADate);
rj.position:=rj.position+1;
CBTime.Items.Assign(rj.LATime);
rj.position:=rj.position+1;

CBExt.Items.Insert(0,fsExtension);
CBDate.Items.Insert(0,fsDate);
CBTime.Items.Insert(0,fsTime);
CBMask.Items.Insert(0,'*');

CBExt.ItemIndex:=0;
CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBMask.ItemIndex:=0;

finally
rj.position:=0;
end;
except
//FormLog.RecError('2004');
end;
end;

procedure TFormFilter.StartWork(oop: integer);
begin
  if(aaa = nil)then
  begin
    aaa:=AnalyzeTh.Create(true);
    aaa.fff:=self;
    aaa.op:=oop;
    aaa.Resume;
  end else
  begin
  //
  end;
end;

procedure TFormFilter.CBTypeChange(Sender: TObject);
begin
if(self.Visible)then
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.FormCreate(Sender: TObject);
begin
self.FreeOnRelease;
aaa:=nil;
CBType.ItemIndex:=0;
CBFrom.ItemIndex:=0;
CBTo.ItemIndex:=0;

CBDate.ItemIndex:=0;
CBTime.ItemIndex:=0;
CBMask.ItemIndex:=0;

CBTop.ItemIndex:=0;
CBFAction.ItemIndex:=0;
CBFActionRes.ItemIndex:=0;

CBHide.ItemIndex:=0;
CBExt.ItemIndex:=0;
end;

procedure TFormFilter.TBExecClick(Sender: TObject);
begin
CBHide.ItemIndex:=1;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBNotExecClick(Sender: TObject);
begin
CBHide.ItemIndex:=0;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBAllClick(Sender: TObject);
begin
CBHide.ItemIndex:=2;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBExistsClick(Sender: TObject);
begin
CBHide.ItemIndex:=3;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBNotExistsClick(Sender: TObject);
begin
CBHide.ItemIndex:=4;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBSuccessClick(Sender: TObject);
begin
CBFActionRes.ItemIndex:=1;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBFailedClick(Sender: TObject);
begin
CBFActionRes.ItemIndex:=2;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.TBAbortedClick(Sender: TObject);
begin
CBFActionRes.ItemIndex:=3;
AssignFilters;
if(TBAuto.Down)then
StartWork(1);
end;

procedure TFormFilter.ToolButton1Click(Sender: TObject);
begin
InvokeHelp(self.Handle,hfFilter);
end;

end.
