unit Uglobal;

interface

uses Windows,Classes,Types,SysUtils,ComCtrls,StrUtils,Forms,Controls,
ShlObj,ComObj,ShellAPI,Masks,Udefinitions,Math,DateUtils,Graphics,Ftp,Menus,Dialogs;

{$I DirSync.inc}

type TWinType = (wtWindows95, wtWindowsNT, wtWin32s, wtUnknown);
type CompFunc = function (Item1, Item2: Pointer): Integer;
type ManHistProc = procedure;
type ManProc = procedure(rj: RJob);
type ClickProc = procedure(Sender: TObject)of object;
type ExpandingProc = procedure(Sender: TObject; Node: TTreeNode;var AllowExpansion: Boolean)of object;
type ShowProc1 = procedure (tto: integer;num: integer = -1);

type
  UniRunTh = class(TThread)
  protected
    procedure Execute; override;
  public
    abortrc: boolean;
    ManP: ManProc;
    rj: RJob;
end;

type
  UniRunTh2 = class(TThread)
  protected
    procedure Execute; override;
  public
    abortrc,selall: boolean;
    ManP: ClickProc;
    ExPr: ExpandingProc;
    fff: FTPJob;
    Snd: TObject;
    wdd: TList;
    rj: RJob;
    Node: TTreeNode;
    AllowExpansion: ^Boolean;
    OpIndex: integer;
    ddir,smask: string;
    mms: TMemoryStream;
    procedure FreeFrame;
    constructor Create(CreateSuspended: boolean); reintroduce;
end;

function HHelp(handle: HWND;help_file: PChar;command: Integer;data: DWORD) : HWND; stdcall; external 'hhctrl.ocx' name 'HtmlHelpA';

//1
procedure ListFrom(LV1,LL: TList;rj: RJob);
procedure ListTo(LV1,LL: TList;rj: RJob);
//3
procedure DispatchList(LV1,LL: TList;rj: RJob);
function DriveFree(drv: string): real;
function RenComp(Item1, Item2: Pointer): Integer;
function SizeString(isize: real): string;
//4
function DelListDir2(inum: integer;LL,DeLL: TList): string;
function RenameMask(fname,mask: string;var num: integer;ntype,context: integer;idd: IDRec): string;
//5
procedure PushChild(child,parent: IDRec);
function GetTreePath(dd: IDRec): string;
procedure RenumL(LL: TList;tt: integer=0);
procedure ExecJob(rr: RJob);
//6
procedure ExecJobName(jname: string);
procedure SyncHistoryLists(rj: RJob;LV: TListView);
function MatchesRect(pp: TPoint;rr: TRect): boolean;
function FormatNumber(nn: string): string;
//7
procedure SellectAll(LL: TListView);
function CreateRec(iname: string='';parent: IDRec=nil;isize:real=0;
                    timeaccess:TDateTime=0;
                    timewrite:TDateTime=0;
                    timecreate:TDateTime=0;
                    timecheck:TDateTime=0;
                    iattr: integer=0;ntype: integer=-1;rj: RJob=nil): IDRec;
procedure DestroyRec(sd: IDRec);
function GetDiskSpace(Drive: string;var FreeSpaceAvailable,TotalSpace: Int64): Bool;
//8
function DirSort(Item1, Item2: Pointer): Integer;
procedure CheckTreeNodes(ad: IDRec;TV: TTreeView;OnlyDir: boolean);
//procedure ExpandTreeNode(tr: TTreeNode;TV: TTreeView;OnlyDir: boolean);
//9
procedure EmptyTreeNode(tr: TTreeNode;needrenum: boolean=true);
procedure EmptyTreeNode1(tr: TTreeNode;recurse: boolean=false);
function EnumFolder(rr: IDRec): string;
//10
function DelDir(dname: string;var abortall: boolean): real;
//11
procedure PopChild(child,parent: IDRec);
function CompareNames(Item1, Item2: Pointer): Integer;
function DiskExists(rr: IDRec): boolean;
function FindRSort(LL: TList;pp: Pointer;comp: CompFunc): integer;
//12
function CompFrom1(Item1, Item2: Pointer): Integer;
function CompFrom2(Item1, Item2: Pointer): Integer;
function CompFrom3(Item1, Item2: Pointer): Integer;
function CompFrom4(Item1, Item2: Pointer): Integer;
//13
function CompTo1(Item1, Item2: Pointer): Integer;
function CompTo2(Item1, Item2: Pointer): Integer;
function CompTo3(Item1, Item2: Pointer): Integer;
function CompTo4(Item1, Item2: Pointer): Integer;
//14
function CompTop1(Item1, Item2: Pointer): Integer;
function CompTop2(Item1, Item2: Pointer): Integer;
function CompTop3(Item1, Item2: Pointer): Integer;
function CompTop4(Item1, Item2: Pointer): Integer;
//15
function CompTop5(Item1, Item2: Pointer): Integer;

function CompTimeWrite(Item1, Item2: Pointer): Integer;
function CompDateWrite(Item1, Item2: Pointer): Integer;

function CompTimeCreate(Item1, Item2: Pointer): Integer;
function CompDateCreate(Item1, Item2: Pointer): Integer;

function CompTimeAccess(Item1, Item2: Pointer): Integer;
function CompDateAccess(Item1, Item2: Pointer): Integer;

function CompNames(Item1, Item2: Pointer): Integer;

function CompIfs(Item1, Item2: Pointer): Integer;
function CompLabel(Item1, Item2: Pointer): Integer;
function CompIfsCV(Item1, Item2: Pointer): Integer;
function CompLabelCV(Item1, Item2: Pointer): Integer;

function CompEachOwnDate(Item1, Item2: Pointer): Integer;
function CompEachOwnTime(Item1, Item2: Pointer): Integer;
function CompEachOwnDateCV(Item1, Item2: Pointer): Integer;
function CompEachOwnTimeCV(Item1, Item2: Pointer): Integer;


function ListToSort(Item1, Item2: Pointer): Integer;
procedure TopListMenuClick(LVTop: TListView;imgindex: integer);
//16
procedure ClickListAdd(dd: IDRec;rj: RJob);
procedure ShowRecords(TBShowAllFDown,TBIcoDown: boolean;tto: integer;rj: RJob;LVTop: TListView;num: integer = -1;showexuted: boolean = true);
function CleanDir(TDL: TDList;dir,pref,root: string;var abortall: boolean): real;
//17

procedure AnalyzeTop(rj: RJob);
function ItemExists(rr: IDRec): boolean;
//18
procedure ReSortTop(TBShowAllFDown,TBIcoDown: boolean;rj: RJob;LVTop: TListView);
procedure ShutDown;
function GetWinType: TWinType;
//19
procedure InvokeDlg(rj: RJob);
procedure ShowWinIcons(Item: TListItem;ico: TIcon);
procedure InvokeShutDown;
//20
function MoveTo(src,dest: string;var ab: boolean;var mess: string;oper: integer=FO_MOVE):integer;
procedure Sync(rr: RJob;bshow: boolean=true);
procedure RangeList(TempL: TList;pp: IDRec;rj: RJob;dto: DirP=nil;cindex: integer=0);
//21
procedure PushChildID(child: CompData;parent: IDRec);
procedure ShowWinIcons2(Item: TListItem;ico: TIcon);
procedure RefreshSystems(LV: TListView);
procedure SaveSystem(gg: RJobSave);
//22
procedure LoadSystems;
function ExtractFileDrive(const FileName: string): string;
//23
function GetError: string;
procedure SetFTPprop(sff:RJobSave;ff: FTPJob);
procedure CheckJobEvents(rj: RJob;isbegin: boolean = false);
function GetRec(dd: string;rj: RJob): IDRec;
//24
procedure CloneTree(src,dest: TTreeView);
function  CheckJob(dname: string;rjinit,rjtemp: RJob;dp: DirP;dr: IDRec;pTempL: Pointer=nil): RJob;
procedure ShowActions(rr: RJob;LVEvents: TListView);
//25
function GetTD(fname: string;direction: integer): TDList;
function EnumFolderI(fname: string): string;
procedure SyncDir(rj: RJob;SP: ShowProc1=nil;FormHide: ManHistProc=nil);
procedure CleanDirShow2(cv: CompData;recurse: boolean=true);
//26
function SyncPrepare(rr: RJob): RJob;
procedure MoveToClickList(CurrJob: RJob;DragList: TList;
Action: integer;path: string = '');
procedure ContextMenuClick(Sender: TObject;CurrJob: RJob;DragList: TList);
//27
procedure ManageJobHistory(rj: RJob);
procedure FillHistoryItem(jh: JobHist;TL: TListItem);
procedure CopyPExList(src: DirP;dest: DirP);
procedure DrawCurrent(TVR: TTreeView;SelL: TRect);
//28
procedure InvokeHelp(hhandle:Cardinal;page: string='Introduction.htm';cindex: integer=0);
function ShowItems: string;
procedure InvokeAbout;
function TimerSTimer: string;
//29
procedure Clickk(pbuf: Pointer;buflen,ncycle: integer);
procedure UnClickk(pbuf: Pointer;buflen,ncycle: integer);
procedure UnUnClickk(pbuf: Pointer;buflen: integer);
procedure CClickk(pbuf: Pointer;buflen: integer);
//30
procedure InvertBuf(pbuf: Pointer;buflen: integer);
procedure Form1BUClick(cr: RegSt;ss: string);
function CreateCV(TL: IDRec;dfrom,dto: DirP;cause: integer;LL: TList): CompData;
function ContextMenuClic: string;
//31
procedure InvokeFreeFTP(fff: FTPJob);
function CompTo3timeC(Item1, Item2: Pointer): Integer;
function CompTo3dateC(Item1, Item2: Pointer): Integer;

function CompTo3timeA(Item1, Item2: Pointer): Integer;
function CompTo3dateA(Item1, Item2: Pointer): Integer;

function CompTo3dateW(Item1, Item2: Pointer): Integer;
function CompTo3timeW(Item1, Item2: Pointer): Integer;

function CompFrom(Item1, Item2: Pointer): Integer;
function CompTo(Item1, Item2: Pointer): Integer;
function DirSortCV(Item1, Item2: Pointer): Integer;

function AssignColumns(ColInd: integer;rj: RJob): integer;
procedure InvokeFilters(rj: RJob;alist,shmode: integer;BShowAll,BShowIcon: TToolButton;LLK: TListView);
procedure BRenTopClick(LVTop: TListView;BRen: TObject);
procedure BDirTopClick(LVTop: TListView;BDir: TObject);
function InvokeRenMaster(defmask: string): string;
function InvokeRename(rn: IDRec): boolean; overload;
function InvokeRename(sel: TList): boolean;overload;
function InvokeDirDialog(idd: IDRec;pyes: boolean = false;onlylocal: boolean = false): string;

implementation

uses ULog, UReqDialog, UshutDown,Ugrsync,UDirDialog, UFormRen,
  Uabout, Ucustomize, Ufilter, UMask;

function InvokeDirDialog(idd: IDRec;pyes: boolean = false;onlylocal: boolean = false): string;
begin
  Result:='';
  if(onlylocal)then
  begin
    FormDirDialog.Label1.Visible:=false;
    FormDirDialog.CBSys.Visible:=false;
  end;
  try
  FormDirDialog.ShowModal;
  if(FormDirDialog.Execute)then
  begin
  Result:=FormDirDialog.fpath;
  if(pyes)then
  idd:=FormDirDialog.rd;
  end;
  finally
    FormDirDialog.Label1.Visible:=true;
    FormDirDialog.CBSys.Visible:=true;
  end;
end;

function InvokeRename(rn: IDRec): boolean;
var
sel: TList;
begin
  Result:=false;
  sel:= TList.Create;
  try
  sel.Add(rn);
  Application.CreateForm(TFormRen,FormRen);
  FormRen.RenList:=sel;
  FormRen.ShowModal;
  Result:=FormRen.Execute;
  finally
    sel.Free;
  end;
end;

function InvokeRename(sel: TList): boolean;
begin
  Result:=false;
  try
  Application.CreateForm(TFormRen,FormRen);
  FormRen.RenList:=sel;
  FormRen.ShowModal;
  Result:=FormRen.Execute;
  except
  //
  end;
end;

function InvokeRenMaster(defmask: string): string;
begin
  Result:=defmask;
  Application.CreateForm(TFormMask,FormMask);
  FormMask.Mask:=defmask;
  FormMask.ShowModal;
  if(FormMask.Executed)then
  Result := FormMask.Mask;
end;

procedure InvokeFilters(rj: RJob;alist,shmode: integer;BShowAll,BShowIcon: TToolButton;LLK: TListView);
begin
if(FormFilter<>nil)and(FormFilter.Visible)then FormFilter.Free;
Application.CreateForm(TFormFilter,FormFilter);
FormFilter.rj:=rj;
FormFilter.LG:=alist;
FormFilter.LV:=LLK;
FormFilter.TBShowAllF:=BShowAll;
FormFilter.TBIco:=BShowIcon;
FormFilter.showmode:=shmode;
FormFilter.Show;
end;

function AssignColumns(ColInd: integer;rj: RJob): integer;
begin
  Result:=0;
  case ColInd of
    0:Result:=psName;
    1:Result:=psSize;
  end;
  case rj.TP.iDateType of
    0:
    begin
      case ColInd of
        2:Result:=psEachOwnDate;
        3:Result:=psEachOwnTime;
      end;
    end;//Each his own
    1:
    begin
      case ColInd of
        2:Result:=psDateCr;
        3:Result:=psTimeCr;
      end;
    end;//Time Create
    2:
    begin
      case ColInd of
        2:Result:=psDateAc;
        3:Result:=psTimeAc;
      end;
    end;//Time Access
    3:
    begin
      case ColInd of
        2:Result:=psDateWr;
        3:Result:=psTimeWr;
      end;
    end;//Time Write
  end;
end;


procedure InvokeFreeFTP(fff: FTPJob);
var
RT: UniRunTh2;
begin
try
 RT:=UniRunTh2.Create(true);
 RT.fff:=fff;
 RT.OpIndex:=2;
 RT.Resume;
except
//
end;
end;

procedure Form1BUClick(cr: RegSt;ss: string);
var
fs: TStringStream;
dd: string;
begin
if(ss = '')then
begin
cr.Rc:=1;
exit;
end;
fs:= TStringStream.Create(ss);
try
try
fs.Seek(ArSz,soFromBeginning);
cr.Bak   :=Trim(fs.ReadString(ArSz));
cr.Mess1 :=Trim(fs.ReadString(ArSz));
cr.Mess2 :=Trim(fs.ReadString(ArSz));
fs.Seek(7,soFromEnd);
dd:=fs.ReadString(7);
cr.Rc:=StrToInt(dd);
except
cr.Rc:=1;
end;
finally
fs.Free;
end;
end;

procedure CClickk(pbuf: Pointer;buflen: integer);
var
i: integer;
begin
try
//for j:=2 to buflen do
for i:=buflen downto 2 do Clickk(pbuf,i,1);
except
//
end;
end;

procedure InvertBuf(pbuf: Pointer;buflen: integer);
begin
  asm
    MOV EAX,[pbuf]
    XOR ECX,ECX
      @REPEAT1:
        PUSH [EAX+ECX]
        INC ECX
        CMP ECX,buflen
      JNE @REPEAT1
      XOR EDX,EDX
      XOR ECX,ECX
      @REPEAT2:
        POP EDX
        MOV [EAX+ECX],DL
        INC ECX
        CMP ECX,buflen
      JNE @REPEAT2
  end;
end;

procedure Clickk(pbuf: Pointer;buflen,ncycle: integer);
begin
try
  asm
    PUSH EBX
    CLD
    MOV ECX,buflen
    MOV EDX,ncycle
    MOV EAX,[pbuf]
   // XOR EBX,EBX
    @REPEAT2:
      DEC ECX
      @REPEAT1:
        MOV BL,[EAX+ECX]
        ROL BL,1
        MOV [EAX+ECX],BL
        DEC ECX
      JNZ @REPEAT1
        MOV BL,[EAX+ECX]
        ROL BL,1
        MOV [EAX+ECX],BL
      //MOV ECX,buflen
      //MOV BL,[EAX+ECX]
      //ROL BL,1
      //MOV [EAX+ECX],BL
     // INC BH
     // SUB ECX,BH
      DEC EDX
    JNZ @REPEAT2
    POP EBX
  end;
except
//
end;
end;

procedure UnUnClickk(pbuf: Pointer;buflen: integer);
var
i: integer;
begin
try
//for j:=2 to buflen do
for i:=2 to buflen do UnClickk(pbuf,i,1);
except
//
end;
end;

procedure UnClickk(pbuf: Pointer;buflen,ncycle: integer);
begin
try
  asm
    PUSH EBX
    CLD
    XOR ECX,ECX
    MOV EDX,ncycle
    MOV EAX,[pbuf]
    @REPEAT2:
      @REPEAT1:
        MOV BL,[EAX+ECX]
        ROR BL,1
        MOV [EAX+ECX],BL
        INC ECX
        CMP ECX,buflen
      JNE @REPEAT1
      XOR ECX,ECX
      //MOV BL,[EAX]
      //ROR BL,1
      //MOV [EAX],BL
      DEC EDX
    JNZ @REPEAT2
    POP EBX
  end;
except
//
end;
end;

function TimerSTimer: string;
var
rr: real;
crr: string;
begin
try
{$ifndef DEVELOPMENT}
asm
lock nop
end;
except
{$endif}
  Result:='';
  if(Butt1 = 0)and(CCRS.Rc = 1)then
  begin
    Butt1:=Now;
    FormCust.SaveAppData;
   // FormCust.LoadAppData;
  end else
  begin
    if(CCRS.Rc = 1)then  //this mean unregistered version
    begin
      rr:=DaySpan(Now,Butt1);
      {$ifndef DEVELOPMENT}
      if(rr>=30)then Application.Terminate;
      {$endif}
      rr:=RoundTo(30-rr,-5);
      crr:=FloatToStr(rr);
      crr:=crr+StringOfChar('0',(8-Length(crr)));
      crr:=CCRS.Mess1+'  '+ CCRS.Bak+'  '+crr+'  '+CCRS.Mess2;
    end else
    crr:=CCRS.Mess1 +'  '+ CCRS.Bak;
    Result:=crr;
  end;
{$ifdef DEVELOPMENT}
except
{$endif}
//
end;
end;

function ShowItems: string;
begin
Result:='';//TimerSTimer;
end;

function ContextMenuClic: string;
begin
Result:='';//TimerSTimer;
end;
////////////////////////////////////////////////////////////////
{
defence defence defence defence defence defence defence defence
}
////////////////////////////////////////////////////////////////
procedure InvokeAbout;
begin
try
Application.CreateForm(TFormAbout,FormAbout);
FormAbout.ShowModal;
except
//
end;
end;

procedure InvokeHelp(hhandle:Cardinal;page: string='Introduction.htm';cindex: integer=0);
var
ppp: string;
begin
try
ppp:=ExtractFilePath(Application.ExeName);
HHelp(hhandle,PChar(ppp+'DirSyncHelp.chm::/'+page),0,0);
except
//
end;
end;

procedure ContextMenuClick(Sender: TObject;CurrJob: RJob;DragList: TList);
var
iaction: integer;
begin
try
  if(TMenuItem(Sender).Parent.Caption<>'')then
  iaction:=TMenuItem(Sender).MenuIndex
  else
  begin
  iaction:=TMenuItem(Sender).MenuIndex+6;
  if(iaction<9)or(iaction = 15)then iaction:=9;
  end;
  MoveToClickList(CurrJob,DragList,iaction);
except
//
end;
end;

procedure MoveToClickList(CurrJob: RJob;DragList: TList;Action: integer;path: string = '');
var
i: integer;
dd: IDRec;
dest: string;
begin
try
try
  if(DragList.Count>0)then
  begin //2
    if(Action in EnActive)then
    begin  //7
    if(path = '')then
    begin  //6
      if(Action = aiCopyTo)or(Action = aiMoveTo)or(Action = aiMoveContentTo)then
      begin  //1
        dest:=InvokeDirDialog(nil);
        if(dest = '')then
        exit;
      end; //1
    end else dest:=path; //6

    for i:=0 to DragList.Count-1 do
    begin
      dd:=IDRec(DragList.Items[i]);
      if(dd.ilabel = dest)then
      DragList.Items[i]:=nil;
    end;
    DragList.Pack;
    if(DragList.Count = 0)then exit;

    if(Action = aiRenameTo)then
    begin //5
      Application.CreateForm(TFormRen,FormRen);
      FormRen.RenList:=DragList;
      FormRen.ShowModal;
      if(not FormRen.Execute)then exit;
    end; //5
    end; //7
    CurrJob.LFTop.Clear;
    //if(Action = aiNoop)then Action:=aiShow;
    for i:=0 to DragList.Count-1 do
    begin  //3
      dd:=IDRec(DragList.Items[i]);
      //dd.ifs:=clSelector;
      if(Action = aiCopyTo)or(Action = aiMoveTo)or(Action = aiMoveContentTo)then
      dd.ifs:=dest+'\'+dd.iname;
      dd.ifs:=AnsiReplaceText(dd.ifs,'\\','\');
      dd.actionindex:=Action;
      ClickListAdd(dd,CurrJob);
    end; //3
    Sync(CurrJob);
  end; //2
finally
DragList.Clear;
end;
except
FormLog.RecError('8001');
end;
end;

procedure UniRunTh.Execute;
begin
self.FreeOnTerminate:=true;
rj.PExecTh:=self;
try
try
ManP(rj);
finally
rj.PExecTh:=nil;
end;
except
FormLog.RecError('8002');
end;
end;

constructor UniRunTh2.Create(CreateSuspended: boolean);
begin
  inherited;
  ManP:=nil;
  ExPr:=nil;
  Snd:=nil;
  wdd:=nil;
  rj:=nil;
  Node:=nil;
  AllowExpansion:=nil;
  OpIndex:=-1;
  ddir:='';
  smask:='';
  mms:=nil;
end;

procedure CleanDirShow2(cv: CompData;recurse: boolean=true);
var
i: integer;
SrcJob: RJob;
begin
try
SrcJob:=cv.dirfrom.rj;
  for i:=0 to High(cv.achild)do
  begin
    SrcJob.PParentJob.DriveExec(jmRun,SrcJob.PParentJob.position-1);
    if(cv.achild[i].achild<>nil)then
    CleanDirShow2(cv.achild[i])
    else
    begin
      cv.achild[i].deleted:=true;
      cv.achild[i].iResult:=tiExecOK;
      if(cv.achild[i].iResult = tiExecErr)then continue;
      if(not(SrcJob.DeleteFrom(cv.achild[i])))then
      begin
        cv.achild[i].iResult:=tiExecErr;
        cv.achild[i].idd.ifs:=cv.achild[i].idd.ifs+','+cv.achild[i].idd.iname+'-'+SrcJob.LastJobError;
        //cv.achild[i].idd.parent.ifs:=cv.achild[i].idd.parent.ifs+','+cv.achild[i].idd.iname+'-'+SrcJob.LastJobError;
        cv.achild[i].parent.iResult:=tiExecErr;
        cv.achild[i].deleted:=false;
      end;
    end;
  end;
  if(recurse)and(cv.iResult <> tiExecErr)then
  begin
    SrcJob.PParentJob.DriveExec(jmRun,SrcJob.PParentJob.position-1);
    if(not(SrcJob.DeleteFrom(cv)))then
    begin
      cv.iResult:=tiExecErr;
      cv.idd.ifs:=cv.idd.ifs+','+cv.idd.iname+'-'+SrcJob.LastJobError;
      cv.deleted:=false;
    end else
      cv.deleted:=true;
  end;
except
//
end;
end;


procedure DrawCurrent(TVR: TTreeView;SelL: TRect);
var
tt,temp: TRect;
tr: TTReeNode;
begin
try
temp:=SelL;
if((TVR<>nil)and(TVR.Selected<>nil))then
    begin
      tr:=TVR.Selected;
      tt:=tr.DisplayRect(true);
      TVR.Canvas.Brush.Color:=TVR.Color;
      if((temp.Top<>tt.Top)and(temp.Bottom<>tt.Bottom))then
      TVR.Canvas.FrameRect(temp);
      temp:=tr.DisplayRect(true);
      TVR.Canvas.Brush.Color:=clRed;
      TVR.Canvas.FrameRect(temp);
      TVR.Canvas.Brush.Color:=TVR.Color;
      SelL:=temp;
    end;
except
//
end;
end;

procedure SyncDir(rj: RJob;SP: ShowProc1=nil;FormHide: ManHistProc=nil);
var
i,nn,dialbuttonsave,ncopy,ndel: integer;
ddir,sdir,represult,fname,fext,rendir,errstr,sfname: string;
Overwrite,notexec,gotoOnHandSusped: boolean;
CV: CompData;
SrcJob,DestJob: RJob;
DDD: TDList;
existsrec: Ddata;
label OnHandSusped;
begin
try
ncopy:=0;
ndel:=0;
rj.ExistsJobError:=false;
rj.DriveExec(jmRun,0,0,rj.LTop.Count);
dialbuttonsave:=bmNoButtons;
rj.StageStr:=mmGrSyncGoOn+#13#10+rj.StageStr;
for i:=0 to rj.LItems.Count-1 do
begin
DDD:= TDList(rj.LItems.Items[i]);
DDD.DPar.Disk.down:=0;
DDD.DPar.Disk.err:=0;
DDD.DPar.Disk.abort:=0;
DDD.DPar.Disk.changed:=true;
if(IsNan(DDD.DPar.Disk.requiredback))or(0>DDD.DPar.Disk.requiredback)or
(DDD.DPar.Disk.required>DDD.DPar.Disk.requiredback)then
DDD.DPar.Disk.requiredback:=DDD.DPar.Disk.required
else
DDD.DPar.Disk.required:=DDD.DPar.Disk.requiredback;
end;
SrcJob:=nil;
DestJob:=nil;
i:=0;
rj.StageStr:=mmGrSyncCopyingCycle+#13#10+rj.StageStr;
while i<rj.LTop.Count do
begin
try
  Inc(ncopy);
  if(rj.babort)then exit;
  notexec:=false;
  gotoOnHandSusped:=false;
  rj.bskip:=false;
  CV:=CompData(rj.LTop.Items[i]);
  CV.deleted:=false;
  CV.created:=false;
  if(SrcJob <> CV.dirfrom.rj)then SrcJob:=rj.BindChild(CV.dirfrom.rj);
  if(DestJob <> CV.dirto.rj)then DestJob:=rj.BindChild(CV.dirto.rj);
  CV.current:=true;
  if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=39;
  
  rj.MessStr:=mmFrom+CV.dirfrom.dname+'\'+CV.idd.iname;
  rj.MessStr1:=mmTo + CV.dirto.dname;
  rj.MessStr:=AnsiReplaceText(rj.MessStr,'\\','\');
  rj.MessStr1:=AnsiReplaceText(rj.MessStr1,'\\','\');
  DDD:= TDList(CV.dirto.pTDList);
  if(not(CV.iResult = aiNoop))then
  begin
    notexec:=true;
    case rj.RetryIndex of
      0: if(CV.iResult = tiExecAbort)then notexec:=false;
      1: if(CV.iResult = tiExecErr)then notexec:=false;
      2: notexec:=false;
    end;
  end;
  if((not CV.dirfrom.exclusive)and(CV.ilevel = 0))or
  ((notexec)or(CV.istate = aiShow))then
  begin
    Inc(i);
    continue;
  end;
  sdir:='';
  ddir:='';
  represult:='';
  rj.DialogButton:=dialbuttonsave;
  Overwrite:=true;
  nn:=0;

  if(rj.babort)then exit;
    if(CV.dirto.itype = dtDir)then
    begin //2
    CV.iResult:=tiExecErr;
    if(CV.dirto.fparam <> fpPlain)then
    begin
      ddir:=CV.dirto.dname+'\'+CV.idd.iname
    end else
    ddir:=CV.dirto.dname+'\'+ExtractFileName(CV.idd.iname);
    ddir:=AnsiReplaceText(ddir,'\\','\');
    if((rendir <> '')and(AnsiContainsText(ddir,fname)))then
    ddir:=AnsiReplaceText(ddir,fname,rendir);
  ///////////////////////////////
    if(not(rj.DialogButton in EnSkipErr))then
    begin
      case CV.dirfrom.over of
        opRenNew  : rj.DialogButton := bmRenNew;
        opRenOld  : rj.DialogButton := bmRenOld;
        opRenCycle: rj.DialogButton :=bmRenCycle;
        opAll     : rj.DialogButton := bmYesToAll;
        opNone    : rj.DialogButton := bmNoToAll;
      end;
    end;
  //////////////////////////////
    try
    if(CV.dirto.fparam <> fpPlain)then
    if(CV.idd.ntype = ntDir)then //3
    begin

      if((CV.parent = nil)or(not CV.parent.created))then
      begin//3.1
        fname:=ddir;
        if(CV.dirfrom.renameall)then
        begin
        ddir:=RenameMask(ddir,CV.dirfrom.renmask,nn,ntDir,rcRenAll,CV.idd);
        rendir:=ddir;
        end;
      if(not DestJob.GetPropTo(ddir,@existsrec,CV.dirto.dname+'\'))then
      begin    //4
        if(DestJob.CreateTo(ddir))then
        begin
          CV.iResult:=tiExecOK;
          CV.created:=true;
          if(fname <> ddir)then
          rendir:=ddir;
        end;
      end else
      begin    //4
        ////////////////////////////////
        if(@FormHide <> nil)and(rj.DialogButton = bmNoButtons)then
        begin
          rj.RDR.mess:=mmGrSyncExistDir;
          rj.RDR.fname:=CV.idd.iname;
          rj.RDR.dfrom:=CV.dirfrom.dname;
          rj.RDR.dto:=CV.dirto.dname;
          rj.RDR.isdir:=true;
          rj.RDR.requestflag:=true;
          rj.RDR.pCompData:=CV;
          rj.RDR.pIDRec:=@existsrec;
          rj.PExecTh.Suspend;
          if(rj.RDR.dbutton = bmSuspend)then raise EHandException.Create('Wait') ;//goto OnHandSusped;
          rj.DialogButton:=rj.RDR.dbutton;
          if(rj.DialogButton in EnSkipErr)then dialbuttonsave:=rj.DialogButton;
        end;
        /////////////////////////////////////////
        if(rj.DialogButton = bmRenOld)or(rj.DialogButton = bmRenAllOld)then
          begin
              while(
              (not DestJob.RenameDest(ddir,RenameMask(ddir,CV.dirfrom.renmask,nn,
              ntDir,rcIsExists,CV.idd)))and(nn < MaxRenNum)
              )do
              Inc(nn);
          end else
          if(rj.DialogButton = bmRenNew)or(rj.DialogButton = bmRenAllNew)then
          begin
              while((DestJob.ExistsS(ddir,false)and(nn < MaxRenNum)))do
              begin
                ddir:=RenameMask(fname,CV.dirfrom.renmask,nn,ntDir,rcIsExists,CV.idd);
                Inc(nn);
              end;
          end else
          if(CV.dirfrom.over = opRenCycle)then
          begin
            rj.StageStr:=mmCyclePrepare+#13#10+rj.StageStr;
            ddir:=DestJob.RenCycle(ddir,CV.dirfrom.rencycle);
            rj.StageStr:=mmGrSyncGoOn+#13#10+rj.StageStr;
          end;
        if(rj.DialogButton = bmCancel)or(rj.DialogButton = bmSuspend)then
        begin
          Inc(i);
          continue;
        end;
        if(((fname <> ddir))or(CV.dirfrom.over = opRenCycle)or(rj.DialogButton = bmRenOld)or
        (rj.DialogButton = bmRenAllOld))then
        begin
          if(DestJob.CreateTo(ddir))then
          begin
            CV.iResult:=tiExecOK;
            if(rj.DialogButton in EnRenameButtons)then rendir:=ddir;
            CV.created:=true;
          end;
        end else
          CV.iResult:=tiExecOK;
      end; //4
      end else //3.1
      begin
        if(DestJob.CreateTo(ddir))then
        begin
        CV.iResult:=tiExecOK;
        CV.created:=true;
        end;
      end; //3.1
    end else//3
    begin
    //if cv.idd is a file
      sdir:=CV.dirfrom.dname+'\'+CV.idd.iname;

        if(CV.dirfrom.renameall)then
        ddir:=RenameMask(ddir,CV.dirfrom.renmask,nn,ntFile,rcRenAll,CV.idd);
        if((CV.parent = nil)or(not CV.parent.created))then
        begin//3.2
        if(DestJob.GetPropTo(ddir,@existsrec,CV.dirto.dname+'\'))then
        begin
          ////////////////////////////////////
          fext:=ExtractFileExt(ddir);
          fname:=ChangeFileExt(ddir,'');
          if(@FormHide <> nil)and(rj.DialogButton = bmNoButtons)then
          begin
            rj.RDR.mess:=mmGrSyncExistFile;
            rj.RDR.fname:=CV.idd.iname;
            rj.RDR.dfrom:=CV.dirfrom.dname;
            rj.RDR.dto:=CV.dirto.dname;
            rj.RDR.isdir:=false;
            rj.RDR.requestflag:=true;
            rj.RDR.pCompData:=CV;
            rj.RDR.pIDRec:=@existsrec;
            rj.PExecTh.Suspend;
            if(rj.RDR.dbutton = bmSuspend)then raise EHandException.Create('Wait') ;//goto OnHandSusped;
            rj.DialogButton:=rj.RDR.dbutton;
            if(rj.DialogButton in EnSkipErr)then dialbuttonsave:=rj.DialogButton;
          end;
          if(rj.DialogButton = bmRenOld)or(rj.DialogButton = bmRenAllOld)then
          begin
              while(
              (not DestJob.RenameDest(ddir,RenameMask(ddir,CV.dirfrom.renmask,nn,
              ntFile,rcIsExists,CV.idd)))and(nn < MaxRenNum)
              )do
              Inc(nn);
          end else
          if(rj.DialogButton = bmRenNew)or(rj.DialogButton = bmRenAllNew)then
          begin
            sfname:=ddir;
              while((DestJob.ExistsS(ddir)and(nn < MaxRenNum)))do
              begin
                ddir:=RenameMask(sfname,CV.dirfrom.renmask,nn,ntFile,rcIsExists,CV.idd);
                Inc(nn);
              end;
          end else
          if(CV.dirfrom.over = opRenCycle)then
          begin
            rj.StageStr:=mmCyclePrepare+#13#10+rj.StageStr;
            ddir:=DestJob.RenCycle(ddir,CV.dirfrom.rencycle);
            rj.StageStr:=mmGrSyncGoOn+#13#10+rj.StageStr;
          end;
          ////////////////////////////////////
          if(rj.DialogButton = bmCancel)then
          begin
            Inc(i);
            continue;
          end;
          if((rj.DialogButton = bmNoToAll)or(rj.DialogButton = bmNo))then Overwrite:=false;
        end;
        end; //3.2
        if(Overwrite)then
        begin
          if(rj.CopyII(CV,ddir))then CV.iResult:=tiExecOK;
        end else
        CV.iResult:=tiExecErr;
    end;
    except
      on EHandException do gotoOnHandSusped:=true;
      else
      CV.iResult := tiExecErr;
    end;
    if(gotoOnHandSusped)then goto OnHandSusped;
    ///////////////////////////////////
    if(rj.babort)then exit;
  if(CV.iResult = tiExecErr)then
  begin
    represult:=rrFailure;
    errstr:=mmFrom+SrcJob.LastJobError+'<--->'+mmTo+DestJob.LastJobError;
    rj.MessStr:=mmFrom+SrcJob.LastJobError;
    rj.MessStr1:=mmTo+DestJob.LastJobError;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=34;
    if(CV.idd.root<>nil)and(CV.idd.root.timeexec = 0)then
    begin
      CV.idd.root.resultindex:=tiExecErr;
      if(CV.idd.root.itt<>nil)then
      CV.idd.root.itt.StateIndex:=tiExecErr;
      CV.idd.root.ifs:=CV.idd.root.ifs+','+errstr;
      CV.idd.root.timeexec:=Now;
    end;
    CV.idd.ifs:=CV.idd.ifs+','+errstr;
    rj.ExistsJobError:=true;
    DDD.DPar.Disk.err:=DDD.DPar.Disk.err+1;
    DDD.DPar.Disk.changed:=true;
  end else
  if(CV.iResult = tiExecOK)then
  begin
    DDD.DPar.Disk.down:=DDD.DPar.Disk.down+1;
    if(CV.idd.ntype = ntFile)then
    DDD.DPar.Disk.required:=DDD.DPar.Disk.required-CV.idd.isize;
    DDD.DPar.Disk.changed:=true;
    represult:=rrSuccess;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=33;
    if(CV.idd.root<>nil)and(CV.idd.root.timeexec = 0)then
    begin
      CV.idd.root.resultindex:=tiExecOK;
      if(CV.idd.root.itt<>nil)then  CV.idd.root.itt.StateIndex:=tiExecOK;
      CV.idd.root.ifs:=CV.idd.root.ifs+',"'+mmSuccessOperation+'"';
      CV.idd.root.timeexec:=Now;
    end;
  end;
  if(CV.dirfrom.report = rpAll)then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult)
  else
  if((CV.dirfrom.report = rpSuccess)and(represult = rrSuccess))then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult)
  else
  if((CV.dirfrom.report = rpFailure)and(represult = rrFailure))then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult);

  if(rj.bskip)then
  begin
    CV.iResult:=tiExecAbort;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=35;
    rj.bskip:=false;
    Dec(ncopy);
    DDD.DPar.Disk.abort:=DDD.DPar.Disk.abort+1;
    DDD.DPar.Disk.changed:=true;
  end;
  if(rj.pskip<>nil)and(rj.pskip^)then
  begin
    CV.iResult:=tiExecAbort;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=35;
    rj.pskip^:=false;
    Dec(ncopy);
    DDD.DPar.Disk.abort:=DDD.DPar.Disk.abort+1;
    DDD.DPar.Disk.changed:=true;
  end;

  if(@SP<>nil)and(not(rj.DialogButton in EnSkipErr))and(CV.iResult = tiExecErr)and(rj.StopOnError)then
  begin
    OnHandSusped:
    gotoOnHandSusped:=false;
    if(CV.cdItem <> nil)then
    CV.cdItem.MakeVisible(false)
    else
    SP(slcCurrent,i);
    //rj.MessStr:=errstr;
    rj.StageStr:=mmExecutionSuspended+#13#10+rj.StageStr;
    rj.CycleVar:=i;
    rj.PExecTh.Suspend;
    if(i <> rj.CycleVar)then
    begin
    i:=rj.CycleVar;
    continue;
    end;
  end;
    /////////////////////////////////////
    end; //2
    rj.DriveExec(jmRun,i);
    CV.current:=false;
    if(CV.cdItem<>nil)then
    CV.cdItem.SubItemImages[1]:=CV.istate;
    Inc(i);
    except
    //
    end;
end;//////////////////////////////////////////////
i:=0;
rj.StageStr:=mmGrSyncRemovingCycle+#13#10+rj.StageStr;
while i<rj.LTop.Count do //removing cycle
begin
try
if(rj.babort)then exit;
  Inc(ndel);
  CV:=CompData(rj.LTop.Items[i]);
  notexec:=false;
  if(not(CV.iResult = aiNoop))and(CV.istate <> aiMoveTo)and(CV.istate <> aiMoveContentTo)then
  begin
    notexec:=true;
    case rj.RetryIndex of
      0: if(CV.iResult = tiExecAbort)then notexec:=false;
      1: if(CV.iResult = tiExecErr)then notexec:=false;
      2: notexec:=false;
    end;
  end;
  if((not CV.dirfrom.exclusive)and(CV.ilevel = 0))or
  ((notexec)or(CV.istate = aiShow))then
  begin
    Inc(i);
    continue;
  end;
  if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=39;
  CV.current:=true;
  //**************************
  SrcJob:=CV.dirfrom.rj;
  SrcJob.pskip:=@rj.bskip;
  SrcJob.pabort:=@rj.babort;
  DestJob:=CV.dirto.rj;
  DestJob.pskip:=@rj.bskip;
  DestJob.pabort:=@rj.babort;
  //**************************
  rj.DriveExec(jmRun,rj.position-1);
if(not CV.deleted)then
begin
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  CV.iResult := tiExecOK;
  sdir:=CV.dirfrom.dname+'\'+CV.idd.iname;
  try
  case CV.istate of
    aiMoveToRecycle:
    if((CV.parent = nil)or((CV.parent <> nil)and(CV.parent.istate<>aiMoveToRecycle)))and
    (SrcJob.MoveToRecycle(sdir) <> 0)then CV.iResult := tiExecErr;
    aiDelete: CleanDirShow2(CV);
    aiMoveTo: CleanDirShow2(CV);
    aiRenameTo: if(CV.idd.ifs='')or(not(SrcJob.RenameSrc(CV,CV.idd.ifs)))then CV.iResult := tiExecErr;
    aiEmpty: CleanDirShow2(CV,false);
    aiEmptyToRecycle:
    if((CV.parent = nil)or((CV.parent <> nil)and(CV.parent.istate<>aiEmptyToRecycle)))and
    ((SrcJob.MoveToRecycle(sdir) <> 0)or(not(SrcJob.CreateFrom(CV))))then CV.iResult := tiExecErr;
    aiMoveContentTo:  CleanDirShow2(CV,false);
  end;
  except
  CV.iResult := tiExecErr;
  end;
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
end;
if(rj.babort)then exit;
  ////////////////////////////////////
  if(CV.iResult = tiExecErr)then
  begin
    represult:=rrFailure;
    errstr:=mmFrom+SrcJob.LastJobError+'<--->'+mmTo+DestJob.LastJobError;
    rj.MessStr:=mmFrom+SrcJob.LastJobError;
    rj.MessStr1:=mmTo+DestJob.LastJobError;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=34;
    if(CV.idd.root<>nil)and(CV.idd.root.timeexec = 0)then
    begin
      CV.idd.root.resultindex:=tiExecErr;
      if(CV.idd.root.itt<>nil)then  CV.idd.root.itt.StateIndex:=tiExecErr;
      CV.idd.root.ifs:=CV.idd.root.ifs+','+errstr;
      CV.idd.root.timeexec:=Now;
    end;
    CV.idd.ifs:=CV.idd.ifs+','+errstr;
    rj.ExistsJobError:=true;
  end else
  if(CV.iResult = tiExecOK)then
  begin
    represult:=rrSuccess;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=33;
    if(CV.idd.root<>nil)and(CV.idd.root.timeexec = 0)then
    begin
      CV.idd.root.resultindex:=tiExecOK;
      if(CV.idd.root.itt<>nil)then  CV.idd.root.itt.StateIndex:=tiExecOK;
      CV.idd.root.ifs:=CV.idd.root.ifs+',"'+mmSuccessOperation+'"';
      CV.idd.root.timeexec:=Now;
    end;
  end;

  if(CV.dirfrom.report = rpAll)then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult)
  else
  if((CV.dirfrom.report = rpSuccess)and(represult = rrSuccess))then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult)
  else
  if((CV.dirfrom.report = rpFailure)and(represult = rrFailure))then
  FormLog.RecGrSync(rj.Save.jobname,sdir,ddir,represult);

  if(rj.bskip)then
    begin
      CV.iResult:=tiExecAbort;
      if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=35;
      rj.bskip:=false;
      Dec(ndel);
    end;
    if(rj.pskip<>nil)and(rj.pskip^)then
    begin
      CV.iResult:=tiExecAbort;
      if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=35;
      rj.pskip^:=false;
      Dec(ndel);
    end;

  if(@SP<>nil)and(not(rj.DialogButton in EnSkipErr))and(CV.iResult = tiExecErr)and(rj.StopOnError)then
  begin
    if(CV.cdItem <> nil)then
    CV.cdItem.MakeVisible(false)
    else
    SP(slcCurrent,i);
    //rj.MessStr:=errstr;
    rj.StageStr:=mmExecutionSuspended+#13#10+rj.StageStr;
    rj.CycleVar:=i;
    rj.PExecTh.Suspend;
    if(i <> rj.CycleVar)then
    begin
    i:=rj.CycleVar;
    continue;
    end;
  end;
  ////////////////////////////////////
  CV.current:=false;
  if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=CV.istate;
  Inc(i);
  except
  //
  end;
end;   //removing cycle  /////////////////////////////////////////////////////////
//sleep(500);
rj.syncended:=true;
  if(rj.babort)then exit;
  if rj.ExistsJobError then
  begin
    rj.StageStr:=mmGrSyncSyncCompleteErr+#13#10+rj.StageStr;
    rj.DriveExec(jmFailure);
  end else
  begin
    rj.StageStr:=mmGrSyncSyncCompleteOk+#13#10+rj.StageStr;
    if(ncopy = rj.LTop.Count)and(ndel = rj.LTop.Count)then
    rj.DriveExec(jmSuccess)
    else
    rj.DriveExec(jmAbort);
  end;
  for i:=0 to rj.LChildren.Count-1 do
  RJob(rj.LChildren.Items[i]).needchecktree:=true;

  if(not rj.ExistsJobError)and(rj.CloseIfNoError)and(@FormHide<>nil)then FormHide;
  except
    FormLog.RecError('8004');
    rj.StageStr:=mmWosError+#13#10+rj.StageStr;
    rj.DriveExec(jmFailure);
  end;
end;

procedure ShowActions(rr: RJob;LVEvents: TListView);
var
i: integer;
hh: HistAct;
LL: TListItem;
ss: string;
begin
try
LVEvents.Items.Clear;
for i:=0 to rr.LActions.Count-1 do
begin
hh:=HistAct(rr.LActions.Items[i]);
LL:=LVEvents.Items.Add;
LL.Caption:=WhatTypesStr[hh.what];
LL.ImageIndex:=hh.what+14;
LL.SubItems.Add('');
LL.SubItems.Add('');
LL.SubItems.Add('');
LL.SubItems.Add('');
  case hh.units of
  ubytes: ss:=FloatToStr(hh.value);
  uKb:    ss:=FloatToStr(RoundTo(hh.value/1024,-3));
  uMb:    ss:=FloatToStr(RoundTo(hh.value/1024/1024,-3));
  uGb:    ss:=FloatToStr(RoundTo(hh.value/1024/1024/1024,-2));
  end;
LL.SubItems.Strings[0]:=ss+' '+eUnitsTypesStr[hh.units];
LL.SubItems.Strings[1]:=hh.where;
LL.SubItems.Strings[2]:=eActionsTypesStr[hh.action];
LL.SubItems.Strings[3]:=hh.operation;
LL.SubItemImages[2]:=hh.action;
LL.Data:=hh;
end;
except
//
end;
end;

procedure CloneTree(src,dest: TTreeView);
var
i,j: integer;
LS,LD: TList;
sn,dn: TTreeNode;
begin
LS:= TList.Create;
LD:= TList.Create;
try
  try
    for i:=0 to src.Items.Count-1 do LS.Add(src.Items.Item[i]);
    for i:=0 to dest.Items.Count-1 do LD.Add(dest.Items.Item[i]);

    for i:=0 to LS.Count-1 do
    begin
      if(LS.Items[i] = nil)then continue;
      sn:=TTreeNode(LS.Items[i]);
      for j:=0 to LD.Count-1 do
      begin
        if(LD.Items[j] = nil)then continue;
        dn:=TTreeNode(LD.Items[j]);
        if(sn.Text = dn.Text)and(i = j)then
        begin
          dn.Expanded:=sn.Expanded;
          LS.Items[i]:=nil;
          LD.Items[i]:=nil;
        end;
      end;
    end;
    //New nodes
    for i:=0 to LS.Count-1 do
    begin
      if(LS.Items[i] = nil)then continue;
      sn:=TTreeNode(LS.Items[i]);
      if(sn.Parent = nil)then  
      dn:=dest.Items.Add(nil,sn.Text)
      else
      dn:=dest.Items.AddChild(nil,sn.Text);
      //dn:=dest.Items.InsertObject(sn.Parent,sn.Text,sn.Data);
      dn.Assign(sn);
    end;
    //del nodes
    for j:=0 to LD.Count-1 do
    begin
      if(LD.Items[j] = nil)then continue;
      dn:=TTreeNode(LD.Items[j]);
      dn.Delete;
    end;
  finally
    LS.Free;
    LD.Free;
  end;
except
FormLog.RecError('8005');
end;
end;

function GetRec(dd: string;rj: RJob): IDRec;
var
p1,len,i: integer;
path,aa: string;
sd,mm: IDRec;
isfind: boolean;
begin
Result:=nil;
try
  sd:=nil;
  path:=dd;
  mm:=nil;
  if(dd<>'')then
  begin
  p1:=Pos('\',path);
  aa:=MidStr(path,0,p1);
  len:=Length(path);
  path:=MidStr(path,p1+1,len);
  isfind:=false;
  for i:=0 to rj.LItems.Count-1 do
  begin
    mm:=IDRec(rj.LItems.Items[i]);
    if((mm.ntype in EnDisk)and(mm.iname = aa))then
    begin
      isfind:=true;
      break;
    end;
  end;
  p1:=Pos('\',path);
  if((isfind)and(mm<>nil))then
  begin
  while p1>0 do
  begin
    if(not isfind)then
    begin
    mm:=nil;
    break;
    end;
    aa:=MidStr(path,0,p1);
    len:=Length(path);
    path:=MidStr(path,p1+1,len);
    isfind:=false;
    for i:=0 to High(mm.ichild) do
    begin
      if(mm.ichild[i].iname = aa)then
      begin
        mm:=mm.ichild[i];
        isfind:=true;
        break;
      end;
    end;
    p1:=Pos('\',path);
  end;
  len:=Length(path);
  if(len>0)then
  begin
    aa:=path;
    isfind:=false;
    for i:=0 to High(mm.ichild) do
    begin
      if(mm.ichild[i].iname = aa)then
      begin
        mm:=mm.ichild[i];
        isfind:=true;
        break;
      end;
    end;
  end;
    if(not isfind)then
    mm:=nil;
    sd:=mm;
  end;
  end;
Result:=sd;
except
//
end;
end;

procedure CheckJobEvents(rj: RJob;isbegin: boolean = false);
var
i: integer;
hh: HistAct;
rr: IDRec;
begin
try
for i:=0 to rj.LActions.Count-1 do
begin
  hh:=HistAct(rj.LActions.Items[i]);
  rr:=GetRec(hh.where,rj);
  if(hh.what = wBEGINNING)then
  begin
    if(isbegin)then
    FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
  end else
  begin
  if(isbegin)then continue;
  case hh.what of
    wMIN_FREE:
    begin
      if(rr <> nil)then
      if((rr.ntype in EnDisk)and(rr.ichild<>nil))then
      if(rr.ichild[0].isize<=hh.value)then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
    wMAX_BUSY:
    begin
      if(rr <> nil)then
      if((rr.ntype in EnDisk)and(rr.ichild<>nil))then
      if(rr.ichild[1].isize >= hh.value)then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
    wMAX_SIZE:
    begin
      if(rr <> nil)then
      if(rr.isize >= hh.value)then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
    wCHANGE:
    begin
      if(rr <> nil)then
      if((rr.isize <> hh.value)or(rj.change>0))then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj,mmChange+IntToStr(rj.change));
    end;
    wCOMPLETION:
    begin
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
    wAPPEAR:
    begin
      if(rj.appear > 0)then
    FormLog.RunAction(hh.action,hh.operation,hh.mess,rj,mmAppear+IntToStr(rj.appear));
    end;
    wDISAPPEAR:
    begin
      if(rj.disappear > 0)then
    FormLog.RunAction(hh.action,hh.operation,hh.mess,rj,mmDisAppear+IntToStr(rj.disappear));
    end;
    wSUCCESS:
    begin
      if(JobHist(rj.LHist.Last).jsuccess = jmSuccess)then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
    wFAILURE:
    begin
      if(JobHist(rj.LHist.Last).jsuccess = jmFailure)then
      FormLog.RunAction(hh.action,hh.operation,hh.mess,rj);
    end;
  end;
  end;
end;
except
//
end;
end;

function GetError: string;
var
arr: array[0..254] of char;
ret: Cardinal;
begin
Result:=mmOkErr;
try
ret:=GetLastError();
if(ret <> ERROR_SUCCESS)then
begin
FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM ,nil,ret,0,arr,254,nil);
Result:='"'+arr+'"';
Result:=AnsiReplaceText(Result,#13#10,'');
end;
except
//
end;
end;

function ExtractFileDrive(const FileName: string): string;
var
pos1: Integer;
begin
Result:=FileName;
try
  pos1:=Pos(':\',FileName);
  if(pos1>0)then
  begin
  Result :=LeftStr(FileName,pos1+1);
  end else Result := '';
except
//
end;
end;

procedure UniRunTh2.FreeFrame;
begin
fff.mtp(@fff.Save,fff.TTab.PageControl,false);
end;

procedure UniRunTh2.Execute;
begin
  self.FreeOnTerminate:=true;
  if(rj<>nil)then
  rj.PExecTh:=self;
  try
    try
      case OpIndex of
        0: ManP(Snd);
        1: ExPr(Snd,Node,AllowExpansion^);
        2: Synchronize(FreeFrame);
      end;
    finally
      if(rj<>nil)then   rj.PExecTh:=nil;
    end;
  except
  FormLog.RecError('8003');
  end;
end;

procedure SaveSystem(gg: RJobSave);
var
ms: TMemoryStream;
rr: JobRecord;
begin
try
if(not DirectoryExists(AppPath))then ForceDirectories(AppPath);
ms:= TMemoryStream.Create;
try
  Move(gg^,rr,sizeof(rr));
  rr.successidicator:=msSuccsess;
  ms.Write(rr,sizeof(rr));
ms.SaveToFile(AppPath+'System\'+gg.sysname+'.sys');
finally
ms.Free;
end;
except
//
end;
end;

procedure LoadSystems;
var
numb,ssize,h1: integer;
ms: TMemoryStream;
gg: RJobSave;
dg: JobRecord;
sr: TSearchRec;
begin
ms:= TMemoryStream.Create;
try
  try
  h1:=FindFirst(AppPath+mmSystem+'*',faAnyFile,sr);
  if h1 = 0 then
  begin //2
    if((sr.Attr and faDirectory)<> 0)then
    FindNext(sr);
    while FindNext(sr) = 0 do
    begin //3
      ms.Clear;
      if(not MatchesMask(sr.Name,'*.sys'))then  continue;
      ms.LoadFromFile(AppPath+mmSystem+sr.Name);
      ssize:= sizeof(dg);
      numb:=ms.Read(dg,ssize);
      if(numb = ssize)then
      begin //1
        if(dg.successidicator <> msSuccsess)then continue;
       // if(dg.jobtype = jtRemoteFTP)then
       // begin
          New(gg);
          Move(dg,gg^,sizeof(dg));
          LSystem.Add(gg);
       // end;
      end else //1
      FormLog.RecError(mmErrReadSystem+sr.Name);
      end;//3
    end; //2
  finally
  ms.Free;
  FindClose(sr);
  end;
except
FormLog.RecError('8006');
end;
end;

procedure SetFTPprop(sff:RJobSave;ff: FTPJob);
begin
try
    ff.mFTP.Account:=          sff.isFTP.Account;
    ff.mFTP.Asynchronous:=     sff.isFTP.Asynchronous;
    ff.mFTP.Cache:=            sff.isFTP.Cashe;
    ff.mFTP.CacheExpire:=      sff.isFTP.CacheExpire;
    ff.mFTP.FileMask:=         sff.isFTP.FileMask;
    ff.mFTP.InitialDirectory:= sff.isFTP.InitialDirectory;
    ff.mFTP.MultiThreaded:=    sff.isFTP.MultiThreaded;
    ff.mFTP.NoopInterval:=     sff.isFTP.NoopInterval;
    ff.mFTP.Passive:=          sff.isFTP.Passive;
    ff.mFTP.Password:=         sff.isFTP.Password;
    ff.mFTP.Port:=             sff.isFTP.Port;
    ff.mFTP.ProxyPassword:=    sff.isFTP.ProxyPassword;
    ff.mFTP.ProxyPort:=        sff.isFTP.ProxyPort;
    ff.mFTP.ProxyServer:=      sff.isFTP.ProxyServer;
    ff.mFTP.ProxyType:=TMFtpProxyType(sff.isFTP.ProxyType);
    ff.mFTP.ProxyUsername:=    sff.isFTP.ProxyUser;
    ff.mFTP.Retries:=          sff.isFTP.Retries;
    ff.mFTP.RetryInterval:=    sff.isFTP.RetryInterval;
    ff.mFTP.Server:=           sff.isFTP.Server;
    ff.mFTP.ServerType:=TMFtpServerType(sff.isFTP.ServerType);
    ff.mFTP.TimeOut:=          sff.isFTP.TimeOut;
    ff.mFTP.TransferMode:=TMFtpTransferType(sff.isFTP.TransferMode);
    ff.mFTP.Username:=         sff.isFTP.User;
except
//
end;
end;

procedure RefreshSystems(LV: TListView);
var
KL: TListItem;
i: integer;
rr: RJobSave;
begin
try
  LV.Clear;
  for i:=0 to LSystem.Count-1 do
  begin
    KL:= LV.Items.Add;
    rr:=RJobSave(LSystem.Items[i]);
    KL.Data:=rr;
    KL.Caption:=rr.sysname;
    if(rr.jobtype = jtRemoteFTP)then KL.SubItems.Add('FTP');
    if(rr.jobtype = jtRemoteNative)then KL.SubItems.Add('Native');
  end;
except
//
end;
end;

procedure DestroyRec(sd: IDRec);
var
hh: integer;
prev: IDRec;
begin
try
  if(sd.ichild<>nil)then EmptyTreeNode(sd.trr,false);
  if(sd.parent<>nil)then
  begin
    prev:=sd.parent;
    sd.parent:=nil;
    PopChild(sd,prev);
  end;
  if(sd.trr<>nil)then
  sd.trr.Delete;
  sd.trr:=nil;
  if(sd.itt<>nil)then
  sd.itt.Delete;
  sd.itt:=nil;
  hh:=sd.rj.LView.IndexOf(sd);
  if(hh>=0)then
  sd.rj.LView.Delete(hh);
  hh:=sd.rj.LFView.IndexOf(sd);
  if(hh>=0)then
  sd.rj.LFView.Delete(hh);
  hh:=sd.rj.LItems.IndexOf(sd);
  if(hh>=0)then
  sd.rj.LItems.Items[hh]:=nil;

  if(sd.PNotify<>nil)then
  begin
    WatchTreeThr(sd.PNotify).rr:=nil;
    WatchTreeThr(sd.PNotify).rec:=nil;
    WatchTreeThr(sd.PNotify).Terminate;
    sd.PNotify:=nil;
  end;
  hh:=sd.rj.QNot.IndexOfObject(TObject(sd));
  if(hh >= 0)then
  sd.rj.QNot.Delete(hh);
  Finalize(sd^);
  Dispose(sd);
except
//
end;
end;

procedure Sync(rr: RJob;bshow: boolean=true);
var
jj: JobHist;
nn: TDateTime;
GGG: GrSyncTh;
begin
try
if(rr<>nil)then
begin
if(not rr.complete)then
begin
MessageDlg(rr.Save.jobname + mmJobIsRunning2, mtInformation	, [mbOK], 0);
exit;
end;
  New(jj);
  nn:=Now;
  jj.jstart:=nn;
  jj.jstop:=0;
  jj.jsuccess:=0;
  jj.listind:=rr.LHist.Add(jj);
  rr.pLastHist:=jj;
  rr.Save.lasttim:=nn;
  jj.starter:=rr.starter;
  if(bshow)then
  begin
    Application.CreateForm(TFormGrSync,FormGrSync);
    FormGrSync.FreeOnRelease;
    //if(rr.Save.jobname)then
    FormGrSync.LTo.Caption:=rr.Save.jobname;
    FormGrSync.Show;
    GGG:=GrSyncTh.Create(true);
    GGG.FreeOnTerminate:=true;
    GGG.FGS:=FormGrSync;
    GGG.rj:=nil;
    GGG.rt:=rr;
    GGG.Resume;
    //FormGrSync.ExecGrSync(rr);
  end else
  begin
    GGG:=GrSyncTh.Create(true);
    GGG.FreeOnTerminate:=true;
    GGG.FGS:=nil;
    GGG.rj:=nil;
    GGG.rt:=rr;
    GGG.Resume;
  end;
end;
except
//
end;
end;

procedure CopyPExList(src: DirP;dest: DirP);
var
i: integer;
begin
try
  if(src.PExList<>nil)then
  begin
    dest.PExList:=TStringList.Create;
    for i:=0 to src.PExList.Count-1 do
    dest.PExList.Add(src.PExList.Strings[i]);
    //dest.PExList.Assign(src.PExList);
  end;
except
//
end;
end;

function  CheckJob(dname: string;rjinit,rjtemp: RJob;dp: DirP;dr: IDRec;pTempL: Pointer=nil): RJob;
var
i: integer;
dd: string;
rs,rd: RJobSave;
ff: FTPJob;
trj: RJob;
begin
Result:=nil;
try
  if(dp<>nil)then
  begin
  ///////////////////////////////
    if(dp.rj<>nil)then
    begin
      Result:=dp.rj;
      exit;
    end;
    //////////////////////
  end else
  if(dr<>nil)then
  begin
    if(dr.rj<>nil)then
    begin
      Result:=dr.rj;
      exit;
    end;
  end else
  if(not AnsiContainsStr(dname,':\'))then
  begin
    Result:=rjtemp;
    exit;
  end;
  //////////////////////
  rd:=nil;
  dd:=ExtractFileDrive(dname);
  if(Length(dd) = 3)then  //local system
  Result:=rjinit
  else
  begin
    for i:=0 to TwinList.Count-1 do
    begin
      trj:= RJob(TwinList.Items[i]);
      if(trj.Save.sysname+':\' = dd)then
      begin
      Result:=trj;
      exit;
      end;
    end;
    for i:=0 to LSystem.Count-1 do
    begin
      rs:=RJobSave(LSystem.Items[i]);
      if(rs.sysname+':\' = dd)then
      begin
      rd:=rs;
      break;
      end;
    end;
    if(rd = nil)then exit
    else
    begin
      if(rd.jobtype = jtRemoteFTP)then
      begin //1
        ff:=FTPJob.Create;
        Move(rd^,ff.Save,sizeof(rd^));
        SetFTPprop(rd,ff);
        ff.mFTP.Asynchronous:=false;
        ff.Save.jobkind:=jkTemp;
        if(pTempL = nil)then
        begin
          ff.listindex:=rjtemp.LTemp.Add(ff);
          ff.Start(false);
        end else
        begin
          ff.listindex:=TList(pTempL).Add(ff);
          ff.Start;
        end;
        Result:=ff;
      end;
      //other jobs
    end;
  end;//if(Length(dd) = 3)then  local system
except
FormLog.RecError('8031');
end;
end;


function SyncPrepare(rr: RJob): RJob;
function FindRootDir(ddir: string;TempJ: RJob): TDList;
var
i: integer;
LVI: TDList;
begin
Result:=nil;
try
  for i:=0 to Tempj.LItems.Count-1 do
  begin
    LVI:= TDList(Tempj.LItems.Items[i]);
    if(LVI.DPar.dname = ddir)then
    begin
      Result:=LVI;
      break;
    end;
  end;
except
//
end;
end;

procedure CopyDPar(s1,s2: DirP);
var
i: integer;
begin
try
s2.direct      :=s1.direct;
s2.report      :=s1.report;
s2.fparam      :=s1.fparam;
s2.over        :=s1.over;
s2.rencycle    :=s1.rencycle;
s2.fattr       :=s1.fattr;
s2.listind     :=s1.listind;
s2.itype       :=s1.itype;
s2.dname       :=s1.dname;
s2.groupname   :=s1.groupname;
s2.mask        :=s1.mask;
s2.renmask     :=s1.renmask;
s2.notifyfilter:=s1.notifyfilter;
for i:=0 to 7 do
s2.notfilt[i]  :=s1.notfilt[i];
for i:=0 to 6 do
s2.fattrarr[i] :=s1.fattrarr[i];
s2.subdirs     :=s1.subdirs;
s2.exclusive   :=s1.exclusive;
s2.notify      :=s1.notify;
s2.maskignoredir:=s1.maskignoredir;
s2.renameall   :=s1.renameall;
s2.compare     :=s1.compare;
except
//
end;
end;

var
i,dtype,len: integer;
LVI,LVD: TDList;
dd: IDRec;
ppath: string;
TempJ,rtr: RJob;
begin
Result:=nil;
try
TempJ:=RJob.Create;
Result:=TempJ;
TempJ.BindChild(rr);
TempJ.Save.jobkind:=jkTemp;
TempJ.Save.jobname:='temp';
TempJ.StopOnError:=true;
TempJ.RetryIndex:=0;
TempJ.CloseIfNoError:=true;

  if(rr.Save.jobkind = jkSync)then
  begin
    for i:=0 to rr.LItems.Count-1 do
    begin
      rtr:=CheckJob(DirP(rr.LItems.Items[i]).dname,rr,TempJ,DirP(rr.LItems.Items[i]),nil,nil);
      if(rtr = nil)then continue;
      LVI:= TDList.Create;
      LVI.idroot:=nil;
      Move(DirP(rr.LItems.Items[i])^,LVI.DPar,sizeof(LVI.DPar));
      CopyDPar(DirP(rr.LItems.Items[i]),@LVI.DPar);
      LVI.DPar.rj:=rtr;
      TempJ.BindChild(LVI.DPar.rj);
      LVI.DPar.itype:=dtDir;
      LVI.DPar.compare:=false;
      CopyPExList(DirP(rr.LItems.Items[i]),@LVI.DPar);
      LVI.pDirTo:=nil;
      LVI.DPar.pTDList:=LVI;
      TempJ.LItems.Add(LVI);
      if(LVI.DPar.fparam = fpEmpty)or(LVI.DPar.fparam = fpSmartSlave)then
      begin
        LVD:=FindRootDir(tsDelete,TempJ);
        if(LVD = nil)then
        begin
        LVD:= TDList.Create;
        TempJ.LItems.Add(LVD);
        LVD.DPar.direct:=dpIn;
        LVD.DPar.itype:=dtDelete;
        LVD.idroot:=nil;
        LVD.DPar.rj:=rr;
        LVD.DPar.report:=rpNone;
        LVD.DPar.over:=opAsk;
        LVD.DPar.rencycle:=1;
        LVD.DPar.dname:=tsDelete;
        LVD.DPar.groupname:=rr.Save.jobname;
        end;
        LVI.pDirTo:=LVD;
      end;
      if(LVI.DPar.fparam = fpRename)then
      begin
        LVD:=FindRootDir(tsRename,TempJ);
        if(LVD = nil)then
        begin
        LVD:= TDList.Create;
        TempJ.LItems.Add(LVD);
        LVD.DPar.direct:=dpIn;
        LVD.DPar.itype:=dtRename;
        LVD.idroot:=nil;
        LVD.DPar.rj:=rr;
        LVD.DPar.report:=rpNone;
        LVD.DPar.over:=opAsk;
        LVD.DPar.rencycle:=1;
        LVD.DPar.dname:=tsRename;
        LVD.DPar.groupname:=rr.Save.jobname;
        end;
        LVI.pDirTo:=LVD;
      end;
    end;
  end else
  begin
    for i:=0 to rr.LFTop.Count-1 do
    begin //1
      if(rr.LFTop.Items[i] = nil)then continue;
      dd:=IDRec(rr.LFTop.Items[i]);
      if(dd.actionindex = aiNoop)then continue;
      if(dd.ifs = clSelector)then dd.ifs := '';
      if(dd.resultindex >=0)then continue;

      if(dd.actionindex = aiProperties)then
      begin
      dd.actionindex:=aiShow;
      TempJ.needshowprop:=true;
      end;
        if(dd.actionindex = aiMoveContentTo)or(dd.actionindex = aiCompare)then
        begin
          ppath:=dd.ilabel;
        end else
        begin
          ppath:=ExtractFilePath(dd.ilabel);;
        end;
        ppath:=AnsiReplaceStr(ppath,'\\','\');
        len:=Length(ppath);
        if(LastDelimiter(':',ppath)>(len-1))and(LastDelimiter('\',ppath) = len)then
        Delete(ppath,Length(ppath),1);
        LVI:=FindRootDir(ppath,TempJ);
        if(LVI = nil)or(dd.actionindex = aiCompare)then    //this is a source job
        begin
          LVI:= TDList.Create;
          TempJ.LItems.Add(LVI);
          LVI.idroot:=nil;
          LVI.pDirTo:=nil;
          LVI.DPar.pTDList:=LVI;
          //if(dd.rj = nil)then
          LVI.DPar.rj:=CheckJob(ppath,rr,TempJ,nil,dd,nil);
          //else
          //LVI.DPar.rj:=dd.rj;
          TempJ.BindChild(LVI.DPar.rj);
          LVI.DPar.itype:=dtDir;
          LVI.DPar.direct:=dpOut;
          LVI.DPar.fparam:=fpMaster;
          if(dd.actionindex = aiCompare)then
          begin
          LVI.DPar.direct:=dpInOut;
          LVI.DPar.fparam:=fpLastWrite;
          LVI.DPar.compare:=true;
          end;
          LVI.DPar.dname:=ppath;
          LVI.DPar.groupname:=rr.Save.jobname;
          LVI.DPar.PExList:=TStringList.Create;
          if(dd.actionindex = aiMoveContentTo)then
          LVI.DPar.exclusive:=false
          else
          LVI.DPar.exclusive:=true;
        end;
        if(dd.actionindex <> aiMoveContentTo)and(dd.actionindex <> aiCompare)then
        LVI.DPar.PExList.AddObject(ExtractFileName(dd.iname),@(dd^));
        //source
        //--------
        //destination
        if(dd.actionindex = aiCompare)then continue;
        dtype:=dtShow;
        case dd.actionindex of
          aiShow           :
            begin
            ppath:=tsShow;
            dtype:=dtShow;
            end;
          aiMoveToRecycle  :
            begin
            ppath:=tsRecycle;
            dtype:=dtRecycle;
            end;
          aiDelete         :
            begin
            ppath:=tsDelete;
            dtype:=dtDelete;
            end;
          aiCopyTo         :
            begin
            ppath:=ExtractFilePath(dd.ifs);
            dtype:=dtDir;
            end;
          aiMoveTo         :
            begin
            ppath:=ExtractFilePath(dd.ifs);
            dtype:=dtDir;
            end;
          aiRenameTo       :
            begin
            ppath:=tsRename;
            dtype:=dtRename;
            end;
          aiEmpty          :
            begin
            ppath:=tsDelete;
            dtype:=dtDelete;
            end;
          aiEmptyToRecycle :
            begin
            ppath:=tsRecycle;
            dtype:=dtRecycle;
            end;
          aiMoveContentTo  :
            begin
            ppath:=ExtractFilePath(dd.ifs);
            dtype:=dtDir;
            end;
          aiCompare        :
            begin
            ppath:=tsShow;
            dtype:=dtShow;
            end;
        end;
        ppath:=AnsiReplaceStr(ppath,'\\','\');
        len:=Length(ppath);
        if(LastDelimiter(':',ppath)>(len-1))and(LastDelimiter('\',ppath) = len)then
        Delete(ppath,Length(ppath),1);
          LVD:=FindRootDir(ppath,TempJ);
          if(LVD = nil)then     //this ia a dest job
          begin
            LVD:= TDList.Create;
            if(dtype = dtShow)then
            TempJ.LItems.Insert(0,LVD)
            else
            TempJ.LItems.Add(LVD);
            LVD.idroot:=nil;
            //if(dd.rj = nil)then
            LVD.DPar.rj:=CheckJob(ppath,rr,TempJ,nil,nil,nil);//(ppath,rr,TempJ,nil,dd,nil);
            //else
            //LVD.DPar.rj:=dd.rj;
            //LVD.DPar.rj:=rr;
            TempJ.BindChild(LVD.DPar.rj);
            LVD.DPar.itype:=dtype;
            LVD.DPar.dname:=ppath;
            LVD.DPar.groupname:=rr.Save.jobname;
          end;
        LVI.pDirTo:=LVD;
    end;
  end;
except
FormLog.RecError('8030');
end;
end;

procedure InvokeShutDown;
begin
try
Application.CreateForm(TFormShutDown,FormShutDown);
FormShutDown.ShowModal;
if(FormShutDown.Confirmation)then
begin
windows.Beep(3000,500);
ShutDown;
Application.Terminate;
end;
except
//
end;
end;

procedure ShowWinIcons(Item: TListItem;ico: TIcon);
var
FileInfo: TSHFileInfo;
irect: TRect;
dd: IDRec;
begin
try
dd:= IDRec(Item.Data);
if(dd.ntype = ntDir)then exit;
//SHGetFileInfo(PChar(GetTreePath(dd)),0,FileInfo,sizeof(FileInfo),SHGFI_SYSICONINDEX or
if(SHGetFileInfo(PChar(dd.ilabel),0,FileInfo,sizeof(FileInfo),SHGFI_SYSICONINDEX or
SHGFI_ICON or SHGFI_SMALLICON)=0)then exit;
try
Item.ImageIndex:=-1;
ico.Handle:=FileInfo.hIcon;
irect:=Item.DisplayRect(drIcon);
Item.ListView.Canvas.Draw(irect.Left,irect.Top,ico);
finally
DestroyIcon(FileInfo.hIcon);
end;
except
FormLog.RecError('8007');
end;
end;

procedure ShowWinIcons2(Item: TListItem;ico: TIcon);
var
FileInfo: TSHFileInfo;
irect: TRect;
cc: CompData;
begin
try
cc:= CompData(Item.Data);
if(Item.Data = nil)or(cc.idd.ntype = ntDir)then exit;
cc.idd.ilabel:=AnsiReplaceStr(cc.idd.ilabel,'\\','\');
//SHGetFileInfo(PChar(GetTreePath(dd)),0,FileInfo,sizeof(FileInfo),SHGFI_SYSICONINDEX or
if(SHGetFileInfo(PChar(cc.idd.ilabel),0,FileInfo,sizeof(FileInfo),SHGFI_SYSICONINDEX or
SHGFI_ICON or SHGFI_SMALLICON)=0)then exit;
try
Item.ImageIndex:=-1;
ico.Handle:=FileInfo.hIcon;
irect:=Item.DisplayRect(drIcon);
Item.ListView.Canvas.Draw(irect.Left,irect.Top,ico);
finally
DestroyIcon(FileInfo.hIcon);
end;
except
FormLog.RecError('8008');
end;
end;


procedure InvokeDlg(rj: RJob);
var
FormReqDialog11: TFormReqDialog;
begin
if(rj.RDR.lockjob)then exit;
try
  try
  rj.RDR.lockjob:=true;
  Application.CreateForm(TFormReqDialog,FormReqDialog11);
  FormReqDialog11.rj:=rj;
  //windows.SetForegroundWindow(FormReqDialog1.Handle);
  FormReqDialog11.ShowModal;
  rj.RDR.dbutton:=FormReqDialog11.dialbutton;
  rj.RDR.requestflag:=false;
  TThread(rj.PExecTh).Resume;
  finally
  FormReqDialog11.Free;
  rj.RDR.lockjob:=false;
  end;
except
FormLog.RecError('8009');
end;
end;

function GetWinType: TWinType;
var
  VersionInfo: TOSVersionInfo;
begin
  Result := wtUnknown;
try
  VersionInfo.dwOSVersionInfoSize := SizeOf(VersionInfo);
  GetVersionEx(VersionInfo);
  case VersionInfo.dwPlatformId of
    VER_PLATFORM_WIN32S        : Result := wtWin32s;
    VER_PLATFORM_WIN32_WINDOWS : Result := wtWindows95;
    VER_PLATFORM_WIN32_NT      : Result := wtWindowsNT;
  end;
except
//
end;
end;

procedure ShutDown;
var
  hToken: THandle;
  tkp: TTokenPrivileges;
  P: Pointer;
  WinType: boolean;
begin
try
  if GetWinType=wtWindowsNT then WinType := True else WinType := False;
  if WinType then // If NT
    begin
      OpenProcessToken(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken);
      P:=nil;
      LookupPrivilegeValue(nil,'SeShutdownPrivilege',tkp.Privileges[0].Luid);
      tkp.PrivilegeCount:= 1;
      tkp.Privileges[0].Attributes:= SE_PRIVILEGE_ENABLED;
      AdjustTokenPrivileges(hToken, FALSE, tkp, 0, TTokenPrivileges(P^), DWORD(P^));
      ExitWindowsEx(EWX_SHUTDOWN OR EWX_FORCE OR EWX_POWEROFF, 0);
      //InitiateSystemShutdown(nil, 'DirSync Shutting Down your System', 10, True, False);
      tkp.Privileges[0].Attributes:= 0;
      AdjustTokenPrivileges(hToken, FALSE, tkp, 0,TTokenPrivileges(P^),DWORD(P^));
    end
  else
    ExitWindowsEx(EWX_SHUTDOWN OR EWX_FORCE OR EWX_POWEROFF, 0);
except
//
end;
end;

procedure ReSortTop(TBShowAllFDown,TBIcoDown: boolean;rj: RJob;LVTop: TListView);
begin
try
  try
  rj.DriveExec(jmRun,8,0,9);
  rj.NowScan:=mmFiltering_Top;
  rj.DriveExec(jmRun,9);
  rj.NowScan:=mmSorting_Top;
  rj.SortList(lnLFTop);
  ShowRecords(TBShowAllFDown,TBIcoDown,slcFirst,rj,LVTop);
  rj.NowScan:='';
  finally
    rj.DriveExec(jmSuccess);
  end;
except
FormLog.RecError('8010');
end;
end;

procedure AnalyzeTop(rj: RJob);
var
i: integer;
rr: IDRec;
aa,ss,dd,ff: TStringList;
begin
try
aa:=TStringList.Create;
ss:=TStringList.Create;
dd:=TStringList.Create;
ff:=TStringList.Create;

aa.Sorted:=true;
ss.Sorted:=true;
dd.Sorted:=true;
ff.Sorted:=true;

aa.Duplicates:=dupIgnore;
ss.Duplicates:=dupIgnore;
dd.Duplicates:=dupIgnore;
ff.Duplicates:=dupIgnore;

try
for i:=0 to rj.LTop.Count-1 do
begin
  rr:=IDRec(rj.LTop.Items[i]);
  if(rr.ntype >= ntFile)then
  begin
  aa.Add(ExtractFileExt(rr.iname));

  ss.Add(DateToStr(rr.timeaccess));
  ss.Add(DateToStr(rr.timewrite));
  ss.Add(DateToStr(rr.timecheck));
  
  ff.Add(TimeToStr(rr.timeaccess));
  ff.Add(TimeToStr(rr.timewrite));
  ff.Add(TimeToStr(rr.timecheck));
  end;
  ss.Add(DateToStr(rr.timecreate));
  ff.Add(TimeToStr(rr.timecreate));
  //if(not rr.inlog)then
  //dd.Add(ExtractFilePath(GetTreePath(rr))+'*');
end;

rj.TP.asDate:=fsDate +','+ ss.CommaText;
rj.TP.asTime:=fsTime +','+ ff.CommaText;
rj.TP.asExt:=fsExtension +','+ aa.CommaText;
rj.TP.asMask:='*,';

finally
aa.Free;
ss.Free;
dd.Free;
ff.Free;
end;
except
//
end;
end;

function ItemExists(rr: IDRec): boolean;
var
PL: string;
begin
Result:=false;
try
  if(rr.ilabel = '')then PL:=GetTreePath(rr) else PL:=rr.ilabel;
  case rr.ntype of
    ntFile:   Result:=FileExists(PL);
    ntDir:    Result:=DirectoryExists(PL);
    ntFileDel:Result:=FileExists(PL);
    ntFileNew:Result:=FileExists(PL);
    ntFileChg:Result:=FileExists(PL);
    ntDirNew: DirectoryExists(PL);
    ntDirDel: DirectoryExists(PL);
  end;
except
//
end;
end;

procedure ShowRecords(TBShowAllFDown,TBIcoDown: boolean;tto: integer;rj: RJob;LVTop: TListView;num: integer = -1;showexuted: boolean = true);
var
i,sss,ddd,iFrom,iTo: integer;
dd: IDRec;
TL: TListItem;
tim: TDateTime;
begin
try
LVTop.Tag:=1;
LVTop.Clear;
if(rj = nil)then exit;
if(rj.LFTop.Count = 0)then exit;
sss:=LVTop.VisibleRowCount-1;
ddd:=rj.LFTop.Count-1;
iFrom:=rj.TopFrom;
iTo:=rj.TopTo;
if(tto>=0)then
begin
  case tto of
    slcFirst:
    begin
      iFrom:=0;
      if(sss<=ddd)then iTo:=sss else iTo:=ddd;
    end;
    slcBBack:
    begin
      if(iFrom-sss>0)then iFrom:=iFrom - sss else iFrom:=0;
      if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
    end;
    slcBack:
    begin
      if(iFrom-1>0)then iFrom:=iFrom - 1 else iFrom:=0;
      if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
    end;
    slcNext:
    begin
      if(iTo+1<=ddd)then iTo:=iTo+1 else iTo:=ddd;
      if(iTo-sss>0)then iFrom:=iTo-sss else iFrom:=0;
    end;
    slcNNext:
    begin
      if(iTo+sss<=ddd)then iTo:=iTo+sss else iTo:=ddd;
      if(iTo-sss<0)then iFrom:=0 else iFrom:=iTo - sss;
    end;
    slcLast:
    begin
      if(sss<=ddd)then iFrom:=ddd-sss else iFrom:=0;
      iTo:=ddd;
    end;
    slcFiltered:
    begin
      iFrom:=0;
      iTo:=ddd;
    end;
    slcCurrent:
    begin
      if(num>=0)then iFrom:=num else iFrom:=0;
      if(iFrom+sss<=ddd)then iTo:=iFrom+sss else iTo:=ddd;
    end;
  end;
rj.TopFrom:=iFrom;
rj.TopTo:=iTo;
end;
if(TBShowAllFDown)and((iFrom<>0)or(iTo<>rj.LFTop.Count-1))then
begin
iFrom:=0;
iTo:=rj.LFTop.Count-1;
end;
//begin
//  -1 -     -   
  //if((iFrom = 0)and(iTo = -1)and(ddd>0))then
 // if(sss<=ddd)then iTo:=sss else iTo:=ddd;
//end;
  if(iTo> rj.LFTop.Count-1)then iTo:=rj.LFTop.Count-1;
  for i:=iFrom to iTo do
  begin
    dd:=IDRec(rj.LFTop.Items[i]);
    TL:=LVTop.Items.Add;
    if(dd.ifs = clSelector)then
    begin
    dd.ifs := '';
    //TL.Selected:=true;
    end;
      if(not dd.inlog)then
      begin
      if(dd.ilabel = '')then dd.ilabel:=GetTreePath(dd);
      TL.Caption:=dd.ilabel;
      end else
      begin
      TL.Caption:=dd.iname;
      end;
    TL.SubItems.Add(SizeString(dd.isize));
    case dd.ntype of
      ntFile:
      begin
      tim:=dd.timewrite;
        case rj.TP.iDateType of
        0: tim:=dd.timewrite;
        1: tim:=dd.timecreate;
        2: tim:=dd.timeaccess;
        3: tim:=dd.timewrite;
        end;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiFile;
        if(dd.rj <> nil)and(dd.rj.Save.jobtype = jtLocal)then
        begin
          if(FileExists(dd.ilabel))then
          TL.SubItemImages[0]:=tiExists
          else
          TL.SubItemImages[0]:=tiNotFind;
        end else
        TL.SubItemImages[0]:=-1;
      end;
      ntDir:
      begin
        tim:=dd.timecreate;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiDir;
        if(dd.rj <> nil)and(dd.rj.Save.jobtype = jtLocal)then
        begin
          if(DirectoryExists(dd.ilabel))then
          TL.SubItemImages[0]:=tiExists
          else
          TL.SubItemImages[0]:=tiNotFind;
        end else
        TL.SubItemImages[0]:=-1;
      end;
      ntFileDel:
      begin
      tim:=dd.timewrite;
        case rj.TP.iDateType of
        0: tim:=dd.timewrite;
        1: tim:=dd.timecreate;
        2: tim:=dd.timeaccess;
        3: tim:=dd.timewrite;
        end;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiFileDel;
      end;
      ntFileNew:
      begin
      tim:=dd.timewrite;
        case rj.TP.iDateType of
        0: tim:=dd.timewrite;
        1: tim:=dd.timecreate;
        2: tim:=dd.timeaccess;
        3: tim:=dd.timewrite;
        end;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiFileNew;
        if(FileExists(dd.ilabel))then
        TL.SubItemImages[0]:=tiExists
        else
        TL.SubItemImages[0]:=tiNotFind;
      end;
      ntFileChg:
      begin
      tim:=dd.timewrite;
        case rj.TP.iDateType of
        0: tim:=dd.timewrite;
        1: tim:=dd.timecreate;
        2: tim:=dd.timeaccess;
        3: tim:=dd.timewrite;
        end;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiFileChg;
        if(FileExists(dd.ilabel))then
        TL.SubItemImages[0]:=tiExists
        else
        TL.SubItemImages[0]:=tiNotFind;
      end;
      ntDirNew :
      begin
        tim:=dd.timecreate;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiDirNew;
        if(DirectoryExists(dd.ilabel))then
        TL.SubItemImages[0]:=tiExists
        else
        TL.SubItemImages[0]:=tiNotFind;
      end;
      ntDirDel :
      begin
        tim:=dd.timecreate;
        TL.SubItems.Add(DateToStr(tim));
        TL.SubItems.Add(TimeToStr(tim));
        if(not TBIcoDown)then
        TL.ImageIndex:=tiDirDel;
      end;
    end;
    TL.StateIndex:=dd.resultindex;
    TL.SubItems.Add(IntToStr(i+1));  //num
    TL.Data:=dd;
    TL.SubItems.Add('');   //action
    //////////////////////////
    if(dd.actionindex = 10)then
    TL.SubItemImages[4]:=39
    else
    TL.SubItemImages[4]:=dd.actionindex;
  case TL.SubItemImages[4] of
    aiShow: TL.SubItems.Strings[4]:=tsShow;
    aiMoveToRecycle: TL.SubItems.Strings[4]:=tsMoveToRecycle;
    aiDelete: TL.SubItems.Strings[4]:=tsDelete;
    aiCopyTo:
if(dd.ifs = '')then TL.SubItems.Strings[4]:=tsCopy else TL.SubItems.Strings[4]:=dd.ifs;
    aiMoveTo:
if(dd.ifs = '')then TL.SubItems.Strings[4]:=tsMove else TL.SubItems.Strings[4]:=dd.ifs;
    aiRenameTo:
if(dd.ifs = '')then TL.SubItems.Strings[4]:=tsRename else TL.SubItems.Strings[4]:=dd.ifs;
    aiEmpty: TL.SubItems.Strings[4]:=tsEmpty;
    aiEmptyToRecycle: TL.SubItems.Strings[4]:=tsEmptyToRecycle;
    aiMoveContentTo:
if(dd.ifs = '')then TL.SubItems.Strings[4]:=tsMoveContent else TL.SubItems.Strings[4]:=dd.ifs;
    39:
    TL.SubItems.Strings[4]:=tsCompare;
  end;
    //////////////////////////
  end;
  LVTop.Tag:=0;
except
//
end;
end;

procedure ClickListAdd(dd: IDRec;rj: RJob);
var
i: integer;
isfind: boolean;
rr: IDRec;
begin
if(dd = nil)then exit;
try
  if(dd.rj.Save.jobkind = jkHistory)then
  begin
    if(dd.ntype>ntFile)then exit;
    if(dd.rj.topped)then
    begin
    dd.rj.LTop.Clear;
    dd.rj.LFTop.Clear;
    dd.rj.topped:=false;
    end;
    isfind:=false;
    for i:=0 to dd.rj.LTop.Count-1 do
    begin
      rr:=IDRec(dd.rj.LTop.Items[i]);
      if(rr = dd)then
      begin
      isfind:=true;
      break;
      end;
    end;

    if(not isfind)then
    begin
    dd.ilabel:=GetTreePath(dd);
    //dd.actionindex:=-1;
    dd.rj.LTop.Add(dd);
    dd.rj.LFTop.Add(dd);
    end;
  end else
  begin
    isfind:=false;
    try
   { i:=0;
    while i < rj.LFTop.Count do
    begin
      if(rj.LFTop.Items[i] = nil)then continue;
      rr:=IDRec(rj.LFTop.Items[i]);
      if(rr.ilabel = dd.ilabel)and(rr.actionindex>=aiShow)then
      begin
      isfind:=true;
      break;
      end;
      Inc(i);
    end; }
    except
    FormLog.RecError('80301');
    end;
    if(dd.ntype>ntFile)then exit;
    if(not isfind)then
    begin
    try
      rr:=CReateRec(dd.ilabel,nil,dd.isize,dd.timeaccess,dd.timewrite,dd.timecreate,now,dd.iattr,dd.ntype,nil);
      //rr.rj:=rj;
      rr.rj:=dd.rj;
      rr.listind:=rj.LTop.Add(rr);
      rj.LFTop.Add(rr);
      rr.ilabel:=dd.ilabel;
      rr.ifs:=dd.ifs;
      //rr.actionindex:=-1;
      rr.actionindex:=dd.actionindex;
      //rr.resultindex:=dd.resultindex;
      rr.inlog:=true;
      rj.changed_history:=true;
    except
    FormLog.RecError('80302');
    end;
    end;
  end;
except
FormLog.RecError('8030');
end;
end;

procedure BDirTopClick(LVTop: TListView;BDir: TObject);
var
LL: TListItem;
i: integer;
rr: IDRec;
dest: string;
begin
try
  dest:=InvokeDirDialog(nil);
  if(dest <> '')then
  for i:=0 to LVTop.Items.Count-1 do
  begin
    LL:=LVTop.Items.Item[i];
    if(not LL.Selected)then continue;
    rr:=IDRec(LL.Data);
    if(rr.ntype = ntFile)and(TToolButton(BDir).ImageIndex = aiMoveContentTo)then
    continue;
    rr.ifs:=dest+'\'+ExtractFileName(rr.iname);
    LL.SubItems.Strings[4]:=rr.ifs;
    LL.SubItemImages[4]:=TToolButton(BDir).ImageIndex;
    rr.actionindex:=TToolButton(BDir).ImageIndex;
  end;
except
//
end;
end;

procedure BRenTopClick(LVTop: TListView;BRen: TObject);
var
LL: TListItem;
i: integer;
dd: IDRec;
sel: TList;
begin
  sel:= TList.Create;
  try
try
if(LVTop.Selected = nil)or(IDRec(LVTop.Selected.Data).ntype in EnDisk)then exit;
Application.CreateForm(TFormRen,FormRen);
  for i:=0 to LVTop.Items.Count-1 do
  if(LVTop.Items.Item[i].Selected)then
  sel.Add(LVTop.Items.Item[i].Data);
  FormRen.RenList:=sel;
  FormRen.ShowModal;
  if(FormRen.Execute)then
  begin
    for i:=0 to LVTop.Items.Count-1 do
    begin
      LL:=LVTop.Items.Item[i];
      if(not LL.Selected)then continue;
      dd:=IDRec(LL.Data);
      LL.SubItems.Strings[4]:=dd.ifs;
      LL.SubItemImages[4]:=TToolButton(BRen).ImageIndex;
      dd.actionindex:=TToolButton(BRen).ImageIndex;
    end;
  end;
  finally
  sel.Free;
  end;
except
//
end;
end;

procedure TopListMenuClick(LVTop: TListView;imgindex: integer);
var
TL: TListItem;
i: integer;
dd: IDRec;
begin
try
  for i:=0 to LVTop.Items.Count-1 do
  begin
    TL:=LVTop.Items.Item[i];
    if(not TL.Selected)then continue;
    dd:=IDRec(TL.Data);
    if(dd.ntype = ntFile)and((imgindex = aiEmpty)or(imgindex = aiEmptyToRecycle)or
    (imgindex = aiMoveContentTo))then continue;
    dd.actionindex:=imgindex;
    TL.SubItemImages[4]:=imgindex;
  case imgindex of
    aiShow: TL.SubItems.Strings[4]:=tsShow;
    aiMoveToRecycle: TL.SubItems.Strings[4]:=tsMoveToRecycle;
    aiDelete: TL.SubItems.Strings[4]:=tsDelete;
    aiEmpty: TL.SubItems.Strings[4]:=tsEmpty;
    aiEmptyToRecycle: TL.SubItems.Strings[4]:=tsEmptyToRecycle;
    39:
    begin
    dd.actionindex:=10;
    TL.SubItems.Strings[4]:=tsCompare;
    end;
  end;
  end;
except
//
end;
end;

function CompareNames(Item1, Item2: Pointer): Integer;
var
d1,d2: IDRec;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  d1:=IDRec(Item1);
  d2:=IDRec(Item2);
  if((d1.ntype = ntFile)and(d2.ntype = ntFile))then Result:=0 else
  if((d1.ntype = ntFile)and(d2.ntype = ntDir))then Result:=1 else
  if((d1.ntype = ntDir)and(d2.ntype = ntFile))then Result:=-1 else
  if((d1.ntype = ntDir)and(d2.ntype = ntDir))then
  begin
    if(d1.parent = d2.parent)then Result := 0;
    if(d1.parent = d2)then Result := 1;
    if(d1 = d2.parent)then Result := -1;
  end;
except
//
end;
end;

function CompTop3(Item1, Item2: Pointer): Integer;
begin
Result:= 0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
if(IDRec(Item1).timeaccess = IDRec(Item2).timeaccess)then Result:= 0 else
if(IDRec(Item1).timeaccess > IDRec(Item2).timeaccess)then Result:= 1 else
if(IDRec(Item1).timeaccess < IDRec(Item2).timeaccess)then Result:= -1;
except
//
end;
end;
//////////////////////////////////////////////////////////////////
function CompDateAccess(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(IDRec(Item1).timeaccess,IDRec(Item2).timeaccess);
  except
  //
  end;
end;

function CompTimeAccess(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(IDRec(Item1).timeaccess,IDRec(Item2).timeaccess);
  except
  //
  end;
end;

function CompDateCreate(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(IDRec(Item1).timecreate,IDRec(Item2).timecreate);
  except
  //
  end;
end;

function CompTimeCreate(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(IDRec(Item1).timecreate,IDRec(Item2).timecreate);
  except
  //
  end;
end;

function CompDateWrite(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(IDRec(Item1).timewrite,IDRec(Item2).timewrite);
  except
  //
  end;
end;

function CompTimeWrite(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(IDRec(Item1).timewrite,IDRec(Item2).timewrite);
  except
  //
  end;
end;

function CompEachOwnDate(Item1, Item2: Pointer): Integer;
var
t1,t2: TDateTime;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  if(IDRec(Item1).ntype = ntFile)then
  t1:=IDRec(Item1).timewrite else t1:=IDRec(Item1).timecreate;

  if(IDRec(Item2).ntype = ntFile)then
  t2:=IDRec(Item2).timewrite else t2:=IDRec(Item2).timecreate;

  Result:=CompareDate(t1,t2);
  except
  //
  end;
end;

function CompEachOwnTime(Item1, Item2: Pointer): Integer;
var
t1,t2: TDateTime;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  if(IDRec(Item1).ntype = ntFile)then
  t1:=IDRec(Item1).timewrite else t1:=IDRec(Item1).timecreate;

  if(IDRec(Item2).ntype = ntFile)then
  t2:=IDRec(Item2).timewrite else t2:=IDRec(Item2).timecreate;

  Result:=CompareTime(t1,t2);
  except
  //
  end;
end;

function CompEachOwnDateCV(Item1, Item2: Pointer): Integer;
var
t1,t2: TDateTime;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  if(CompData(Item1).idd.ntype = ntFile)then
  t1:=CompData(Item1).idd.timewrite else t1:=CompData(Item1).idd.timecreate;

  if(CompData(Item2).idd.ntype = ntFile)then
  t2:=CompData(Item2).idd.timewrite else t2:=CompData(Item2).idd.timecreate;

  Result:=CompareDate(t1,t2);
  except
  //
  end;
end;

function CompEachOwnTimeCV(Item1, Item2: Pointer): Integer;
var
t1,t2: TDateTime;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  if(CompData(Item1).idd.ntype = ntFile)then
  t1:=CompData(Item1).idd.timewrite else t1:=CompData(Item1).idd.timecreate;

  if(CompData(Item2).idd.ntype = ntFile)then
  t2:=CompData(Item2).idd.timewrite else t2:=CompData(Item2).idd.timecreate;

  Result:=CompareTime(t1,t2);
  except
  //
  end;
end;

/////////////////////////////////////////////////////////

function CompNames(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:= CompareText(IDRec(Item1).iname,IDRec(Item2).iname);
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompLabel(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:= CompareText(IDRec(Item1).ilabel,IDRec(Item2).ilabel);
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompIfs(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:= CompareText(IDRec(Item1).ifs,IDRec(Item2).ifs);
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompLabelCV(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
Result:= CompareText(CompData(Item1).idd.ilabel,CompData(Item2).idd.ilabel);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompIfsCV(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
Result:= CompareText(CompData(Item1).idd.ifs,CompData(Item2).idd.ifs);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompFrom(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
Result:= CompareText(CompData(Item1).dirfrom.dname,CompData(Item2).dirfrom.dname);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

function CompTo(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
Result:= CompareText(CompData(Item1).dirto.dname,CompData(Item2).dirto.dname);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
  except
  //
  end;
end;

////////////////////////////////////////////////////////////////////
function CompTop4(Item1, Item2: Pointer): Integer;
begin
Result:= 0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
if(IDRec(Item1).timewrite = IDRec(Item2).timewrite)then Result := 0 else
if(IDRec(Item1).timewrite > IDRec(Item2).timewrite)then Result := 1 else
if(IDRec(Item1).timewrite < IDRec(Item2).timewrite)then Result := -1;
except
//
end;
end;

function CompTop2(Item1, Item2: Pointer): Integer;
begin
Result:= 0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
if(IDRec(Item1).timecreate = IDRec(Item2).timecreate)then Result := 0 else
if(IDRec(Item1).timecreate > IDRec(Item2).timecreate)then Result := 1 else
if(IDRec(Item1).timecreate < IDRec(Item2).timecreate)then Result := -1;
except
//
end;
end;

function CompTop1(Item1, Item2: Pointer): Integer;
begin
Result:= 0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
if(IDRec(Item1).isize = IDRec(Item2).isize)then Result := 0 else
if(IDRec(Item1).isize > IDRec(Item2).isize)then Result := 1 else
if(IDRec(Item1).isize < IDRec(Item2).isize)then Result := -1;
except
//
end;
end;

function CompTop5(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
Result:= CompareText(IDRec(Item1).iname,IDRec(Item2).iname);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
except
//
end;
end;

function CompFrom1(Item1, Item2: Pointer): Integer;
begin
Result :=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
//if(IDData(Item1).ilevel = IDData(Item2).ilevel)then
//begin
Result:= CompareText(IDRec(Item1).iname,IDRec(Item2).iname);
if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
//end else
//begin
//if(IDData(Item1).ilevel < IDData(Item2).ilevel)then Result := 1 else
//if(IDData(Item1).ilevel > IDData(Item2).ilevel)then Result := -1;
//end;
except
//
end;
end;

function CompFrom2(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(IDRec(Item1).isize=IDRec(Item2).isize)then Result:=0 else
  if(IDRec(Item1).isize>IDRec(Item2).isize)then Result:=1 else
  if(IDRec(Item1).isize<IDRec(Item2).isize)then Result:=-1;
except
//
end;
end;

function CompFrom3(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(IDRec(Item1).timewrite = IDRec(Item2).timewrite)then Result:=0 else
  if(IDRec(Item1).timewrite > IDRec(Item2).timewrite)then Result:=1 else
  if(IDRec(Item1).timewrite < IDRec(Item2).timewrite)then Result:=-1;
except
//
end;
end;

function CompFrom4(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(IDRec(Item1).iattr = IDRec(Item2).iattr)then Result:=0 else
  if(IDRec(Item1).iattr > IDRec(Item2).iattr)then Result:=1 else
  if(IDRec(Item1).iattr < IDRec(Item2).iattr)then Result:=-1;
except
//
end;
end;

function CompTo1(Item1, Item2: Pointer): Integer;
begin
  Result :=0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
    if(CompData(Item1).idd.ntype = CompData(Item2).idd.ntype)then
    begin
    Result:=CompareText(CompData(Item1).idd.iname,CompData(Item2).idd.iname);
    if(Result>1)then Result:= -1
    else
    if(Result<1)then Result:= 1;
    end else
    begin
      if(CompData(Item1).idd.ntype = ntFile)then
      Result := -1
      else
      Result := 1;
    end;
except
//
end;
end;

function CompTo2(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(CompData(Item1).idd.isize=CompData(Item2).idd.isize)then Result:=0 else
  if(CompData(Item1).idd.isize>CompData(Item2).idd.isize)then Result:=1 else
  if(CompData(Item1).idd.isize<CompData(Item2).idd.isize)then Result:=-1;
except
//
end;
end;

function CompTo3(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(CompData(Item1).idd.timewrite = CompData(Item2).idd.timewrite)then Result:=0 else
  if(CompData(Item1).idd.timewrite > CompData(Item2).idd.timewrite)then Result:=1 else
  if(CompData(Item1).idd.timewrite < CompData(Item2).idd.timewrite)then Result:=-1;
except
//
end;
end;
///////////////////////////
function CompTo3timeC(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(CompData(Item1).idd.timecreate,CompData(Item2).idd.timecreate);
  except
  //
  end;
end;

function CompTo3dateC(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(CompData(Item1).idd.timecreate,CompData(Item2).idd.timecreate);
  except
  //
  end;
end;

function CompTo3timeA(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(CompData(Item1).idd.timeaccess,CompData(Item2).idd.timeaccess);
  except
  //
  end;
end;

function CompTo3dateA(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(CompData(Item1).idd.timeaccess,CompData(Item2).idd.timeaccess);
  except
  //
  end;
end;

function CompTo3dateW(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareDate(CompData(Item1).idd.timewrite,CompData(Item2).idd.timewrite);
  except
  //
  end;
end;

function CompTo3timeW(Item1, Item2: Pointer): Integer;
begin
  Result:= 0;
  if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
  try
  Result:=CompareTime(CompData(Item1).idd.timewrite,CompData(Item2).idd.timewrite);
  except
  //
  end;
end;

function CompTo4(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(CompData(Item1).idd.iattr=CompData(Item2).idd.iattr)then Result:=0 else
  if(CompData(Item1).idd.iattr>CompData(Item2).idd.iattr)then Result:=1 else
  if(CompData(Item1).idd.iattr<CompData(Item2).idd.iattr)then Result:=-1;
except
//
end;
end;

function EnumFolder(rr: IDRec): string;
var
res: string;
dir:string;
hh: integer;
sr: TSearchRec;
begin
res:='';
dir:=rr.ilabel;
  dir:=dir+'\*';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(rr.ilabel,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        res:=res+rr.ilabel+'\'+sr.Name+#0;
        hh:=FindNext(sr);
      end;
    end;
  except
  FormLog.RecError('8012');
  end;
  finally
    FindClose(sr);
  end;
  Result:=res;
end;

function EnumFolderI(fname: string): string;
var
res: string;
dir:string;
hh: integer;
sr: TSearchRec;
begin
res:='';
dir:=fname;
  dir:=dir+'\*';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(fname,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        res:=res+fname+'\'+sr.Name+#0;
        hh:=FindNext(sr);
      end;
    end;
  except
  FormLog.RecError('8013');
  end;
  finally
    FindClose(sr);
  end;
  Result:=res;
end;

procedure EmptyTreeNode(tr: TTreeNode;needrenum: boolean=true);
begin
try
if(tr = nil)then exit;
if(tr.Data = nil)then exit;
if(not IDRec(tr.Data).rj.complete)then exit;
EmptyTreeNode1(tr);
if needrenum then
RenumL(IDRec(tr.Data).rj.LItems);
except
//
end;
end;

procedure EmptyTreeNode1(tr: TTreeNode;recurse: boolean=false);
var
i: integer;
sd,rr: IDRec;
begin
if(tr = nil)or(tr.Data = nil)then exit;
try
  sd:=IDRec(tr.Data);
  sd.parent:=nil;
  if(sd.ichild<>nil)then
  begin
    for i:=0 to High(sd.ichild)do
    begin
      if(sd.ichild[i] = nil)then continue;
      rr:= sd.ichild[i];
      rr.parent:=nil;
      if(rr.PNotify<>nil)then
      begin
        WatchTreeThr(rr.PNotify).rr:=nil;
        WatchTreeThr(rr.PNotify).rec:=nil;
        WatchTreeThr(rr.PNotify).Terminate;
        rr.PNotify:=nil;
      end;
      rr.rj.LItems.Items[rr.listind]:=nil;
      if(rr.trr<>nil)then
      begin
        if(rr.trr.Count>0)then EmptyTreeNode1(rr.trr,true);
        rr.trr.Delete;
        rr.trr:=nil;
      end;
      if(rr.itt <> nil)then rr.itt.Delete;
      Finalize(rr^);
      Dispose(rr);
    end;
    if(not recurse)then
    Finalize(sd.ichild);
    sd.ichild := nil;
    if(not(sd.ntype in EnDisk))then sd.isize:=0;
  end;
  //if((sd.trr<>nil)and(sd.trr.Count>0))then
  //sd.trr.DeleteChildren;
except
//windows.Beep(3000,300);
FormLog.RecError('8014');
end;
end;

procedure CheckTreeNodes(ad: IDRec;TV: TTreeView;OnlyDir: boolean);
var
i: integer;
tr2: TTreeNode;
sd: IDRec;
begin
try
  if((ad.ichild<>nil)and(ad.trr<>nil))then
  begin  //1
    if(ad.trr.Expanded)then
    begin //2
      for i:=0 to High(ad.ichild) do
      begin  //3
        if(ad.ichild[i] = nil)then continue;
        sd:= ad.ichild[i];
        if(sd.trr = nil)then
        begin
          if((sd.ntype <> ntFile)or(not OnlyDir))then
          begin
            tr2:=TV.Items.AddChild(ad.trr,sd.iname);
            tr2.Data:=sd;
            sd.trr:=tr2;
            if((sd.ichild <> nil)and(not tr2.Expanded))then
            tr2.HasChildren:=true;
            //TV.Items.AddChildFirst(tr2,'Scan');
            tr2.ImageIndex:=sd.ntype;
            tr2.SelectedIndex:=tr2.ImageIndex;
          end;
        end else
        begin
          if(sd.ntype <> ntFile)then
          CheckTreeNodes(sd,TV,OnlyDir)
          else
          if(OnlyDir)then
          begin
          sd.trr.Delete;
          sd.trr:=nil;
          end;
        end;
      end; //3
    end else  //2
    if((ad.ichild<>nil)and(ad.trr.Count = 0))then
    ad.trr.HasChildren:=true;
    //TV.Items.AddChildFirst(ad.trr,'Scan');
  end; //1
except
FormLog.RecError('8016');
end;
end;



function DiskExists(rr: IDRec): boolean;
var
i,mm,disktype: integer;
drvarr,volname: array[0..255] of char;
dr: array[0..4] of char;
ss: TList;
curr: string;
dd: drive;
fr,tt: int64;
Number, FileLength, VolFlags: DWORD;
TimScan: TDateTime;
begin
TimScan:=now;
ss:= TList.Create;
Result:=false;
try
try
    FillChar(drvarr,255,#0);
    GetLogicalDriveStrings(254,drvarr);
    curr:=ExtractFileDrive(GetCurrentDir)+'\';
    FillChar(dr,4,#0);
    mm:=0;
    for i:=0 to 252 do
    begin
      dr[i mod 4]:=drvarr[i];
      if(drvarr[i] = #0)then
      begin
      if((dr[0] = 'A')or(dr[0] = 'B'))then continue;
      if(dr[0] = 'C')then mm:=3;
      New(dd);
      dd.name:=dr;
      dd.ind:=mm;
      if(dd.name = curr)then dd.ind:=0;
      ss.Add(dd);
      mm:=mm+1;
      if(drvarr[i+1]=#0)then break;
      end;
    end;
    for i:=0 to ss.Count-1 do
    begin
      dd:=drive(ss.Items[i]);
      if(not GetDiskSpace(dd.name,fr,tt))then
      begin
      fr:=0;
      tt:=0;
      end;
      disktype:=GetDriveType(PChar(dd.name));
      case disktype of
        DRIVE_UNKNOWN     : disktype:= ntUnknown;
        DRIVE_NO_ROOT_DIR : disktype:= ntUnknown;
        DRIVE_REMOVABLE   : disktype:= ntRemovable;
        DRIVE_FIXED       : disktype:= ntDisk;
        DRIVE_REMOTE      : disktype:= ntRemote;
        DRIVE_CDROM       : disktype:= ntCDRom;
        DRIVE_RAMDISK     : disktype:= ntRam;
      end;
      FillChar(drvarr,255,#0);
      FillChar(volname,255,#0);
GetVolumeInformation(PChar(dd.name),volname,255,@Number, FileLength, VolFlags,drvarr,255);
      if(dd.name = rr.iname)then
      begin
      Result:=true;
      rr.timecheck:=TimScan;
      rr.ilabel:=volname;
      rr.ifs:=drvarr;
      if(disktype = ntCDRom)then rr.ilabel:=mmCDRom;
      if(disktype = ntRemovable)then rr.ilabel:=mmRemovable;
      if(rr.ilabel = '')then rr.ilabel:=mmLocalDisk;
      end;
    end;
finally
  for i:=0 to ss.Count-1 do
  begin
  dd:= drive(ss.Items[i]);
  Finalize(dd^);
  Dispose(dd);
  end;
  ss.Free;
end;
except
FormLog.RecError('8017');
end;
end;

function DirSort(Item1, Item2: Pointer): Integer;
var
a1,a2: IDRec;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if((Item1 = nil)or(Item1 = nil))then exit;
  a1:=IDRec(Item1);
  a2:=IDRec(Item2);
  if(a1.ntype = a2.ntype)then
  Result:=CompareText(a1.iname,a2.iname)
  else
  if(a1.ntype = ntFile)then
  Result:=1
  else
  Result:=-1;
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
except
//
end;
end;

function DirSortCV(Item1, Item2: Pointer): Integer;
var
a1,a2: IDRec;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  a1:=CompData(Item1).idd;
  a2:=CompData(Item2).idd;
  if(a1.ntype = a2.ntype)then
  Result:=CompareText(a1.iname,a2.iname)
  else
  if(a1.ntype = ntFile)then
  Result:=1
  else
  Result:=-1;
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
except
//
end;
end;

function ListToSort(Item1, Item2: Pointer): Integer;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
  if(CompData(Item1).idd.ntype = CompData(Item2).idd.ntype)then
  Result:=CompareText(CompData(Item1).idd.iname,CompData(Item2).idd.iname)
  else
  if(CompData(Item1).idd.ntype = ntFile)then
  Result:=1
  else
  Result:=-1;
  if(Result>1)then Result:= 1
  else
  if(Result<1)then Result:= -1;
except
//
end;
end;

function GetDiskSpace(Drive: string;var FreeSpaceAvailable,TotalSpace: Int64): Bool;
begin
Result :=false;
try
  Result := GetDiskFreeSpaceEx(PChar(Drive), FreeSpaceAvailable, TotalSpace, nil);
except
//
end;
end;

function CreateRec(iname: string='';parent: IDRec=nil;isize:real=0;
                    timeaccess:TDateTime=0;
                    timewrite:TDateTime=0;
                    timecreate:TDateTime=0;
                    timecheck:TDateTime=0;
                    iattr: integer=0;ntype: integer=-1;rj: RJob=nil): IDRec;
var
tr: IDRec;
begin
  try
    New(tr);
    tr.numdirs:=0;
    tr.numfiles:=0;
    tr.itt:=nil;
    tr.PNotify:=nil;
    tr.inlog:=false;
    tr.ilabel:='';
    tr.actionindex:=-1;
    tr.resultindex:=-1;
    tr.iname:=iname;
    tr.ntype:=ntype;
    tr.isize:=isize;
    tr.timecheck:=timecheck;
    tr.timeaccess:=timeaccess;
    tr.timewrite:=timewrite;
    tr.timecreate:=timecreate;
    tr.timeexec:=0;
    tr.haschild:=false;
    tr.searchchild:=false;
    tr.explored:=false;
    tr.rj:=rj;
    if(tr.ntype = -1)then
    begin
      if((iattr and faDirectory)<> 0) then
      tr.ntype:=ntDir
      else
      tr.ntype:=ntFile;
    end;
    tr.iattr:=iattr;
    if(rj<>nil)then
    tr.listind:=rj.LItems.Add(tr);
    tr.ichild:=nil;
    tr.parent:=parent;
    if(parent<>nil)then
    PushChild(tr,parent);
    tr.trr:=nil;
    Result:= tr;
  except
    Result:=nil;
  end;
end;  




procedure SellectAll(LL: TListView);
var
i: integer;
begin
try
  for i:=0 to LL.Items.Count-1 do
  begin
    LL.Items.Item[i].Selected:=true;
  end;
  LL.SetFocus;
except
//
end;
end;

function FormatNumber(nn: string): string;
var
len: integer;
begin
Result:=nn;
try
  len:=Length(nn);
  if(len>3)then
  begin
    len:=len-2;
    while len>0 do
    begin
      Insert('  ',nn,len);
      len:=len-3;
    end;
  end;
Result:=nn;
except
//
end;
end;

function MatchesRect(pp: TPoint;rr: TRect): boolean;
begin
Result:=false;
try
if((pp.X > rr.Left)and(pp.X < rr.Right)and(pp.Y > rr.Top)and(pp.Y < rr.Bottom))then
Result:= true
else
Result:=false;
except
//
end;
end;

procedure ManageJobHistory(rj: RJob);
var
i,j: integer;
jh: JobHist;
nn: TDateTime;
begin
  try
  //////////////////////////////////////
    nn:=Now;
    if(rj.Save.savelastdays)then nn:=IncDay(nn,(rj.Save.savelast *(-1)));
    for j:=0 to rj.LHist.Count-1 do
    begin
      jh:=JobHist(rj.LHist.Items[j]);
      if((not rj.Save.savelastdays)and((rj.LHist.Count-j)>rj.Save.savelast))then
      begin
        Dispose(jh);
        rj.LHist.Items[j]:=nil;
        continue;
      end;
      if((rj.Save.savelastdays)and(jh.jstart<nn))then
      begin
        Dispose(jh);
        rj.LHist.Items[j]:=nil;
        continue;
      end;
    end;
    rj.LHist.Pack;
    for i:=0 to rj.LHist.Count-1 do
    JobHist(rj.LHist.Items[i]).listind:=i;
  except
  //
  end;
end;

procedure FillHistoryItem(jh: JobHist;TL: TListItem);
begin
try
TL.Data:=jh;
  case jh.starter of
    spManual:
    begin
    TL.Caption:=stManual;
    TL.ImageIndex:=0;
    end;
    spTimer:
    begin
    TL.Caption:=stTimer;
    TL.ImageIndex:=1;
    end;
    spNotify:
    begin
    TL.Caption:=stNotify;
    TL.ImageIndex:=2;
    end;
  end;
  TL.SubItems.Strings[0]:=DateToStr(jh.jstart);
  TL.SubItems.Strings[1]:=TimeToStr(jh.jstart);
  TL.SubItems.Strings[2]:=TimeToStr(jh.jstop);
  case jh.jsuccess of
    jmAbort   :
    begin
      TL.SubItems.Strings[3]:=rrAbort;
      TL.SubItemImages[0]:=3;
    end;
    jmFailure :
    begin
      TL.SubItems.Strings[3]:=rrFailure;
      TL.SubItemImages[0]:=4;
    end;
    jmSuccess :
    begin
      TL.SubItems.Strings[3]:=rrSuccess;
      TL.SubItemImages[0]:=5;
    end;
    jmRun     :
    begin
      TL.SubItems.Strings[3]:=rrRun;
      TL.SubItemImages[0]:=6;
    end;
  end;
except
//
end;
end;

procedure SyncHistoryLists(rj: RJob;LV: TListView);
var
j: integer;
TL: TListItem;
jh: JobHist;
begin
if(rj.LHist.Count = 0)then exit;
  try
  ManageJobHistory(rj);
  while(LV.Items.Count>0)and(LV.Items.Item[0].Data <> rj.LHist.Items[0])do
  LV.Items.Delete(0);
  for j:=0 to rj.LHist.Count-1 do
  begin
    jh:=JobHist(rj.LHist.Items[j]);
    if(j<LV.Items.Count)then
    begin
      TL:=LV.Items.Item[j];
      if(TL.Data <> jh)then  FillHistoryItem(jh,TL);
    end else
    begin
      TL:=LV.Items.Add;
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      FillHistoryItem(jh,TL);
    end;
    if(TL.SubItemImages[0] = 6)or(TL.SubItemImages[0] = -1)then
    begin
      case jh.jsuccess of
        jmAbort   :
        begin
          TL.SubItems.Strings[3]:=rrAbort;
          TL.SubItemImages[0]:=3;
        end;
        jmFailure :
        begin
          TL.SubItems.Strings[3]:=rrFailure;
          TL.SubItemImages[0]:=4;
        end;
        jmSuccess :
        begin
          TL.SubItems.Strings[3]:=rrSuccess;
          TL.SubItemImages[0]:=5;
        end;
        jmRun     :
        begin
          TL.SubItems.Strings[3]:=rrRun;
          TL.SubItemImages[0]:=6;
        end;
        else
        begin
          if(j <> (rj.LHist.Count-1))then
          begin
            TL.SubItems.Strings[3]:=rrUnknown;
            TL.SubItemImages[0]:=6;
          end;
        end;
      end;
      TL.SubItems.Strings[2]:=TimeToStr(jh.jstop);
    end;
  end;
  except
  //
  end;
end;

procedure ExecJob(rr: RJob);
begin
try
  if(rr.Save.jobkind = jkSync)then
  begin
  rr.SyncHide;
  end;
  if(rr.Save.jobkind = jkHistory)then
  begin
  rr.ScanSH;
  end;
except
//
end;
end;

procedure ExecJobName(jname: string);
var
i: integer;
rr: RJob;
begin
try
  for i:=0 to GRList.Count-1 do
  begin
    rr:=RJob(GRList.Items[i]);
    if(rr.Save.jobname = jname)then
    begin
    rr.SyncHide;
    break;
    end;
  end;
except
//
end;
end;

procedure RenumL(LL: TList;tt: integer=0);
var
i,num: integer;
kk: TList;
begin
  kk:=TList.Create;
  try
    try
      for i:=0 to LL.Count-1 do
      if(LL.Items[i] <> nil)then
      kk.Add(LL.Items[i]);

      LL.Clear;
      LL.Assign(kk);
      num:=LL.Count-1;

      if(tt = 0)then
      for i:=0 to num do
      begin
        try
      IDRec(LL.Items[i]).listind:=i;
        except
          LL.Delete(i);
         // num:=num-1;
        end;
      end;

      if(tt = 1)then
      for i:=0 to num do
      begin
        try
      JobHist(LL.Items[i]).listind:=i;
        except
          LL.Delete(i);
         // num:=num-1;
        end;
      end;
    finally
      kk.Free;
    end;
  except
  FormLog.RecError('8018');
  end;
end;

function GetTreePath(dd: IDRec): string;
var
path: string;
sd: IDRec;
begin
path:='';
try
  if((dd <> nil)and(dd.ntype <> ntScan)and(dd.ntype <> ntLog)and(dd.parent<>nil)and
  (dd.ntype <> ntHistory)and(dd.ntype <> ntRoot))then
  begin
   { if((dd.ntype<=ntFile)and(dd.ilabel<>''))then
    begin
    Result:=dd.ilabel;
    exit;
    end;  }
    if((dd.ntype = ntDir)or(dd.ntype = ntFile)or(dd.ntype in EnDisk))then
    path:=dd.iname;
    sd:=dd.parent;
    while((sd.parent<> nil)and(not (sd.ntype = ntScan)))do
    begin
      if(not(sd.ntype = ntBusy))then
      begin
        if(sd.ntype in EnDisk)then
        path:=sd.iname+path
        else
        path:=sd.iname+'\'+path;
      end;
      sd:=sd.parent;
    end;
  end;
except
FormLog.RecError('8019');
end;
Result:=path;
end;

procedure PushChild(child,parent: IDRec);
var
prev: integer;
begin
try
prev:= High(parent.ichild)+2;
SetLength(parent.ichild,prev);
parent.ichild[prev-1]:=child;
except
//
end;
end;

procedure PushChildID(child: CompData;parent: IDRec);
var
prev: integer;
begin
try
prev:= High(parent.cchild)+2;
SetLength(parent.cchild,prev);
parent.cchild[prev-1]:=child;
except
//
end;
end;

procedure PopChild(child,parent: IDRec);
var
i,ind: integer;
begin
try
  ind:=-1;
  for i:=0 to High(parent.ichild) do
  if(parent.ichild[i] = child)then
  begin
  ind:=i;
  break;
  end;
  if(ind = -1)then exit;
  for i:=ind to High(parent.ichild)-1 do
  parent.ichild[i]:=parent.ichild[i+1];
  SetLength(parent.ichild,High(parent.ichild));
except
//
end;
end;

function RenameMask(fname,mask: string;var num: integer;ntype,context: integer;idd: IDRec): string;
function FormatN(dd: integer): string;
begin
  Result:=IntToStr(dd);
  if(dd<10)then
  Result:='0'+Result;
end;
var
p1,p2,p3,len,i,step,start: integer;
res,fext,prev,post,fpath,temp,fmask,sstep,sstart: string;
aa,bb: char;
begin
{
*     
*[U]-UpperCase
*[L]-LowerCase
*[U1]-UpperCase First Letter
*[U11]-UpperCase First Letters
*[L1]-LowerCase
*[L11]-LowerCase
*[D-9+N+M]- Start at + Step by
*[9]   -   -    
*[6-9]   -   -    

*[d]  
*[dd] 
*[m] 
*[y] 
*[t]  

*[dw]     
*[ddw] 
*[mw] 
*[yw] 
*[tw]  

*[d]    
------------------------------------

[.exe] - changing all extensions of files
[^]  
[sdfg#5475687]  
[a-z$3]   
 *    
}
if(idd.ifs <>'')then
begin
Result:=idd.ifs;
idd.ifs:='';
num:=num-1;
exit;
end;
Result:=fname;
try
  fpath:=ExtractFilePath(fname);
  res:=ExtractFileName(fname);
  mask:=Trim(mask);
  if(mask = '*')then exit;
  fmask:=mask;
  if(AnsiContainsText(mask,'[9]'))then
    mask:=AnsiReplaceStr(mask,'[9]',IntToStr(num+1))
    else
  if(context = rcIsExists)then
    mask:=mask+IntToStr(num);
  if(AnsiContainsText(mask,'[d]'))then
    mask:=AnsiReplaceStr(mask,'[d]',DateToStr(Now));
  if(AnsiContainsText(mask,'[t]'))then
    mask:=AnsiReplaceStr(mask,'[t]',AnsiReplaceStr(TimeToStr(Now),':','-'));
  if(AnsiContainsText(mask,'[dd]'))then
    mask:=AnsiReplaceStr(mask,'[dd]',FormatN(DayOfTheMonth(Now)));
  if(AnsiContainsText(mask,'[m]'))then
    mask:=AnsiReplaceStr(mask,'[m]',FormatN(MonthOf(Now)));
  if(AnsiContainsText(mask,'[y]'))then
    mask:=AnsiReplaceStr(mask,'[y]',IntToStr(YearOf(Now)));

    if(AnsiContainsText(mask,'[dw]'))then
    mask:=AnsiReplaceStr(mask,'[dw]',DateToStr(idd.timewrite));
  if(AnsiContainsText(mask,'[tw]'))then
    mask:=AnsiReplaceStr(mask,'[tw]',AnsiReplaceStr(TimeToStr(idd.timewrite),':','-'));
  if(AnsiContainsText(mask,'[ddw]'))then
    mask:=AnsiReplaceStr(mask,'[ddw]',FormatN(DayOfTheMonth(idd.timewrite)));
  if(AnsiContainsText(mask,'[mw]'))then
    mask:=AnsiReplaceStr(mask,'[mw]',FormatN(MonthOf(idd.timewrite)));
  if(AnsiContainsText(mask,'[yw]'))then
    mask:=AnsiReplaceStr(mask,'[yw]',IntToStr(YearOf(idd.timewrite)));

    if(AnsiContainsText(mask,'[dc]'))then
    mask:=AnsiReplaceStr(mask,'[dc]',DateToStr(idd.timecreate));
  if(AnsiContainsText(mask,'[tc]'))then
    mask:=AnsiReplaceStr(mask,'[tc]',AnsiReplaceStr(TimeToStr(idd.timecreate),':','-'));
  if(AnsiContainsText(mask,'[ddc]'))then
    mask:=AnsiReplaceStr(mask,'[ddc]',FormatN(DayOfTheMonth(idd.timecreate)));
  if(AnsiContainsText(mask,'[mc]'))then
    mask:=AnsiReplaceStr(mask,'[mc]',FormatN(MonthOf(idd.timecreate)));
  if(AnsiContainsText(mask,'[yc]'))then
    mask:=AnsiReplaceStr(mask,'[yc]',IntToStr(YearOf(idd.timecreate)));

  if(AnsiContainsText(mask,'-9+'))then
  begin
    p1:=Pos('-9+',mask);
    len:=Length(mask);
    p3:=1;
    for i:=p1 downto 1 do
    if(mask[i] = '[')then
    begin
      p3:=i;
      break;
    end;
    prev:=MidStr(mask,p3+1,p1-p3-1);
    temp:=MidStr(mask,p1+3,len-p1);
    p1:=Pos('+',temp);
    p2:=Pos(']',temp);
    sstart:=MidStr(temp,0,p1-1);
    start:=StrToInt(sstart);
    sstep:=MidStr(temp,p1+1,p2-p1-1);
    step:=StrToInt(sstep);

    temp:=IntToStr(num*step+start);
    p2:=StrToInt(prev)- Length(temp);
    if(p2<0)then p2:=0;
    post:=StringOfChar('0',p2)+temp;
    mask:=AnsiReplaceStr(mask,'['+prev+'-9+'+sstart+'+'+sstep+']',post);
  end;
  if(AnsiContainsText(mask,'-9]'))then
  begin
    p1:=Pos('-9]',mask);
    //len:=Length(mask);
    p3:=1;
    for i:=p1 downto 1 do
    if(mask[i] = '[')then
    begin
      p3:=i;
      break;
    end;
    prev:=MidStr(mask,p3+1,p1-p3-1);
    temp:=IntToStr(num+1);
    p2:=StrToInt(prev)- Length(temp);
    if(p2<0)then p2:=0;
    post:=StringOfChar('0',p2)+temp;
    mask:=AnsiReplaceStr(mask,'['+prev+'-9]',post);
  end;
  if(AnsiContainsText(mask,'[.'))then
  begin
    p1:=Pos('[.',mask);
    len:=Length(mask);
    p2:=p1+2;
    for i:=p1+2 to len do
    if(mask[i] = ']')then
    begin
      p2:=i;
      break;
    end;
    fext:=MidStr(mask,p1+2,p2-p1-2);
    mask:=AnsiReplaceStr(mask,'[.'+fext+']','');
    fext:='.'+fext;
    if(ntype = ntFile)then
    res:=ChangeFileExt(res,fext);
  end;
 while(AnsiContainsText(mask,'[^'))do
  begin
    p1:=Pos('[^',mask);
    len:=Length(mask);
    p2:=p1+2;
    for i:=p1+2 to len do
    if(mask[i] = ']')then
    begin
      p2:=i;
      break;
    end;
    fext:=MidStr(mask,p1+2,p2-p1-2);
    mask:=AnsiReplaceStr(mask,'[^'+fext+']','');
    res:=AnsiReplaceStr(res,fext,'');
  end;
  while(AnsiContainsText(mask,'#'))do
  begin
    p1:=Pos('#',mask);
    len:=Length(mask);
    p2:=p1+1;
    for i:=p1+1 to len do
    if(mask[i] = ']')then
    begin
      p2:=i;
      break;
    end;
    p3:=1;
    for i:=p1 downto 1 do
    if(mask[i] = '[')then
    begin
      p3:=i;
      break;
    end;
    prev:=MidStr(mask,p3+1,p1-p3-1);
    post:=MidStr(mask,p1+1,p2-p1-1);
    mask:=AnsiReplaceStr(mask,'['+prev+'#'+post+']','');
    res:=AnsiReplaceStr(res,prev,post);
  end;
  while(AnsiContainsText(mask,'$'))do
  begin
    p1:=Pos('$',mask);
    len:=Length(mask);
    p2:=p1+1;
    for i:=p1+1 to len do
    if(mask[i] = ']')then
    begin
      p2:=i;
      break;
    end;
    p3:=1;
    for i:=p1 downto 1 do
    if(mask[i] = '[')then
    begin
      p3:=i;
      break;
    end;
    prev:=MidStr(mask,p3+1,p1-p3-1);
    post:=MidStr(mask,p1+1,p2-p1-1);
    mask:=AnsiReplaceStr(mask,'['+prev+'$'+post+']','');
    aa:=prev[1];
    bb:=prev[3];
    for i:=ord(aa) to ord(bb) do
    res:=AnsiReplaceStr(res,chr(i),post);
  end;
  if(fmask = mask)then mask:='*';

  if(ntype = ntFile)then
  begin
  fext:=ExtractFileExt(res);
  res:=ChangeFileExt(res,'');
  res:=AnsiReplaceStr(mask,'*',res)+fext;
  end else
  begin
  res:=AnsiReplaceStr(mask,'*',res);
  end;

  if(AnsiContainsText(mask,'[U]'))then
  begin
    res:=AnsiReplaceStr(res,'[U]','');
    res:=AnsiUpperCase(res);
  end;
  if(AnsiContainsText(mask,'[L]'))then
  begin
    res:=AnsiReplaceStr(res,'[L]','');
    res:=AnsiLowerCase(res);
  end;
  if(AnsiContainsText(mask,'[U1]'))then
  begin
    res:=AnsiReplaceStr(res,'[U1]','');
    prev:=MidStr(res,0,1);
    res:=MidStr(res,2,Length(res));
    prev:=AnsiUpperCase(prev);
    res:=prev+res;
  end;
  if(AnsiContainsText(mask,'[L1]'))then
  begin
    res:=AnsiReplaceStr(res,'[L1]','');
    prev:=MidStr(res,0,1);
    res:=MidStr(res,2,Length(res));
    prev:=AnsiLowerCase(prev);
    res:=prev+res;
  end;
  Result:=fpath+res;
except
//
end;
end;

function MoveTo(src,dest: string;var ab: boolean;var mess: string;oper: integer=FO_MOVE):integer;
var
pp: _SHFILEOPSTRUCTA;
res: integer;
begin
res:=-1;
try
pp.Wnd:=0;
pp.wFunc:=oper;
pp.pFrom:=PChar(src+#0);
pp.pTo:=PChar(dest+#0);
//FOF_ALLOWUNDO or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_SILENT
pp.fFlags:=FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_SILENT;
pp.fAnyOperationsAborted:=ab;
pp.hNameMappings:=nil;
pp.lpszProgressTitle:=nil;
res:=SHFileOperation(pp);
except
SetLength(mess,255);
FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS,nil,
GetLastError(),0,PChar(mess),255, nil);
end;
Result:=res;
FormLog.RecError('8020');
end;

procedure ListFrom(LV1,LL: TList;rj: RJob);
var
i,j,m1: integer;
LVI: TDList;
begin
try
for i:=0 to LV1.Count-1 do
begin //1
    LVI:=TDList(LV1.Items[i]);
    if((LVI.DPar.direct <> dpIn)and(LVI.DPar.direct <> dpOnlyReport))or
    (LVI.DPar.fparam = fpRename)then
    begin //2
      case LVI.DPar.fparam of
        fpMaster: m1:=caMaster;
        fpRename: m1:=caUnique;
        fpEmpty:  m1:=caUnique;
        fpSmartSlave: m1:=caUnique;
        else
        m1:=caNoop;
      end;
      for j:=1 to LVI.Count-1 do
      begin //3
        if rj.babort then exit;
        CreateCV(IDRec(LVI.Items[j]),@LVI.DPar,nil,m1,LL);
      end;//3
    end;//2
  if rj.babort then exit;
end;//1
except
//
end;
end;

function CreateCV(TL: IDRec;dfrom,dto: DirP;cause: integer;LL: TList): CompData;
var
CV: CompData;
begin
Result:=nil;
try
  New(CV);
  Result:=CV;
  CV.idd:=TL;
  CV.dirfrom:=dfrom;//@LVI.DPar;
  CV.dirto:=dto;
  CV.istate:=0;
  CV.ilevel:=TL.ilevel;
  CV.expanded:=false;
  CV.deleted:=false;
  CV.current:=false;
  CV.cdItem:=nil;
  CV.parent:=nil;
  CV.achild:=nil;
  CV.iResult:=aiNoop;
  CV.iddest:=nil;
  //CV.rsize:=TL.isize;
  CV.icause:=cause;
  CV.iindex:=LL.Add(CV);
except
//
end;
end;

{
ListTo - Here we are deciding what items must be move in to each directory
}
procedure ListTo(LV1,LL: TList;rj: RJob);

procedure InsertIn(idd: IDRec;CV1: CompData;dirto: DirP;Liname1: TList;m11: integer;Last1: TDateTime);
begin
try
  if(dirto.fparam = fpLastChanges)and(Last1 < CV1.idd.timewrite)then
  begin
  Liname1.Items[m11]:=CV1;
  CV1.icause:=caLastWrite;
  end else
  if((dirto.fparam = fpLastWrite)and(idd.timewrite < CV1.idd.timewrite))then
  begin
  Liname1.Items[m11]:=CV1;
  CV1.icause:=caLastWrite;
  end else
  if((dirto.fparam = fpFirstWrite)and(idd.timewrite > CV1.idd.timewrite))then
  begin
  Liname1.Items[m11]:=CV1;
  CV1.icause:=caFirstWrite;
  end else
  if((dirto.fparam = fpSizeMore)and(idd.isize < CV1.idd.isize))then
  begin
  Liname1.Items[m11]:=CV1;
  CV1.icause:=caSizeMore;
  end else
  if((dirto.fparam = fpSizeLess)and(idd.isize > CV1.idd.isize))then
  begin
  Liname1.Items[m11]:=CV1;
  CV1.icause:=caSizeLess;
  end;
except
//
end;
end;

function CauseIn(idd: IDRec;CV1: CompData;dirto: DirP;Last1: TDateTime): integer;
begin
Result:=caNoop;
try
  if(dirto.fparam = fpLastChanges)and(Last1 < CV1.idd.timewrite)then
  begin
  Result:=caLastWrite;
  end else
  if((dirto.fparam = fpSlave)or(CV1.dirfrom.fparam = fpMaster))then
  begin
  Result:=caMaster;
  end else
  if((dirto.fparam = fpLastWrite)and(idd.timewrite < CV1.idd.timewrite))then
  begin
  Result:=caLastWrite;
  end else
  if((dirto.fparam = fpFirstWrite)and(idd.timewrite > CV1.idd.timewrite))then
  begin
  Result:=caFirstWrite;
  end else
  if((dirto.fparam = fpSizeMore)and(idd.isize < CV1.idd.isize))then
  begin
  Result:=caSizeMore;
  end else
  if((dirto.fparam = fpSizeLess)and(idd.isize > CV1.idd.isize))then
  begin
  Result:=caSizeLess;
  end;
except
//
end;
end;

var
i,j,k,m1,first,cause,nn: integer;
CV,CVV,CVDel: CompData;
id,rd: IDRec;
LV: TDList;
Liname: TList;
TempL: TList;
ddir: string;
tname: TStringList;
isfile: boolean;
Last: TDateTime;
jj: JobHist;
begin
TempL:=TList.Create;
Liname:= TList.Create;
tname:= TStringList.Create;
tname.Sorted:=true;
tname.Duplicates:=dupIgnore;
try
try
  for i:=0 to LL.Count-1 do
  begin//1
    CV:=CompData(LL.Items[i]);
    if(CV.dirfrom.pTDList = nil)then continue;
    LV:= TDList(CV.dirfrom.pTDList);
    if(LV.pDirTo<>nil)then
    begin
      CVV:=CreateCV(CV.idd,CV.dirfrom,@LV.pDirTo.DPar,CV.icause,TempL);
      case LV.DPar.fparam of
        fpRename:
        begin
          nn:=1;
          ddir:=CVV.dirfrom.dname+'\'+ExtractFileName(CVV.idd.iname);
          ddir:=RenameMask(ddir,CV.dirfrom.renmask,nn,CVV.idd.ntype,rcRenAll,CVV.idd);
          isfile:=false;
          if(CVV.idd.ntype = ntFile)then isfile:=true;
          while(CVV.dirfrom.rj.ExistsS(ddir,isfile))or(tname.IndexOf(ddir)>=0)do
          begin
            ddir:=RenameMask(ddir,CV.dirfrom.renmask,nn,CVV.idd.ntype,rcRenAll,CVV.idd);
            Inc(nn);
            if(nn >= MaxRenNum)then
            begin
            ddir:=mmImpossibleFindName;
            break;
            end;
          end;
          CVV.idd.ifs:=ddir;
          CVV.idd.actionindex := aiRenameTo;
          CVV.iddest:=CVV.idd;
          tname.Add(ddir);
        end;
        fpSmartSlave: CVV.idd.actionindex := aiDelete;
        fpEmpty:      CVV.idd.actionindex := aiDelete;
      end; //case LV.DPar.fparam of
      PushChildID(CVV,CV.idd);
      LL.Items[i]:=nil;
    end;
  end;
  LL.Pack;
//****************************************************
Last:=now;
for j:=0 to LV1.Count-1 do
begin //2
LV:=TDList(LV1.Items[j]);
Liname.Clear;
if((LV.DPar.fparam = fpMaster)or
(LV.DPar.direct = dpOut)or(LV.DPar.direct = dpOutOut)or
(LV.DPar.direct = dpOnlyReport)or(LV.DPar.itype <> dtDir))then continue;
if(LV.DPar.fparam = fpLastChanges)then
begin
  if(LV.DPar.rj.Save.jobkind <> jkTemp)and(LV.DPar.rj.LHist.Count>0)then
    for i:= LV.DPar.rj.LHist.Count-1 downto 0 do
    begin
      jj:= JobHist(LV.DPar.rj.LHist.Items[i]);
      if(jj.jsuccess = jmSuccess)then
      begin
        Last:=jj.jstart;
        break;
      end;
    end;
end;
  for i:=0 to LL.Count-1 do
  begin//1
  CV:=CompData(LL.Items[i]);
    rd:=nil;
    if(CV.dirfrom <> @LV.DPar)and(LV.DPar.itype <> dtShow)then
    begin//7
    first:=0;
    if(LV.DPar.fparam = fpLastChanges)and(CV.idd.timewrite <= Last)then
    continue;
    if(LV.DPar.exclusive)then first:=1;
    for k:=first to LV.Count-1 do
    begin//3
      id:=IDRec(LV.Items[k]);
      if(id.iname = CV.idd.iname)then
      begin
      rd:=id;
      break;
      end;
    end;//3
    if(rd <> nil)then
    begin//4
      if(LV.DPar.fparam = fpSmartSlave)then
      begin
       { rd.actionindex:=aiNoop;
        CVDel:=CompData(rd.cchild[0]);
        CVDel.istate:=aiNoop;
        rd.actionindex:=aiNoop; }
          CVDel:=CompData(rd.cchild[0]);
          TempL.Delete(CVDel.iindex);
          for k:=CVDel.iindex to TempL.Count-1 do
          CompData(TempL.Items[k]).iindex:=k;
          rd.cchild:=nil;
          Dispose(CVDel);
          //continue;
        //end;
      end;
    //  if(rd.ntype = ntFile)then
    //  begin//9
        cause:=CauseIn(rd,CV,@LV.DPar,Last);
        if(cause <> caNoop)then
        begin//8
          CV.dirto:=@LV.DPar;
          CV.icause:=cause;
          m1:=FindRSort(Liname,CV,@CompTo1);
          case m1 of
          -2: Liname.Add(CV);
          -1: Liname.Insert(0,CV);
          end;
          if(m1>=0)then
          begin
            CVV:=CompData(Liname.Items[m1]);
            if(CV.dirfrom.over = opAll)or(CV.dirfrom.over = opRenCycle)then
            CV.iddest:=rd;
            if(CVV.idd.iname <> CV.idd.iname)then
            Liname.Insert(m1,CV)
            else
            InsertIn(rd,CV,CVV.dirto,Liname,m1,Last);
          end;
        end;//8
     // end; //9
    end else begin //4
        CV.dirto:=@LV.DPar;
        if(CV.icause = caNoop)then
        CV.icause:=caUnique;
        m1:=FindRSort(Liname,CV,@CompTo1);
        case m1 of
        -2: Liname.Add(CV);
        -1: Liname.Insert(0,CV);
        end;
        if(m1>=0)then
        begin
          CVV:=CompData(Liname.Items[m1]);
          if(CVV.idd.iname <> CV.idd.iname)then
          Liname.Insert(m1,CV)
          else
          InsertIn(rd,CV,CVV.dirto,Liname,m1,Last);
        end;
    end;//4
    end;//7
  end;//1
  for m1:=0 to Liname.Count-1 do
  begin
    CV:=CompData(Liname.Items[m1]);
    CVV:=CreateCV(CV.idd,CV.dirfrom,@LV.DPar,CV.icause,TempL);
    CVV.iddest:=CV.iddest;
    PushChildID(CVV,CV.idd);
  end;
end;//2

for i:=0 to LL.Count-1 do
begin
Dispose(CompData(LL.Items[i]));
end;
LL.Clear;
LL.Assign(TempL);
finally
TempL.Free;
Liname.Free;
tname.Free;
end;
except
//
end;
end;

function FindRSort(LL: TList;pp: Pointer;comp: CompFunc): integer;
var
imin,imax,i,cc,maxi:integer;
begin
  Result:=-2;
try
  cc:=0;
  if(LL.Count = 0)then
  begin
  Result:=-2;
  exit;
  end;
  case comp(LL.First,pp) of
    0:
    begin
      Result:=0;
      exit;
    end;
    1:
    begin
      cc:=-1;
    end;
    -1:
    begin
      Result:=-1;
      exit;
    end;
  end;
  case comp(LL.Last,pp) of
    0:
    begin
      Result:=LL.Count-1;
      exit;
    end;
    1:
    begin
      Result:=-2;
      exit;
    end;
  end;
  if((cc = -1)and(LL.Count = 2))then
  begin
    Result:=1;
    exit;
  end;
 imin :=0;
 imax := LL.Count-1;
 maxi:=imax;
 repeat
  i := (imin + imax) div 2;
  cc:=comp(LL.Items[i],pp);
  Dec(maxi);
  if(maxi = 0)then break;
  case cc of
    0:
    begin
     Result := i;
     break;
    end;
    1:
    begin
      if(imax - imin <= 1) then
      begin
        if(i+1<LL.Count)then Result:=i+1 else Result:=i;
        break;
      end;
      imin := i;
    end;
    -1:
    begin
      if(imax - imin <= 1) then
      begin
        if(i-1>=0)then Result:=i-1 else Result:=0;
        break;
      end;
      imax := i;
    end;
  end;
 until false;
except
//
end;
end;

procedure RangeList(TempL: TList;pp: IDRec;rj: RJob;dto: DirP=nil;cindex: integer=0);
var
CV,cc: CompData;
prev,i,j,k,hc,hc1,hc2: integer;
id: IDRec;
begin
try
  hc:=High(pp.cchild);
  for i:=0 to hc do
  begin //1
    CV:= CompData(pp.cchild[i]);
    if(CV.dirto = dto)or(dto = nil)then
    begin //22
      CV.iindex:=TempL.Add(CV);
      if(pp.ichild<>nil)then
      begin
        hc1:=High(pp.ichild);
        for j:=0 to hc1 do
        begin //2
          id:= pp.ichild[j];
          hc2:= High(id.cchild);
          for k:=0 to hc2 do
          begin //3
            cc:= CompData(id.cchild[k]);
            if(CV.dirto = cc.dirto)then
            begin //4
              if(id.ichild = nil)then
              begin
                cc.iindex:=TempL.Add(cc);
              end;
              prev:= High(CV.achild)+2;
              SetLength(CV.achild,prev);
              CV.achild[prev-1]:=cc;
              cc.parent:=CV;
            end; //4
          end; //3
          if(id.ichild<>nil)then
          RangeList(TempL,id,rj,CV.dirto,cindex);
        end; //2
      end;
    end; //22
  end; //1
except
FormLog.RecError('8021');
end;
end;

procedure DispatchList(LV1,LL: TList;rj: RJob);
var
i,j,cc: integer;
CV: CompData;
TempL: TList;
dd: TDList;
sum,diffsum: real;
begin
TempL:=TList.Create;
try
try
  //LL.Sort(@DirSort);
  //LL.Sort(@CompTo1);
  for i:=0 to LL.Count-1 do
  begin
    CV:=CompData(LL.Items[i]);
    CV.cdItem:=nil;
    if(CV.idd.root = nil)then
    begin
      if(CV.icause = caNoop)then
      begin
      CV.istate := aiShow;
      continue;
      end;
      if(CV.dirfrom.direct = dpOut)or(CV.dirfrom.direct = dpInOut)then
      CV.istate := aiCopyTo
      else
      if(CV.dirfrom.direct = dpOutOut)or(CV.dirfrom.direct = dpInOutOut)then
      CV.istate := aiMoveTo;

      case CV.dirto.itype of
        dtRecycle: CV.istate := aiMoveToRecycle;
        dtDelete : CV.istate := aiDelete;
        dtShow   : CV.istate := aiShow;
        dtRename : CV.istate := aiRenameTo;
      end;
    end else
    begin
      CV.istate :=CV.idd.root.actionindex;
    end;
  end;
  if(LL.Count>0)then
  begin
    for i:=0 to LV1.Count-1 do
    begin
      dd:=TDList(LV1.Items[i]);
      if(dd.Count = 0)then continue;
      if(dd.DPar.direct in EnDirectOut)then
      begin
        //if(not dd.DPar.exclusive)then
        //RangeList(TempL,dd.idroot,rj)
        //else
        //begin
          for j:=0 to High(dd.idroot.ichild)do
          RangeList(TempL,dd.idroot.ichild[j],rj);
        //end;
      end;
    end;
    //LL.Clear;
    TempL.Assign(LL,laOr);
    LL.Clear;
    //LL.Assign(TempL,laXor);
    LL.Assign(TempL);
  end;
/////////////////////show disks
for i:=0 to LV1.Count-1 do
begin
  dd:=TDList(LV1.Items[i]);
  if(i = 0)then
  begin
  rj.TP.asFrom:=dd.DPar.dname;
  rj.TP.asTo:=dd.DPar.dname;
  end else
  begin
  rj.TP.asFrom:=rj.TP.asFrom +',' + dd.DPar.dname;
  rj.TP.asTo:=rj.TP.asTo +','+ dd.DPar.dname;
  end;
  if(dd.DPar.itype = dtDir)then
  begin
    if(dd.DPar.rj.ClassName = 'FTPJob')then
    begin
      dd.DPar.Disk.disk:=ExtractFileDrive(dd.DPar.dname);
      dd.DPar.Disk.free:=0;
    end else
    begin
      dd.DPar.Disk.disk:=ExtractFileDrive(dd.DPar.dname);
      dd.DPar.Disk.free:=DriveFree(ExtractFileDrive(dd.DPar.dname));
    end;
    dd.DPar.Disk.err:=0;
  end else
  begin
  dd.DPar.Disk.disk:=dd.DPar.dname;
  dd.DPar.Disk.free:=0;
  end;
  cc:=0;
  sum:=0;
  diffsum:=0;
    for j:=0 to LL.Count-1 do
    begin
      CV:=CompData(LL.Items[j]);
      if(CV.dirto = @dd.DPar)then
      begin
      cc:=cc+1;
      if(CV.idd.ntype = ntFile)then
      begin
        sum:=sum+CV.idd.isize;
        if(CV.iddest<>nil)then
        begin
          if(CV.idd <> CV.iddest)then
          diffsum:=diffsum - CV.iddest.isize
          else
          diffsum:=diffsum - CV.idd.isize;
        end;
      end;
      end;
    end;
  dd.DPar.Disk.items:=cc;
  dd.DPar.Disk.down:=0;
  dd.DPar.Disk.required:=sum+diffsum;
  dd.DPar.Disk.diffreq:=diffsum;
end;
finally
TempL.Free;
end;
except
FormLog.RecError('8022');
end;
end;

function DriveFree(drv: string): real;
var
fr,tt: Int64;
begin
Result:=0;
try
  if(not GetDiskSpace(drv,fr,tt))then
  begin
  fr:=0;
  tt:=0;
  end;
Result:=fr;
except
FormLog.RecError('8023');
end;
end;

function RenComp(Item1, Item2: Pointer): Integer;
var
i,len1,len2: integer;
s1,s2: string;
begin
Result:=0;
if(Item1 = nil)or(Item2 = nil)then exit;
if(Item1 = Item2)then exit;
try
s1:=TRen(Item1).oldname;
s2:=TRen(Item2).oldname;
len1:=Length(s1);
len2:=Length(s2);
i:=CompareText(s1,s2);
if((len1<len2)and(i>0))then
i:=-1 else
if((len1>len2)and(i<0))then
i:=1;
  Result := i;
except
//
end;
end;

function SizeString(isize: real): string;
var
res: string;
begin
try
res:='0';
if(IsNan(isize))then isize:=0;
  if(isize>1073741824)then
  res:=' '+FloatToStr(RoundTo(isize/1024/1024/1024,-2))+mmGB
  else
  if(isize>1048576)then
  res:=' '+FloatToStr(RoundTo(isize/1024/1024,-2))+mmMb
  else
  if(isize>1024)then
  res:=' '+FloatToStr(RoundTo(isize/1024,-2))+mmKb
  else
  res:=' '+FloatToStr(Round(isize))+mmBytes;
Result:= res;
except
FormLog.RecError('8024');
end;
end;
{
function RenCycle(fname: string; nc: integer;var abortall: boolean): string;
var
NList: TList;
fext,nname,res,path,rname,dob: string;
hh,i,nn: integer;
sr: TSearchRec;
rr: TRen;
begin
res:='';
dob:='';
NList:=TList.Create;
try
try
fext:=ExtractFileExt(fname);
rname:=ChangeFileExt(fname,'');
nname:=rname+'*';
rname:=ExtractFileName(rname);
path:=ExtractFilePath(fname);
    hh:=FindFirst(nname,faAnyFile,sr);
    if hh = 0 then
    begin
      New(rr);
      rr.oldname:=path+sr.Name;
      if((sr.Attr and faDirectory)<> 0)then
      rr.isfile:=false
      else
      rr.isfile:=true;
      NList.Add(rr);
      while FindNext(sr) = 0 do
      begin
      New(rr);
      rr.oldname:=path+sr.Name;
      if((sr.Attr and faDirectory)<> 0)then
      rr.isfile:=false
      else
      rr.isfile:=true;
      NList.Add(rr);
      end;
    end;
nn:=NList.Count-1;
NList.Sort(@RenComp);
res:=path+rname;
  while(nn >= 0)do
  begin
    rr:= TRen(NList.Items[nn]);
    if((nn>=(nc-1))and (rr<>nil))then
    begin
      if(rr.isfile)then
      DeleteFile(rr.oldname)
      else begin
      DelDir(rr.oldname,abortall);
      end;
      NList.Delete(nn);
      Finalize(rr^);
      Dispose(rr);
      nn:=NList.Count-1;
      continue;
    end;
    rr.newname:=path+rname+IntToStr(nn+1)+dob+fext;
    if(not RenameFile(rr.oldname,rr.newname))then dob:=dob+'!!!';
    nn:=nn-1;
  end;
finally
for i:=0 to NList.Count-1 do
begin
Finalize(TRen(NList.Items[i])^);
Dispose(TRen(NList.Items[i]));
end;
NList.Free;
FindClose(sr);
end;
except
FormLog.RecError('8026');
end;
Result:=res+dob+fext;
end;
}
{
this function are deleting file and folders from emptying dir for visibility
}
function DelListDir2(inum: integer;LL,DeLL: TList): string;
var
mm,ss: string;
CV,CD: CompData;
ind: integer;
isdelete: boolean;
begin
try
CV:=CompData(LL.Items[inum]);
ss:=CV.dirfrom.dname+'\';
ind:=inum+1;
  if(DeLL.Count = 0)then
  begin
    mm:=ss+ CV.idd.iname +'*';
    CD:=CV;
    while((CD<>nil)and(MatchesMask((ss+CD.idd.iname),mm)))do
    begin
      DeLL.Add(CD);
      if(ind >= LL.Count)then break;
      CD:=CompData(LL.Items[ind]);
      ind:=ind+1;
    end;
  end;
  if(DeLL.Count>0)then
  begin
    CV:=CompData(DeLL.Items[DeLL.Count-1]);
    DeLL.Delete(Dell.Count-1);
    if(CV.idd.ntype = ntFile)then
    begin
    FileSetAttr(ss+CV.idd.iname,0);
    isdelete:= DeleteFile(ss+CV.idd.iname)
    end else
    isdelete:= RemoveDir(ss+CV.idd.iname);

    if isdelete then
    begin
    ss:=rrSuccess;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=33;
    if(CV.dirfrom.report = rpSuccess)then FormLog.RecDel(ss+CV.idd.iname,rrSuccess);
    end else
    begin
    ss:=rrFailure;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[2]:=34;
    if(CV.dirfrom.report = rpFailure)then FormLog.RecDel(ss+CV.idd.iname,rrFailure);
    end;
  end;
except
FormLog.RecError('8027');
end;
  Result:=ss;
end;

function GetTD(fname: string;direction: integer): TDList;
var
dd: TDList;
begin
Result:=nil;
try
 dd:=TDlist.Create;
  dd.DPar.dname:=fname;
  dd.DPar.groupname:=' ';
  dd.DPar.mask:='*';
  dd.DPar.direct:=direction;
  dd.DPar.report:=rpNone;
  dd.DPar.fparam:=fpFirstWrite;
  dd.DPar.over:=opAsk;
  dd.DPar.rencycle:=0;
  dd.DPar.fattr:=faAnyFile;
  dd.DPar.fattrarr[0]:=false;
  dd.DPar.fattrarr[1]:=false;
  dd.DPar.fattrarr[2]:=false;
  dd.DPar.fattrarr[3]:=false;
  dd.DPar.fattrarr[4]:=false;
  dd.DPar.fattrarr[5]:=false;
  dd.DPar.fattrarr[6]:=true;
  dd.DPar.subdirs:=true;
  dd.DPar.exclusive:=false;
  Result:=dd;
except
//
end;
end;

function DelDir(dname: string;var abortall: boolean): real;
var
dd: TDList;
res: real;
begin
Result:=-1;
try
 dd:=GetTD(dname,dpOut);
  try
  res:=CleanDir(dd,dd.DPar.dname,'',dd.DPar.dname,abortall);
  RemoveDir(dname);
  finally
  dd.Free;
  end;
  Result:=res;
except
FormLog.RecError('8028');
end;
end;

function CleanDir(TDL: TDList;dir,pref,root: string;var abortall: boolean): real;
var
id: IDData;
ddir,sd:string;
hh,i: integer;
sum,numb,pp1: real;
sr: TSearchRec;
CDL: TList;
isdelete: boolean;
begin
Result:=-1;
try
sum:=0;
  ddir:=dir;
  dir:=dir+'\*';
  CDL:=TList.Create;
  try

    hh:=FindFirst(dir,TDL.DPar.fattr,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(ddir,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if abortall then
        begin
        Result:=sum;
        exit;
        end;
        if((not MatchesMask(sr.Name,string(TDL.DPar.mask)))and
        ((sr.Attr and faDirectory)= 0))then continue;
        New(id);
        CDL.Add(id);
        if(pref <>'')then
        id.iname:=pref+'\'+sr.Name
        else
        id.iname:=sr.Name;
        if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
        if(((sr.Attr and faDirectory)<> 0)and(TDL.DPar.subdirs))then
        begin
            id.isfile:=false;
            if(pref <>'')then
            numb:=CleanDir(TDL,ddir+'\'+sr.Name,pref+'\'+sr.Name,root,abortall)
            else
            numb:=CleanDir(TDL,ddir+'\'+sr.Name,sr.Name,root,abortall);
        end else
        begin
          id.isfile:=true;
          numb:= pp1;
        end;
        id.isize:=pp1;
        id.iattr:=sr.Attr;
        sum:=sum+numb;
        hh:=FindNext(sr);
      end;
    end;
for i:=0 to CDL.Count-1 do
begin
  id:=IDData(CDL.Items[i]);
  sd:=root+'\'+id.iname;
  if(id.isfile)then
  begin
    FileSetAttr(sd,0);
    isdelete:=DeleteFile(sd);
  end else
  isdelete:=RemoveDir(sd);

  if(isdelete and((TDL.DPar.report = rpSuccess)or(TDL.DPar.report = rpAll)))then
    FormLog.RecDel(sd,rrSuccess)
    else
  if((not isdelete)and((TDL.DPar.report = rpSuccess)or(TDL.DPar.report = rpAll)))then
    FormLog.RecDel(sd,rrFailure);
  Finalize(id^);
  Dispose(id);
end;
  finally
    FindClose(sr);
    CDL.Free;
  end;
Result:=0;
except
FormLog.RecError('8029');
end;
end;


end.
