unit Upass;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Menus, StdCtrls, ExtCtrls, ToolWin, ImgList,Clipbrd;

type
NCell =^NoteCell;
NoteCell = record
len: integer;
sst: string
end;

PassCell = ^PasswordCell;
PasswordCell = record
PassName,Login,Password,ID,ControlStr,MemWord: string[64];
Description,URL: string[255];
Created,Changed: TDateTime;
successidicator: integer;
end;

PassCellU = ^PasswordCellU;
PasswordCellU = record
PassName,Login,Password,ID,ControlStr,MemWord: string[64];
Description,URL,Path: string[255];
Created,Changed: TDateTime;
successidicator: integer;
end;



type
  TFormPurse = class(TForm)
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    TBOk: TToolButton;
    TBDell: TToolButton;
    TBExit: TToolButton;
    TV: TTreeView;
    Splitter1: TSplitter;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit9: TMenuItem;
    Help1: TMenuItem;
    ILPass: TImageList;
    TBSave: TToolButton;
    TBSaveAs: TToolButton;
    TBCust: TToolButton;
    TBLock: TToolButton;
    PC: TPageControl;
    TSPass: TTabSheet;
    TSNotes: TTabSheet;
    PanelPass: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EName: TEdit;
    ELogin: TEdit;
    EPass: TEdit;
    EID: TEdit;
    ECStr: TEdit;
    EMemWord: TEdit;
    MPassDescr: TMemo;
    ECreated: TEdit;
    EChanged: TEdit;
    TSMail: TTabSheet;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    TSCards: TTabSheet;
    Label2: TLabel;
    EURL: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Edit4: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label18: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    TBOpen: TToolButton;
    Timer1: TTimer;
    CBEditPass: TCheckBox;
    TBCaseAdd: TToolButton;
    procedure TBOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure TBOpenClick(Sender: TObject);
    procedure TVClick(Sender: TObject);
    procedure TBExitClick(Sender: TObject);
    procedure ENameClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CBEditPassClick(Sender: TObject);
    procedure TBCaseAddClick(Sender: TObject);
    procedure TBDellClick(Sender: TObject);
  private
    { Private declarations }
  public
    PassList: TList;
    Roots: array[0..4] of TTreeNode;
    SelL: TRect;
    function FindName(nname: string;parent: TTreeNode = nil): TTreeNode;
    procedure SaveList(ppath: string);
    procedure LoadList(ppath: string);
    procedure DelNode(tr: TTreeNode);
    function  GetTreeP(tr: TTreeNode): string;
  end;

var
  FormPurse: TFormPurse;

implementation

uses Udefinitions, Uglobal;

{$R *.dfm}

function TFormPurse.FindName(nname: string;parent: TTreeNode = nil): TTreeNode;
var
i: integer;
tr,trr: TTreeNode;
begin
Result:=nil;
  if(parent = nil)then
  begin
    if(TV.Selected<>nil)then
    begin
      tr:=TV.Selected;
      for i:=0 to tr.Count-1 do
      begin
        trr:=tr.Item[i];
        if(trr.Text = nname)then
        begin
          Result:=trr;
          break;
        end;
      end;
    end;
  end else
  begin
    tr:=parent;
    for i:=0 to tr.Count-1 do
    begin
      trr:=tr.Item[i];
      if(trr.Text = nname)then
      begin
        Result:=trr;
        break;
      end;
    end;
  end;
end;

function TFormPurse.GetTreeP(tr: TTreeNode): string;
begin
Result:=tr.Parent.Text;
if(tr.Parent.Parent<>nil)then
Result:=Result+'/'+GetTreeP(tr.Parent);
end;

procedure TFormPurse.SaveList(ppath: string);
var
i: integer;
ms: TMemoryStream;
pp: PassCellU;
begin
try
ms:= TMemoryStream.Create;
try
  i:=PassList.Count;
  ms.Write(i,sizeof(i));
  for i:=0 to PassList.Count-1 do
  begin
    pp:= PassCellU(PassList.Items[i]);
    ms.Write(pp^,sizeof(pp^));
  end;
  ms.SaveToFile(ppath);
finally
ms.Free;
end;
except
//
end;
end;

procedure TFormPurse.TBOkClick(Sender: TObject);
var
pp: PassCellU;
ctr,ptr: TTreeNode;
begin
  case PC.ActivePageIndex of
    0:
    begin
      if(EName.Text = '')then exit;
      if(TV.Selected<>nil)then
      begin
        if(TV.Selected.Parent = nil)then ptr:=TV.Selected else ptr:=TV.Selected.Parent;
        ctr:=FindName(EName.Text);
        if(ctr = nil)then
        begin
          New(pp);
          ctr:=TV.Items.AddChild(ptr,EName.Text);
          ctr.Data:=pp;
          PassList.Add(pp);
          ctr.ImageIndex:=7;
          ctr.SelectedIndex:=0;
          pp.PassName:=EName.Text;
          pp.Login:=ELogin.Text;
          pp.Password:=EPass.Text;
          pp.ID:=EID.Text;
          pp.ControlStr:=ECStr.Text;
          pp.MemWord:=EMemWord.Text;
          pp.URL:=EURL.Text;
          pp.Description:=MPassDescr.Text;
          pp.Created:=Now;
          pp.Changed:=pp.Created;
          pp.Path:=GetTreeP(ptr);
          ECreated.Text:=DateTimeToStr(pp.Changed);
          EChanged.Text:=ECreated.Text;
        end else
        begin
          pp:=PassCellU(ctr.Data);
          pp.PassName:=EName.Text;
          pp.Login:=ELogin.Text;
          pp.Password:=EPass.Text;
          pp.ID:=EID.Text;
          pp.ControlStr:=ECStr.Text;
          pp.MemWord:=EMemWord.Text;
          pp.URL:=EURL.Text;
          pp.Description:=MPassDescr.Text;
          pp.Changed:=Now;
          ECreated.Text:=DateTimeToStr(pp.Created);
          EChanged.Text:=DateTimeToStr(pp.Changed);
        end;
      end;
    end;
    1:;
    2:;
    3:;
  end;
end;


procedure TFormPurse.FormCreate(Sender: TObject);
begin
  PassList:= TList.Create;
  Roots[0]:=TV.Items.Item[0];
  Roots[1]:=TV.Items.Item[1];
  Roots[2]:=TV.Items.Item[2];
  Roots[3]:=TV.Items.Item[3];
  Roots[4]:=TV.Items.Item[4];
end;

procedure TFormPurse.FormDestroy(Sender: TObject);
var
i: integer;
begin
  for i:=0 to PassList.Count-1 do
  Dispose(PassCell(PassList.Items[i]));
  PassList.Free;
end;

procedure TFormPurse.LoadList(ppath: string);
var
i,num: integer;
ms: TMemoryStream;
pp: PassCell;
pp1: PassCellU;
ctr,ptr: TTreeNode;
begin
try
ms:= TMemoryStream.Create;
New(pp);
try
  if(not FileExists(ppath))then exit;
  ms.LoadFromFile(ppath);
  ms.Read(num,sizeof(num));
  ptr:=Roots[0];
  for i:=0 to num-1 do
  begin
    New(pp1);
   // FillChar(pp,sizeof(pp),0);
    ms.Read(pp^,sizeof(pp^));
    pp1.PassName:=pp.PassName;
    pp1.Login:=pp.Login;
    pp1.Password:=pp.Password;
    pp1.ID:=pp.ID;
    pp1.ControlStr:=pp.ControlStr;
    pp1.MemWord:=pp.MemWord;
    pp1.Description:=pp.Description;
    pp1.URL:=pp.URL;
    pp1.Created:=pp.Created;
    pp1.Changed:=pp.Changed;
    pp1.Path:=ptr.Text;
    PassList.Add(pp1);
    ctr:=TV.Items.AddChild(ptr,pp1.PassName);
    ctr.Data:=pp1;
    ctr.ImageIndex:=7;
    ctr.SelectedIndex:=0;
  end;
  ms.SaveToFile('Pass.dat');
finally
ms.Free;
Dispose(pp);
end;
except
//
end;
end;

procedure TFormPurse.TBSaveClick(Sender: TObject);
begin
SaveList(AppPath+'Purse.dat');
end;

procedure TFormPurse.TBOpenClick(Sender: TObject);
begin
LoadList(AppPath+'Purse.dat');
end;

procedure TFormPurse.TVClick(Sender: TObject);
var
ctr,ptr: TTreeNode;
pp: PassCellU;
begin
  if(TV.Selected<>nil)and(TV.Selected.Data<>nil)then
  begin
    ptr:=TV.Selected.Parent;
    ctr:=TV.Selected;
    SelL:=ctr.DisplayRect(true);
    if(ctr.Data = nil)then exit;
    if(ptr = Roots[0])then
    begin
      PC.ActivePageIndex:=0;
      pp:= PassCellU(ctr.Data);
      EName.Text:=pp.PassName;
      ELogin.Text:=pp.Login;
      EPass.Text:=pp.Password;
      EID.Text:=pp.ID;
      ECStr.Text:=pp.ControlStr;
      EMemWord.Text:=pp.MemWord;
      EURL.Text:=pp.URL;
      MPassDescr.Text:=pp.Description;
      ECreated.Text:=DateTimeToStr(pp.Created);
      EChanged.Text:=DateTimeToStr(pp.Changed);
    end;
  end;
end;

procedure TFormPurse.TBExitClick(Sender: TObject);
begin
Hide;
end;

procedure TFormPurse.ENameClick(Sender: TObject);
begin
if(CBEditPass.Checked)then exit;
if(TEdit(Sender).Color=clYellow)then
TEdit(Sender).Color:=TV.Color
else
TEdit(Sender).Color:=clYellow;
TEdit(Sender).SelectAll;
Clipboard.SetTextBuf(PChar(TEdit(Sender).Text));
end;

procedure TFormPurse.Timer1Timer(Sender: TObject);
begin
DrawCurrent(TV,SelL);
end;

procedure TFormPurse.CBEditPassClick(Sender: TObject);
begin
EName.ReadOnly:=not CBEditPass.Checked;
ELogin.ReadOnly:=not CBEditPass.Checked;
EPass.ReadOnly:=not CBEditPass.Checked;
EID.ReadOnly:=not CBEditPass.Checked;
ECStr.ReadOnly:=not CBEditPass.Checked;
EMemWord.ReadOnly:=not CBEditPass.Checked;
EURL.ReadOnly:=not CBEditPass.Checked;
MPassDescr.ReadOnly:=not CBEditPass.Checked;
end;

procedure TFormPurse.TBCaseAddClick(Sender: TObject);
var
ctr,ptr: TTreeNode;
name: string;
begin
  if(TV.Selected <> nil)then
  begin
    ptr:=TV.Selected;
    name:=caDefName;
    ctr:=FindName(name);
    while(ctr <> nil)do
    begin
      name:=name+'+';
      ctr:=FindName(name);
    end;
    ctr:=TV.Items.AddChild(ptr,name);
    ctr.ImageIndex:=12;
    ctr.SelectedIndex:=12;
    ctr.Data:=nil;
    ptr.Expand(false);
    //TV.ClearSelection();
    //ctr.Selected:=true;
  end;
end;

procedure TFormPurse.DelNode(tr: TTreeNode);
begin
if(tr = nil)or(tr.Parent = nil)then exit;
  while tr.Count>0 do
  DelNode(tr.Item[0]);
  if(tr.Data<>nil)then
  Dispose(tr.Data);
  tr.Delete;
end;

procedure TFormPurse.TBDellClick(Sender: TObject);
begin
  DelNode(TV.Selected);
end;

end.
