unit Udefinitions;

interface

uses Windows,Classes,Types,SysUtils,ComCtrls,SyncObjs,Masks,ShellAPI, FTPSock,
FtpData,StrUtils,Ftp,Forms,Contnrs,Graphics,ShlObj,ShellCtrls,Messages,Controls;


{$I DirSync.inc}
{$I DirSync_Eng.msg}
type EHandException = class(Exception);

const

//Names of files
FAppDataSave = 'DirSyncCust_1_2_403.dat';
FAppVersion = '1.2';
FAppTitle1 = 'DirSync';
FAppTitle2 = 'TreeSizeFinderPro';
FAppTitle3 = 'SUSynchronizer';

//appcode
AppCode = 0;
//sort items
siIDRec = 0;
siCompData = 1;
ArSz = 40;
//cause appearance
caNoop       = 0;
caUnique     = 1;
caMaster     = 2;
caLastWrite  = 3;
caFirstWrite = 4;
caSizeMore   = 5;
caSizeLess   = 6;

//DiskAppear/disappear
daAppear = 0;
daDisAppear = 1;

//listnumbers
lnLTop       = 0;
lnLFTop      = 1;
lnLView      = 2;
lnLFView     = 3;
lnLChildren  = 4;
lnLTemp      = 5;
lnLNotifiers = 6;

//paramsort
psName   = 0;
psLabel  = 1;
psIfs    = 2;
psSize   = 3;
psDateCr = 4;
psTimeCr = 5;
psDateAc = 6;
psTimeAc = 7;
psDateWr = 8;
psTimeWr = 9;
psCommon = 10;
psEachOwnDate = 11;
psEachOwnTime = 12;
psFrom   = 13;
psTo     = 14;

DefSortColumn = 19;
//filtertypes
ftType = 0;
ftFiles = 1;
ftFolders = 2;
ftDeletedFiles = 3;
ftNewFiles = 4;
ftChangedFiles = 5;
ftNewFolders = 6;
ftDeletedFolders = 7;


//help Files
hfGrSync = 'GroupSync.htm';
hfSync = 'Synchronization.htm';
hfControl ='ControlCenter.htm';
hfLog = 'Log.htm';
hfTwinEx = 'TwinExplorer.htm';
hfCustomize = 'Customize.htm';
hfRenameTemplate = 'RenameTemplate.htm';
hfFilter = 'Filter.htm';
hfRename = 'Rename.htm';
hfMaskMaster = 'MaskMaster.htm';

MaxHighFileTime = $24C73B5B;
MaxLowFileTime  = $E5F1000;
//chartoperations
coCreateTop     = 1;
coLoadHistory   = 2;
coSaveHistory   = 3;
coClearSelected = 4;
coClearAll      = 5;
coEmptySelected = 6;
coSortTop       = 7;

//recchanges
rcSizeUp   =$00000001;
rcWrite    =$00000002;
rcAccess   =$00000004;
rcSizeDown =$00000008;
rcCreate   =$00000010;

//jobtypes
jtLocal        = 0;
jtRemoteFTP    = 1;
jtRemoteNative = 2;

//action index
aiNoop           =-1;
aiShow           = 0;
aiMoveToRecycle  = 1;
aiDelete         = 2;
aiCopyTo         = 3;
aiMoveTo         = 4;
aiRenameTo       = 5;

aiEmpty          = 6;
aiEmptyToRecycle = 7;
aiMoveContentTo  = 8;
aiProperties     = 9;
aiCompare        =10;


EnNoChangeChildren: set of byte = [aiMoveToRecycle,aiDelete,aiMoveTo,aiEmpty,aiEmptyToRecycle];
EnDirToNone: set of byte = [aiShow,aiMoveToRecycle,aiDelete,aiRenameTo,
aiEmpty,aiEmptyToRecycle];
EnDirNoExplore: set of byte = [aiMoveToRecycle,aiRenameTo,aiEmptyToRecycle];
EnDirNeedExplore: set of byte = [aiDelete,aiCopyTo,aiMoveTo,aiEmpty,aiMoveContentTo];
EnDelRec: set of byte = [aiMoveToRecycle,aiDelete,aiMoveTo,aiRenameTo];
EnSpaceNeed: set of byte = [aiCopyTo,aiMoveTo,aiMoveContentTo];
EnActive: set of byte = [aiMoveToRecycle,aiDelete,aiCopyTo,aiMoveTo,aiRenameTo,aiEmpty,
aiEmptyToRecycle,aiMoveContentTo];

//messages for exchange opeeations
mmExchgOperations = 'In This window you may exchange only kindred operations';
//tableicons
tiExecOK         = 10;
tiExecErr        = 11;
tiExists         = 12;
tiNotFind        = 9;
tiFile           = 17; //1
tiDir            = 16; //0
tiFileDel        = 19; //+10
tiFileNew        = 20;
tiFileChg        = 21;
tiDirNew         = 22;
tiDirDel         = 23;
tiExecAbort      = 24;

//dirtypes
dtDir     = 0;
dtRecycle = 1;
dtDelete  = 2;
dtRename  = 3;
dtShow    = 4;

EnStdTypes: set of byte = [aiShow,aiMoveToRecycle,aiDelete,aiRenameTo,
aiEmpty,aiEmptyToRecycle];

StdTypesArr: array[0..10] of string = (
tsShow,tsRecycle,tsDelete,
tsCopy,tsMove,tsRename,tsDelete,
tsRecycle,tsMoveContent,tsProperties,tsCompare
);

OperationsArr: array[0..10] of string = (
tsShow ,tsMoveToRecycle,tsDelete,
tsCopy,tsMove,tsRename,tsEmpty,
tsEmptyToRecycle,tsMoveContent,
tsProperties,tsCompare
);

//showFlags
sfAll = 0;
sfOnlyDir = 1;

crCursorPieHold = 12;
crCursorDragM = 13;

//RenameContext
rcRenAll = 0;
rcIsExists =1;

sizedivider = ' -';
//marker of successfull loading
msSuccsess = 296423827;

//Button Messages
bmNoButtons = 0;
bmYes       = 1;
bmNo        = 2;
bmYesToAll  = 3;
bmNoToAll   = 4;
bmRenNew    = 5;
bmRenOld    = 6;
bmRenAllNew = 7;
bmRenAllOld = 8;
bmCancel    = 9;
bmAsk       = 10;
bmSuspend   = 11;
bmRenCycle  = 12;

//Files Parameters
fpLastWrite  = 0;
fpFirstWrite = 1;
fpSizeMore   = 2;
fpSizeLess   = 3;
fpMaster     = 4;
fpSlave      = 5;
fpEmpty      = 6;
fpPlain      = 7;
fpRename     = 8;
fpLastChanges= 9;
fpSmartSlave =10;
fpCompare    =11;


//Overwrite Parameters   for active side
opAsk      = 0;
opAll      = 1;
opNone     = 2;
opRenNew   = 3;
opRenOld   = 4;
opRenCycle = 5;

//Report Parameters
rpAll     = 0;
rpSuccess = 1;
rpFailure = 2;
rpNone    = 3;

//Direction Parameters
dpIn         = 0;
dpOut        = 1;
dpInOut      = 2;
dpOutOut     = 3;
dpInOutOut   = 4;
dpOnlyReport = 5;

//SyncEvent Parameters
spManual = 0;
spTimer  = 1;
spNotify = 2;

//FileActions
faCopy   = 0;
faMove   = 1;
faDelete = 2;

//Notify Filters
NFilters: array[0..7] of dword = (
FILE_NOTIFY_CHANGE_FILE_NAME,
FILE_NOTIFY_CHANGE_DIR_NAME,
FILE_NOTIFY_CHANGE_ATTRIBUTES,
FILE_NOTIFY_CHANGE_SIZE,
FILE_NOTIFY_CHANGE_LAST_WRITE,
FILE_NOTIFY_CHANGE_LAST_ACCESS,
FILE_NOTIFY_CHANGE_CREATION,
FILE_NOTIFY_CHANGE_SECURITY);

//File Attributes
FileAttr: array[0..6] of integer = (faReadOnly,faHidden,faSysFile,
faVolumeID,faDirectory,faArchive, faAnyFile);

//Common Parameters
cpNumAttRename = 300;
//0001-0008 - timers error
//USync - 1000
//UGrSync - 2000
//Ugrsyncth - 3000
//ULog - 4000
//Udefinitions - 5000
//UCustomize - 6000
//UChart - 7000
//UGlobal - 8000 -30
//UMulticomp - 9000

//ShowLogCodes
slcFirst = 0;
slcBBack = 1;
slcBack  = 2;
slcNext  = 3;
slcNNext = 4;
slcLast  = 5;
slcAll   = 6;
slcFiltered = 7;
slcCurrent = 8;


//ttypes
ttJobHist = 0;
ttDirP = 1;
ttDirG = 2;
ttRJob = 3;


//what
wMIN_FREE = 0;
wMAX_BUSY = 1;
wMAX_SIZE = 2;
wCHANGE   = 3;
wCOMPLETION=4;
wAPPEAR    =5;
wDISAPPEAR =6;
wSUCCESS   =7;
wFAILURE   =8;
wBEGINNING =9;


WhatTypes: array[0..9] of byte =(wMIN_FREE,wMAX_BUSY,wMAX_SIZE,wCHANGE,wCOMPLETION,
wAPPEAR,wDISAPPEAR,wSUCCESS,wFAILURE,wBEGINNING);
WhatTypesStr: array[0..9] of string =(sMIN_FREE,sMAX_BUSY,sMAX_SIZE,sCHANGE,sCOMPLETION,
sAPPEAR,sDISAPPEAR,sSUCCESS,sFAILURE,sBEGINNING);

WhatTypeArr: array[4..8] of string =(sCOMPLETION,'','',sSUCCESS,sFAILURE);

//units
ubytes = 0;
uKb    = 1;
uMb    = 2;
uGb    = 3;

eUnitsTypes: array[0..3] of byte =(ubytes,uKb,uMb,uGb);
eUnitsTypesStr: array[0..3] of string =(usbytes,usKb,usMb,usGb);

//actions
acBEEP        = 0;
acPLAY_SOUND  = 1;
acSEND_MAIL   = 2;
acEXECUTE     = 3;
acRUN_SYNC    = 4;
acSHUT_DOWN   = 5;
acMoveToRecycle  = 6;
acDelete         = 7;
acCopy           = 8;
acMove           = 9;
acRename         = 10;
acEmpty          = 11;
acEmptyToRecycle = 12;
acMoveContent    = 13;

eActionsTypes: array[0..13] of byte =(acBEEP,acPLAY_SOUND,acSEND_MAIL,acEXECUTE,
acRUN_SYNC,acSHUT_DOWN,acMoveToRecycle,acDelete,acCopy,acMove,acRename,
acEmpty,acEmptyToRecycle,acMoveContent);

eActionsTypesStr: array[0..13] of string =(sBEEP,sPLAY_SOUND,sSEND_MAIL,sEXECUTE,
sRUN_SYNC,sSHUT_DOWN,sMoveToRecycle,sDelete,sCopy,sMove,sRename,
sEmpty,sEmptyToRecycle,sMoveContent);

//params composer
pComposer = '***';

//mpactions
mpJUMP    = 0;
mpEXEC    = 1;
mpShSync  = 2;
mpShChart = 3;
mpShTwin  = 4;
mpShLog   = 5;
mpShCust  = 6;
mpShMain  = 7;

//top kind
tpMAX_SIZE    = 0;
tpLAST_CREATE = 1;
tpLAST_ACCESS = 2;
tpLAST_WRITE  = 3;

//top actions
taShow           = -1;
taMoveToRecycle  = 1;
taEmptyToRecycle = 2;
taDELETE         = 3;
taEMPTY          = 4;
taMOVE           = 5;
//

//nodes types
ntDir     = 0;
ntFile    = 1;
ntDisk    = 2;
ntFree    = 3;
ntBusy    = 4;
ntScan    = 5;
ntRoot    = 6;
ntHistory = 7;
ntLog     = 8;
ntFileDel = 9;
ntFileNew = 10;
ntFileChg = 11;
ntDirNew  = 12;
ntDirDel  = 13;
ntCDRom   = 14;
ntRemovable=15;
ntUnknown = 16;
ntRemote  = 17;
ntRam     = 18;
ntSysFolders = 19;

ReportColors: array[9..13] of integer = (
$000000af,
$00ff0000,
$00006f00,
$00ff0000,
$000000af
);
TChngStr: array[9..13] of string = (
tcDisappear      ,
tcAppear   ,
tcChanging    ,
tcAppear      ,
tcDisappear
);

TObjStr: array[0..18] of string = (
mmDir   ,
mmFile1 ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmFile1 ,
mmFile1 ,
mmFile1 ,
mmDir   ,
mmDir   ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk  ,
mmDisk
);
//addtypes
adInt = 0;
adChr = 1;
adDate= 2;
adTime= 3;
adDateTime=4;

//CompDataStates
cdsRun = 0;
cdsSkip= 1;
cdsOk  = 2;
cdsFail= 3;

//commands
coExplore = 0;
coExpand  = 1;
coAbort   = 2;
coChangeDirectory         = 3;
coChangeToParentDirectory = 4;
coCreateDirectory = 5;
coDeleteDirectory = 6;
coDeleteFile  = 7;
coFileSetAttr = 8;
coGetFile     = 9;
coLogin       = 10;
coPutFile     = 11;
coStart       = 12;
coQuit        = 13;
coRefresh     = 14;
coRenameFile  = 15;
coGetPropTo   = 16;
coPrepareEx   = 17;

FTPComm: array[0..17] of integer = (
coExplore                 ,
coExpand                  ,
coAbort                   ,
coChangeDirectory         ,
coChangeToParentDirectory ,
coCreateDirectory         ,
coDeleteDirectory         ,
coDeleteFile              ,
coFileSetAttr             ,
coGetFile                 ,
coLogin                   ,
coPutFile                 ,
coStart                   ,
coQuit                    ,
coRefresh                 ,
coRenameFile              ,
coGetPropTo               ,
coPrepareEx
);

FTPCommColors: array[0..17] of integer = (
$00ff0000, //Explore
$00ff0000, //Expand
$000000af, //Abort
$00006f00, //ChangeDirectory
$00006f00, //ChangeToParentDirectory
$0000f800, //CreateDirectory
$000000af, //DeleteDirectory
$000000af, //DeleteFile
$00ff0000, //FileSetAttr
$00006f00, //GetFile
$00fa00fa, //Login
$00ff0000, //PutFile
$00fa00fa, //Start
$00000000, //Quit
$00ff8800, //Refresh
$00af0000, //RenameFile
$00af0000, //GetPropTo
$00af0000  //PrepareEx
);

FTPCommStr: array[0..17] of string = (
scoExplore                 ,
scoExpand                  ,
scoAbort                   ,
scoChangeDirectory         ,
scoChangeToParentDirectory ,
scoCreateDirectory         ,
scoDeleteDirectory         ,
scoDeleteFile              ,
scoFileSetAttr             ,
scoGetFile                 ,
scoLogin                   ,
scoPutFile                 ,
scoStart                   ,
scoQuit                    ,
scoRefresh                 ,
scoRenameFile              ,
scoGetPropTo               ,
scoPrepareEx
);

type
SPar = ^SortPar;
SortPar = record
Column,Tag,Sind: integer;
end;

type
ComRec = ^TCommandRec;
TCommandRec = record
icomm: integer;
dname,dnewname,smask: string;
attr: integer;
async,executed,selall: boolean;
ms: TMemoryStream;
tr: TTreeNode;
OnlyDir: boolean;
LVEx, LVAttr: TListView;
prr: Pointer;
end;

type    TMessageType  = (msgCommand, {$ifndef NODEBUG}msgDebug,{$endif} msgError, msgException, msgReply, msgStatus);

type
RegSt = ^UnStruct;
UnStruct = record
RegKey1: array[0..ArSz] of char;
Bak,Mess1,Mess2: string[ArSz];
RegKey2: array[0..ArSz] of char;
Rc: integer;
end;

type
ReqD = ^ReqDlgRec;
ReqDlgRec = record
mess,fname,dfrom,dto: string;
isdir,requestflag,lockjob: boolean;
dbutton: integer;
pCompData: Pointer;
pIDRec: Pointer;
end;

type
JobHist = ^JobHistory;
JobHistory = record
jstart,jstop: TDateTime;
jsuccess,listind,starter: integer;
successidicator: integer;
end;

type
DirPH=^DirParamHist;
DirParamHist=record
direct,report,fparam,over,rencycle,fattr: integer;
dname: string[250];
groupname,mask,renmask: string[40];
notifyfilter: dword;
notfilt: array[0..7] of boolean;
fattrarr: array[0..6] of boolean;
subdirs,exclusive,notify,maskignoredir,renameall: boolean;
numExRecords: integer;// number of string[250]
successidicator: integer;
end;

type
DirPH2=^DirParamHist2;
DirParamHist2=record
successidicator1,versionid: integer;
direct,report,fparam,over,rencycle,fattr: integer;
dname: string[250];
groupname,mask,renmask: string[40];
notifyfilter: dword;
notfilt: array[0..7] of boolean;
fattrarr: array[0..6] of boolean;
subdirs,exclusive,notify,maskignoredir,renameall: boolean;
numExRecords: integer;// number of string[250]
successidicator: integer;
end;

type
IDData = ^idata;
idata = record
isfile: boolean;
iname: string;
isize: real;
itime: TDateTime;
iattr: integer;
end;

type
RecSave = ^DdataSave;
DdataSave = record
ntype: integer;
isize: real;
timeaccess,timewrite,timecreate,timecheck: TDateTime;
iattr: integer;
inamelen: integer;
numchild: integer;
inlog: boolean;
successidicator: integer;
end;

type
TRen = ^rendata;
rendata = record
isfile: boolean;
oldname,newname: string;
end;

type
TLRec = ^logrec;
logrec = record
rtype: string[10];
rdate: string[12];
rtime: string[10];
rdescr: string[255];
ruser: string[25];
res: string[8];
end;

type
drive =^tdr;
tdr = record
name: string;
ind: integer;
end;

type
TTRec = ^irect;
irect=record
RR: TRect;
dname: string;
end;

//job kind
const
jkHistory = 0;
jkSync    = 1;
jkTwin    = 2;
jkTemp    = 3;

//Job mess
jmAbort   = -1;
jmFailure = -2;
jmSuccess = -3;
jmRun     = -4;

type
HistAct = ^HistoryAction;
HistoryAction = record
what,action,units: integer;
value: real;
where,operation,mess: string[250];
successidicator: integer;
end;

type
FTPSave = ^FTPRec;
FTPRec = record
Account,Server,User,Password,ProxyServer,ProxyUser,ProxyPassword,FileMask: string[40];
InitialDirectory: string[200];
Asynchronous,Cashe,Passive,MultiThreaded: boolean;
ProxyType,ProxyPort,ServerType,CacheExpire,NoopInterval,Port: integer;
TimeOut,TransferMode,Retries,RetryInterval: integer;
end;

type
RJobSave = ^JobRecord;
JobRecord = record
jobkind,jobtype: Cardinal;
syncevent,iday,ihour,imin,idayw,idaym,fattr,savelast: integer;
nexttim,lasttim: TDateTime;
tcreate,tchange: TDateTime;
NumItems: integer;// array of DirP;
NumHist: integer;// array of JobHist;
NumAction: integer;
jobname,mask: string[40];
notifyfilter: dword;
sysname: string[18];
shedule,anyscan,notify,exclusive,autosave : boolean;
subdirs,maskignoredir,savelastdays: boolean;
notfilt: array[0..7] of boolean;
fattrarr: array[0..6] of boolean;
isFTP: FTPRec;
successidicator: integer;
end;

type
TopPar = ^TopParam;
TopParam = record
sTime,sDate,sMask,sExt: string;
asTime,asDate,asMask,asExt,asFrom,asTo: string;
iAction,iResult,iExec,iDateType: integer;
iType: integer;
sFrom,sTo: string;
end;

type
  SyncATh = class(TThread)
  protected
    procedure Execute; override;
  public
    GS: Pointer;
    flag,showmode: integer;
end;

type
SysNode = class(TWinControl,IShellCommandVerb)
private
    FRoot,
    FOldRoot : TRoot;
    FRootFolder: TShellFolder;
    FObjectTypes: TShellObjectTypes;
    FImages: Integer;
    FLoadingRoot,
    FAutoContext,
    FUpdating: Boolean;
    FAutoRefresh,
    FImageListChanging,
    FUseShellImages: Boolean;
    FNotifier: TShellChangeNotifier;
    FOnAddFolder: TAddFolderEvent;
    FSavePath: string;
    FNodeToMonitor: TTreeNode;
    function FolderExists(FindID: PItemIDList; InNode: TTreeNode): TTreeNode;
    function GetFolder(Index: Integer): TShellFolder;
    function GetPath: string;
    procedure SetPath(const Value: string);
    procedure SetPathFromID(ID: PItemIDList);
    procedure SetRoot(const Value: TRoot);
    procedure SetUseShellImages(const Value: Boolean);
    procedure SetAutoRefresh(const Value: boolean);
protected
    //function CanChange(Node: TTreeNode): Boolean; override;
    //function CanExpand(Node: TTreeNode): Boolean; override;
    procedure CreateRoot;
    //procedure CreateWnd; override;
    //procedure DestroyWnd; override;
    //procedure DoContextPopup(MousePos: TPoint; var Handled: Boolean); override;
    //procedure Edit(const Item: TTVItem); override;
    procedure GetImageIndex(Node: TTreeNode);
    procedure GetSelectedIndex(Node: TTreeNode);
    procedure InitNode(NewNode: TTreeNode; ID: PItemIDList; ParentNode: TTreeNode);
    //procedure Loaded; override;
    //procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Delete(Node: TTreeNode);
    function NodeFromAbsoluteID(StartNode: TTreeNode; ID: PItemIDList): TTreeNode;
    function NodeFromRelativeID(ParentNode: TTreeNode; ID: PItemIDList): TTreeNode;
    //procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure PopulateNode(Node: TTreeNode);
    procedure RootChanged;
   // procedure SetObjectTypes(Value: TShellObjectTypes); virtual;
    //procedure WMDestroy(var Message: TWMDestroy);
    procedure WndProc(var Message: TMessage);
    procedure ClearItems;
    procedure RefreshEvent;
  public
    constructor Create(AOwner: TComponent);
    destructor Destroy;
    procedure Refresh(Node: TTreeNode);
    function SelectedFolder: TShellFolder;
    procedure CommandCompleted(Verb: String; Succeeded: Boolean);
    procedure ExecuteCommand(Verb: String; var Handled: Boolean);
end;

type
RJob = class
private
    FComplete: boolean;
    FBabort: boolean;
    Fmaxval2,Fposition2,Fmaxval,Fposition: integer;
    procedure SetComplete(compval: boolean);
    procedure SetAbort(compval: boolean);virtual;
    procedure Setmaxval(const Value: integer);
    procedure Setmaxval2(const Value: integer);
    procedure Setposition(const Value: integer);
    procedure Setposition2(const Value: integer);
public
//lists
LHist,LItems,LActions,LTop,LFTop: TList;
LView,LFView,LChildren,LTemp,LNotifiers: TList;
QQ,SortPar,SortParTop: TList;
QNot: TStringList;
//integers
CycleVar: integer;

listindex,starter,appear,disappear,change,numdisk: integer;
RetryIndex,DialogButton: integer;
TopFrom,TopTo,TotalMinus: integer;
iFrom,iTo: integer;
//floats
cursize: real;

//booleans
enabled,changed_job,changed_tree,changed_history,topped,filterchange: boolean;
needchecktree,woserror,needshowprop,defaultfilter: boolean;
bskip,ExistsJobError,StopOnError,CloseIfNoError: boolean;
TBShowAllFDown,TBIcoDown,syncended,prescandirs: boolean;
//strings
SavePath,NowScan,StageStr,MessStr,MessStr1: string;
SysName: string;

//pointers
pLastHist: JobHist;
pabort,pskip: ^boolean;
Save: JobRecord;
trr: TTreeNode;

PNotify,PExecTh: TThread;
PServiceTh: SyncATh;
TP: TopParam;
RDR: ReqDlgRec;
TimScan: TDateTime;
TTab:  TTabSheet;
TTree: TTreeView;
LVDSync: TListView;
hMess: Cardinal;
PParentJob: RJob;
CNode: Pointer;
LAExt,LADate,LATime,LAPath: TStringList;
Sys1: SysNode;

property  complete: boolean read FComplete write SetComplete;
property  babort: boolean read FBabort write SetAbort;
property  maxval2: integer read Fmaxval2 write Setmaxval2;
property  maxval: integer read Fmaxval write Setmaxval;
property  position2: integer read Fposition2 write Setposition2;
property  position: integer read Fposition write Setposition;
/////////////
procedure MarkNode(dp: Pointer = nil);
procedure EnumSysFolders(tr: TTreeNode;OnlyDir: boolean=true);
procedure SetLTopColumns(LVTop: TListView);
procedure SetLVDSyncColumns;
procedure ClearSortView;
procedure ClearSortTop;
procedure AddSortViewCol(Col: TListColumn;si: integer);
procedure AddSortTopCol(Col: TListColumn;si: integer);
procedure ManViewCol(Col: TListColumn;si: integer);
procedure ManTopCol(Col: TListColumn;si: integer);
procedure DelSortViewCol(Col: TListColumn);
procedure DelSortTopCol(Col: TListColumn);
function  CheckDefaultFilters: boolean;
function  CheckDSort: boolean;
function  CheckDFilter: boolean;
/////////////////
function  BindChild(rj: RJob): RJob;
procedure BreakChild(rj: RJob=nil);
procedure DriveExec(state: integer=jmRun;ps: integer=-1;ps2: integer=-1;mx: integer=-1;mx2: integer=-1);
//////////////////////////////////////////////////////////////////////////////////
procedure StartNotifyWatch(dp: Pointer = nil);
procedure StopNotifyWatch(dp: Pointer = nil);
procedure MyConvertFileTime(sr: TSearchRec;var tcreate: TDateTime;
var taccess: TDateTime;var twrite: TDateTime);
procedure CopyPropIDRec(psrc,pdest: Pointer);

procedure ScanSH;
procedure SyncHide;
procedure ScanAll;
procedure AbortJob;
procedure SortList(SList: integer;ItemType: integer = 0);
procedure ShowNodeRecords(TBShowAllFDown,TBIcoDown: boolean;tto: integer;num: integer = -1);
procedure AnalyzeItemList(KL: TList);
procedure AnalyzeIt(its: integer);
procedure SetDefFilters;
procedure ExpandTreeNode1(tr: TTreeNode;OnlyDir: boolean=true);
procedure ExploreFolder1(prr: Pointer);
procedure FilterView;
procedure FilterTop;
procedure CheckRescan;
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
function  CreateI(ddir: string;isfile: boolean = true): boolean;virtual;
procedure ExpandTreeNode(tr: TTreeNode;OnlyDir: boolean=true);virtual;
procedure ExploreFolder(TBShowAllFDown,TBIcoDown: boolean;prr: Pointer);virtual;
procedure PrepareEx(dir: string;LVEx,LVAttr: TListView;smask: string;selall: boolean);virtual;
procedure PrepareCompare(dir: string;ExList: TStringList);virtual;
procedure RescanDir(rec: Pointer);virtual;
procedure ReadSystem;virtual;
function  Start(needthread: boolean=true): boolean;virtual;
function  SetDateI(fname: string;timeaccess,timewrite,timecreate: TDateTime): boolean;virtual;
procedure BreakJob;virtual;

procedure EnumDir(pr: Pointer;dir: string);virtual;
procedure ScanDisk(pr: Pointer;dir: string);virtual;
procedure ScanHistory;virtual;
procedure Rescan(pn,pd,lg: Pointer;dir: string);virtual;

procedure RescanEx(pn,pd,lg: Pointer;dir: string);virtual;
function  RenCycle(fname: string; nc: integer): string;virtual;
//******************************
function  ExistsTo(ddir: string;isfile: boolean=true): boolean ;virtual;
function  GetPropTo(var ddir: string; pIDRec: Pointer;dToName: string=''): boolean;virtual;
function  ExistsI(pr: Pointer): boolean ;virtual;
function  ExistsS(dname: string;isfile: boolean=true): boolean ;virtual;

function  CopyI(dfromdto: string): boolean;virtual;
function  MoveI(dfromdto: string): boolean;virtual;
function  RenameI(dfromdto: string): boolean;virtual;
function  MoveContentI(dfromdto: string): boolean;virtual;

function  DeleteI(dname: string): boolean;virtual;
function  EmptyI(fname: string):real;virtual;
function  EmptyToRecycle(fname: string):integer;virtual;

function  CopyII(pCompData: Pointer;ddir: string): boolean;virtual;

function  DeleteFrom(pCompData: Pointer): boolean ;virtual;
function  DeleteTo(pCompData: Pointer): boolean ;virtual;
function  DeleteS(dname: string; isfile: boolean;recurse: boolean=true): boolean;virtual;


function  RenameDest(const ddir: string;const newname: string): boolean ;virtual;
function  RenameSrc(pCompData: Pointer;newname: string): boolean;virtual;

function  CreateTo(ddir: string): boolean ;virtual;
function  CreateFrom(pCompData: Pointer): boolean;virtual;
function  CompletePut: boolean;virtual;

function  MoveToRecycle(fname: string):integer;virtual;
procedure ListDirEx(pTDL: Pointer;dir,pref: string);virtual;
function  ListDir(pTDL: Pointer;dir,pref: string;pprev: Pointer = nil;pdd: Pointer = nil): real;virtual;

function  GetSrcFrom(pCompData: Pointer): TStream;virtual;
function  GetSrcTo(pCompData: Pointer;ddir: string): TStream;virtual;
procedure FinalizeSrc(sf: TStream);virtual;

function LastJobError: string; virtual;
procedure CollapseNode(Node: TTreeNode);virtual;
procedure ExpandNode(Node: TTreeNode);virtual;
function SetAttr(const FileName: string; Attr: Integer): Integer;virtual;
function SetDateTo(pCompData: Pointer): boolean;virtual;
//******************************

procedure DiffScanSys(nn,nd,lg :Pointer);
procedure ClearTree(sdk: Pointer);
procedure ScanEx;
function  InLog(lg,itm: Pointer):boolean;
function  WaitEvent(ehandle: Cardinal;maxtime: Cardinal=0): Cardinal;

procedure ClearTree1(sdk: Pointer);
procedure EmptyNode(sdk: Pointer);
function CRec(iname: string='';parent: Pointer=nil;isize:real=0;
                    timeaccess:TDateTime=0;
                    timewrite:TDateTime=0;
                    timecreate:TDateTime=0;
                    timecheck:TDateTime=0;
                    iattr: integer=0;ntype: integer=-1): Pointer;
constructor Create; reintroduce;
destructor Destroy; override;
end;

type
   TFTPThread = class(TThread)
   protected
    procedure Execute; override;
    procedure SetNodeState(Node: TTreeNode;st: integer);
    procedure SetNodeState2;
   private
    QQ: TList;
    prj: Pointer;
    Nd: TTreeNode;
    stt: integer;
   public
    ff: TMFtp;
    hLock: Cardinal;
    thlock: boolean;
    procedure Abort;
    function CreateComm: ComRec;
    function GetProp(var ddir: string; pIDRec: Pointer): boolean;
    function ChangeDirectory(dir: string): boolean;
    function ChangeToParentDirectory : boolean;
    function CreateDirectory(dir: string): boolean;
    function DeleteDirectory(dir: string): boolean;
    function DeleteFile(dir: string): boolean;
    function FileSetAttr(dir: string;attr: integer): boolean;
    function GetFile(dir: string): TStream;
    function Login : boolean;
    function PutFile(ms: TMemoryStream): boolean;
    procedure Quit;
    function Refresh: boolean;
    function RenameFile(dir: string): boolean;
    function PrepEx(dir: string; LVEx, LVAttr: TListView;smask: string; selall: boolean): boolean;
end;

type ManTabProc1 = procedure(rr: RJobSave;PgCont: TPageControl;bcreate: boolean=true);

type
FTPJob = class(RJob)
private
procedure SetAbort(compval: boolean);override;
public
mtp: ManTabProc1;
mFTP: TmFTP;
ttf: TFTPThread;
MessList: TStringList;
needexpand,needlist: TTreeNode;
TwinExItem: TListItem;
onneedlist,filereceived,messlock: boolean;
pcrec,pFrame: Pointer;
rootname,ftproot,LastError,putdir: string;
//putms: TMemoryStream;

////////////////////////////////////
procedure AddMessage(Msg: String; MsgType: TMessageType);
procedure CheckConnect;
procedure MFtp1LoggedIn(Sender: TObject);
procedure MFtp1ListingDone(Sender: TObject);
procedure MFtp1FtpReady(Sender: TObject);
procedure MFtp1FtpQuit(Sender: TObject);
procedure MFtp1FtpNeedInfo(Sender: TObject; need: TMFtpInfoNeeded; var Value: String);
procedure MFtp1FtpInfo(Sender: TObject; info: FtpInfo;addinfo: String);
procedure MFtp1FtpError(Sender: TObject; error: FtpError;addinfo: String);
procedure MFtp1FtpBusy(Sender: TObject);
procedure MFtp1FileStored(Sender: TObject);
procedure MFtp1FileRenamed(Sender: TObject);
procedure MFtp1FileReceived(Sender: TObject);
procedure MFtp1FileDeleted(Sender: TObject);
procedure MFtp1DirectoryDeleted(Sender: TObject);
procedure MFtp1DirectoryCreated(Sender: TObject);
procedure MFtp1DirectoryChanged(Sender: TObject);
procedure MFtp1Aborted(Sender: TObject);
////////////////////////////////////
function  CreateI(ddir: string;isfile: boolean = true): boolean;override;
procedure ExpandTreeNode(tr: TTreeNode;OnlyDir: boolean=true);override;
procedure ExploreFolder(TBShowAllFDown,TBIcoDown: boolean;prr: Pointer);override;

function  Start(async: boolean=true): boolean;override;
function  CreateTo(ddir: string): boolean ;override;
function  CreateFrom(pCompData: Pointer): boolean ;override;
function  MoveToRecycle(fname: string):integer;override;
procedure BreakJob;override;

procedure ListDirEx(pTDL: Pointer;dir,pref: string);override;
function  ListDir(pTDL: Pointer;dir,pref: string;pprev: Pointer = nil;pdd: Pointer = nil): real;override;
procedure EnumDir(pr: Pointer;dir: string);override;
function  SetDateI(fname: string;timeaccess,timewrite,timecreate: TDateTime): boolean;override;

//***************************************************
function  ExistsTo(ddir: string;isfile: boolean=true): boolean ;override;
function  ExistsI(pr: Pointer): boolean ;override;
function  ExistsS(dname: string;isfile: boolean=true): boolean ;override;
function  GetPropTo(var ddir: string; pIDRec: Pointer;dToName: string=''): boolean;override;

function  DeleteFrom(pCompData: Pointer): boolean ;override;
function  DeleteTo(pCompData: Pointer): boolean ;override;
function  DeleteS(dname: string; isfile: boolean;recurse: boolean=true): boolean;override;
function  DeleteI(dname: string): boolean;override;

function  CopyI(dfromdto: string): boolean;override;
function  MoveI(dfromdto: string): boolean;override;
function  RenameI(dfromdto: string): boolean;override;
function  MoveContentI(dfromdto: string): boolean;override;
function  EmptyI(fname: string):real;override;
function  EmptyToRecycle(fname: string):integer;override;

function  RenameDest(const ddir: string;const newname: string): boolean ;override;
function  RenameSrc(pCompData: Pointer;newname: string): boolean;override;
function  RenameS(oldname,newname: string): boolean;
function  RenCycle(fname: string; nc: integer): string;override;

function  GetSrcFrom(pCompData: Pointer): TStream;override;
function  GetSrcTo(pCompData: Pointer;ddir: string): TStream;override;
procedure FinalizeSrc(sf: TStream);override;
procedure AbortFTP;

function  LastJobError: string;override;
procedure RescanDir(rec: Pointer);override;
procedure RescanTree;
function  ChangeDir(dir: string;getlist: boolean=false;parent: boolean=false;refresh: boolean = false): boolean;

function  CompletePut: boolean;override;
procedure PrepareEx1(dir: string;LVEx,LVAttr: TListView;smask: string;selall: boolean);
procedure PrepareEx(dir: string;LVEx,LVAttr: TListView;smask: string;selall: boolean);override;
procedure PrepareCompare(dir: string;ExList: TStringList);override;

procedure CollapseNode(Node: TTreeNode);override;
procedure ExpandNode(Node: TTreeNode);override;
function  SetAttr(const FileName: string; Attr: Integer): Integer;override;
function  SetDateTo(pCompData: Pointer): boolean;override;

//***************************************************
function  ConvertDir(dir: string): string;
function  FindRoot(fname: string): Pointer;
procedure WaitingFreedom;
constructor Create; reintroduce;
destructor Destroy; override;
end;

type
DiskD = ^DiskData;
DiskData = record
disk: string;
items,down,err,abort: integer;
free,required,requiredback,diffreq: real;
changed: boolean;
end;

type
DirP=^DirParam;
DirParam=record
direct,report,fparam,over,rencycle,fattr,listind,itype: integer;
dname: string[250];
groupname,mask,renmask: string[40];
notifyfilter: dword;
notfilt: array[0..7] of boolean;
fattrarr: array[0..6] of boolean;
subdirs,exclusive,notify,maskignoredir,renameall,compare: boolean;
PExList: TStringList;
PNotify,pTDList: Pointer;
rj: RJob;
Disk: DiskData;
end;


type
IDRec = ^Ddata;
Ddata = record
iname,ilabel,ifs: string;
ntype: integer;
isize,ifree: real;
timeaccess,timewrite,timecreate,timecheck,timeexec: TDateTime;
iattr,listind,actionindex,resultindex,numdirs,numfiles: integer;
inlog,explored,searchchild,haschild: boolean;
ichild: array of IDRec;
ilevel: integer;
cchild: array of Pointer;
parent,root: IDRec;
trr: TTreeNode;
itt: TListItem;
PNotify: Pointer;
rj: RJob;
end;

type
TDList=class(TList)
public
DPar: DirParam;
idroot: IDRec;
ifiles,ifolders: integer;
fsize: real;
pDirTo: TDList;
//rj: RJob;
DL: TListItem;
constructor Create;
destructor  Destroy; override;
end;

type
CompData = ^cdata;
cdata = record
idd,iddest: IDRec;
istate,ilevel,iindex,iResult,icause: integer;
//rsize: real;
expanded,deleted,created,current: boolean;
cdItem: TListItem;
parent: CompData;
achild: array of CompData;
dirfrom,dirto: DirP;
end;

type
RecSaveTW = ^DdataSaveTW;
DdataSaveTW = record
ntype,iattr: integer;
isize: real;
timeaccess,timewrite,timecreate,timecheck,timeexec: TDateTime;
actionindex,resultindex,Namelen,LabelLen,IfsLen: integer;
successidicator: integer;
end;

type
  WatchThr = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  public
  dd: DirP;
  rr: RJob;
  dirname: string;
  rec: IDRec;
end;

type
  WatchHistThr = class(WatchThr)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  public
end;

type
  WatchTreeThr = class(WatchThr)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  public
  hWait: HWND;
end;

type
  GrSyncThP = class(TThread)
  public
    wossuspended,analyze: boolean;
    FGS: TObject;
    rj,rt: RJob;
end;

type
  GrSyncTh = class(GrSyncThP)
  protected
    procedure Execute; override;
end;


function CheckJobSync(gr: RJob): RJob;
procedure CreateGlobalCriticalSection;
procedure FreeGlobalCriticalSection;
procedure AbortA;
//Global variables///////////////////////////////////////////////////

var
Gstartlabels,Glastformcreate,bShutDownAll,bShutDownComp,bBeepOnError: boolean;
AppPath,UserName,Systemname,srid: string;

GRList,JList,LLJob,ThreadList,LSystem,TwinList: TList;
TempJobList,GrSyncFormList: TList;

GCSection: TCriticalSection;
RCount,MaxRenNum,LocalBufSz,RemoteBufSz: integer;
Butt1: real;
CCRS: UnStruct;
EnDisk: set of byte = [ntDisk,ntCDRom,ntRemovable,ntUnknown,ntRemote,ntRam];
SetNotifyObj: set of byte = [ntDir,ntFile,ntDisk,ntRemovable];
RemDisk: set of byte = [ntRemovable,ntUnknown,ntRemote,ntRam];
SetFiles: set of byte = [ntFile,ntFileDel,ntFileNew,ntFileChg];
SetFolders: set of byte = [ntDir,ntDirNew,ntDirDel];
SetChng: set of byte = [ntFileDel,ntFileNew,ntDirNew,ntDirDel];
SetDel: set of byte = [ntFileDel,ntDirDel];

EnUndelHist: set of byte = [ntDisk,ntFree,ntBusy,ntScan,ntLog,
                            ntCDRom,ntRemovable,ntUnknown,ntRemote,ntRam];
EnNotTop: set of byte = [ntDisk,ntCDRom,ntRemovable,ntUnknown,ntRemote,ntRam,ntFree,
                                              ntBusy,ntScan,ntRoot,ntHistory,ntLog];
EnDirectOut: set of byte = [dpOut,dpInOut,dpOutOut,dpInOutOut];
EnClearNeed: set of byte =[slcFirst,slcBack,slcBBack,slcNext,slcNNext,slcLast,slcAll,slcFiltered];

CCenterAMS,GSyncAMS,TwinExAMS,LogAMS,CustAMS,SyncAMS,MainAMS,ManSyncAMS,GlobalAMS: integer;
DefAMS,PropAMS,CommonAMS: integer;
NoFileNameSigns: set of Char= ['\','/',':','*','?','"','<','>','|'];
eNumericTypes: set of char =['0','1','2','3','4','5','6','7','8','9',',','.'];

KeysStr: array[0..3] of string =(ksShift,ksCtrl,ksAlt,ksWin);
KeysNum: array[0..3] of integer =(MOD_SHIFT,MOD_CONTROL,MOD_ALT,MOD_WIN);

EnShowInfo: set of FtpInfo = [ftpServerConnected,ftpTraceIn,ftpTraceOut,ftpRetrying,
      ftpNotSupportResume,ftpSupportResume,ftpServerDisconnected,ftpNothing,ftpLoggedIn];

EnSkipErr: set of byte = [bmYesToAll,bmNoToAll,bmRenAllNew,bmRenAllOld];
EnRenameButtons: set of byte = [bmRenNew,bmRenOld,bmRenCycle,bmRenAllOld,bmRenAllNew];


implementation

uses ULog, Usysscanth, Uglobal,UFTPFrame, Ugrsync;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
procedure GrSyncTh.Execute;
var
i: integer;
LVI: TDList;
FF: TFormGrSync;
//nn: TDateTime;
label AAA;
begin
  wossuspended:=false;
  self.FreeOnTerminate:=true;
  rj:=SyncPrepare(rt);
  rj.PExecTh:=self;
  if(not rj.complete)then exit else  rj.complete:=false;
  rj.syncended:=false;
  rt.PExecTh:=self;
  if(not rt.complete)then exit else  rt.complete:=false;
  ThreadList.Add(self);
  FF:= TFormGrSync(FGS);
  if(FGS <> nil)then
  begin
    FF.TempJ:=rj;
    FF.SetTh(self);
    if(rj.needshowprop)then
    begin
      rj.needshowprop:=false;
      FF.TBProp1.Down:=true;
      FF.PProp.Height:=65;
    end;
  end;
try
try
    rj.position:=0;
    CheckJobEvents(rt,true);
    if(rj.babort)then goto AAA;
    rj.maxval:=rj.LItems.Count;
    if(FGS<>nil)then
    FF.PCurrent.Height:=40;
    rj.StageStr:=mmGrSyncGExplore;
    for i:=0 to rj.LItems.Count-1 do
    begin
      LVI:=TDList(rj.LItems.Items[i]);
        if(LVI.DPar.direct <> dpIn)then
        begin
          if(LVI.DPar.exclusive)then
          LVI.DPar.rj.ListDirEx(LVI,LVI.DPar.dname,'')
          else
          LVI.DPar.rj.ListDir(LVI,LVI.DPar.dname,'');
        end;
      if(rj.babort)then goto AAA;
      rj.position:=rj.position+1;
    end;
    rj.position:=0;
    rj.maxval:=4;
    rj.StageStr:=mmGrSyncListFrom+#13#10+rj.StageStr;
    ListFrom(rj.LItems,rj.LTop,rj);

    rj.position:=1;
    if(rj.babort)then goto AAA;
    rj.StageStr:=mmGrSyncListTo+#13#10+rj.StageStr;
    ListTo(rj.LItems,rj.LTop,rj);

    rj.position:=2;
    if(rj.babort)then goto AAA;
    rj.StageStr:=mmGrSyncDispatchList+#13#10+rj.StageStr;
    DispatchList(rj.LItems,rj.LTop,rj);

    rj.position:=3;
    if(rj.babort)then goto AAA;
    if(FGS<>nil)then FF.ShowDisks;

    //rj.StageStr:=mmGrAnalyseLog+#13#10+rj.StageStr;
    //rj.position:=4;
    //if(FGS<>nil)then FF.AnalyzeLog;

    rj.position:=0;
    rj.maxval:=rj.LTop.Count;
    for i:=0 to rj.LTop.Count-1 do
    begin
      rj.position:=rj.position+1;
      rj.LFTop.Add(rj.LTop.Items[i]);
    end;
  if(FGS<>nil)then
  begin
    ShowSyncRecords(slcFirst);
    rj.StageStr:=mmGrSyncReadySync+#13#10+rj.StageStr;
    wossuspended:=true;
    repeat
      Suspend;
      if(rj.babort)then goto AAA;
      try
      FF.ToolBar2.Enabled:=true;
      if(not rj.babort)then
      SyncDir(rj,@ShowSyncRecords,@HideForm);
      except
      //
      end;
      if(rj.babort)then goto AAA;
    until(((FF.CBClose.Checked)and(not rj.ExistsJobError))or(FF.TempJ.babort));
  end else
    SyncDir(rj);
  AAA:
finally
  if(rj.babort)then
  rj.DriveExec(jmAbort);
  rj.PExecTh:=nil;
  rt.PExecTh:=nil;
  rt.complete:=true;
  rt.changed_history:=true;
  //rt.babort:=false;
  if(FGS<>nil)then
  begin
    FF.SetTh(nil);
    FF.TempJ:=nil;
    sleep(300);
    FF.Release;
  end ;
    for i:=0 to rj.LItems.Count-1 do
    begin
      TDList(rj.LItems.Items[i]).DPar.rj.needchecktree:=true;
      TDList(rj.LItems.Items[i]).Free;
    end;
    rj.LItems.Clear;
    for i:=0 to rj.LTop.Count-1 do
    begin
      Finalize(CompData(rj.LTop.Items[i])^);
      Dispose(CompData(rj.LTop.Items[i]));
    end;
    rj.LTop.Clear;
    rj.LFTop.Clear;
  rj.Free;
  ThreadList.Delete(ThreadList.IndexOf(self));
end;
except
//FormLog.RecError('3001');
end;
end;



procedure SyncATh.Execute;
var
ss: TFormGrSync;
begin
ss:=TFormGrSync(GS);
try
try
  self.FreeOnTerminate:=true;
  if(flag = 1)then
  ShowSyncRecords(showmode);
  if(flag = 2)then
  begin
  ss.ColumnSort;
  ss.TBSort.Down:=false;
  end;
finally
  ss.SetTh2(nil);
  if(not ss.Visible)then ss.Release;
end;
except
//FormLog.RecError('3003');
end;
end;

{ TDList }
procedure CreateGlobalCriticalSection;
begin
GCSection:=TCriticalSection.Create;
end;

procedure FreeGlobalCriticalSection;
begin
if(GCSection<>nil)then
GCSection.Free;
end;

constructor TDList.Create;
begin
self.ifiles:=0;
self.ifolders:=0;
self.fsize:=0;
DPar.compare:=false;
DL:=nil;
self.DPar.mask:='*';
DPar.renmask:='*[9]';
self.DPar.fattr:=faAnyFile;
DPar.maskignoredir:=true;
DPar.subdirs:=true;
pDirTo:=nil;
self.DPar.pTDList:=self;
DPar.Disk.items:=0;
DPar.Disk.down:=0;
DPar.Disk.err:=0;
DPar.Disk.abort:=0;
DPar.Disk.free:=0;
DPar.Disk.required:=0;
DPar.Disk.requiredback:=0;
self.DPar.rencycle:=1;
self.DPar.direct:=dpIn;
self.idroot:=nil;
DPar.report:=rpNone;
DPar.over:=opAsk;
DPar.PExList:=nil;
inherited;
end;

destructor TDList.Destroy;
var
i: integer;
begin
for i:=0 to self.Count-1 do
begin
Finalize(IDRec(self.Items[i])^);
Dispose(IDRec(self.Items[i]));
end;
//if(idroot<>nil)then
//Finalize(self.idroot^);
//Dispose(self.idroot);
  inherited;
end;

{ RJob }

procedure RJob.PrepareEx(dir: string;LVEx,LVAttr: TListView;smask: string;selall: boolean);
var
TL: TListItem;
ddir:string;
hh,attr,i: integer;
sr: TSearchRec;
begin
LVEx.Items.Clear;
attr:=0;
for i:=0 to 6 do
begin
  if(LVAttr.Items.Item[i].Checked)then
  attr:=attr or FileAttr[i];
end;
if(attr = 0)then
begin
LVAttr.Items.Item[6].Checked:=true;
attr:=faAnyFile;
end;
  ddir:=dir;
  dir:=dir+'\*';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(ddir,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
       if babort then exit;
if(not MatchesMask(sr.Name,smask))then continue;
if((sr.Attr <> $80)and(attr and faAnyFile <> 0))then
if((sr.Attr and attr)=0)then continue;
        TL:=LVEx.Items.Add;
        TL.Caption:=sr.Name;
        TL.Checked:=selall;
        if((sr.Attr and faDirectory)<> 0) then
        TL.ImageIndex:=0 else TL.ImageIndex:=1;
        hh:=FindNext(sr);
      end;
    end;
    LVEx.Refresh;
  except
  FormLog.RecError('5001');
  end;
  finally
    FindClose(sr);
  end;
end;

procedure RJob.PrepareCompare(dir: string;ExList: TStringList);
var
ddir:string;
hh: integer;
sr: TSearchRec;
begin
  ddir:=dir;
  dir:=dir+'\*';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(ddir,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if babort then exit;
        ExList.Add(sr.Name);
        hh:=FindNext(sr);
      end;
    end;
  except
  FormLog.RecError('5002');
  end;
  finally
    FindClose(sr);
  end;
end;

procedure AbortA;
var
i: integer;
begin
try
  for i:=0 to ThreadList.Count-1 do
  begin
    if(GrSyncThP(ThreadList.Items[i]).Suspended)then
    begin
    GrSyncThP(ThreadList.Items[i]).rj.babort:=true;
    GrSyncThP(ThreadList.Items[i]).Resume;
    end;
    TThread(ThreadList.Items[i]).Terminate;
    //MsgWaitForMultipleObjects(1,TThread(ThreadList.Items[i]),false,100,QS_ALLEVENTS);
  end;
  i:=0;
  while ThreadList.Count>0 do
  begin
    sleep(50);
    Application.ProcessMessages; //AbortA;
    Inc(i);
    if(i>100)then
    begin
      windows.Beep(3000,200);
      break;
    end;
  end;
except
//
end;
end;

constructor RJob.Create;
begin
inherited;
try
Sys1:=nil;
TotalMinus:=0;
CycleVar:=0;
pLastHist:=nil;
PParentJob:=nil;
PServiceTh:=nil;
RetryIndex:=0;
StopOnError:=false;
needshowprop:=false;
CloseIfNoError:=false;
TBShowAllFDown:=false;
TBIcoDown:=false;
DialogButton:=bmNoButtons;
needchecktree:=false;
cursize:=-1;
bskip:=false;
FBabort:=false;
SysName:='';
self.TTab:=nil;
self.TTree:=nil;
LVDSync:=nil;
CNode:=nil;
self.Save.jobtype:=jtLocal;
LHist:=TList.Create;
LItems:=TList.Create;
LActions:=TList.Create;
LTop:=TList.Create;
LFTop:=TList.Create;
LView:=TList.Create;
LFView:=TList.Create;
LChildren:=TList.Create;
LTemp:=TList.Create;
LNotifiers:= TList.Create;
QQ:= TList.Create;
SortPar:= TList.Create;
SortParTop:= TList.Create;


maxval:=1;
position:=0;
FComplete:=true;
enabled:=false;
pabort:=nil;
pskip:=nil;
PNotify:=nil;
self.appear:=0;
self.disappear:=0;
self.change:=0;
numdisk:=-1;
topped:=false;
self.Save.savelast:=10;
self.Save.savelastdays:=false;
self.TopFrom:=0;
self.TopTo:=-1;
self.filterchange:=false;
self.Save.nexttim:=0;
self.Save.lasttim:=0;
RDR.dbutton:=0;
RDR.requestflag:=false;
RDR.lockjob:=false;

SetDefFilters;
QNot:= TStringList.Create;
LAExt:=TStringList.Create;
LADate:=TStringList.Create;
LATime:=TStringList.Create;
LAPath:=TStringList.Create;

LAExt.Sorted:=true;
LADate.Sorted:=true;
LATime.Sorted:=true;
LAPath.Sorted:=true;
QNot.Sorted:=true;

LAExt.Duplicates:=dupIgnore;
LADate.Duplicates:=dupIgnore;
LATime.Duplicates:=dupIgnore;
LAPath.Duplicates:=dupIgnore;
QNot.Duplicates:=dupIgnore;

except
Free;
end;
end;

destructor RJob.Destroy;
var
i: integer;
rr: IDRec;
begin
try
LAExt.Free;
LADate.Free;
LATime.Free;
complete:=true;
babort:=true;
StopNotifyWatch;
  try
  if(Save.jobkind = jkTwin)then
  begin
    for i:=0 to LItems.Count-1 do
    begin
    if(LItems.Items[i] = nil)then continue;
    rr:=IDRec(LItems.Items[i]);
    if(rr.PNotify<>nil)then
    self.StopNotifyWatch(rr);
    Finalize(rr^);
    Dispose(rr);
    end;
    for i:=0 to self.LTop.Count-1 do
    begin
      if(LTop.Items[i] = nil)then continue;
      rr:=IDRec(self.LTop.Items[i]);
      Finalize(rr^);
      Dispose(rr);
    end;
  end;
  except
  //
  end;
for i:=0 to LHist.Count-1 do
begin
if(LHist.Items[i] = nil)then continue;
Dispose(JobHist(LHist.Items[i]));
end;
LHist.Free;

if(Save.jobkind = jkSync)then
begin
  for i:=0 to LItems.Count-1 do
  begin
  if(LItems.Items[i] = nil)then continue;
  if(DirP(LItems.Items[i]).PExList<>nil)then
  DirP(LItems.Items[i]).PExList.Free;
  Finalize(DirP(LItems.Items[i])^);
  Dispose(DirP(LItems.Items[i]));
  end;
end;

if(Save.jobkind = jkHistory)then
begin
  for i:=0 to LItems.Count-1 do
  begin
  if(LItems.Items[i] = nil)then continue;
  Finalize(IDRec(LItems.Items[i])^);
  dispose(IDRec(LItems.Items[i]));
  end;
  for i:=0 to LActions.Count-1 do
  begin
  if(LActions.Items[i] = nil)then continue;
  dispose(HistAct(LActions.Items[i]));
  end;
end;

for i:=0 to LTemp.Count-1 do
RJob(LTemp.Items[i]).Free;

for i:=0 to LNotifiers.Count-1 do
begin
if(WatchThr(LNotifiers.Items[i]).rr <> nil)then
WatchThr(LNotifiers.Items[i]).rr.PNotify:=nil;
if(WatchThr(LNotifiers.Items[i]).dd <> nil)then
WatchThr(LNotifiers.Items[i]).dd.PNotify:=nil;
WatchThr(LNotifiers.Items[i]).rr:=nil;
WatchThr(LNotifiers.Items[i]).rec:=nil;
WatchThr(LNotifiers.Items[i]).dd:=nil;
WatchThr(LNotifiers.Items[i]).Terminate;
end;

while QQ.Count>0 do
begin
Dispose(ComRec(QQ.Items[0]));
QQ.Delete(0);
end;

ClearSortTop;
ClearSortView;
SortPar.Free;
SortParTop.Free;

QQ.Free;
LNotifiers.Free;
LTemp.Free;

LChildren.Free;
LItems.Free;
LTop.Free;
LFTop.Free;
LView.Free;
LFView.Free;
QNot.Free;
Sys1.Free;
//CloseHandle(hEvent);
except
//FormLog.RecError('5003');
end;
  inherited;
end;

procedure RJob.AnalyzeIt(its: integer);
begin
PServiceTh:= SyncATh.Create(true);

end;

procedure RJob.AnalyzeItemList(KL: TList);
var
i: integer;
rr: IDRec;
begin
try
try
LAExt.Clear;
LADate.Clear;
LATime.Clear;
position:=0;
maxval:=KL.Count;
  for i:=0 to KL.Count-1 do
  begin
    rr:=IDRec(KL.Items[i]);
    position:=position+1;
    if(babort)then exit;

    if(rr.ntype >= ntFile)then
    begin
    LAExt.Add(ExtractFileExt(rr.iname));
    LADate.Add(DateToStr(rr.timeaccess));
    LADate.Add(DateToStr(rr.timewrite));
    LATime.Add(TimeToStr(rr.timeaccess));
    LATime.Add(TimeToStr(rr.timewrite));
    end;
    LADate.Add(DateToStr(rr.timecreate));
    LATime.Add(TimeToStr(rr.timecreate));
  end;
//LAExt.Sorted:=false;
//LADate.Sorted:=false;
//LATime.Sorted:=false;

//LAExt.Insert(0,fsExtension);
//LADate.Insert(0,fsDate);
//LATime.Insert(0,fsTime);
finally
self.babort:=false;
end;
except
//
end;
end;

procedure RJob.SetDefFilters;
begin
    self.TP.sTime:=fsTime;
    self.TP.sDate:=fsDate;
    self.TP.sMask:=fsMask;
    self.TP.sExt:=fsExtension;
    self.TP.sFrom:=gsFrom;
    self.TP.sTo:=gsTo;
    
    self.TP.iType:=0;
    self.TP.iAction:=0;
    self.TP.iResult:=0;
    self.TP.iExec:=0;
    self.TP.iDateType:=0;
    self.ClearSortView;
    self.ClearSortTop;
    defaultfilter:=true;
end;

function RJob.CheckDefaultFilters: boolean;
begin
    if(self.TP.sTime   = fsTime)and
    (self.TP.sDate     = fsDate)and
    (self.TP.iType     = 0)and
    (self.TP.sMask     = fsMask)and
    (self.TP.sExt      = fsExtension)and
    (self.TP.iAction   = 0)and
    (self.TP.iResult   = 0)and
    (self.TP.iExec     = 0)and
    (self.TP.iDateType = 0)and
    (SortPar.Count     = 0)and
    (SortParTop.Count  = 0)then
    defaultfilter:=true
    else
    defaultfilter:=false;
    Result:=defaultfilter;
end;

function RJob.CheckDFilter: boolean;
begin
    if(self.TP.sTime   = fsTime)and
    (self.TP.sDate     = fsDate)and
    (self.TP.iType     = 0)and
    (self.TP.sMask     = fsMask)and
    (self.TP.sExt      = fsExtension)and
    (self.TP.iAction   = 0)and
    (self.TP.iResult   = 0)and
    (self.TP.iExec     = 0)and
    (self.TP.iDateType = 0)then
    Result:=true
    else
    Result:=false;
end;

function RJob.CheckDSort: boolean;
begin
    if(SortPar.Count     = 0)and
    (SortParTop.Count  = 0)then
    Result:=true
    else
    Result:=false;
end;

procedure RJob.ExploreFolder(TBShowAllFDown,TBIcoDown: boolean;prr: Pointer);
begin
  if(not complete)then exit else  complete:=false;
  try
    self.TBShowAllFDown:=TBShowAllFDown;
    self.TBIcoDown:=TBIcoDown;
    if(IDRec(prr).ntype <> ntSysFolders)then
    begin
      StartNotifyWatch(IDRec(prr));
      ExploreFolder1(prr);
    end else
    begin
      //
    end;
  complete:=true;
  except
  complete:=true;
  end;
end;

procedure RJob.ExploreFolder1(prr: Pointer);
var
i: integer;
TT: TTreeView;
rr: IDRec;
begin
TT:=self.TTree;
rr:=IDRec(prr);
try
    if(rr.trr = nil)then exit;
    TT.ClearSelection(false);
    rr.trr.Selected:=true;
    if(rr.ntype<>ntScan)or(self.Save.jobtype = jtRemoteFTP)then
    begin
      if((rr.ntype<>ntFile)and(not rr.trr.Expanded))then
      begin
        if((rr.ntype = ntDir)or(rr.ntype in EnDisk))then
        begin
          EnumDir(rr,rr.ilabel);
          rr.trr.HasChildren:=rr.haschild;
          if(rr.ntype in EnDisk)and(not rr.trr.Expanded)then
          rr.trr.HasChildren:=true;
        end;
      end;
    end;
    LView.Clear;
    LFView.Clear;
    for i:=0 to High(rr.ichild)do
    LView.Add(rr.ichild[i]);
    if(rr.ntype<>ntScan)then
    begin
    LFView.Assign(LView);
    SortList(lnLFView);
    end else
    LFView.Assign(LView);
    ShowNodeRecords(TBShowAllFDown,TBIcoDown,slcFirst);
except
FormLog.RecError('9009');
end;
end;

procedure RJob.SetLTopColumns(LVTop: TListView);
var
i,j: integer;
ss: SPar;
begin
  for j:=0 to 3 do
  begin
    LVTop.Columns.Items[j].Tag:=0;
    LVTop.Columns.Items[j].ImageIndex:=13;
  end;
  for i:=0 to SortParTop.Count-1 do
  begin
    ss:= SPar(SortParTop.Items[i]);
    for j:=0 to 3 do
    begin
      if(LVTop.Columns.Items[j].ID = ss.Column)then
      begin
        LVTop.Columns.Items[j].Tag:=ss.Tag;
        case ss.Tag of
          -1: LVTop.Columns.Items[j].ImageIndex:=15;
          0:  LVTop.Columns.Items[j].ImageIndex:=13;
          1:  LVTop.Columns.Items[j].ImageIndex:=14;
        end;
      end;
    end;
  end;
end;

procedure RJob.SetLVDSyncColumns;
var
i,j: integer;
ss: SPar;
begin
  for j:=0 to 3 do
  begin
    LVDSync.Columns.Items[j].Tag:=0;
    LVDSync.Columns.Items[j].ImageIndex:=19;
  end;
  for i:=0 to SortPar.Count-1 do
  begin
    ss:= SPar(SortPar.Items[i]);
    for j:=0 to 3 do
    begin
      if(LVDSync.Columns.Items[j].ID = ss.Column)then
      begin
        LVDSync.Columns.Items[j].Tag:=ss.Tag;
        case ss.Tag of
          -1: LVDSync.Columns.Items[j].ImageIndex:=21;
          0:  LVDSync.Columns.Items[j].ImageIndex:=19;
          1:  LVDSync.Columns.Items[j].ImageIndex:=20;
        end;
      end;
    end;
  end;
end;

procedure RJob.ShowNodeRecords(TBShowAllFDown,TBIcoDown: boolean;tto: integer;num: integer = -1);
var
i,sss,ddd: integer;
dd: IDRec;
TL: TListItem;
CurrNode: IDRec;
CurrJob: RJob;
begin
try
if(LVDSync = nil)or(CNode = nil)or(LVDSync.Tag = 1)then exit;
CurrNode:= IDRec(CNode);
CurrJob:=self;
LVDSync.Tag:=1;
try
sss:=LVDSync.VisibleRowCount-1;
ddd:=CurrJob.LFView.Count-1;
case tto of
  slcFirst:
  begin
    iFrom:=0;
    if(sss<=ddd)then iTo:=sss else iTo:=ddd;
  end;
  slcBBack:
  begin
    if(iFrom-sss>0)then iFrom:=iFrom - sss else iFrom:=0;
    if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
  end;
  slcBack:
  begin
    if(iFrom-1>0)then iFrom:=iFrom - 1 else iFrom:=0;
    if(iFrom+sss<ddd)then iTo:=iFrom+sss else iTo:=ddd;
  end;
  slcNext:
  begin
    if(iTo+1<=ddd)then iTo:=iTo+1 else iTo:=ddd;
    if(iTo-sss>0)then iFrom:=iTo-sss else iFrom:=0;
  end;
  slcNNext:
  begin
    if(iTo+sss<=ddd)then iTo:=iTo+sss else iTo:=ddd;
    if(iTo-sss<0)then iFrom:=0 else iFrom:=iTo - sss;
  end;
  slcLast:
  begin
    if(sss<=ddd)then iFrom:=ddd-sss else iFrom:=0;
    iTo:=ddd;
  end;
  slcAll:
  begin
    iFrom:=0;
    iTo:=CurrJob.LFView.Count-1;
  end;
  slcFiltered:
  begin
    iFrom:=0;
    iTo:=ddd;
  end;
  slcCurrent:
  begin
    if(num>=0)then iFrom:=num else iFrom:=0;
    if(iFrom+sss<=ddd)then iTo:=iFrom+sss else iTo:=ddd;
  end;
end;
if(TBShowAllFDown)and((iFrom<>0)or(iTo<>CurrJob.LFView.Count-1))then
begin
iFrom:=0;
iTo:=CurrJob.LFView.Count-1;
end;
for i:=0 to LVDSync.Items.Count-1 do
IDRec(LVDSync.Items.Item[i].Data).itt:=nil;
LVDSync.Clear;
  for i:=iFrom to iTo do
  begin
    dd:=IDRec(CurrJob.LFView.Items[i]);
    dd.inlog:=false;
    if(dd = nil)then
    begin
     // hh:=hh+1;
      continue;
    end;
    TL:=LVDSync.Items.Add;
    TL.SubItems.Add('');
    TL.SubItems.Add('');
    TL.SubItems.Add('');
    TL.SubItems.Add('');
    dd.itt:=TL;
    TL.Data:=dd;

    if(dd.ntype in EnDisk)then
    TL.Caption:=dd.iname+'( '+dd.ifs+' )'+SizeString(dd.ifree)+' '+mmFree
    else
    TL.Caption:=dd.iname;
    if(not TBIcoDown)then
    begin
      if(dd.ntype <> ntSysFolders)then
      TL.ImageIndex:=dd.ntype
      else
      TL.ImageIndex:=34;
    end;
    if(dd.ntype <> ntDir)then
    TL.SubItems.Strings[0]:=SizeString(dd.isize);

    if(dd.ntype = ntFile)then
    begin
    TL.SubItems.Strings[1]:=DateToStr(dd.timewrite);
    TL.SubItems.Strings[2]:=TimeToStr(dd.timewrite);
    end else
    if(dd.ntype = ntDir)then
    begin
    TL.SubItems.Strings[1]:=DateToStr(dd.timecreate);
    TL.SubItems.Strings[2]:=TimeToStr(dd.timecreate);
    end;
    TL.SubItems.Strings[3]:=IntToStr(i+1);
  end;
  CurrJob.StartNotifyWatch(CurrNode);
finally
LVDSync.Tag:=0;
end;
except
FormLog.RecError('9001');
end;
end;

function RJob.BindChild(rj: RJob): RJob;
var
i: integer;
begin
Result:=rj;
if(rj = self)then exit;
try
i:=LChildren.IndexOf(rj);
if(i>=0)then exit;
LChildren.Add(rj);
rj.pskip:=@bskip;
rj.pabort:=@babort;
rj.PParentJob:=self;
except
//
end;
end;

procedure RJob.BreakChild(rj: RJob=nil);
var
i: integer;
rr: RJob;
begin
try
  if(rj<>nil)then
  begin
    i:=LChildren.IndexOf(rj);
    if(i>=0)then
    LChildren.Delete(i);
    rj.pskip:=nil;
    rj.pabort:=nil;
    rj.PParentJob:=nil;
  end else
  begin
    for i:=0 to LChildren.Count-1 do
    begin
      rr:= RJob(LChildren.Items[i]);
      rr.pskip:=nil;
      rr.pabort:=nil;
      rr.PParentJob:=nil;
    end;
    LChildren.Clear;
  end;
except
//
end;
end;

procedure RJob.SetAbort(compval: boolean);
begin
 FBabort:=compval;
end;

procedure RJob.DriveExec(state: integer=jmRun;ps: integer=-1;ps2: integer=-1;mx: integer=-1;mx2: integer=-1);
var
i: integer;
rr: RJob;
begin
try
  if(mx>=0)then maxval:=mx;
  if(ps>=0)then position:=ps;
  if(mx2>=0)then maxval2:=mx2;
  if(ps2>=0)then position2:=ps2;
  if(pLastHist <> nil)then
  begin
    pLastHist.jstop:=now;
    pLastHist.jsuccess:=state;
  end;
  for i:=0 to LChildren.Count-1 do
  begin
    rr:= RJob(LChildren.Items[i]);
    rr.maxval:=maxval;
    rr.position:=position;
    rr.maxval2:=maxval2;
    rr.position2:=position2;
    if(rr.pLastHist <> nil)then
    begin
    rr.pLastHist.jstop:=now;
    rr.pLastHist.jsuccess:=state;
    end;
    if(state <> jmRun)then
    begin
      rr.position:=0;
      rr.maxval:=10;
      rr.position2:=0;
      rr.maxval2:=10;
      if(rr.pLastHist <> nil)then rr.pLastHist:=nil;
      if(i = 0)then CheckJobEvents(rr);
      //rr.BreakJob;
      rr.complete:=true;
    end;
  end;
  if(state <> jmRun)then
  begin
    position:=0;
    maxval:=10;
    position2:=0;
    maxval2:=10;
    if(pLastHist <> nil)then pLastHist:=nil;
    BreakJob;
    complete:=true;
    BreakChild;
  end;
except
//
end;
end;

procedure RJob.StartNotifyWatch(dp: Pointer = nil);
var
i,ind: integer;
dd: DirP;
ww: WatchHistThr;
ww2: WatchTreeThr;
TRR: WatchThr;
isfind: boolean;
rr: IDRec;
begin
try
  if(self.Save.jobkind = jkSync)then
  begin
    if(dp<>nil)then
    begin
      dd:=DirP(dp);
       if(dd.notify)then
        begin
          if(dd.PNotify<>nil)then
          begin
          ind:=LNotifiers.IndexOf(dd.PNotify);
          if(ind>=0)then LNotifiers.Delete(ind);
          WatchThr(dd.PNotify).Terminate;
          end;
          TRR:=WatchThr.Create(true);
          TRR.FreeOnTerminate:=true;
          TRR.dd:=dd;
          dd.PNotify:=TRR;
          LNotifiers.Add(TRR);
          TRR.rr:=self;
          TRR.Resume;
        end;
    end else
    begin
      for i:=0 to self.LItems.Count-1 do
      begin
      dd:=DirP(self.LItems.Items[i]);
        if(dd.notify)then
        begin
          if(dd.PNotify<>nil)then
          begin
          ind:=LNotifiers.IndexOf(dd.PNotify);
          if(ind>=0)then LNotifiers.Delete(ind);
          WatchThr(dd.PNotify).Terminate;
          end;
          TRR:=WatchThr.Create(true);
          TRR.FreeOnTerminate:=true;
          TRR.dd:=dd;
          LNotifiers.Add(TRR);
          dd.PNotify:=TRR;
          TRR.rr:=self;
          TRR.Resume;
        end;
      end;
    end;
  end;
  if(self.Save.jobkind = jkHistory)then
  begin
    isfind:=false;
    rr:=nil;
    for i:=0 to self.LItems.Count-1 do
    begin
      rr:=IDRec(self.LItems.Items[i]);
      if(rr.ntype = ntDir)then
      begin
        isfind:=true;
        break;
      end;
    end;
    if(isfind and (rr<>nil))then
    begin
    if(self.Save.notify)then
    begin
      if(self.PNotify<>nil)then
      begin
      ind:=LNotifiers.IndexOf(self.PNotify);
      if(ind>=0)then LNotifiers.Delete(ind);
      WatchHistThr(self.PNotify).Terminate;
      end;
      self.PNotify := nil;
      ww:=WatchHistThr.Create(true);
      LNotifiers.Add(ww);
      ww.FreeOnTerminate:=true;
      self.PNotify:=ww;
      ww.rr:=self;
      ww.dirname:=GetTreePath(rr);
      ww.Resume;
    end;
    end;
  end;
  if(self.Save.jobkind = jkTwin)then
  begin
      rr:=IDRec(dp);
      if(dp = nil)or(self.Save.jobtype <> jtLocal)or(not(rr.ntype in SetNotifyObj))then exit;
      if(rr.ntype = ntDir)or(rr.ntype in EnDisk)then
      begin
        if(rr.PNotify<>nil)then exit;
       { begin
          WatchTreeThr(rr.PNotify).rr:=nil;
          WatchTreeThr(rr.PNotify).rec:=nil;
          WatchTreeThr(rr.PNotify).Terminate;
          rr.PNotify:=nil;
        end;  }
        ww2:=WatchTreeThr.Create(true);
        LNotifiers.Add(ww2);
        ww2.FreeOnTerminate:=true;
        rr.PNotify:=ww2;
        ww2.rr:=self;
        ww2.rec:=rr;
        ww2.dirname:=GetTreePath(rr);
        ww2.Resume;
        if(rr.trr<>nil)then
        begin
          if(not(rr.ntype in EnDisk))then
          begin
            rr.trr.ImageIndex:=33;
            rr.trr.SelectedIndex:=33;
          end else
          begin
            rr.trr.ImageIndex:=3;
            rr.trr.SelectedIndex:=3;
          end;
        end;
      end;
  end;
  except
//
end;
end;

procedure RJob.StopNotifyWatch(dp: Pointer = nil);
var
i,ind: integer;
dd: DirP;
rr: IDRec;
begin
try
  if(self.Save.jobkind = jkSync)then
  begin
    if(dp<>nil)then
    begin
        dd:=DirP(dp);
        if(dd.PNotify<>nil)then
        begin
        ind:=LNotifiers.IndexOf(dd.PNotify);
        if(ind>=0)then LNotifiers.Delete(ind);
        WatchThr(dd.PNotify).Terminate;
        dd.PNotify:=nil;
        end;
    end else
    begin
      for i:=0 to self.LItems.Count-1 do
      begin
      dd:=DirP(self.LItems.Items[i]);
        if(dd.PNotify<>nil)then
        begin
        ind:=LNotifiers.IndexOf(dd.PNotify);
        if(ind>=0)then LNotifiers.Delete(ind);
        WatchThr(dd.PNotify).Terminate;
        dd.PNotify:=nil;
        end;
      end;
    end;
  end;
  if(self.Save.jobkind = jkHistory)then
  begin
    if(self.PNotify<>nil)then
    begin
      ind:=LNotifiers.IndexOf(self.PNotify);
      if(ind>=0)then LNotifiers.Delete(ind);
      WatchHistThr(self.PNotify).Terminate;
      self.PNotify := nil;
    end;
  end;
  if(self.Save.jobkind = jkTwin)and(dp<>nil)then
  begin
    rr:=IDRec(dp);
    if(rr.PNotify<>nil)then
    begin
    ind:=LNotifiers.IndexOf(rr.PNotify);
    if(ind>=0)then LNotifiers.Delete(ind);
    WatchTreeThr(rr.PNotify).rr:=nil;
    WatchTreeThr(rr.PNotify).rec:=nil;
    WatchTreeThr(rr.PNotify).Terminate;
    end;
    rr.PNotify:=nil;
    if(rr.trr<>nil)then
    begin
      rr.trr.ImageIndex:=rr.ntype;
      rr.trr.SelectedIndex:=rr.ntype;
     { if(not(rr.ntype in EnDisk))then
      begin
        rr.trr.ImageIndex:=0;
        rr.trr.SelectedIndex:=0;
      end else
      begin
        rr.trr.ImageIndex:=2;
        rr.trr.SelectedIndex:=2;
      end; }
    end;
  end;
except
//
end;
end;

procedure WatchThr.Execute;
var
hWait: HWND;
begin
//hWait:=0;
try
dirname:=dd.dname;
hWait:=FindFirstChangeNotification(PChar(dirname),true,dd.notifyfilter);
while(not Terminated)do
begin
  if( WaitForSingleObject( hWait, 1000 ) = WAIT_OBJECT_0 )then
  begin
  if(dd.direct<>(dpOnlyReport))then
  begin
  rr.starter:=spNotify;
  rr.SyncHide;
  end else
  FormLog.RecEvent(dd.dname,IntToStr(dd.notifyfilter));
  end;
FindNextChangeNotification( hWait );
end;
FindCloseChangeNotification( hWait );
except
Terminate;
end;
end;

procedure WatchHistThr.Execute;
var
  hWait: HWND;
begin
//hWait:=0;
try
  hWait:=FindFirstChangeNotification(PChar(dirname),true,rr.Save.notifyfilter);
  while(not Terminated)do
  begin
    if( WaitForSingleObject( hWait, 1000 ) = WAIT_OBJECT_0 )then
    begin
    rr.starter:=spNotify;
    rr.ScanSH;
    end;
  FindNextChangeNotification( hWait );
  end;
  FindCloseChangeNotification( hWait );
except
//Treminate;
end;
end;

procedure WatchTreeThr.Execute;
var
  i: integer;
  filt: cardinal;
begin
try
  filt:=0;
  for i:=0 to 7 do
  filt:=filt or NFilters[i];
  hWait:=FindFirstChangeNotification(PChar(dirname),true,filt);
  while(not Terminated)do
  begin
    if( WaitForSingleObject( hWait,1000) = WAIT_OBJECT_0 )then
    begin
    if(rr<>nil)and(rec<>nil)then
    Self.rr.QNot.AddObject(rec.ilabel,TObject(rec));
    //Application.ProcessMessages;
    end;
  FindNextChangeNotification( hWait );
  end;
  FindCloseChangeNotification( hWait );
except
//Treminate;
end;
end;

procedure RJob.CheckRescan;
var
rr: IDRec;
begin
  if(not complete)then exit;
  try
    while QNot.Count>0 do
    begin
      rr:=IDRec(QNot.Objects[0]);
      QNot.Delete(0);
      RescanDir(rr);
    end;
  except
  //
  end;
end;

procedure RJob.ScanSH;
var
jj: JobHist;
nn: TDateTime;
SST: SysScanTh;
begin
try
if(self.complete)then
begin
  New(jj);
  nn:=Now;
  jj.jstart:=nn;
  jj.jstop:=0;
  jj.jsuccess:=0;
  jj.listind:=self.LHist.Add(jj);
  self.pLastHist:=jj;
  self.Save.lasttim:=nn;
  self.TimScan:=nn;
  if((self.Save.syncevent = spTimer)or(self.Save.notify))then
  self.changed_history:=true;
  jj.starter:=self.starter;
  SST:=SysScanTh.Create(true);
  SST.prj:=self;
  SST.Operation:=0;
  SST.Resume;
end;
except
FormLog.RecError('5003');
end;
end;

procedure RJob.ScanAll;
var
SST: SysScanTh;
sd,dd: IDRec;
i: integer;
begin
try
if((self.Save.exclusive)or(not self.complete)or(self.LItems.Count<4))then exit;
    dd:=IDRec(self.LItems.Items[0]);//history
    if(dd.ichild<>nil)then
    begin
      dd:=dd.ichild[1]; //root
      if(dd.ichild<>nil)then
      begin
        sd:=dd.ichild[0]; //scan
        self.position:=0;
        if(numdisk<0)then numdisk:=0;
        for i:=numdisk to High(sd.ichild) do
        begin
          dd:=sd.ichild[i];//disk
          if(dd.trr<>nil)then dd.trr.Collapse(true);
          dd:=dd.ichild[1];//busy
          if(dd.isize <> 0)then
          begin
          self.NowScan:=dd.parent.iname;
          SST:=SysScanTh.Create(true);
          SST.prj:=self;
          SST.ad:=dd;
          self.changed_tree:=true;
          SST.Operation:=1;
          SST.Resume;
          numdisk:=numdisk+1;
          break;
          end;
        end;
        if(numdisk >= High(sd.ichild))then numdisk:=-1;
      end;
    end;
except
//
end;
end;

procedure RJob.SyncHide;
begin
try
  Sync(self,false);
except
//
end;
end;

function RJob.CRec(iname: string='';parent: Pointer=nil;isize:real=0;
                    timeaccess:TDateTime=0;
                    timewrite:TDateTime=0;
                    timecreate:TDateTime=0;
                    timecheck:TDateTime=0;
                    iattr: integer=0;ntype: integer=-1): Pointer;
var
tr: IDRec;
begin
  try
    New(tr);
    tr.itt:=nil;
    tr.PNotify:=nil;
    tr.inlog:=false;
    tr.ilabel:='';
    tr.actionindex:=-1;
    tr.resultindex:=-1;
    tr.iname:=iname;
    tr.ntype:=ntype;
    tr.isize:=isize;
    tr.timecheck:=timecheck;
    tr.timeaccess:=timeaccess;
    tr.timewrite:=timewrite;
    tr.timecreate:=timecreate;
    tr.timeexec:=0;
    tr.haschild:=false;
    tr.searchchild:=false;
    tr.rj:=self;
    if(tr.ntype = -1)then
    begin
      if((iattr and faDirectory)<> 0) then
      tr.ntype:=ntDir
      else
      tr.ntype:=ntFile;
    end;
    tr.iattr:=iattr;
    tr.listind:=self.LItems.Add(tr);
    tr.ichild:=nil;
    tr.parent:=IDRec(parent);
    if(parent<>nil)then PushChild(tr,IDRec(parent));
    tr.trr:=nil;
    Result:= tr;
  except
    FormLog.RecError('5004');
    Result:=nil;
  end;
end;

function CheckJobSync(gr: RJob): RJob;
var
i: integer;
rr: RJob;
begin
Result:=nil;
try
  try
  GCSection.Acquire;
  i:=JList.IndexOf(gr);
  if(i=-1)then
  begin
    if((gr.Save.syncevent = spTimer)or(gr.Save.notify))then
    JList.Add(gr);
    rr:=gr;
  end else
  begin
    if((gr.Save.syncevent <> spTimer)and(not gr.Save.notify))then
    begin
    gr.StopNotifyWatch;
    JList.Delete(i);
    end;
    rr:=nil;
  end;
  finally
  GCSection.Release;
  end;
Result:=rr;
except
//
end;
end;


procedure RJob.RescanDir(rec: Pointer);
var
rr: IDRec;
begin
if(not self.complete)then exit;
try
rr:=IDRec(rec);
if(rr.ntype = ntScan)then
ReadSystem
else
EnumDir(rr,rr.ilabel);
except
//
end;
end;
//***************************************************************************
procedure RJob.ReadSystem;
var
i,j,mm,disktype: integer;
drvarr,volname: array[0..255] of char;
dr: array[0..4] of char;
ss: TList;
curr: string;
dd: drive;
fr,tt: int64;
Number, FileLength, VolFlags: DWORD;
disk,scan,ad,sd: IDRec;
//sys: IDRec;
TimScan: TDateTime;
KK,MML: TList;
rj: RJob;
begin
rj:=self;
KK:=TList.Create;
MML:=TList.Create;
TimScan:=now;
ss:= TList.Create;
try
try
    FillChar(drvarr,255,#0);
    GetLogicalDriveStrings(254,drvarr);
    curr:=ExtractFileDrive(GetCurrentDir)+'\';
    FillChar(dr,4,#0);
    mm:=0;
    for i:=0 to 252 do
    begin
      dr[i mod 4]:=drvarr[i];
      if(drvarr[i] = #0)then
      begin
      if((dr[0] = 'A')or(dr[0] = 'B'))then continue;
      if(dr[0] = 'C')then mm:=3;
      New(dd);
      dd.name:=dr;
      dd.ind:=mm;
      if(dd.name = curr)then dd.ind:=0;
      ss.Add(dd);
      mm:=mm+1;
      if(drvarr[i+1]=#0)then break;
      end;
    end;
    if(rj.LItems.Count = 0)then
    begin
    scan:=CReateRec(systemname,nil,0,0,0,0,0,0,ntScan);
    //sys:=CReateRec(mmSysFolders,nil,0,0,0,0,0,0,ntSysFolders);
    KK.Add(scan);
    //KK.Add(sys);
    end;
    for i:=0 to ss.Count-1 do
    begin
      dd:=drive(ss.Items[i]);
      try
      disktype:=GetDriveType(PChar(dd.name));
      case disktype of
        DRIVE_UNKNOWN     : disktype:= ntUnknown;
        DRIVE_NO_ROOT_DIR : disktype:= ntUnknown;
        DRIVE_REMOVABLE   : disktype:= ntRemovable;
        DRIVE_FIXED       : disktype:= ntDisk;
        DRIVE_REMOTE      : disktype:= ntRemote;
        DRIVE_CDROM       : disktype:= ntCDRom;
        DRIVE_RAMDISK     : disktype:= ntRam;
      end;
      fr:=0;
      tt:=0;
      if(disktype<> ntCDRom)then
      if(not GetDiskSpace(dd.name,fr,tt))then
      begin
      fr:=0;
      tt:=0;
      end;
      disk:=CReateRec(dd.name,nil,tt,0,0,0,TimScan,0,disktype);
      disk.ifree:=fr;
      FillChar(drvarr,255,#0);
      FillChar(volname,255,#0);
      KK.Add(disk);
GetVolumeInformation(PChar(dd.name),volname,255,@Number, FileLength, VolFlags,drvarr,255);
      disk.ilabel:=dd.name;
      disk.ifs:=drvarr;
      except
      //continue;
      end;
      //if(disktype = ntCDRom)then disk.ilabel:='CDRom';
      //if(disktype = ntRemovable)then disk.ilabel:='Removable';
      //if(disk.ilabel = '')then disk.ilabel:='LocalDisk';
    end;
    //mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
    if(rj.LItems.Count>0)then
    begin //1
    for i:=0 to High(IDRec(rj.LItems.Items[0]).ichild) do
    MML.Add(IDRec(rj.LItems.Items[0]).ichild[i]);

    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      for j:=0 to MML.Count-1 do
      begin
        sd:=IDRec(MML.Items[j]);
        if((sd.ntype=ntDir)or(sd.ntype=ntFile))then continue;
        if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
        begin
          sd.isize:=ad.isize;
          sd.ilabel:=ad.ilabel;
          sd.ifs:=ad.ifs;
          sd.timecheck:=ad.timecheck;
          sd.ntype:=ad.ntype;
          MML.Delete(j);
          KK.Items[i]:=nil;
          Finalize(ad^);
          Dispose(ad);
          break;
        end;
      end;
    end;
    KK.Pack;
    for j:=0 to MML.Count-1 do //it are deleted items
    DestroyRec(IDRec(MML.Items[j]));

    if(MML.Count>0)then RenumL(rj.LItems);
    end;//1
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);//it are new items
      ad.listind:=rj.LItems.Add(ad);
      ad.rj:=rj;
      ad.inlog:=true;
      if(ad.ntype<>ntScan)then
      begin
      PushChild(ad,IDRec(rj.LItems.Items[0]));
      ad.parent:=IDRec(rj.LItems.Items[0]);
      end;
    end;
    if(MML.Count>0)or(KK.Count>0)then
    changed_tree:=true;
finally
  for i:=0 to ss.Count-1 do
  begin
  dd:= drive(ss.Items[i]);
  Finalize(dd^);
  Dispose(dd);
  end;
  ss.Free;
  KK.Free;
  MML.Free;
end;
except
FormLog.RecError('5005');
end;
end;

procedure RJob.EnumDir(pr: Pointer;dir: string);
var
ad,sd: IDRec;
hh,i,j: integer;
ddir,slash: string;
sr: TSearchRec;
tcreate,taccess,twrite: TDateTime;
KK,MM: TList;
pp1: real;
renum,chng: boolean;
rj: RJob;
prev: IDRec;
begin
rj:=self;
prev:=IDRec(pr);
KK:=TList.Create;
MM:=TList.Create;
prev.numdirs:=0;
prev.numfiles:=0;
chng:=false;
  ddir:=dir;
  dir:=dir+'\*';
  slash:='\';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(ddir,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
  ad:=CReateRec(sr.Name,nil,pp1,taccess,twrite,tcreate,now,sr.Attr,-1);
          KK.Add(ad);
          if(not (prev.ntype in EnDisk))then slash:='\' else slash:='';
          ad.ilabel:=ddir+slash+sr.Name;
          if(ad.ntype = ntDir)then
          begin
            prev.haschild:=true;
            Inc(prev.numdirs);
            if(self.prescandirs)then
            begin
              if(prev.searchchild)then
              begin
                prev.searchchild:=false;
                exit;
              end;
              ad.searchchild:=true;
              EnumDir(ad,ddir+slash+sr.Name);
            end;
          end else
          Inc(prev.numfiles);
        hh:=FindNext(sr);
     end;
    end;
    if(prev.searchchild)then
    begin
      prev.searchchild:=false;
      exit;
    end;
    KK.Sort(@DirSort);
    if(prev.ichild<>nil)then
    begin //if(prev.ichild<>nil)then
    renum:=true;
    for j:=0 to High(prev.ichild) do  MM.Add(prev.ichild[j]);
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      for j:=0 to MM.Count-1 do
      begin
        sd:=IDRec(MM.Items[j]);
        if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
        begin
          sd.actionindex:=-1;
          if(sd.ntype = ntFile)then
          begin
            if(sd.isize > ad.isize)then
            begin
              sd.isize:=ad.isize;
              if(sd.actionindex = -1)then sd.actionindex:=0;
              sd.actionindex:=sd.actionindex or rcSizeDown;
            end else
            if(sd.isize < ad.isize)then
            begin
              sd.isize:=ad.isize;
              if(sd.actionindex = -1)then sd.actionindex:=0;
              sd.actionindex:=sd.actionindex or rcSizeUp;
            end;

            if(sd.timeaccess <> ad.timeaccess)then
            begin
              if(sd.actionindex = -1)then sd.actionindex:=0;
              sd.timeaccess:=ad.timeaccess;
              chng:=true;
              sd.actionindex:=sd.actionindex or rcAccess;
            end; 
            if(sd.timewrite <> ad.timewrite)then
            begin
              if(sd.actionindex = -1)then sd.actionindex:=0;
              sd.timewrite:=ad.timewrite;
              sd.actionindex:=sd.actionindex or rcWrite;
              chng:=true;
            end;
          end else
          begin
            if(sd.timecreate <> ad.timecreate)then
            begin
              sd.timecreate:=ad.timecreate;
              if(sd.actionindex = -1)then sd.actionindex:=0;
              chng:=true;
              sd.actionindex:=sd.actionindex or rcCreate;
            end;
          end;
          MM.Delete(j);
          KK.Items[i]:=nil;
          Finalize(ad^);
          Dispose(ad);
          break;
        end; //if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
      end;
    end;
    KK.Pack;
    for j:=0 to MM.Count-1 do //it's are deleted items
    DestroyRec(IDRec(MM.Items[j]));
    if(MM.Count>0)then
    begin
      //rj.LItems.Pack;
      RenumL(rj.LItems);
    end;

    end //if(prev.ichild<>nil)then
    else renum:=false;

    if(KK.Count>0)then
    begin
      for i:=0 to KK.Count-1 do
      begin
        ad:=IDRec(KK.Items[i]);//it's are new items
        KK.Items[i]:=nil;
        ad.listind:=rj.LItems.Add(ad);
        PushChild(ad,prev);
        ad.rj:=rj;
        ad.parent:=prev;
        if(renum)then
        begin
          ad.inlog:=true;
          LView.Add(ad);
          LFView.Add(ad);
        end;
      end;
      if(prev.ntype<>ntScan)then
      begin
      LFView.Sort(@DirSort);
      end;
    end;
     if(MM.Count>0)or(KK.Count>0)or(chng)then
     changed_tree:=true;
      KK.Pack;
    //************************************************
  except
  FormLog.RecError('5006');
  end;
  finally
    FindClose(sr);
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      Finalize(ad^);
      Dispose(ad);
    end;
    KK.Free;
    MM.Free;
  end;
end;

procedure RJob.EnumSysFolders(tr: TTreeNode;OnlyDir: boolean=true);
{var
ad,sd: IDRec;
hh,i,j: integer;
ddir,slash: string;
sr: TSearchRec;
tcreate,taccess,twrite: TDateTime;
KK,MM: TList;
pp1: real;
renum,chng: boolean;
rj: RJob;
prev: IDRec;  }
begin
 { if(self.Sys1 = nil)and(self.TTree<>nil)then
  begin
    Sys1:=SysNode.Create(self.TTree);
  end; }
  
end;

procedure RJob.MyConvertFileTime(sr: TSearchRec;var tcreate: TDateTime;
var taccess: TDateTime;var twrite: TDateTime);
var
stcreate,staccess,stwrite: SYSTEMTIME;
ftcreate,ftaccess,ftwrite: FILETIME;
begin
  taccess:=0;
  twrite :=0;
  try
  if(sr.FindData.ftLastAccessTime.dwHighDateTime>MaxHighFileTime)then
  begin
  sr.FindData.ftLastAccessTime.dwLowDateTime:=MaxLowFileTime;
  sr.FindData.ftLastAccessTime.dwHighDateTime:=MaxHighFileTime;
  end;
  if(sr.FindData.ftLastWriteTime.dwHighDateTime>MaxHighFileTime)then
  begin
  sr.FindData.ftLastWriteTime.dwLowDateTime:=MaxLowFileTime;
  sr.FindData.ftLastWriteTime.dwHighDateTime:=MaxHighFileTime;
  end;
  if(sr.FindData.ftCreationTime.dwHighDateTime>MaxHighFileTime)then
  begin
  sr.FindData.ftCreationTime.dwLowDateTime:=MaxLowFileTime;
  sr.FindData.ftCreationTime.dwHighDateTime:=MaxHighFileTime;
  end;
  if((sr.Attr and faDirectory)= 0) then
  begin
  FileTimeToLocalFileTime(sr.FindData.ftLastAccessTime,ftaccess);
  FileTimeToLocalFileTime(sr.FindData.ftLastWriteTime,ftwrite);
  FileTimeToSystemTime(ftaccess,staccess);
  FileTimeToSystemTime(ftwrite,stwrite);
  taccess:=SystemTimeToDateTime(staccess);
  twrite :=SystemTimeToDateTime(stwrite);
  end;
  FileTimeToLocalFileTime(sr.FindData.ftCreationTime,ftcreate);
  FileTimeToSystemTime(ftcreate,stcreate);
  tcreate:=SystemTimeToDateTime(stcreate);
  except
    taccess:=0;
    twrite :=0;
    if((sr.Attr and faDirectory)= 0) then
    twrite :=sr.Time
    else
    tcreate:=sr.Time;
  end;
end;

procedure RJob.ScanDisk(pr: Pointer;dir: string);
var
ad: IDRec;
ddir:string;
hh,i: integer;
sum,sumf,pp1: real;
sr: TSearchRec;
tcreate,taccess,twrite: TDateTime;
KK: TList;
ismatch: boolean;
rj: RJob;
prev: IDRec;
begin
rj:=self;
prev:= IDRec(pr);
sum:=0;
sumf:=0;
KK:=TList.Create;
  ddir:=dir;
  dir:=dir+'\*';
  try
  try
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      //if((sr.Attr and faDirectory)<> 0)then
      if(sr.Name = '.')then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if(pabort<>nil)and(pabort^)then break;
        if(babort)then break;
        ismatch:=true;
        if((sr.Attr <> $80)and(rj.Save.fattr and faAnyFile <> 0)and
        ((sr.Attr and rj.Save.fattr)=0))then ismatch:=false;

        if(rj.Save.mask <> '*')then
        if((((sr.Attr and faDirectory)=0)or(not rj.Save.maskignoredir))and(ismatch))then
        begin
          if(prev.ntype = ntBusy)then
          ismatch:=MatchesMask(ddir+sr.Name,rj.Save.mask)
          else
          ismatch:=MatchesMask(ddir+'\'+sr.Name,rj.Save.mask);
        end;
        if(ismatch)then
        begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
  ad:=IDRec(rj.CRec(sr.Name,nil,pp1,taccess,twrite,tcreate,TimScan,sr.Attr,-1));
          KK.Add(ad);
          if((ad.ntype = ntDir)and(rj.Save.subdirs))then
          begin
            if(prev.ntype <> ntBusy)then
            ScanDisk(ad,ddir+'\'+sr.Name)
            else
            ScanDisk(ad,ddir+sr.Name);
          end;
        end;
        hh:=FindNext(sr);
     end;
    end;
    SetLength(prev.ichild,KK.Count);
    KK.Sort(@DirSort);
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      sum:=sum+ad.isize;
      prev.ichild[i]:=ad;
      ad.parent:=prev;
      if(ad.ntype = ntFile)then
      sumf:=sumf+ad.isize;
    end;
    position:=position + Round(sumf/1024/1024);
    if(prev.ntype <> ntBusy)then prev.isize:=sum;
  finally
    FindClose(sr);
    KK.Free;
  end;
  except
  FormLog.RecError('5007');
  self.ExistsJobError:=true;
  end;
end;

procedure RJob.ScanHistory;
var
i,mm,disktype: integer;
drvarr,volname: array[0..255] of char;
dr: array[0..4] of char;
ss: TList;
disk,free,scan,root,log,oldscan,sd,hh: IDRec;
curr: string;
dd: drive;
nn,totals,frees: real;
fr,tt: int64;
Number, FileLength, VolFlags: DWORD;
rj: RJob;
begin
rj:=self;
ss:= TList.Create;
try
try
    FillChar(drvarr,255,#0);
    GetLogicalDriveStrings(254,drvarr);
    curr:=ExtractFileDrive(GetCurrentDir)+'\';
    FillChar(dr,4,#0);
    mm:=0;
    for i:=0 to 252 do
    begin
      dr[i mod 4]:=drvarr[i];
      if(drvarr[i] = #0)then
      begin
      if((dr[0] = 'A')or(dr[0] = 'B'))then continue;
      if(dr[0] = 'C')then mm:=3;
      New(dd);
      dd.name:=dr;
      dd.ind:=mm;
      if(dd.name = curr)then dd.ind:=0;
      ss.Add(dd);
      mm:=mm+1;
      if(drvarr[i+1]=#0)then break;
      end;
    end;
    totals:=0;
    frees:=0;
    root:=nil;
    log:=nil;
    hh:= IDRec(rj.LItems.Items[0]);
    if(hh.ichild<>nil)then
    for i:=0 to High(hh.ichild)do
    begin
      sd:=hh.ichild[i];
      if(sd.iname = systemname)then root:=sd;
      if(sd.ntype = ntLog)then log:=sd;
     end;
    if(root = nil)then
    Root:=IDRec(rj.CRec(systemname,hh,0,0,0,0,0,0,ntRoot));
    scan:=IDRec(rj.CRec(mmScan,nil,1,0,0,0,TimScan,0,ntScan));
    for i:=0 to ss.Count-1 do
    begin
      dd:=drive(ss.Items[i]);
      try
      if(not GetDiskSpace(dd.name,fr,tt))then
      begin
      fr:=0;
      tt:=0;
      end;
      nn:=tt;
      disktype:=GetDriveType(PChar(dd.name));
      case disktype of
        DRIVE_UNKNOWN     : disktype:= ntUnknown;
        DRIVE_NO_ROOT_DIR : disktype:= ntUnknown;
        DRIVE_REMOVABLE   : disktype:= ntRemovable;
        DRIVE_FIXED       : disktype:= ntDisk;
        DRIVE_REMOTE      : disktype:= ntRemote;
        DRIVE_CDROM       : disktype:= ntCDRom;
        DRIVE_RAMDISK     : disktype:= ntRam;
      end;
      if(nn <= 0)then nn:=0;
      disk:=IDRec(rj.CRec(dd.name,scan,nn,0,0,0,TimScan,0,disktype));
      FillChar(drvarr,255,#0);
      FillChar(volname,255,#0);
GetVolumeInformation(PChar(dd.name),volname,255,@Number, FileLength, VolFlags,drvarr,255);
      disk.ilabel:=volname;
      disk.ifs:=drvarr;
      if(disktype = ntCDRom)then disk.ilabel:='CDRom';
      if(disktype = ntRemovable)then disk.ilabel:='Removable';
      if(disktype = ntRemote)then disk.ilabel:='Remote';
      if(disk.ilabel = '')then disk.ilabel:='LocalDisk';
      nn:=fr;
      if(nn <= 0)then nn:=0;
      free:=IDRec(rj.CRec(mmFree,disk,nn,0,0,0,TimScan,0,ntFree));
      rj.CRec(mmBusy,disk,(disk.isize-free.isize),0,0,0,TimScan,0,ntBusy);
      totals:=totals+disk.isize;
      frees:=frees+free.isize;
      except
      //continue;
      end;
    end;
    //busys:=totals-frees;
    root.isize:=Totals;
    if(root.ichild<>nil)then
    begin
      oldscan:= Root.ichild[0];
      if(log <> nil)then
      begin
        DiffScanSys(scan,oldscan,log);
        //if(not tabortall)then
        if(pabort<>nil)and((pabort^))then
        begin
          ClearTree(scan);
          exit;
        end else
        begin
          if(oldscan.trr<>nil)then
          oldscan.trr.Delete;
          ClearTree(oldscan);
        end;
      end;
    end;
    SetLength(Root.ichild,1);
    Root.ichild[0]:=scan;
    scan.parent:=Root;
finally
  for i:=0 to ss.Count-1 do
  begin
  dd:= drive(ss.Items[i]);
  Dispose(dd);
  end;
  ss.Free;
end;
except
FormLog.RecError('5007');
self.ExistsJobError:=true;
end;
end;

procedure RJob.Rescan(pn,pd,lg: Pointer;dir: string);
var
ad,sd,nn,dd,asd: IDRec;
ddir:string;
hh,i,j: integer;
sum,sumf,pp1: real;
sr: TSearchRec;
KK,MM: TList;
tcreate,taccess,twrite: TDateTime;
ismatch: boolean;
pnew,pold,log: IDRec;
begin
pnew:=pn;
pold:=pd;
log:=lg;
sum:=0;
sumf:=0;
if(pold.ntype = ntBusy)then
begin
position:=0;
maxval:=Round(pold.isize/1024/1024);
end;
KK:=TList.Create;
MM:=TList.Create;
  ddir:=dir;
  dir:=dir+'\*';
  try
  try
    if((pold<>nil)and(pold.ichild<>nil))then
    for j:=0 to High(pold.ichild) do
    MM.Add(pold.ichild[j]);

    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(pold.ntype <> ntBusy)then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if(pabort<>nil)and(not(pabort^))then exit;
        ismatch:=true;
        if((sr.Attr <> $80)and(pold.rj.Save.fattr and faAnyFile <> 0)and
        ((sr.Attr and pold.rj.Save.fattr)=0))then ismatch:=false;
        if(pold.rj.Save.mask <> '*')then
        if((((sr.Attr and faDirectory)=0)or(not pold.rj.Save.maskignoredir))and(ismatch))then
        begin
          if(pold.ntype = ntBusy)then
          ismatch:=MatchesMask(ddir+sr.Name,pold.rj.Save.mask)
          else
          ismatch:=MatchesMask(ddir+'\'+sr.Name,pold.rj.Save.mask);
        end;
        if(ismatch)then
        begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
  ad:=IDRec(CRec(sr.Name,nil,pp1,taccess,twrite,tcreate,TimScan,sr.Attr,-1));
          KK.Add(ad);
          if(((sr.Attr and faDirectory)<> 0)and(pold.rj.Save.subdirs))then
          begin
            asd:=nil;
            for i:=0 to MM.Count-1 do
            begin
              sd:=IDRec(MM.Items[i]);
              if(sd.iname = ad.iname)then
              begin
              asd:=sd;
              break;
              end;
            end;
            if((asd<>nil))then
            begin
              if(pold.ntype <> ntBusy)then
              Rescan(ad,asd,log,ddir+'\'+sr.Name)
              else
              Rescan(ad,asd,log,ddir+sr.Name);
            end else
            begin
              if(pold.ntype <> ntBusy)then
              ScanDisk(ad,ddir+'\'+sr.Name)
              else
              ScanDisk(ad,ddir+sr.Name);
            end;
          end;
          end;
        hh:=FindNext(sr);
      end;
    end;
    KK.Sort(@DirSort);
    SetLength(pnew.ichild,KK.Count);

    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      sum:=sum+ad.isize;
      pnew.ichild[i]:=ad;
      ad.parent:=pnew;
      if(ad.ntype = ntFile)then
      sumf:=sumf+ad.isize;
    end;
    if(MM.Count > 0)then
    begin
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      for j:=0 to MM.Count-1 do
      begin
      if(pabort<>nil)and(not(pabort^))then exit;
        sd:=IDRec(MM.Items[j]);
        if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
        begin
          if(sd.ntype = ntFile)then
          if((sd.isize <> ad.isize)or(sd.timewrite<>ad.timewrite))then
          begin     //it's are changed items
nn:=IDRec(CRec(ddir+'\'+ad.iname,nil,ad.isize,ad.timeaccess,ad.timewrite,ad.timecreate,ad.timecheck,ad.iattr,ntFileChg));
dd:=IDRec(CRec(ddir+'\'+sd.iname,nil,sd.isize,sd.timeaccess,sd.timewrite,sd.timecreate,sd.timecheck,sd.iattr,ntFileChg));
           InLog(log,dd);
           InLog(log,nn);
           pold.rj.change:=pold.rj.change+1;
          end;
          MM.Delete(j);
          KK.Items[i]:=nil;
          break;
        end;
      end;
    end;
    KK.Pack;
    for j:=0 to MM.Count-1 do
    begin
    if(pabort<>nil)and(not(pabort^))then exit;
      sd:=IDRec(MM.Items[j]);//it's are deleted items
dd:=IDRec(CRec(ddir+'\'+sd.iname,nil,sd.isize,sd.timeaccess,sd.timewrite,sd.timecreate,TimScan,sd.iattr,sd.ntype));
        if(dd.ntype = ntFile)then
        dd.ntype:=ntFileDel
        else
        dd.ntype:=ntDirDel;
        InLog(log,dd);
        pold.rj.disappear:=pold.rj.disappear + 1;
    end;
    MM.Pack;
    for i:=0 to KK.Count-1 do
    begin
    if(pabort<>nil)and(not(pabort^))then exit;
      ad:=IDRec(KK.Items[i]);//it's are new items
nn:=IDRec(CRec(ddir+'\'+ad.iname,nil,ad.isize,ad.timeaccess,ad.timewrite,ad.timecreate,ad.timecheck,ad.iattr,ad.ntype));
        if(nn.ntype = ntFile)then
        nn.ntype:=ntFileNew
        else
        nn.ntype:=ntDirNew;
        InLog(log,nn);
        pold.rj.appear:=pold.rj.appear + 1;
    end;
    end;
    position:=position+Round(sumf/1024/1024);
    if(pnew.ntype <> ntBusy)then pnew.isize:=sum;
  finally
    FindClose(sr);
    KK.Free;
    MM.Free;
  end;
  except
  FormLog.RecError('5008');
  self.ExistsJobError:=true;
  end;
end;

procedure RJob.DiffScanSys(nn,nd,lg :Pointer);
var
i,j: integer;
ad,sd,hh,bn,bd,fn,fd: IDRec;
snew,sold: TList;
nnew,nold,log :IDRec;
begin
nnew:=nn;
nold:=nd;
log:=lg;
snew:=TList.Create;
sold:=TList.Create;
try
try
//it's a disks
for i:=0 to High(nnew.ichild)do
if(nnew.ichild[i].isize>0)then
snew.Add(nnew.ichild[i]);
for i:=0 to High(nold.ichild)do
if(nold.ichild[i].isize>0)then
sold.Add(nold.ichild[i]);
j:=0;
while j<snew.Count do
begin
  sd:=IDRec(snew.Items[j]);
  fn:=sd.ichild[0];
  bn:=sd.ichild[1];
  i:=0;
  while i<sold.Count do
  begin
    ad:=IDRec(sold.Items[i]);
    fd:=ad.ichild[0];
    bd:=ad.ichild[1];
    if(sd.iname = ad.iname)then
    begin
      //changed disks
      if(bn.isize <> bd.isize)then
      begin
        hh:=IDRec(ad.rj.CRec(ad.iname,nil,ad.isize,0,0,0,ad.timecheck,0,ad.ntype));
        fd.rj.CRec(fd.iname,hh,fd.isize,0,0,0,fd.timecheck,0,fd.ntype);
        bd.rj.CRec(bd.iname,hh,bd.isize,0,0,0,bd.timecheck,0,bd.ntype);
        InLog(log,hh);

        hh:=IDRec(ad.rj.CRec(sd.iname,nil,sd.isize,0,0,0,sd.timecheck,0,sd.ntype));
        fd.rj.CRec(fn.iname,hh,fn.isize,0,0,0,fn.timecheck,0,fn.ntype);
        bn.rj.CRec(bn.iname,hh,bn.isize,0,0,0,bn.timecheck,0,bn.ntype);
        InLog(log,hh);
      end;
      if(((bn.isize <> bd.isize)or bd.rj.Save.anyscan) and (bd.ichild <> nil))then
      begin
        self.maxval:=Round(bn.isize/1024/1024);
        self.position:=0;
        NowScan:=bd.parent.iname;
        Rescan(bn,bd,log,bd.parent.iname);
        if(pabort<>nil)and(not(pabort^))then exit;
        NowScan:='';
      end else
      begin
        if(bd.ichild <> nil)then
        begin
          bn.ichild:=bd.ichild;
          bd.ichild:=nil;
        end;
      end;
      sold.Delete(i);
      snew.Items[j]:=nil;
      break;
    end;
    i:=i+1;
  end;
j:=j+1;
end;
snew.Pack;
//new installed disks
for i:=0 to snew.Count-1 do
begin
  ad:=IDRec(snew.Items[i]);
  fd:=ad.ichild[0];
  bd:=ad.ichild[1];
  hh:=IDRec(ad.rj.CRec(ad.iname,nil,ad.isize,0,0,0,ad.timecheck,0,ad.ntype));
  fd.rj.CRec(fd.iname,hh,fd.isize,0,0,0,fd.timecheck,0,fd.ntype);
  bd.rj.CRec(bd.iname,hh,bd.isize,0,0,0,bd.timecheck,0,bd.ntype);
  hh.actionindex:=daAppear;
  InLog(log,hh);
end;
//removed disks
for i:=0 to sold.Count-1 do
begin
  ad:=IDRec(sold.Items[i]);
  fd:=ad.ichild[0];
  bd:=ad.ichild[1];
  hh:=IDRec(ad.rj.CRec(ad.iname,nil,ad.isize,0,0,0,ad.timecheck,0,ad.ntype));
  fd.rj.CRec(fd.iname,hh,fd.isize,0,0,0,fd.timecheck,0,fd.ntype);
  bd.rj.CRec(bd.iname,hh,bd.isize,0,0,0,bd.timecheck,0,bd.ntype);
  hh.actionindex:=daDisAppear;
  InLog(log,hh);
end;
finally
snew.Free;
sold.Free;
end;
except
  FormLog.RecError('5009');
  self.ExistsJobError:=true;
  end;
end;

procedure RJob.ClearTree(sdk: Pointer);
var
pp: IDRec;
i,k,ss: integer;
asd: array of IDRec;
sd: IDRec;
begin
sd:= IDRec(sdk);
try
    maxval:=LItems.Count div 2;
    position:=0;
    if(sd.ichild<>nil)then
    begin
      for i:=0 to High(sd.ichild)do
      ClearTree1(sd.ichild[i]);
    end;

    if(sd.parent<>nil)then
    begin
      ss:=High(sd.parent.ichild);
      SetLength(asd,ss);
      k:=0;
      for i:=0 to ss do
      begin
        pp:=IDRec(sd.parent.ichild[i]);
        if(pp <> sd)then
        begin
        asd[k]:=sd.parent.ichild[i];
        k:=k+1;
        end;
      end;
      SetLength(sd.parent.ichild,ss);
      for i:=0 to ss-1 do
      sd.parent.ichild[i]:=asd[i];
      asd:=nil;
    end;
    sd.rj.LItems.Items[sd.listind]:=nil;
    RenumL(sd.rj.LItems);
    Finalize(sd^);
    Dispose(sd);
except
FormLog.RecError('5010');
self.ExistsJobError:=true;
end;
end;

procedure RJob.ScanEx;
var
ad,nw,newscan,oldscan,root,log: IDRec;
hh,i: integer;
begin
try
root:=nil;
log:=nil;
if(LItems.Count>2)then
begin
  for i:=0 to LItems.Count-1 do
  begin
    ad:=IDRec(LItems.Items[i]);
    if((ad.ntype = ntRoot)and(ad.iname = systemname))then root:=ad;
    if(ad.ntype = ntLog)then log:=ad;
  end;
  if((root<>nil)and(root.ichild<>nil)and(log<>nil))then
  begin
    newscan:=IDRec(CRec(mmScan,nil,1,0,0,0,TimScan,0,ntScan));
    oldscan:=root.ichild[0];
    hh:=High(oldscan.ichild);
    if(hh>=0)then
    begin
    for i:=0 to hh do
    begin
      ad:=oldscan.ichild[i];
      if(((ad.ntype = ntDir)or(ad.ntype = ntFile)))then
      begin
        NowScan:=ad.iname;
        if((ad.ichild = nil)and(ad.ntype = ntDir))then
        ScanDisk(ad,ad.iname);
  nw:=IDRec(CRec(ad.iname,newscan,0,ad.timeaccess,ad.timewrite,ad.timecreate,TimScan,ad.iattr,ad.ntype));
        RescanEx(nw,ad,log,ad.iname);
        NowScan:='';
      end;
    end;
    if(pabort<>nil)and(pabort^)then
    begin
      ClearTree(newscan);
    end else
    begin
      root.ichild[0]:=newscan;
      newscan.parent:=root;
      oldscan.parent:=nil;
      if(oldscan.trr<>nil)then oldscan.trr.Delete;
      ClearTree(oldscan);
    end;
    end;
  end;
end;
except
//
end;
end;

function RJob.InLog(lg,itm: Pointer):boolean;
var
i: integer;
sd,df,first: IDRec;
//diff: real;
res,add: boolean;
log,item: IDRec;
begin
log:=lg;
item:=itm;
//if(tabortall)then exit;
try
res:=false;
df:=nil;
add:=false;
  for i:=0 to High(log.ichild) do
  begin
    sd:=log.ichild[i];
    if((sd.iname = item.iname))then
    begin
      df:=sd;
      break;
    end;
  end;
  if(df = nil)then
  begin
    PushChild(item,log);
    item.inlog:=true;
    item.parent:=log;
    item.rj:=log.rj;
    res:=true;
  end else
  begin
  first:=df;
    if((df.ntype in EnDisk)and(item.ntype in EnDisk))then
    begin
      while(High(first.ichild) >1)do first:=first.ichild[2];
      //diff:=df.ichild[1].isize - item.ichild[1].isize;
      if((df.timecheck <> item.timecheck)and(item.timecheck<>first.timecheck))or
      (item.actionindex = daDisAppear)then add:=true;
    end else
    begin
      while(first.ichild <> nil)do first:=first.ichild[0];
      if(
      ((df.timecheck <> item.timecheck)and(item.timecheck<>first.timecheck)and
      (df.isize <> item.isize))or
      (item.ntype in SetChng)
      )then add:=true;
    end;
    if(add)then
    begin
      log.ichild[i]:=item;
      item.parent:=log;
      item.inlog:=true;
      item.rj:=log.rj;
      PushChild(df,item);
      df.parent:=item;
      if(df.trr<>nil)then
      begin
        df.trr.Collapse(true);
        item.trr:=df.trr;
        item.trr.Data:=item;
        df.trr:=nil;
      end;
      res:=true;
    end;
  end;
  Result:=res;
except
FormLog.RecError('5011');
self.ExistsJobError:=true;
Result:=false;
end;
end;

procedure RJob.RescanEx(pn,pd,lg: Pointer;dir: string);
var
ad,sd,nn,dd,asd: IDRec;
ddir:string;
hh,i,j: integer;
sum,sumf,pp1: real;
sr: TSearchRec;
KK,MM: TList;
tcreate,taccess,twrite: TDateTime;
ismatch: boolean;
pnew,pold,log: IDRec;
begin
pnew:=pn;
pold:=pd;
log:=lg;
sum:=0;
sumf:=0;
KK:=TList.Create;
MM:=TList.Create;
  ddir:=dir;
  if(pold.ntype<>ntFile)then
  dir:=dir+'\*';
  try
  try
    if((pold<>nil)and(pold.ichild<>nil))then
    for j:=0 to High(pold.ichild) do
    MM.Add(pold.ichild[j]);

    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if(pabort<>nil)and(not(pabort^))then break;
        ismatch:=true;
        if((sr.Attr <> $80)and(pold.rj.Save.fattr and faAnyFile <> 0)and
        ((sr.Attr and pold.rj.Save.fattr)=0))then ismatch:=false;
        if(pold.rj.Save.mask <> '*')then
        if((((sr.Attr and faDirectory)=0)or(not pold.rj.Save.maskignoredir))and(ismatch))then
        begin
          if(pold.ntype = ntBusy)then
          ismatch:=MatchesMask(ddir+sr.Name,pold.rj.Save.mask)
          else
          ismatch:=MatchesMask(ddir+'\'+sr.Name,pold.rj.Save.mask);
        end;
        if(ismatch)then
        begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
  ad:=IDRec(CRec(sr.Name,nil,pp1,taccess,twrite,tcreate,TimScan,sr.Attr,-1));
          KK.Add(ad);
          if(((sr.Attr and faDirectory)<> 0)and(pold.rj.Save.subdirs))then
          begin
            asd:=nil;
            for i:=0 to MM.Count-1 do
            begin
              sd:=IDRec(MM.Items[i]);
              if(sd.iname = ad.iname)then
              begin
              asd:=sd;
              break;
              end;
            end;
            if((asd<>nil))then
              RescanEx(ad,asd,log,ddir+'\'+sr.Name)
            else
              ScanDisk(ad,ddir+'\'+sr.Name)
          end;
          end;
        hh:=FindNext(sr);
      end;
    end;
    KK.Sort(@DirSort);
    SetLength(pnew.ichild,KK.Count);
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      sum:=sum+ad.isize;
      pnew.ichild[i]:=ad;
      ad.parent:=pnew;
      if(ad.ntype = ntFile)then
      sumf:=sumf+ad.isize;
    end;
    if(MM.Count > 0)then
    begin
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      for j:=0 to MM.Count-1 do
      begin
      if(pabort<>nil)and(not(pabort^))then exit;
        sd:=IDRec(MM.Items[j]);
        if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
        begin
          if(sd.ntype = ntFile)then
          if((sd.isize <> ad.isize)or(sd.timewrite<>ad.timewrite))then
          begin
nn:=IDRec(CRec(ddir+'\'+ad.iname,nil,ad.isize,ad.timeaccess,ad.timewrite,ad.timecreate,ad.timecheck,ad.iattr,ntFileChg));
dd:=IDRec(CRec(ddir+'\'+sd.iname,nil,sd.isize,sd.timeaccess,sd.timewrite,sd.timecreate,sd.timecheck,sd.iattr,ntFileChg));
           InLog(log,dd);
           InLog(log,nn);
           pold.rj.change:=pold.rj.change+1;
          end;
          MM.Delete(j);
          KK.Items[i]:=nil;
          break;
        end;
      end;
    end;
    KK.Pack;
    for j:=0 to MM.Count-1 do
    begin
    if(pabort<>nil)and(not(pabort^))then exit;
      sd:=IDRec(MM.Items[j]);//it's a deleted items
dd:=IDRec(CRec(ddir+'\'+sd.iname,nil,sd.isize,sd.timeaccess,sd.timewrite,sd.timecreate,TimScan,sd.iattr,sd.ntype));
        if(dd.ntype = ntFile)then
        dd.ntype:=ntFileDel
        else
        dd.ntype:=ntDirDel;
        InLog(log,dd);
        pold.rj.disappear:=pold.rj.disappear + 1;
    end;
    MM.Pack;
    for i:=0 to KK.Count-1 do
    begin
    if(pabort<>nil)and(not(pabort^))then exit;
      ad:=IDRec(KK.Items[i]);//it's a new items
nn:=IDRec(CRec(ddir+'\'+ad.iname,nil,ad.isize,ad.timeaccess,ad.timewrite,ad.timecreate,ad.timecheck,ad.iattr,ad.ntype));
        if(nn.ntype = ntFile)then
        nn.ntype:=ntFileNew
        else
        nn.ntype:=ntDirNew;
        InLog(log,nn);
        pold.rj.appear:=pold.rj.appear + 1;
    end;
    end;
   //if(pnew.ntype <> ntScan)then
   pnew.isize:=sum;
  except
  FormLog.RecError('5012');
  self.ExistsJobError:=true;
  end;
  finally
    FindClose(sr);
    KK.Free;
    MM.Free;
  end;
end;

procedure RJob.ClearTree1(sdk: Pointer);
var
i: integer;
sd: IDRec;
begin
sd:=IDRec(sdk);
try
  if(sd.ichild<>nil)then
  begin
    for i:=0 to High(sd.ichild)do
    ClearTree1(sd.ichild[i]);
  end;
  position:=position+1;
  sd.rj.LItems.Items[sd.listind]:=nil;
  Finalize(sd^);
  Dispose(sd);
  RCount:=RCount-1;
except
FormLog.RecError('5013');
self.ExistsJobError:=true;
end;
end;

procedure RJob.EmptyNode(sdk: Pointer);
var
i: integer;
sd: IDRec;
begin
sd:=IDRec(sdk);
try
    maxval:=High(sd.ichild)+1;
    position:=0;
    if(sd.ichild<>nil)then
    begin
      for i:=0 to High(sd.ichild)do
      ClearTree1(sd.ichild[i]);
    end;
    RenumL(sd.rj.LItems);
    sd.ichild:=nil;
except
FormLog.RecError('5014');
self.ExistsJobError:=true;
end;
end;

function RJob.CopyI(dfromdto: string): boolean;
var
dfrom,dto,mm: string;
pos1: integer;
begin
  Result:=false;
try
  pos1:=Pos(pComposer,dfromdto);
  dfrom:=MidStr(dfromdto,0,pos1-1);
  dto:=MidStr(dfromdto,pos1+3,Length(dfromdto)-pos1);
  if(MoveTo(dfrom,dto,FBabort,mm)>=0)then Result:=true;
except
//
end;
end;

function RJob.CopyII(pCompData: Pointer;ddir: string): boolean;
var
dd: CompData;
fssrc,fsdest: TStream;
src,dest: RJob;
num: real;
//pnum: real;
bn: integer;
//bb: array[0..DS_MAX_BUFF] of byte;
bb: array of byte;
begin    //third job moving data from one to another
Result:=false;
try
  SetLength(bb,LocalBufSz+1);
  dd:= CompData(pCompData);
  src:=dd.dirfrom.rj;
  dest:=dd.dirto.rj;
  fssrc:=src.GetSrcFrom(pCompData);
  fsdest:=dest.GetSrcTo(pCompData,ddir);
  if(fssrc = nil)or(fsdest = nil)then exit;

    try
    num:=fssrc.Size;
    //if((num/DS_MAX_BUFF)*2) > 2147483647 then
    if((num/LocalBufSz)*2) > 2147483647 then
    self.maxval2:=2147483647
    else
    self.maxval2:=Round((num/LocalBufSz)*2);
    //self.maxval2:=Round((num/DS_MAX_BUFF)*2);
    self.position2:=0;
    if(fsdest = nil)then exit;
    while fssrc.Position < fssrc.Size do
    begin
      if(pabort<>nil)and(pabort^)then break;
      if(bskip)then break;
      bn:=fssrc.Read(bb[0],LocalBufSz);
      //bn:=fssrc.Read(bb,DS_MAX_BUFF);
      fsdest.Write(bb[0],bn);
      if(self.position2>= 2147483627)then
      self.position2:=0;
      self.position2:=self.position2+1;
    end;
    //pnum:=fsdest.Size;
    if(fsdest<>nil)and(fsdest.Size = num)and(dest.CompletePut)then Result:=true;
    finally
      src.FinalizeSrc(fssrc);
      dest.FinalizeSrc(fsdest);
      if Result then dest.SetDateTo(dd);
      self.position2:=0;
    end;
  except
  FormLog.RecError('5015');
  end;
//***************************
end;

function RJob.GetSrcFrom(pCompData: Pointer): TStream;
var
dd: CompData;
begin
//Result:=nil;
dd:= CompData(pCompData);
try
Result:= TFileStream.Create(dd.dirfrom.dname+'\'+dd.idd.iname,fmOpenRead or fmShareDenyWrite);
except
FormLog.RecError('5016');
Result:=nil
end;
end;

function RJob.GetSrcTo(pCompData: Pointer;ddir: string): TStream;
begin
try
Result:= TFileStream.Create(ddir,fmCreate);
except
FormLog.RecError('5017');
Result:=nil
end;
end;

function RJob.DeleteFrom(pCompData: Pointer): boolean;
var
dd: CompData;
begin
Result:=false;
try
dd:= CompData(pCompData);
SetFileAttributes(PChar(dd.dirfrom.dname+'\'+dd.idd.iname),0);
if(dd.idd.ntype = ntDir)then
Result:=RemoveDir(dd.dirfrom.dname+'\'+dd.idd.iname)
else
Result:=DeleteFile(dd.dirfrom.dname+'\'+dd.idd.iname);
except
//
end;
end;

function RJob.DeleteTo(pCompData: Pointer): boolean;
var
dd: CompData;
begin
Result:=false;
try
dd:= CompData(pCompData);
SetFileAttributes(PChar(dd.dirto.dname+'\'+dd.idd.iname),0);
if(dd.idd.ntype = ntDir)then
Result:=RemoveDir(dd.dirto.dname+'\'+dd.idd.iname)
else
Result:=DeleteFile(dd.dirto.dname+'\'+dd.idd.iname);
except
//
end;
end;

function RJob.ExistsTo(ddir: string;isfile: boolean=true): boolean;
begin
if(isfile)then
Result:=FileExists(ddir)
else
Result:=DirectoryExists(ddir);
end;

function RJob.RenameDest(const ddir: string;const newname: string): boolean;
begin
Result:=false;
try
if(ddir <> newname)then
Result:=RenameFile(ddir,newname);
except
//
end;
end;

function RJob.RenameSrc(pCompData: Pointer;newname: string): boolean;
var
dd: CompData;
begin
Result:=false;
try
dd:= CompData(pCompData);
Result:=RenameFile(dd.dirfrom.dname+'\'+dd.idd.iname,newname);
except
//
end;
end;

function RJob.CreateI(ddir: string;isfile: boolean = true): boolean;
begin
Result:=false;
try
  if(isfile)then
  begin
    if(FileCreate(ddir)<>-1)then Result:=true;
  end else
  Result:=CreateDir(ddir);
except
//
end;
end;

function RJob.CreateTo(ddir: string): boolean;
begin
Result:=false;
try
Result:=CreateDir(ddir);
except
//
end;
end;

function RJob.CreateFrom(pCompData: Pointer): boolean;
var
dd: CompData;
begin
Result:=false;
try
dd:= CompData(pCompData);
if(dd.idd.ntype = ntDir)then
Result:=CreateDir(dd.dirfrom.dname+'\'+dd.idd.iname);
except
//
end;
end;

function RJob.WaitEvent(ehandle: Cardinal;maxtime: Cardinal=0): Cardinal;
var
num,timeout: cardinal;
messup: boolean;
begin
Result:=WAIT_TIMEOUT;
try
  num:=0;
  timeout:=50;
  if(PParentJob<>nil)then PParentJob.maxval2:=maxtime div timeout;
  if(PParentJob<>nil)then
  PParentJob.position2:=0;
  //Result:= MsgWaitForMultipleObjects(1,ehandle,false,timeout,QS_SENDMESSAGE);
  Result:=WaitForSingleObject(ehandle,timeout);
  messup:=false;
  while(Result<>WAIT_OBJECT_0)do
  begin
    Inc(num);
    if(PParentJob<>nil)then
    begin
      PParentJob.position2:=num;
      if(not messup)then
      begin
        //PParentJob.MessStr:=self.MessStr+mmWaitingConnections;
        //PParentJob.MessStr:=self.MessStr;
        messup:=true;
      end;
    end;
    if(pabort<>nil)and(pabort^)then break;
    if(babort)then break;
    if(bskip)then break;
    if(pskip<>nil)and(pskip^)then break;
    if(woserror)then
    begin
      woserror:=false;
      Result:=WAIT_ABANDONED;
      break;
    end;
    //Result:= MsgWaitForMultipleObjects(1,ehandle,false,timeout,QS_SENDMESSAGE);
    Result:=WaitForSingleObject(ehandle,timeout);
    Application.ProcessMessages;
    if(maxtime <> 0)and(num*timeout>=maxtime)then break;
  end;
if(PParentJob<>nil)then
PParentJob.position2:=0;
except
//
end;
end;

function RJob.RenCycle(fname: string; nc: integer): string;
var
NList: TList;
fext,nname,res,path,rname,dob: string;
hh,i,nn: integer;
sr: TSearchRec;
rr: TRen;
begin
Result:=fname;
try
res:='';
dob:='';
NList:=TList.Create;
try
fext:=ExtractFileExt(fname);
rname:=ChangeFileExt(fname,'');
nname:=rname+'*';
rname:=ExtractFileName(rname);
path:=ExtractFilePath(fname);
    hh:=FindFirst(nname,faAnyFile,sr);
    if hh = 0 then
    begin
      New(rr);
      rr.oldname:=path+sr.Name;
      if((sr.Attr and faDirectory)<> 0)then
      rr.isfile:=false
      else
      rr.isfile:=true;
      NList.Add(rr);
      while FindNext(sr) = 0 do
      begin
      New(rr);
      rr.oldname:=path+sr.Name;
      if((sr.Attr and faDirectory)<> 0)then
      rr.isfile:=false
      else
      rr.isfile:=true;
      NList.Add(rr);
      end;
    end;
nn:=NList.Count-1;
  if(PParentJob<>nil)then PParentJob.maxval2:=nn;
  if(PParentJob<>nil)then PParentJob.position2:=1;
NList.Sort(@RenComp);
res:=path+rname;
  while(nn >= 0)do
  begin
    rr:= TRen(NList.Items[nn]);
    if(PParentJob<>nil)then PParentJob.position2:=PParentJob.position2+1;
    if((nn>=(nc-1))and (rr<>nil))then
    begin
      if(rr.isfile)then
      DeleteFile(rr.oldname)
      else begin
      DelDir(rr.oldname,FBabort);
      end;
      NList.Delete(nn);
      Dispose(rr);
      nn:=NList.Count-1;
      continue;
    end;
    rr.newname:=path+rname+IntToStr(nn+1)+dob+fext;
    if(not RenameFile(rr.oldname,rr.newname))then dob:=dob+'!';
    nn:=nn-1;
  end;
  if(PParentJob<>nil)then
  PParentJob.position2:=0;
finally
for i:=0 to NList.Count-1 do
Dispose(NList.Items[i]);
NList.Free;
FindClose(sr);
end;
Result:=res+dob+fext;
except
//
end;
end;

function RJob.MoveToRecycle(fname: string):integer;
var
pp: _SHFILEOPSTRUCTA;
res: integer;
begin
res:=-1;
try
pp.Wnd:=0;
pp.wFunc:=FO_DELETE;
pp.pFrom:=PChar(fname+#0);
pp.pTo:=nil;
//FOF_ALLOWUNDO or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_SILENT
pp.fFlags:=FOF_ALLOWUNDO or FOF_NOCONFIRMATION;
pp.fAnyOperationsAborted:=self.FBabort;
pp.hNameMappings:=nil;
pp.lpszProgressTitle:=nil;
res:=SHFileOperation(pp);
except
FormLog.RecError('5018');
end;
Result:=res;
end;

procedure RJob.ListDirEx(pTDL: Pointer;dir,pref: string);
var
ad,prev: IDRec;
i: integer;
pp1: real;
sr: TSearchRec;
ddir: string;
ismatch: boolean;
dd: IDRec;
tcreate,taccess,twrite: TDateTime;
tnow: TDateTime;
KL: TList;
TDL: TDList;
begin
  try
  KL:= TList.Create;
  try
TDL:= TDList(pTDL);
tnow:=Now;
New(TDL.idroot);
TDL.idroot.ilevel:=0;
TDL.idroot.listind:=TDL.Add(TDL.idroot);
TDL.idroot.ntype:=ntDir;
TDL.idroot.iname:=TDL.DPar.dname;
TDL.idroot.isize:=0;
TDL.idroot.timewrite:=0;
TDL.idroot.iattr:=faDirectory;
TDL.idroot.parent:=nil;
TDL.idroot.ichild:=nil;
TDL.idroot.root:=nil;

prev:=TDL.idroot;
    if((TDL.DPar.exclusive)and(TDL.DPar.PExList <> nil))then
    begin
      if(TDL.DPar.compare)then
      PrepareCompare(TDL.DPar.dname,TDL.DPar.PExList);
      for i:=0 to TDL.DPar.PExList.Count-1 do
      begin
      dd:=nil;
      ddir:=dir+'\'+TDL.DPar.PExList.Strings[i];
      if(TDL.DPar.PExList.Objects[i]<>nil)then
      dd:=IDRec(TDL.DPar.PExList.Objects[i]);
      if(FindFirst(ddir,faAnyFile,sr)<>0)then continue;
        if babort then exit;
        ismatch:=true;
        if((sr.Attr <> $80)and(TDL.DPar.fattr and faAnyFile <> 0)and
        ((sr.Attr and TDL.DPar.fattr)=0))then ismatch:=false;
        if(TDL.DPar.mask <> '*')then
        if((((sr.Attr and faDirectory)=0)or(not TDL.DPar.maskignoredir))and(ismatch))then
        ismatch:=MatchesMask(sr.Name,TDL.DPar.mask);
        if(ismatch)then
        begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
          ad:=CReateRec(sr.Name,prev,pp1,taccess,twrite,tcreate,tnow,sr.Attr,-1);
          ad.listind:=TDL.Add(ad);
          ad.ilabel:=ddir;
          KL.Add(ad);
          ad.root:=dd;
          ad.ilevel:=0;
          ad.rj:=self;

          if(dd<>nil)then
          begin
            ad.actionindex:=dd.actionindex;
            ad.ifs:=dd.ifs;
            if(not(dd.actionindex in EnDirNoExplore))then
            begin
              if((sr.Attr and faDirectory)<> 0)then
              begin
                Inc(TDL.ifolders);
                if(TDL.DPar.subdirs) then
                begin
                ad.explored:=true;
                dd.explored:=true;
                ListDir(TDL,ddir,sr.Name,ad,dd);
                end;
              end else
              Inc(TDL.ifiles);
            end;
          end else
          begin
            if((sr.Attr and faDirectory)<> 0)then
            begin
              Inc(TDL.ifolders);
              if(TDL.DPar.subdirs) then
              begin
              ad.explored:=true;
              ListDir(TDL,ddir,sr.Name,ad,dd);
              end;
            end else
            Inc(TDL.ifiles);
          end;
        end;
      end;
      KL.Sort(@DirSort);
      SetLength(prev.ichild,KL.Count);
      for i:=0 to KL.Count-1 do
      prev.ichild[i]:=KL.Items[i];
    end;
  finally
    FindClose(sr);
    KL.Free;
  end;
  except
  FormLog.RecError('5019');
  end;
end;

function RJob.ListDir(pTDL: Pointer;dir,pref: string;pprev: Pointer = nil;pdd: Pointer = nil): real;
var
ad: IDRec;
ddir:string;
hh,i: integer;
pp1,sum: real;
sr: TSearchRec;
ismatch: boolean;
tcreate,taccess,twrite: TDateTime;
tnow: TDateTime;
KL: TList;
TDL: TDList;
prev,dd: IDRec;
begin
Result:=0;
  try
  KL:= TList.Create;
  prev:=IDRec(pprev);
  try
TDL:= TDList(pTDL);
dd:=  IDRec(pdd);
tnow:=Now;
sum:=0;
Result:=0;
  if(prev = nil)then
  begin
  New(TDL.idroot);
  TDL.idroot.ilevel:=0;
  TDL.idroot.listind:=TDL.Add(TDL.idroot);
  TDL.idroot.ntype:=ntDir;
  TDL.idroot.iname:=TDL.DPar.dname;
  TDL.idroot.isize:=0;
  TDL.idroot.timewrite:=0;
  TDL.idroot.iattr:=faDirectory;
  TDL.idroot.parent:=nil;
  TDL.idroot.ichild:=nil;
  TDL.idroot.root:=nil;
  prev:=TDL.idroot;
  //prev.ilevel:=-1;
  end;
  ddir:=dir;
  dir:=dir+'\*';
    hh:=FindFirst(dir,faAnyFile,sr);
    if hh = 0 then
    begin
      if(not MatchesMask(ddir,'*:\'))then
      if((sr.Attr and faDirectory)<> 0)then
      begin
      FindNext(sr);
      hh:=FindNext(sr);
      end;
      while hh = 0 do
      begin
        if babort then  exit;
        ismatch:=true;
        if((sr.Attr <> $80)and(TDL.DPar.fattr and faAnyFile <> 0)and
        ((sr.Attr and TDL.DPar.fattr)=0))then ismatch:=false;
        if(TDL.DPar.mask <> '*')then
        if((((sr.Attr and faDirectory)=0)or(not TDL.DPar.maskignoredir))and(ismatch))then
        ismatch:=MatchesMask(pref+'\'+sr.Name,TDL.DPar.mask);

        if(ismatch)then
        begin
          MyConvertFileTime(sr,tcreate,taccess,twrite);
          if(sr.Size<0)then
          pp1:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
          else
          pp1:=sr.Size;
          sum:=sum+pp1;
          ad:=CReateRec(sr.Name,prev,pp1,taccess,twrite,tcreate,tnow,sr.Attr,-1);
          ad.listind:=TDL.Add(ad);
          ad.ilabel:=ddir+'\'+sr.Name;
          KL.Add(ad);
          ad.root:=dd;
          ad.rj:=self;
          if(dd<>nil)then ad.actionindex:=dd.actionindex;
          ad.ilevel:=prev.ilevel+1;
          if(pref <>'')then ad.iname:=pref+'\'+sr.Name;

          if(((sr.Attr and faDirectory)<> 0)and(TDL.DPar.subdirs)) then
          begin
              Inc(TDL.ifolders);
              if(pref <>'')then
              sum:=sum+ListDir(TDL,ddir+'\'+sr.Name,pref+'\'+sr.Name,ad,dd)
              else
              sum:=sum+ListDir(TDL,ddir+'\'+sr.Name,sr.Name,ad,dd);
          end;
          if((sr.Attr and faDirectory)= 0)then Inc(TDL.ifiles);
          TDL.fsize:=TDL.fsize+pp1;
        end;
        hh:=FindNext(sr);
      end;
      if(KL.Count>0)then
      begin
        KL.Sort(@DirSort);
        SetLength(prev.ichild,KL.Count);
        for i:=0 to KL.Count-1 do
        prev.ichild[i]:=KL.Items[i];
      end else
      begin
        if(TDL.idroot = prev)then
        begin
          TDL.Delete(prev.listind);
          TDL.idroot:=nil;
          Dispose(prev);
          prev:=nil;
        end;
      end;
      if(prev <> nil)then
      prev.isize:=sum;
    end;
  Result:=sum;
  finally
    if(prev <> nil)then
    prev.explored:=true;
    FindClose(sr);
    KL.Free;
  end;
  except
  FormLog.RecError('5020');
  end;
end;


function RJob.ExistsI(pr: Pointer): boolean;
var
dd: IDRec;
begin
dd:= IDRec(pr);
Result:=true;
try
if(dd = nil)or(dd.ntype > ntFile)then exit;
if(dd.ntype = ntDir)then
Result:=DirectoryExists(dd.ilabel)
else
Result:=FileExists(dd.ilabel);
except
//
end;
end;

procedure RJob.FinalizeSrc(sf: TStream);
begin
try
//pskip:=nil;
sf.Free;
except
//
end;
end;

function RJob.ExistsS(dname: string;isfile: boolean=true): boolean;
begin
Result:=false;
try
if(not isfile)then
Result:=DirectoryExists(dname)
else
Result:=FileExists(dname);
except
//
end;
end;

function RJob.LastJobError: string;
begin
Result:='--';
try
Result:=GetError;
except
//
end;
end;

function RJob.CompletePut: boolean;
begin
Result:=true;
end;

function RJob.DeleteS(dname: string; isfile, recurse: boolean): boolean;
begin
Result:=false;
try
if(DirectoryExists(dname))and(DelDir(dname,FBabort)>0)then Result:=true else
if(FileExists(dname))then Result:=DeleteFile(dname);
except
//
end;
end;

function RJob.DeleteI(dname: string): boolean;
begin
Result:=false;
try
if(DirectoryExists(dname))and(DelDir(dname,FBabort)>=0)then Result:=true else
if(FileExists(dname))then Result:=DeleteFile(dname);
except
//
end;
end;


function RJob.EmptyToRecycle(fname: string): integer;
begin
Result:=0;
try
Result:=MoveToRecycle(fname);
CreateDir(fname);
except
//
end;
end;
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function RJob.EmptyI(fname: string): real;
begin
Result:=-1;
try
if(DirectoryExists(fname))then
begin
Result:=DelDir(fname,FBabort);
CreateDir(fname);
end;
except
//
end;
end;

function RJob.MoveContentI(dfromdto: string): boolean;
var
dfrom,dto,mm: string;
pos1: integer;
begin
  Result:=false;
  try
  pos1:=Pos(pComposer,dfromdto);
  dfrom:=MidStr(dfromdto,0,pos1-1);
  dto:=MidStr(dfromdto,pos1+3,Length(dfromdto)-pos1);
  if(MoveTo(EnumFolderI(dfrom),dto,FBabort,mm)>=0)and
  (EmptyI(dfrom)>=0)then Result:=true;
  except
//
end;
end;

function RJob.MoveI(dfromdto: string): boolean;
var
dfrom,dto,mm: string;
pos1: integer;
begin
  Result:=false;
  try
  pos1:=Pos(pComposer,dfromdto);
  dfrom:=MidStr(dfromdto,0,pos1-1);
  dto:=MidStr(dfromdto,pos1+3,Length(dfromdto)-pos1);
  if(MoveTo(dfrom,dto,FBabort,mm)>=0)and(DeleteI(dfrom))then
  Result:=true;
  except
//
end;
end;

function RJob.RenameI(dfromdto: string): boolean;
var
dfrom,dto: string;
pos1: integer;
begin
  Result:=false;
  try
  pos1:=Pos(pComposer,dfromdto);
  dfrom:=MidStr(dfromdto,0,pos1-1);
  dto:=MidStr(dfromdto,pos1+3,Length(dfromdto)-pos1);
  if(RenameFile(dfrom,dto))then
  Result:=true;
  except
//
end;
end;

procedure RJob.CollapseNode(Node: TTreeNode);
var
rr: IDRec;
begin
try
if(Node.Data<>nil)then
  begin
    rr:=IDRec(Node.Data);
    if(rr.ntype <> ntSysFolders)then
    if(rr.ntype<>ntScan)and(complete)then
    begin
    StopNotifyWatch(rr);
    complete:=false;
    try
    EmptyTreeNode(Node);
    rr.explored:=false;
    rr.trr.HasChildren:=rr.haschild;
    if(rr.ntype in EnDisk)and(not rr.trr.Expanded)then
    rr.trr.HasChildren:=true;
    finally
    complete:=true;
    end;
    end;
  end;
except
//
end;
end;

procedure RJob.ExpandNode(Node: TTreeNode);
begin
 //
end;

function RJob.SetAttr(const FileName: string; Attr: Integer): Integer;
begin
Result:=FileSetAttr(FileName,Attr);
end;

function RJob.SetDateTo(pCompData: Pointer): boolean;
var
dd: CompData;
//ftcreate,ftaccess,ftwrite: FILETIME;
//stcreate,staccess,stwrite: SYSTEMTIME;
hh,h2: Cardinal;
fname: string;
sr: TSearchRec;
begin
Result:=false;
dd:= CompData(pCompData);
hh:=INVALID_HANDLE_VALUE;
try
try
fname:=dd.dirto.dname+'\'+dd.idd.iname;
hh:=windows.CreateFile(PChar(fname),GENERIC_WRITE,0, nil,OPEN_EXISTING,0,0);
fname:=dd.dirfrom.dname+'\'+dd.idd.iname;
h2:=FindFirst(fname,faAnyFile,sr);

if(hh <> INVALID_HANDLE_VALUE)and(h2 <> INVALID_HANDLE_VALUE)then
begin
{
DateTimeToSystemTime(dd.idd.timeaccess,staccess);
DateTimeToSystemTime(dd.idd.timewrite,stwrite);
DateTimeToSystemTime(dd.idd.timecreate,stcreate);

SystemTimeToFileTime(staccess,ftaccess);
SystemTimeToFileTime(stwrite,ftwrite);
SystemTimeToFileTime(stcreate,ftcreate);

LocalFileTimeToFileTime(ftaccess,ftaccess);
LocalFileTimeToFileTime(ftwrite,ftwrite);
LocalFileTimeToFileTime(ftcreate,ftcreate);

Result:=windows.SetFileTime(hh,@ftcreate,@ftaccess,@ftwrite);
}
Result:=windows.SetFileTime(hh,@sr.FindData.ftCreationTime,
@sr.FindData.ftLastAccessTime,@sr.FindData.ftLastWriteTime);
end;
finally
//if(hh <> INVALID_HANDLE_VALUE)then
windows.CloseHandle(hh);
FindClose(sr);
end;
except
//
end;
end;

function RJob.SetDateI(fname: string;timeaccess,timewrite,timecreate: TDateTime): boolean;
var
ftcreate,ftaccess,ftwrite: FILETIME;
stcreate,staccess,stwrite: SYSTEMTIME;
hh: Cardinal;
begin
Result:=false;
hh:=INVALID_HANDLE_VALUE;
try
try
hh:=windows.CreateFile(PChar(fname),GENERIC_WRITE,0, nil,OPEN_EXISTING,0,0);
if(hh <> INVALID_HANDLE_VALUE)then
begin
DateTimeToSystemTime(timeaccess,staccess);
DateTimeToSystemTime(timewrite,stwrite);
DateTimeToSystemTime(timecreate,stcreate);
SystemTimeToFileTime(staccess,ftaccess);
SystemTimeToFileTime(stwrite,ftwrite);
SystemTimeToFileTime(stcreate,ftcreate);
LocalFileTimeToFileTime(ftaccess,ftaccess);
LocalFileTimeToFileTime(ftwrite,ftwrite);
LocalFileTimeToFileTime(ftcreate,ftcreate);
Result:=windows.SetFileTime(hh,@ftcreate,@ftaccess,@ftwrite);
end;
finally
windows.CloseHandle(hh);
end;
except
//
end;
end;

function RJob.GetPropTo(var ddir: string; pIDRec: Pointer;dToName: string=''): boolean;
var
rr: IDRec;
tcreate,taccess,twrite: TDateTime;
sr: TSearchRec;
pathname: string;
begin
  Result:=false;
  try
  rr:=IDRec(pIDRec);
  try
  pathname:=ExtractFilePath(ddir);
    if(not DirectoryExists(pathname))then
    ddir:=AnsiReplaceStr(ddir,pathname,dToName)
    else
    if(FindFirst(ddir,faAnyFile,sr)=0)then
    begin
      MyConvertFileTime(sr,tcreate,taccess,twrite);
      rr.timeaccess:=taccess;
      rr.timewrite:=twrite;
      rr.timecreate:=tcreate;
      if(sr.Size<0)then
      rr.isize:=sr.FindData.nFileSizeHigh*MAXWORD+sr.FindData.nFileSizeLow
      else
      rr.isize:=sr.Size;
      rr.iattr:=sr.Attr;
      if((sr.Attr and faDirectory)= 0)then rr.ntype:=ntFile else
      rr.ntype:=ntDir;
      Result:=true;
    end;
  finally
  FindClose(sr);
  end;
  except
//
end;
end;

procedure RJob.SetComplete(compval: boolean);
begin
  FComplete:=compval;
  if(compval)then FBabort:=false;
end;


procedure RJob.AbortJob;
begin
try
babort:=true;
 DriveExec(jmAbort);
  if(PExecTh<>nil)then
  begin
    if(TThread(PExecTh).Suspended)then
    TThread(PExecTh).Resume;
    PExecTh:=nil;
  end;
  except
//
end;
end;

procedure RJob.BreakJob;
begin
try
//babort:=true;
  if(PExecTh <> nil)then
  begin
    if(TThread(PExecTh).Suspended)then
    TThread(PExecTh).Resume;
    PExecTh:=nil;
  end;
  except
//
end;
end;


procedure RJob.CopyPropIDRec(psrc,pdest: Pointer);
var
src,dest: IDRec;
begin
try
src:=IDRec(psrc);
dest:=IDRec(pdest);

dest.iname:=src.iname;
dest.ilabel:=src.ilabel;
dest.ifs:=src.ifs;
dest.ntype:=src.ntype;
dest.isize:=src.isize;
dest.ifree:=src.ifree;

dest.timeaccess:=src.timeaccess;
dest.timewrite:=src.timewrite;
dest.timecreate:=src.timecreate;
dest.timecheck:=src.timecheck;
dest.timeexec:=src.timeexec;

dest.iattr:=src.iattr;
dest.listind:=src.listind;
dest.actionindex:=src.actionindex;
dest.resultindex:=src.resultindex;

dest.inlog:=src.inlog;
dest.explored:=src.explored;
dest.ilevel:=src.ilevel;
except
//
end;
end;

function RJob.Start(needthread: boolean=true): boolean;
begin
Result:=true;
end;

procedure RJob.AddSortTopCol(Col: TListColumn;si: integer);
var
ss: SPar;
begin
New(ss);
ss.Column:=Col.ID;
ss.Tag:=Col.Tag;
ss.Sind:=si;
self.SortParTop.Add(ss);
end;

procedure RJob.AddSortViewCol(Col: TListColumn;si: integer);
var
ss: SPar;
begin
New(ss);
ss.Column:=Col.ID;
ss.Tag:=Col.Tag;
ss.Sind:=si;
self.SortPar.Add(ss);
end;

procedure RJob.ManTopCol(Col: TListColumn;si: integer);
var
ss: SPar;
i: integer;
begin
  for i:=0 to SortParTop.Count-1 do
  if(SPar(SortParTop.Items[i]).Column = Col.ID)then
  begin
    ss:=SPar(SortParTop.Items[i]);
    if(Col.Tag = 0)then
    begin
      Dispose(ss);
      SortParTop.Delete(i);
      exit;
    end else
    begin
      ss.Tag:=Col.Tag;
      ss.Sind:=si;
      exit;
    end;
  end;
New(ss);
ss.Column:=Col.ID;
ss.Tag:=Col.Tag;
ss.Sind:=si;
self.SortParTop.Add(ss);
self.CheckDefaultFilters;
end;

procedure RJob.ManViewCol(Col: TListColumn;si: integer);
var
ss: SPar;
i: integer;
begin
  for i:=0 to SortPar.Count-1 do
  if(SPar(SortPar.Items[i]).Column = Col.ID)then
  begin
    ss:=SPar(SortPar.Items[i]);
    if(Col.Tag = 0)then
    begin
      Dispose(ss);
      SortPar.Delete(i);
      exit;
    end else
    begin
      ss.Tag:=Col.Tag;
      ss.Sind:=si;
      exit;
    end;
  end;
New(ss);
ss.Column:=Col.ID;
ss.Tag:=Col.Tag;
ss.Sind:=si;
self.SortPar.Add(ss);
self.CheckDefaultFilters;
end;

procedure RJob.ClearSortTop;
var
i: integer;
begin
for i:=0 to SortParTop.Count-1 do
Dispose(SPar(SortParTop.Items[i]));
SortParTop.Clear;
end;

procedure RJob.ClearSortView;
var
i: integer;
begin
for i:=0 to SortPar.Count-1 do
Dispose(SPar(SortPar.Items[i]));
SortPar.Clear;
end;

procedure RJob.DelSortTopCol(Col: TListColumn);
var
i: integer;
begin
for i:=0 to SortParTop.Count-1 do
begin
  if(SPar(SortParTop.Items[i]).Column = Col.ID)then
  begin
    Dispose(SPar(SortParTop.Items[i]));
    SortParTop.Delete(i);
    break;
  end;
end;
end;

procedure RJob.DelSortViewCol(Col: TListColumn);
var
i: integer;
begin
for i:=0 to SortPar.Count-1 do
begin
  if(SPar(SortPar.Items[i]).Column = Col.ID)then
  begin
    Dispose(SPar(SortPar.Items[i]));
    SortPar.Delete(i);
    break;
  end;
end;
end;

procedure RJob.FilterView;
var
i: integer;
dd: IDRec;
isadd: integer;
begin
try
    LFView.Clear;
    for i:=0 to LView.Count-1 do
    begin
      dd:=IDRec(LView.Items[i]);
      isadd:=0;
      dd.inlog:=false;
      if(dd.ntype in EnDisk)then
      begin
      LFView.Add(dd);
      continue;
      end;
      if(dd.ntype = ntFile)then
      begin
      if((self.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = self.TP.sTime))then
      isadd:=isadd+1;
      if((self.TP.sDate = fsDate)or(self.TP.sDate = DateToStr(dd.timewrite)))then
      isadd:=isadd+1;
      end else
      begin
      if((self.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = self.TP.sTime))then
      isadd:=isadd+1;
      if((self.TP.sDate = fsDate)or(self.TP.sDate = DateToStr(dd.timecreate)))then
      isadd:=isadd+1;
      end;

      if((self.TP.iType = ftType)or((self.TP.iType = ftFolders)and(dd.ntype <> ntFile)))then
      isadd:=isadd+1;
      if((self.TP.iType = ftFiles)and(dd.ntype = ntFile))then
      isadd:=isadd+1;
      if((self.TP.sMask = fsMask)or(MatchesMask(dd.iname,self.TP.sMask)))then
      isadd:=isadd+1;
      if((self.TP.sExt = fsExtension)or(ExtractFileExt(dd.iname) = self.TP.sExt))then
      isadd:=isadd+1;
      if(isadd = 5)then
      begin
        LFView.Add(dd);
      end;
    end;
except
//
end;
end;

procedure RJob.FilterTop;
var
i: integer;
dd: IDRec;
isadd: integer;
PL: string;
rj: RJob;
begin
try
rj:=self;
  rj.LFTop.Clear;
  rj.position2:=0;
  rj.maxval2:=rj.LTop.Count;

  for i:=0 to rj.LTop.Count-1 do
  begin
    dd:=IDRec(rj.LTop.Items[i]);
    rj.position2:=i;
    isadd:=0;
    if(rj.babort)then break;
    if(dd.ntype = ntFile)then
    begin
      case rj.TP.iDateType of
        0:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        1:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
          isadd:=isadd+1;
        end;
        2:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timeaccess) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timeaccess)))then
          isadd:=isadd+1;
        end;
        3:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        4:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
          isadd:=isadd+1;
        end;
      end;
    end else
    begin
      if(rj.TP.iDateType = 4)then
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
        isadd:=isadd+1;
      end else
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
        isadd:=isadd+1;
      end;
    end;
      case rj.TP.iType of
      0: isadd:=isadd+1;
      1: if(dd.ntype = ntFile)then isadd:=isadd+1;
      2: if(dd.ntype = ntDir)then isadd:=isadd+1;
      3: if(dd.ntype = ntFileDel)then isadd:=isadd+1;
      4: if(dd.ntype = ntFileNew)then isadd:=isadd+1;
      5: if(dd.ntype = ntFileChg)then isadd:=isadd+1;
      6: if(dd.ntype = ntDirNew)then isadd:=isadd+1;
      7: if(dd.ntype = ntDirDel)then isadd:=isadd+1;
      end;
      if(dd.ilabel = '')then PL:=GetTreePath(dd) else PL:=dd.ilabel;
      
    if((rj.TP.sMask = '*')or(MatchesMask(PL,rj.TP.sMask)))then
    isadd:=isadd+1;
    if((rj.TP.sExt = fsExtension)or(ExtractFileExt(dd.iname) = rj.TP.sExt))then
    isadd:=isadd+1;
    //**********************************
    if((rj.TP.iAction = 0)or(rj.TP.iAction-1 = dd.actionindex))then
    isadd:=isadd+1;
    if((rj.TP.iResult = 0)or(rj.TP.iResult+9 = dd.resultindex))then
    isadd:=isadd+1;
    if(
    ((rj.TP.iExec = 0)and((dd.resultindex = -1)or(dd.resultindex = tiExecErr)))or
    ((rj.TP.iExec = 1)and(dd.resultindex >=0))or
    (rj.TP.iExec = 2)or
    ((rj.TP.iExec = 3)and(ItemExists(dd)))or
    ((rj.TP.iExec = 4)and(not ItemExists(dd)))
    )then
    isadd:=isadd+1;
    //**********************************
    if(isadd = 8)then
    begin
      rj.LFTop.Add(dd);
    end;
  end;
rj.filterchange:=false;
rj.position2:=0;
except
//
end;
end;

{ FTPJob }
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

constructor FTPJob.Create;
begin
inherited;
try
ftproot:='/';
TwinExItem:=nil;
mtp:=nil;
pcrec:=nil;
self.pFrame:=nil;
filereceived:=true;
needexpand:=nil;
needlist:=nil;
messlock:=true;
onneedlist:=false;
woserror:=false;
LastError:='';
MessList:= TStringList.Create;
hMess:=windows.CreateEvent(nil,true,false,nil);

self.Save.jobkind:=jkTwin;
self.Save.jobtype:= jtRemoteFTP;

mFTp:=TmFtp.Create(nil);
ttf:=TFTPThread.Create(false);
ttf.FreeOnTerminate:=true;
ttf.ff:=mFTP;
ttf.prj:=self;
ttf.QQ:=QQ;
ttf.Resume;

mFTP.prj:=self;
self.Save.jobtype:=jtRemoteFTP;

mFTp.OnLoggedIn:= MFtp1LoggedIn;
mFTp.OnListingDone:= MFtp1ListingDone;

mFTp.OnFtpReady:= MFtp1FtpReady;
//mFTp.OnFtpQuit:= MFtp1FtpQuit;

mFTp.OnFtpNeedInfo:= MFtp1FtpNeedInfo;
mFTp.OnFtpInfo:= MFtp1FtpInfo;
mFTp.OnFtpError:= MFtp1FtpError;

mFTp.OnFtpBusy:= MFtp1FtpBusy;
mFTp.OnFileStored:= MFtp1FileStored;

mFTp.OnFileRenamed:= MFtp1FileRenamed;
mFTp.OnFileReceived:= MFtp1FileReceived;

mFTp.OnFileDeleted:= MFtp1FileDeleted;
mFTp.OnDirectoryDeleted:= MFtp1DirectoryDeleted;
mFTp.OnDirectoryCreated:= MFtp1DirectoryCreated;

mFTp.OnDirectoryChanged:= MFtp1DirectoryChanged;
mFTp.OnAborted:= MFtp1Aborted;
except
//
end;
end;

destructor FTPJob.Destroy;
begin
try
self.babort:=true;
if(self.pFrame<>nil)then
TFTPFrame(self.pFrame).Timer1.Enabled:=false;
ttf.Quit;
ttf.Terminate;
while ttf.QQ.Count>0 do
begin
Dispose(ComRec(QQ.Items[0]));
QQ.Delete(0);
end;
ttf:=nil;

mFTP.Abort;
Application.ProcessMessages; //FTPJob.Destroy;
mFTP.Free;
mFTP:=nil;
MessList.Free;
MessList:=nil;
CloseHandle(hMess);
inherited;
except
//
end;
end;

procedure FTPJob.EnumDir(pr: Pointer; dir: string);
var
df: MFtpFileInfo;
ad,sd: IDRec;
i,j: integer;
KK,MM: TList;
renum,chng: boolean;
prev: IDRec;
OSep: char;
s1,s2,s3: string;
sz: real;
begin
if(pr = nil)then exit;
prev:=IDRec(pr);
KK:=TList.Create;
MM:=TList.Create;

chng:=false;
if(dir<>rootname)then dir:=dir+'\';
dir:=AnsiReplaceText(dir,'\\','\');
  try
  try
  OSep:=DateSeparator;
  s1:=ShortDateFormat;
  s2:=ShortTimeFormat;
  s3:=TimePMString;
  DateSeparator := '/';
  ShortDateFormat	 := 'mm/dd/yy';
  ShortTimeFormat :='hh:nn';
  TimePMString:='am/pm';
    for i:=0 to mFTP.Directories.Count-1 do
    begin
      df:=mFTP.Directories.Items[i];
      ad:=CReateRec(df.Filename,nil,StrToFloat(df.Size),0,0,StrToDateTime(df.DateTime),0,faDirectory,ntDir);
      ad.ilabel:=dir+df.Filename;
      KK.Add(ad);
    end;
    if(mFTP.Directories.Count>0)then
    prev.haschild:=true;
    for i:=0 to mFTP.Files.Count-1 do
    begin
      df:=mFTP.Files.Items[i];
      try
        sz:=StrToFloat(df.Size);
      except
      sz:=0;
      end;
      ad:=CReateRec(df.Filename,nil,sz,0,StrToDateTime(df.DateTime),0,0,0,ntFile);
      ad.ilabel:=dir+df.Filename;
      KK.Add(ad);
    end;
    DateSeparator:=OSep;
    ShortDateFormat:=s1;
    ShortTimeFormat:=s2;
    TimePMString:=s3;
    KK.Sort(@DirSort);
    if(prev.ichild<>nil)then
    begin
    renum:=true;
    for j:=0 to High(prev.ichild) do
    MM.Add(prev.ichild[j]);
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);
      for j:=0 to MM.Count-1 do
      begin
        sd:=IDRec(MM.Items[j]);
        if((sd.iname = ad.iname)and(sd.ntype = ad.ntype))then
        begin
          if(sd.ntype = ntFile)then
          begin
            if(sd.isize > ad.isize)then
            begin
              sd.isize:=ad.isize;
              sd.actionindex:=sd.actionindex or rcSizeDown;
            end else
            if(sd.isize < ad.isize)then
            begin
              sd.isize:=ad.isize;
              sd.actionindex:=sd.actionindex or rcSizeUp;
            end;
            
            if(sd.timeaccess <> ad.timeaccess)then
            begin
              sd.timeaccess:=ad.timeaccess;
              chng:=true;
              sd.actionindex:=sd.actionindex or rcAccess;
            end;
            if(sd.timewrite <> ad.timewrite)then
            begin
              sd.timewrite:=ad.timewrite;
              sd.actionindex:=sd.actionindex or rcWrite;
              chng:=true;
            end;
          end else
          begin
            if(sd.timecreate <> ad.timecreate)then
            begin
              sd.timecreate:=ad.timecreate;
              chng:=true;
              sd.actionindex:=sd.actionindex or rcCreate;
            end;
          end;
          MM.Delete(j);
          KK.Items[i]:=nil;
          Finalize(ad^);
          Dispose(ad);
          break;
        end;
      end;
    end;
    KK.Pack;
    for j:=0 to MM.Count-1 do //it's are deleted items
    DestroyRec(IDRec(MM.Items[j]));
    
    if(MM.Count>0)then
    begin
    //LItems.Pack;
    RenumL(LItems);
    end;
    end //if(prev.ichild<>nil)then
    else renum:=false;

    if(KK.Count>0)then
    begin
    for i:=0 to KK.Count-1 do
    begin
      ad:=IDRec(KK.Items[i]);//it's are new items
      ad.listind:=LItems.Add(ad);
      ad.rj:=self;
      PushChild(ad,prev);
      ad.parent:=prev;
      if(renum)then
      begin
        ad.inlog:=true;
        LView.Add(ad);
        LFView.Add(ad);
      end;
    end;
    LFView.Sort(@DirSort);
    end;
    if(MM.Count>0)or(KK.Count>0)or(chng)then
    changed_tree:=true;
    //************************************************
    if(onneedlist)then
    begin
    needlist:=prev.trr;
    onneedlist:=false;
    end else
    needexpand:=prev.trr;
  finally
    prev.explored:=true;
    KK.Free;
    MM.Free;
  end;
  except
  FormLog.RecError('5021');
  end;
end;


function FTPJob.ListDir(pTDL: Pointer; dir, pref: string;pprev, pdd: Pointer): real;
var
ad: IDRec;
df: MFtpFileInfo;
i: integer;
pp1,sum: real;
ismatch: boolean;
tnow: TDateTime;
KL,KK: TList;
TDL: TDList;
prev,dd: IDRec;
OSep: char;
s1,s2,s3: string;
begin
TDL:= TDList(pTDL);
prev:=IDRec(pprev);
dd:=  IDRec(pdd);
tnow:=Now;
KK:= TList.Create;
KL:= TList.Create;
sum:=0;
Result:=0;
  if(prev = nil)then
  begin
  New(TDL.idroot);
  TDL.idroot.ilevel:=0;
  TDL.idroot.listind:=TDL.Add(TDL.idroot);
  TDL.idroot.ntype:=ntDir;
  TDL.idroot.iname:=TDL.DPar.dname;
  TDL.idroot.isize:=0;
  TDL.idroot.timewrite:=0;
  TDL.idroot.iattr:=faDirectory;
  TDL.idroot.parent:=nil;
  TDL.idroot.ichild:=nil;
  TDL.idroot.root:=nil;
  prev:=TDL.idroot;
  end;
  try
  try
  if(not ChangeDir(dir,true))then
  begin
    exit;
  end;
  OSep:=DateSeparator;
  s1:=ShortDateFormat;
  s2:=ShortTimeFormat;
  s3:=TimePMString;
  DateSeparator := '/';
  ShortDateFormat	 := 'mm/dd/yy';
  ShortTimeFormat :='hh:nn';
  TimePMString:='am/pm';
    for i:=0 to mFTP.Directories.Count-1 do
    begin
      df:=mFTP.Directories.Items[i];
      ad:=CReateRec(df.Filename,nil,StrToFloat(df.Size),0,0,StrToDateTime(df.DateTime),tnow,faDirectory,ntDir);
      ad.ilabel:=dir+'\'+df.Filename;
      KK.Add(ad);
    end;
    for i:=0 to mFTP.Files.Count-1 do
    begin
      df:=mFTP.Files.Items[i];
      ad:=CReateRec(df.Filename,nil,StrToFloat(df.Size),0,StrToDateTime(df.DateTime),0,tnow,0,ntFile);
      ad.ilabel:=dir+'\'+df.Filename;
      KK.Add(ad);
    end;
    DateSeparator:=OSep;
    ShortDateFormat:=s1;
    ShortTimeFormat:=s2;
    TimePMString:=s3;
    KK.Sort(@DirSort);
      for i:=0 to KK.Count-1 do
      begin
        ad:=IDRec(KK.Items[i]);
        pp1:=0;
        if babort then
        begin
          mFTP.Abort;
          exit;
        end;
        if(pabort<>nil)and(pabort^)then
        begin
          mFTP.Abort;
          exit;
        end;
        ismatch:=true;
        if((ad.iattr <> 0)and(TDL.DPar.fattr and faAnyFile <> 0)and
        ((ad.iattr and TDL.DPar.fattr)=0))then ismatch:=false;
        if(TDL.DPar.mask <> '*')then
        if((((ad.iattr and faDirectory)=0)or(not TDL.DPar.maskignoredir))and(ismatch))then
        ismatch:=MatchesMask(pref+'\'+ad.iname,TDL.DPar.mask);

        if(ismatch)then
        begin
          KL.Add(ad);
          ad.listind:=TDL.Add(ad);
          ad.root:=dd;
          ad.rj:=self;
          if(dd<>nil)then
          ad.actionindex:=dd.actionindex;
          ad.ilevel:=prev.ilevel+1;
          if(pref <>'')then ad.iname:=pref+'\'+ad.iname;
          if(ad.ntype = ntDir)and(TDL.DPar.subdirs) then
          begin
              Inc(TDL.ifolders);
              if(ChangeDir(ad.ilabel,true))then
              pp1:=ListDir(TDL,ad.ilabel,ad.iname,ad,dd);
          end;
          if(ad.ntype = ntFile)then
          begin
            Inc(TDL.ifiles);
            pp1:=ad.isize;
            TDL.fsize:=TDL.fsize+pp1;
          end;
          sum:=sum+pp1;
        end;
      end;
    {  if(KL.Count>0)then
      begin
        KL.Sort(@DirSort);
        SetLength(prev.ichild,KL.Count);
        for i:=0 to KL.Count-1 do
        prev.ichild[i]:=KL.Items[i];
      end; }
      ///////////////
    if(KL.Count>0)then
    begin
      KL.Sort(@DirSort);
      for i:=0 to KL.Count-1 do
      begin
        ad:=IDRec(KL.Items[i]);//it's are new items
        ad.listind:=LItems.Add(ad);
        ad.rj:=self;
        PushChild(ad,prev);
        ad.parent:=prev;
      end;
    end;
      ///////////////
      prev.isize:=sum;
  except
  FormLog.RecError('5022');
  end;
  Result:=sum;
  finally
    KL.Free;
    KK.Free;
  end;
end;

procedure FTPJob.ListDirEx(pTDL: Pointer; dir, pref: string);
var
ad,prev: IDRec;
i: integer;
ddir,df,exstr: string;
dd: IDRec;
tnow: TDateTime;
KL: TList;
TDL: TDList;
//waitres: Cardinal;
rda: DData;
begin
TDL:= TDList(pTDL);
tnow:=Now;
New(TDL.idroot);
TDL.idroot.ilevel:=0;
TDL.idroot.listind:=TDL.Add(TDL.idroot);
TDL.idroot.ntype:=ntDir;
TDL.idroot.iname:=TDL.DPar.dname;
TDL.idroot.isize:=0;
TDL.idroot.timewrite:=0;
TDL.idroot.iattr:=faDirectory;
TDL.idroot.parent:=nil;
TDL.idroot.ichild:=nil;
TDL.idroot.root:=nil;
KL:= TList.Create;
prev:=TDL.idroot;
  try
  try
    if((TDL.DPar.exclusive)and(TDL.DPar.PExList <> nil))then
    begin
      for i:=0 to TDL.DPar.PExList.Count-1 do
      begin
        exstr:=TDL.DPar.PExList.Strings[i];
        ddir:=dir+'\'+exstr;
        dd:=IDRec(TDL.DPar.PExList.Objects[i]);
        if babort then
        begin
          mFTP.Abort;
          exit;
        end;
        if(pabort<>nil)and(pabort^)then
        begin
          mFTP.Abort;
          exit;
        end;
        if(dd = nil)then
        begin
          if(not GetPropTo(ddir,@rda))then continue;
          case TDL.DPar.direct of
          dpIn:       continue;
          dpOut:      rda.actionindex:= aiCopyTo;
          dpInOut:    rda.actionindex:= aiCopyTo;
          dpOutOut:   rda.actionindex:= aiMoveTo;
          dpInOutOut: rda.actionindex:= aiMoveTo;
          end;
          if(TDL.DPar.fparam = fpEmpty)then rda.actionindex:=aiDelete;
        end else
        CopyPropIDRec(dd,@rda);

          ad:=CReateRec(ExtractFileName(rda.iname),prev,rda.isize,0,rda.timewrite,
                        rda.timecreate,tnow,rda.iattr,-1);
          ad.listind:=TDL.Add(ad);
          ad.ilabel:=ddir;
          KL.Add(ad);
          ad.root:=dd;
          ad.ilevel:=0;
          ad.rj:=self;
            ad.actionindex:=rda.actionindex;
            ad.ifs:=rda.ifs;
            if(not(rda.actionindex in EnDirNoExplore))then
            begin
              if(rda.ntype = ntDir)then
              begin
                Inc(TDL.ifolders);
                if(TDL.DPar.subdirs) then
                begin
                ad.explored:=true;
                if(dd <> nil)then dd.explored:=true;
                df:=ddir;
                if(ChangeDir(ddir,true))then
                ListDir(TDL,df,ad.iname,ad,ad);
                end;
              end else
              Inc(TDL.ifiles);
            end;
      end;
      KL.Sort(@DirSort);
      SetLength(prev.ichild,KL.Count);
      for i:=0 to KL.Count-1 do
      prev.ichild[i]:=KL.Items[i];
    end;
  except
  FormLog.RecError('5023');
  end;
  finally
    KL.Free;
  end;
end;

function FTPJob.Start(async: boolean=true): boolean;
var
scan: IDRec;
begin
scan:=IDRec(CRec(mmScan,nil,1,0,0,0,TimScan,0,ntScan));
if(TTree<>nil)then
begin
TTree.Items.Clear;
trr:=TTree.Items.Add(nil,'ftp://' + mFtp.Server + '/');
trr.Data:=scan;
scan.trr:=trr;
trr.ImageIndex:=17;
trr.SelectedIndex:=17;
trr.HasChildren:=true;
end;
scan.ilabel:=self.Save.sysname+':\';
rootname:=scan.ilabel;
pcrec:=scan;
if(async)then
self.ttf.Login
else
  if(not mFTP.Connected)then
  begin
    ResetEvent(mFTP.hListDone);
    mFTP.Login;
    WaitEvent(mFTP.hListDone,mFTP.TimeOut*1000);
  end;
Result:=mFTP.Connected;
end;

procedure FTPJob.MFtp1LoggedIn(Sender: TObject);
begin
  ftproot:=mFTP.CurrentDirectory+'/';
  mFTP.Refresh;
  if(TTree<>nil)then
  begin
  trr.ImageIndex:=17;
  trr.SelectedIndex:=17;
  end;
end;

procedure FTPJob.MFtp1ListingDone(Sender: TObject);
begin
SetEvent(mFTP.hListDone);
end;

procedure FTPJob.MFtp1FtpReady(Sender: TObject);
begin
//self.complete:=true;
end;

procedure FTPJob.MFtp1FtpQuit(Sender: TObject);
begin
//
end;

procedure FTPJob.MFtp1FtpNeedInfo(Sender: TObject;
  need: TMFtpInfoNeeded; var Value: String);
begin
   case need of
   {
      niAccount: Value := 'guest';
      niUsername: Value := 'anonymous';
      niPassword: Value := 'guest@microsoft.com';
    }
      // determine the local name of the file being downloaded
    {  niLocalFile:
      begin
        with SaveDialog1 do
        begin
            Filter := 'All Files|*.*';
            Filename := Value;
            if Execute then Value := Filename;
        end;
      end;
      // determine whether the file will be overwritten }
      niOverwrite:  Value := 'Overwrite';
   end;
end;

procedure FTPJob.MFtp1FtpInfo(Sender: TObject; info: FtpInfo;addinfo: String);
begin
if(ttf.QQ = nil)then exit;
try
if(not mFTP.Connected)then
MessStr:=addinfo;
if(addinfo = '')or(not mFTP.Connected)or(mFTP.Aborted)then exit;
addinfo:=AnsiReplaceStr(addinfo,#13#10,'');
   case info of
      ftpServerConnected:
      begin
         with mFTP do
         begin
            if (Server = '') and (addinfo = '') then
               AddMessage(msgConnectTo + msgSpecifiedS, msgStatus)
            else
            if (Server <> '') and (Server <> addinfo) then
            begin
               if addinfo <> '' then
                  AddMessage(msgConnectTo + Server + ' - ' + addinfo, msgStatus)
               else
                  AddMessage(msgConnectTo + Server, msgStatus);
            end
            else
            begin
               AddMessage(msgConnectTo + addinfo, msgStatus);
            end;
         end;
      end;
      ftpTraceIn:  AddMessage(addinfo, msgReply);
      ftpTraceOut: AddMessage(addinfo, msgCommand);
      ftpRetrying: AddMessage(addinfo, msgStatus);
      ftpNotSupportResume:   AddMessage(addinfo, msgStatus);
      ftpSupportResume:      AddMessage(addinfo, msgStatus);
      ftpServerDisconnected: AddMessage(msgDisconnected , msgStatus);
      ftpNothing: AddMessage(addinfo, msgStatus);
      ftpLoggedIn: AddMessage(msgLoginS, msgStatus);
   end;
except
FormLog.RecError('5024');
end;
end;

procedure FTPJob.AddMessage(Msg: String; MsgType: TMessageType);
var
C: String;
begin
try
if(MessList = nil)then exit;
  C := '0';
  case MsgType of
     msgCommand:   C := '1';
     msgError:     C := '2';
     msgException: C := '3';
     msgReply:     C := '4';
     msgStatus:    C := '5';
  end;
  //ResetEvent(hMess);
  messlock:=true;
  MessList.Add(Msg+'='+C);
  messlock:=false;
  //SetEvent(hMess);
except
FormLog.RecError('5024-1');
end;
end;

procedure FTPJob.MFtp1FtpError(Sender: TObject; error: FtpError;
  addinfo: String);
begin
woserror:=true;
LastError:=addinfo;
//MessList.SaveToFile('ftpmess.txt');
end;

procedure FTPJob.MFtp1FtpBusy(Sender: TObject);
begin
//
end;

procedure FTPJob.MFtp1FileStored(Sender: TObject);
begin
SetEvent(mFTP.hFilePut);
end;

procedure FTPJob.MFtp1FileRenamed(Sender: TObject);
begin
SetEvent(mFTP.hRename);
end;

procedure FTPJob.MFtp1FileReceived(Sender: TObject);
begin
//TFTPFrame(pFrame).Mess.AddMessage('2222222----'+FloatToStr(mFTP.TrBytes),msgStatus);
SetEvent(mFTP.hFileGet);
filereceived:=true;
end;

procedure FTPJob.MFtp1FileDeleted(Sender: TObject);
begin
SetEvent(mFTP.hDelete);
end;

procedure FTPJob.MFtp1DirectoryDeleted(Sender: TObject);
begin
SetEvent(mFTP.hDelete);
end;

procedure FTPJob.MFtp1DirectoryCreated(Sender: TObject);
begin
SetEvent(mFTP.hCreate);
end;

procedure FTPJob.MFtp1DirectoryChanged(Sender: TObject);
begin
SetEvent(mFTP.hDirCng);
end;

procedure FTPJob.MFtp1Aborted(Sender: TObject);
begin
//SetEvent(mFTP.hDataDisconnect);
self.complete:=true;
end;

function FTPJob.CreateTo(ddir: string): boolean;
var
dir: string;
waitres: cardinal;
begin
  Result:=false;
dir:=ExtractFilePath(ddir);
    if(not ChangeDir(dir))then exit;
dir:=ExtractFileName(ddir);
    ResetEvent(mFTP.hCreate);
    mFTP.CreateDirectory(dir);
    waitres:=WaitEvent(mFTP.hCreate,mFTP.TimeOut*1000);
    if(waitres <> WAIT_OBJECT_0)then
    exit
    else
    Result:=true;
end;

function FTPJob.CreateFrom(pCompData: Pointer): boolean;
var
dd: CompData;
dir: string;
waitres: cardinal;
begin
  Result:=false;
  dd:= CompData(pCompData);
dir:=dd.dirfrom.dname+dd.idd.iname;
dir:=ExtractFilePath(dir);
    if(not ChangeDir(dir))then exit;
dir:=ExtractFileName(dd.idd.iname);
    ResetEvent(mFTP.hCreate);
    mFTP.CreateDirectory(dir);
    waitres:=WaitEvent(mFTP.hCreate,mFTP.TimeOut*1000);
    if(waitres <> WAIT_OBJECT_0)then
    exit
    else
    Result:=true;
end;

function FTPJob.DeleteFrom(pCompData: Pointer): boolean;
var
dd: CompData;
dir: string;
waitres: cardinal;
begin
Result:=false;
dd:= CompData(pCompData);
dir:=dd.dirfrom.dname+dd.idd.iname;
//dir:=ConvertDir(dir)
//if(dd.idd.ntype = ntFile)then
//self.ttf.DeleteFile(dir)

if(dd.idd.ntype = ntFile)then
dir:=ConvertDir(dir)
else
begin
dir:=ExtractFilePath(dir);
if(not ChangeDir(dir))then exit;
dir:=ExtractFileName(dd.idd.iname);
end;
  ResetEvent(mFTP.hDelete);
  if(dd.idd.ntype = ntFile)then
  mFTP.DeleteFile(dir)
  else
  mFTP.DeleteDirectory(dir);
  waitres:=WaitEvent(mFTP.hDelete,mFTP.TimeOut*1000);
  if(waitres <> WAIT_OBJECT_0)then
  exit
  else
  Result:=true;
end;

function FTPJob.DeleteTo(pCompData: Pointer): boolean;
var
dd: CompData;
dir: string;
waitres: cardinal;
begin
Result:=false;
dd:= CompData(pCompData);
dir:=dd.dirto.dname+dd.idd.iname;
dir:=ExtractFilePath(dir);
  if(not ChangeDir(dir))then
  exit;
dir:=ExtractFileName(dd.idd.iname);
    ResetEvent(mFTP.hDelete);
    if(dd.idd.ntype = ntFile)then
    mFTP.DeleteFile(dir)
    else
    mFTP.DeleteDirectory(dir);
    waitres:=WaitEvent(mFTP.hDelete,mFTP.TimeOut*1000);
  if(waitres <> WAIT_OBJECT_0)then
    exit
  else
    Result:=true;
end;


function FTPJob.ExistsTo(ddir: string;isfile: boolean=true): boolean;
var
dir: string;
i: integer;
rr: IDRec;
begin
Result:=false;
if(isfile)then
begin
dir:=ExtractFilePath(ddir);
end else
dir:=ddir;
/////////
  if(not ChangeDir(dir,true))then
  exit
  else
  begin
    if(isfile)then
    begin
      dir:=ExtractFileName(ddir);
      for i:=0 to LItems.Count-1 do
      begin
        rr:= IDRec(LItems.Items[i]);
        if(rr.iname = dir)then
        begin
          Result:=true;
          break;
        end;
      end;
    end else
    Result:=true;
  end;
end;


function FTPJob.ExistsI(pr: Pointer): boolean;
begin
Result:=true;
self.ttf.GetProp(IDRec(pr).ilabel,pr);
end;

function FTPJob.GetSrcFrom(pCompData: Pointer): TStream;
var
dd: CompData;
dir: string;
begin
try
dd:= CompData(pCompData);
cursize:=dd.idd.isize;
dir:=dd.idd.ilabel;
dir:=ConvertDir(dir);
mFTP.ExpectedSize:=cursize;
mFTP.DFF.Clear;
CheckConnect;
ResetEvent(mFTP.hFileGet);
Result:=mFTP.GetFileStream(dir);
self.WaitEvent(mFTP.hFileGet,mFTP.TimeOut*1000);
  try
  if(Result.Size>0)then
  Result.Seek(0,soFromBeginning);
  except
  Result:=nil;
  FormLog.RecError('5028');
  end;
except
Result:=nil;
FormLog.RecError('5027');
end;
end;

function FTPJob.GetSrcTo(pCompData: Pointer;ddir: string): TStream;
var
dd: CompData;
dir: string;
begin
try
mFTP.DFF.Clear;
Result:=mFTP.DFF;
dd:= CompData(pCompData);
cursize:=dd.idd.isize;
dir:=ExtractFilePath(ddir);
    if(not ChangeDir(dir))then
    exit;
dir:=ExtractFileName(ddir);
//self.MessList.Add('**********************************222');
mFTP.ExpectedSize:=cursize;
self.putdir:=dir;
except
Result:=nil;
FormLog.RecError('5028');
end;
end;

function FTPJob.MoveToRecycle(fname: string): integer;
begin
Result:=-1;
end;

function FTPJob.RenameDest(const ddir: string;const newname: string): boolean;
var
dir: string;
waitres: cardinal;
begin
Result:=false;
dir:=ExtractFilePath(ddir);
  if(not ChangeDir(dir))then
  exit;
dir:=ExtractFileName(ddir);
    ResetEvent(mFTP.hRename);
    mFTP.RenameFile(dir,ExtractFileName(newname));
    waitres:=WaitEvent(mFTP.hRename,mFTP.TimeOut*1000);
  if(waitres <> WAIT_OBJECT_0)then
    exit
  else
    Result:=true;
end;

function FTPJob.RenameSrc(pCompData: Pointer; newname: string): boolean;
var
dd: CompData;
dir: string;
waitres: cardinal;
begin
Result:=false;
dd:= CompData(pCompData);
dir:=dd.dirfrom.dname+dd.idd.iname;
dir:=ExtractFilePath(dir);
  if(not ChangeDir(dir))then
    exit;
dir:=ExtractFileName(dd.idd.iname);
    ResetEvent(mFTP.hRename);
    mFTP.RenameFile(dir,ExtractFileName(newname));
    waitres:=WaitEvent(mFTP.hRename,mFTP.TimeOut*1000);
  if(waitres <> WAIT_OBJECT_0)then
    exit
  else
    Result:=true;
end;

function FTPJob.RenameS(oldname,newname: string): boolean;
var
dir: string;
waitres: cardinal;
begin
Result:=false;
dir:=oldname;
dir:=ExtractFilePath(dir);
  if(not ChangeDir(dir))then
    exit;
dir:=ExtractFileName(oldname);
    ResetEvent(mFTP.hRename);
    mFTP.RenameFile(dir,ExtractFileName(newname));
    waitres:=WaitEvent(mFTP.hRename,mFTP.TimeOut*1000);
  if(waitres <> WAIT_OBJECT_0)then
    exit
  else
    Result:=true;
end;

function FTPJob.ConvertDir(dir: string): string;
var
len: integer;
begin
  Result:=AnsiReplaceText(dir,rootname,ftproot);
  Result:=AnsiReplaceText(Result,'\','/');
  Result:=AnsiReplaceText(Result,'//','/');
  Result:=AnsiReplaceText(Result,'//','/');
  len:= Length(Result);
  if(len>1)and(LastDelimiter('/',Result) = len)then
  Result:=LeftStr(Result,len-1);
end;

procedure FTPJob.FinalizeSrc(sf: TStream);
begin
//mFTP.DFF.Clear;
//mFTP.Abort;
end;

function FTPJob.ExistsS(dname: string; isfile: boolean): boolean;
var
dir: string;
i: integer;
rr: IDRec;
begin
Result:=false;
if(isfile)then
dir:=ExtractFilePath(dname)
else
dir:=dname;
  if(not ChangeDir(dir,true))then
  exit
  else
  begin
    if(isfile)then
    begin
      dir:=ExtractFileName(dname);
      for i:=0 to LItems.Count-1 do
      begin
        rr:= IDRec(LItems.Items[i]);
        if(rr.iname = dir)then
        begin
          Result:=true;
          break;
        end;
      end;
    end else
    Result:=true;
  end;
end;

procedure FTPJob.AbortFTP;
begin
try
mFTP.Abort;
except
//
end;
end;

function FTPJob.LastJobError: string;
begin
try
Result:=self.Save.jobname+'-'+self.LastError;
except
//
end;
end;

procedure FTPJob.RescanDir(rec: Pointer);
var
rr: IDRec;
begin
rr:=IDRec(rec);
if(needexpand = nil)then
EnumDir(rr,rr.ilabel);
end;

procedure FTPJob.RescanTree;
var
i: integer;
rr: IDRec;
cc: ComRec;
begin
  ttf.Suspend;
  try
  i:=0;
  while i<LItems.Count-1 do
  begin
    rr:=IDRec(LItems.Items[i]);
    if(rr.trr<>nil)and(rr = self.CNode)then
    begin
      cc:=ttf.CreateComm;
      cc.icomm:=coExplore;
      rr.explored:=false;
      cc.prr:=rr;
      cc.tr:=rr.trr;
      QQ.Add(cc);
      Inc(i);
      continue;
    end;
    if(rr.trr<>nil)and(rr.trr.Expanded)then
    begin
      //rr.trr.Collapse(true);
      ttf.GetProp(rr.ilabel,rr);
    end;
    Inc(i);
  end;
  finally
  ttf.Resume;
  end;
end;

function FTPJob.ChangeDir(dir: string;getlist: boolean=false;parent: boolean=false;refresh: boolean = false): boolean;
var
waitres: cardinal;
begin
  Result:=false;
  try
  if(not mFTP.Connected)then
  begin
    ResetEvent(mFTP.hListDone);
    mFTP.Login;
    waitres:=WaitEvent(mFTP.hListDone,mFTP.TimeOut*1000);
    if(waitres <> WAIT_OBJECT_0)then exit;
  end;
  dir:=ConvertDir(dir);
  WaitingFreedom;
  woserror:=false;
  if(dir<>mFTP.CurrentDirectory)or(parent)then
  begin
    ResetEvent(mFTP.hDirCng);
    if(parent)then
    mFTP.ChangeToParentDirectory
    else
    mFTP.ChangeDirectory(dir);
    waitres:=WaitEvent(mFTP.hDirCng,mFTP.TimeOut*1000);
    if(waitres <> WAIT_OBJECT_0)or(woserror)then exit;
  end;
  if(getlist)or(refresh)then
  begin
    ResetEvent(mFTP.hListDone);
    mFTP.Refresh;
    waitres:=WaitEvent(mFTP.hListDone,mFTP.TimeOut*1000);
    if(waitres <> WAIT_OBJECT_0)or(woserror)then exit;
  end;
  //if(waitres = WAIT_OBJECT_0)and(not woserror)then Result:=true;
  Result:=true;
  woserror:=false;
  except
  //
  end;
end;


function FTPJob.CompletePut: boolean;
var
waitres: cardinal;
begin
Result:=false;
woserror:=false;
ResetEvent(mFTP.hFilePut);
mFTP.PutFileStream(putdir);
waitres:=WaitEvent(mFTP.hFilePut,mFTP.TimeOut*1000);
if(waitres = WAIT_OBJECT_0)and(not woserror)then Result:=true;
woserror:=false;
end;

function FTPJob.FindRoot(fname: string): Pointer;
var
i: integer;
drr: IDRec;
begin
  Result:=nil;
  for i:=0 to LItems.Count-1 do
  begin
    drr:= IDRec(LItems.Items[i]);
    if(fname = drr.ilabel+'\')then
    begin
      Result:=drr;
      break;
    end;
  end;
end;

function FTPJob.RenCycle(fname: string; nc: integer): string;
var
NList: TList;
fext,nname,res,path,rname,dob,dir: string;
i,nn: integer;
rr: TRen;
df: MFtpFileInfo;
begin
Result:=fname;
NList:=TList.Create;
try
try
res:='';
dob:='';
dir:=fname;
dir:=ExtractFilePath(dir);
  if(not ChangeDir(dir,true))then
  exit;
fext:=ExtractFileExt(fname);
rname:=ChangeFileExt(fname,'');
rname:=ExtractFileName(rname);
nname:=rname+'*';
path:=ExtractFilePath(fname);

  for i:=0 to mFTP.Directories.Count-1 do
    begin
      df:=mFTP.Directories.Items[i];
      if(MatchesMask(df.Filename,nname))then
      begin
        New(rr);
        rr.isfile:=false;
        rr.oldname:=path+df.Filename;
        NList.Add(rr);
      end;
    end;
    for i:=0 to mFTP.Files.Count-1 do
    begin
      df:=mFTP.Files.Items[i];
      if(MatchesMask(df.Filename,nname))then
      begin
        New(rr);
        rr.isfile:=true;
        rr.oldname:=path+df.Filename;
        NList.Add(rr);
      end;
    end;
nn:=NList.Count-1;
  if(PParentJob<>nil)then PParentJob.maxval2:=nn;
  if(PParentJob<>nil)then PParentJob.position2:=1;
NList.Sort(@RenComp);
res:=path+rname;
  while(nn >= 0)do
  begin
    rr:= TRen(NList.Items[nn]);
    if(PParentJob<>nil)then PParentJob.position2:=PParentJob.position2+1;
    if((nn>=(nc-1))and (rr<>nil))then
    begin
      DeleteS(rr.oldname,rr.isfile);
      NList.Delete(nn);
      Dispose(rr);
      nn:=NList.Count-1;
      continue;
    end;
    rr.newname:=path+rname+IntToStr(nn+1)+dob+fext;
    if(rr.oldname<>rr.newname)then
    begin
    if(not RenameS(rr.oldname,rr.newname))then dob:=dob+'!';
    end;
    nn:=nn-1;
  end;
  if(PParentJob<>nil)then
  PParentJob.position2:=0;
finally
for i:=0 to NList.Count-1 do
Dispose(NList.Items[i]);
NList.Free;
end;
except
//
end;
Result:=res+dob+fext;
end;

function FTPJob.DeleteS(dname: string; isfile: boolean;recurse: boolean=true): boolean;
var
dir: string;
waitres: cardinal;
i: integer;
DList,FList: TStringList;
begin
Result:=false;
DList:=TStringList.Create;
FList:=TStringList.Create;
try
    if(isfile)then
    begin
      dir:=ExtractFilePath(dname);
      if(not ChangeDir(dir))then
        exit;
      dir:=ExtractFileName(dname);
      ResetEvent(mFTP.hDelete);
      mFTP.DeleteFile(dir);
      waitres:=WaitEvent(mFTP.hDelete,mFTP.TimeOut*1000);
      if(waitres <> WAIT_OBJECT_0)then
        exit
      else
        Result:=true;
    end else
    begin
      dir:=dname;
      if(not ChangeDir(dir,true,false,true))then
        exit;
      dir:=ExtractFileName(dname);
      ///////////////////
      for i:=0 to mFTP.Directories.Count-1 do
      DList.Add(mFTP.Directories.Items[i].Filename);

      for i:=0 to mFTP.Files.Count-1 do
      FList.Add(mFTP.Files.Items[i].Filename);

      for i:=0 to DList.Count-1 do
      DeleteS(DList.Strings[i],false);

      for i:=0 to FList.Count-1 do
      begin
        ResetEvent(mFTP.hDelete);
        mFTP.DeleteFile(FList.Strings[i]);
        waitres:=WaitEvent(mFTP.hDelete,mFTP.TimeOut*1000);
        if(waitres <> WAIT_OBJECT_0)then
        exit;
      end;
      if(not ChangeDir(dir,false,true))then
        exit;
      ResetEvent(mFTP.hDelete);
      mFTP.DeleteDirectory(dir);
      waitres:=WaitEvent(mFTP.hDelete,mFTP.TimeOut*1000);
      if(waitres <> WAIT_OBJECT_0)then
      exit
      else
      Result:=true;
    end;
finally
DList.Free;
FList.Free;
end;
end;

procedure FTPJob.PrepareEx1(dir: string;LVEx,LVAttr: TListView;smask: string;selall: boolean);
var
TL: TListItem;
i: integer;
df: MFtpFileInfo;
OSep: char;
s1,s2,s3: string;
begin
LVEx.Items.Clear;
  if(not ChangeDir(dir))then
    exit;
  if(dir<>rootname)then dir:=dir+'\';
  try
  try
  OSep:=DateSeparator;
  s1:=ShortDateFormat;
  s2:=ShortTimeFormat;
  s3:=TimePMString;
  DateSeparator := '/';
  ShortDateFormat	 := 'mm/dd/yy';
  ShortTimeFormat :='hh:nn';
  TimePMString:='am/pm';
    for i:=0 to mFTP.Directories.Count-1 do
    begin
      df:=mFTP.Directories.Items[i];
      if(not MatchesMask(df.Filename,smask))then continue;
      TL:=LVEx.Items.Add;
      TL.Caption:=df.Filename;
      TL.Checked:=selall;
      TL.ImageIndex:=0;
    end;
    for i:=0 to mFTP.Files.Count-1 do
    begin
      df:=mFTP.Files.Items[i];
      if(not MatchesMask(df.Filename,smask))then continue;
      TL:=LVEx.Items.Add;
      TL.Caption:=df.Filename;
      TL.Checked:=selall;
      TL.ImageIndex:=1;
    end;
    DateSeparator:=OSep;
    ShortDateFormat:=s1;
    ShortTimeFormat:=s2;
    TimePMString:=s3;
  LVEx.Refresh;
 
  except
  FormLog.RecError('5025');
  end;
  finally
    self.complete:=true;
  end;
end;

procedure FTPJob.WaitingFreedom;
var
num: integer;
tryabort,tryconnect: boolean;
begin
{  num:=0;
  tryabort:=false;
  tryconnect:=false;
  while mFTP.Busy do
  begin
    //sleep(100);
    Application.ProcessMessages;
    Inc(num);
    if(num*10>=mFTP.TimeOut)then
    begin  
      if (mFTP.FtpLastAction = ftplaGET) or (mFTP.FtpLastAction = ftplaPUT) then
      num:=0
      else
      if(mFTP.Connected)then
      begin
        if(tryabort)then
        begin
          num:=0;
          mFTP.Disconnect;
        end else
        begin
          num:=0;
          tryabort:=true;
          mFTP.Abort;
        end;
      end else
      begin
        if(tryconnect)then
        begin
          break;
        end else
        begin
          tryconnect:=true;
          mFTP.Login;
        end;
      end;
    end;
  end; }
end;

procedure FTPJob.PrepareEx(dir: string; LVEx, LVAttr: TListView;
  smask: string; selall: boolean);
begin
ttf.PrepEx(dir,LVEx,LVAttr,smask,selall);
end;

function FTPJob.DeleteI(dname: string): boolean;
begin
Result:=false;
end;

function FTPJob.CopyI(dfromdto: string): boolean;
begin
Result:=false;
end;

function FTPJob.EmptyI(fname: string): real;
begin
Result:=-1;
end;

function FTPJob.EmptyToRecycle(fname: string): integer;
begin
Result:=-1;
end;

function FTPJob.MoveContentI(dfromdto: string): boolean;
begin
Result:=false;
end;

function FTPJob.MoveI(dfromdto: string): boolean;
begin
Result:=false;
end;

function FTPJob.RenameI(dfromdto: string): boolean;
begin
Result:=false;
end;

procedure FTPJob.CollapseNode(Node: TTreeNode);
begin
 //
end;

procedure FTPJob.ExpandNode(Node: TTreeNode);
begin
//
end;

function FTPJob.SetAttr(const FileName: string; Attr: Integer): Integer;
begin
Result:=-1;
end;

procedure FTPJob.PrepareCompare(dir: string; ExList: TStringList);
begin
//
end;

function FTPJob.SetDateTo(pCompData: Pointer): boolean;
begin
Result:=false;
end;

function FTPJob.GetPropTo(var ddir: string; pIDRec: Pointer;dToName: string=''): boolean;
var
rr,rd: IDRec;
dir: string;
i: integer;
df: MFtpFileInfo;
OSep: char;
s1,s2,s3: string;
begin
Result:=false;
try
rr:=IDRec(pIDRec);
dir:=ExtractFilePath(ddir);
  if(not AnsiContainsStr(mFTP.CurrentDirectory,dir))then
  begin
    if(not ChangeDir(dir,true))then
      exit;
    dir:=ExtractFileName(ddir);
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  OSep:=DateSeparator;
  s1:=ShortDateFormat;
  s2:=ShortTimeFormat;
  s3:=TimePMString;
  DateSeparator := '/';
  ShortDateFormat	 := 'mm/dd/yy';
  ShortTimeFormat :='hh:nn';
  TimePMString:='am/pm';
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    for i:=0 to mFTP.Directories.Count-1 do
    begin
      df:=mFTP.Directories.Items[i];
      if(dir = df.Filename)then
      begin
        rr.iname:=df.Filename;
        rr.timeaccess:=0;
        rr.timewrite:=0;
        rr.timecreate:=StrToDateTime(df.DateTime);
        rr.isize:=StrToFloat(df.Size);
        rr.iattr:=faDirectory;
        rr.ntype:=ntDir;
        Result:=true;
        break;
      end;
    end;
    for i:=0 to mFTP.Files.Count-1 do
    begin
      df:=mFTP.Files.Items[i];
      if(dir = df.Filename)then
      begin
        rr.iname:=df.Filename;
        rr.timeaccess:=0;
        rr.timewrite:=StrToDateTime(df.DateTime);
        rr.timecreate:=0;
        rr.isize:=StrToFloat(df.Size);
        rr.iattr:=0;
        rr.ntype:=ntFile;
        Result:=true;
        break;
      end;
    end;
    //xxxxxxxxxxxxxxxxxxx
    DateSeparator:=OSep;
    ShortDateFormat:=s1;
    ShortTimeFormat:=s2;
    TimePMString:=s3;
    //xxxxxxxxxxxxxxxxxxxxx
  end else
  begin
    for i:=0 to LItems.Count-1 do
    begin
      rd:= IDRec(LItems.Items[i]);
      if(rd.ilabel = ddir)then
      begin
        CopyPropIDRec(rd,rr);
        Result:=true;
        break;
      end;
    end;
  end;
except
FormLog.RecError('5026');
end;
end;


procedure FTPJob.SetAbort(compval: boolean);
begin
  inherited;
if(mFTP <> nil)then  
mFTP.Abort;
end;

function FTPJob.SetDateI(fname: string; timeaccess, timewrite,
  timecreate: TDateTime): boolean;
begin
Result:=false;
end;

procedure FTPJob.BreakJob;
begin
mFTP.Abort;
mFTP.Disconnect;
  inherited;
end;

procedure FTPJob.CheckConnect;
begin
if(not mFTP.Connected)then
begin
ResetEvent(mFTP.hReady);
mFTP.Login;
WaitEvent(mFTP.hReady,mFTP.TimeOut*1000);
end;
end;

procedure RJob.SortList(SList: integer;ItemType: integer = 0);
function CompPrev(PLL: TList;fr,dr: IDrec): integer;
var
h: integer;
ev: CompFunc;
begin
  Result:=0;
  for h:=0 to PLL.Count-1 do
  begin
    ev:=CompFunc(PLL.Items[h]);
    Result:=Result+Abs(ev(fr,dr));
  end;
end;
var
LL1,RL,PL,SL,ParL: TList;
cc: CompFunc;
i,j,k: integer;
sorted: boolean;
rr,first: IDRec;
ss: SPar;
begin
RL:= TList.Create;
PL:= TList.Create;
SL:= TList.Create;
try
  case SList of
    lnLTop       :LL1:=self.LTop;
    lnLFTop      :LL1:=self.LFTop;
    lnLView      :LL1:=self.LView;
    lnLFView     :LL1:=self.LFView;
    else
    exit;
  end;
  case SList of
    lnLTop       :ParL:=self.SortParTop;
    lnLFTop      :ParL:=self.SortParTop;
    lnLView      :ParL:=self.SortPar;
    lnLFView     :ParL:=self.SortPar;
    else
    exit;
  end;
  sorted:=false;
  cc:=nil;
  //prev:=nil;
  for i:=0 to ParL.Count-1 do
  begin
    ss:= SPar(ParL.Items[i]);
    if(ss = nil)then continue;
      if(@cc<>nil)then
      SL.Add(@cc);
      case ItemType of
        siIDRec:
        begin
          case ss.Sind of
            psName   : cc:=DirSort;//CompNames; 0
            psLabel  : cc:=CompLabel;          //1
            psIfs    : cc:=CompIfs;            //2
            psSize   : cc:=CompTop1;           //3
            psDateCr : cc:=CompDateCreate;     //4
            psTimeCr : cc:=CompTimeCreate;     //5
            psDateAc : cc:=CompDateAccess;     //6
            psTimeAc : cc:=CompTimeAccess;     //7
            psDateWr : cc:=CompDateWrite;      //8
            psTimeWr : cc:=CompTimeWrite;      //9
            psCommon : cc:=DirSort;            //10
            psEachOwnDate: cc:=CompEachOwnDate;//11
            psEachOwnTime: cc:=CompEachOwnTime;//12
            //psFrom   : cc:=CompFrom;
            //psTo     : cc:=CompTo;
          end;
        end;
        siCompData:
        begin
          case ss.Sind of
            psName   : cc:=CompTo1;
            psLabel  : cc:=CompLabelCV;          //1
            psIfs    : cc:=CompIfsCV;            //2
            psSize   : cc:=CompTo2;           //3
            psDateCr : cc:=CompTo3dateC;     //4
            psTimeCr : cc:=CompTo3timeC;     //5
            psDateAc : cc:=CompTo3dateA;     //6
            psTimeAc : cc:=CompTo3timeA;     //7
            psDateWr : cc:=CompTo3dateW;      //8
            psTimeWr : cc:=CompTo3timeW;      //9
            psCommon : cc:=CompTo1;            //10
            psEachOwnDate: cc:=CompEachOwnDateCV;//11
            psEachOwnTime: cc:=CompEachOwnTimeCV;//12
            psFrom   : cc:=CompFrom;
            psTo     : cc:=CompTo;
          end;
        end;
      end;
      if(not sorted)then
      begin
        LL1.Sort(cc);
        sorted:=true;
        if(ss.Tag>0)then
        begin
          for j:=0 to LL1.Count-1 do
          RL.Add(LL1.Items[LL1.Count-j-1]);
          LL1.Clear;
          LL1.Assign(RL);
          RL.Clear;
        end;
      end else
      begin
        first:=nil;
        RL.Clear;
        if(PL.Count>0)then
        begin
          LL1.Clear;
          LL1.Assign(PL);
          PL.Clear;
        end;
        if(LL1.Count>0)then first:=IDRec(LL1.Items[0]);
        for k:=0 to LL1.Count-1 do
        begin
          rr:= IDRec(LL1.Items[k]);
          if(CompPrev(SL,first,rr) <> 0)or(k = LL1.Count-1)then
          begin
            if(RL.Count>0)then
            begin
              RL.Sort(cc);
              if(ss.Tag>0)then
              begin
                for j:=0 to RL.Count-1 do
                PL.Add(RL.Items[RL.Count-j-1]);
              end else
              begin
                for j:=0 to RL.Count-1 do
                PL.Add(RL.Items[j]);
              end;
            end;
            first:=rr;
            RL.Clear;
            RL.Add(rr);
            if(k = LL1.Count-1)and(first = rr)then
            PL.Add(rr);
          end else
          RL.Add(rr);
        end;
      end;
  end;
  if(PL.Count>0)then
  begin
    LL1.Clear;
    LL1.Assign(PL);
  end else
    if(not sorted)then
      case ItemType of
        siIDRec:    LL1.Sort(@DirSort);
        siCompData: LL1.Sort(@DirSortCV);
      end;

finally
RL.Free;
PL.Free;
SL.Free;
end;
end;

procedure RJob.ExpandTreeNode(tr: TTreeNode;OnlyDir: boolean=true);
begin
    if(not complete)then exit else complete:=false;
    try
    if(IDRec(tr.Data).ntype <> ntSysFolders)then
    ExploreFolder1(IDRec(tr.Data))
    else
    EnumSysFolders(tr,OnlyDir);
    StartNotifyWatch(IDRec(tr.Data));
    ExpandTreeNode1(tr,OnlyDir);
    complete:=true;
    except
      complete:=true;
    end;
end;

procedure RJob.ExpandTreeNode1(tr: TTreeNode;OnlyDir: boolean=true);
var
i: integer;
tr2: TTreeNode;
ad,sd: IDRec;
begin
try
  if(tr<>nil)then
  begin
    if(tr.Data = nil)then exit;
    ad:=IDRec(tr.Data);

    if(tr.Count>0)then tr.DeleteChildren;
    if(ad.ichild<>nil)then
    begin
      for i:=0 to High(ad.ichild) do
      begin
        if(ad.ichild[i] = nil)then continue;
        sd:= ad.ichild[i];
        if((OnlyDir)and(sd.ntype = ntFile))then continue;
        tr2:=TTree.Items.AddChild(tr,sd.iname);
        tr2.Data:=sd;
        sd.trr:=tr2;
        tr2.HasChildren:=sd.haschild;
        if((sd.ntype in EnDisk)and(not tr2.Expanded))or
        (self.Save.jobtype = jtRemoteFTP)or
        (not self.prescandirs)then
        tr2.HasChildren:=true;
        if(sd.ntype <> ntSysFolders)then
        tr2.ImageIndex:=sd.ntype
        else
        begin
        tr2.ImageIndex:=34;
        tr2.HasChildren:=true;
        end;
        tr2.SelectedIndex:=tr2.ImageIndex;
      end;
    end;
  end;
except
FormLog.RecError('8015');
end;
end;

procedure FTPJob.ExpandTreeNode(tr: TTreeNode; OnlyDir: boolean);
var
cc: ComRec;
begin
if(IDRec(tr.Data).explored)then
begin
ExpandTreeNode1(tr,OnlyDir);
exit;
end;
tr.StateIndex:=6;
cc:=ttf.CreateComm;
cc.icomm:=coExpand;
cc.prr:=IDRec(tr.Data);
cc.tr:=tr;
cc.OnlyDir:=OnlyDir;
QQ.Add(cc);
end;

procedure FTPJob.ExploreFolder(TBShowAllFDown, TBIcoDown: boolean;prr: Pointer);
var
cc: ComRec;
begin
self.TBShowAllFDown:=TBShowAllFDown;
self.TBIcoDown:=TBIcoDown;
if(IDRec(prr).explored)then
begin
ExploreFolder1(prr);
exit;
end;
cc:=ttf.CreateComm;
cc.icomm:=coExplore;
cc.prr:=prr;
cc.tr:=IDRec(prr).trr;
QQ.Add(cc);
end;

procedure RJob.Setmaxval(const Value: integer);
begin
  Fmaxval := Value;
end;

procedure RJob.Setmaxval2(const Value: integer);
begin
  Fmaxval2 := Value;
end;

procedure RJob.Setposition(const Value: integer);
begin
  Fposition := Value;
end;

procedure RJob.Setposition2(const Value: integer);
begin
  Fposition2 := Value;
end;

procedure RJob.MarkNode(dp: Pointer);
var
rr: IDRec;
begin
  if(dp =  nil)then exit;
  rr:= IDRec(dp);
  if(rr.trr<> nil)then
  begin
    //
  end;
end;

{ TFTPThread }

procedure TFTPThread.Abort;
var
cc: ComRec;
begin
cc:=CreateComm;
cc.icomm:=coAbort;
QQ.Add(cc);
end;

procedure TFTPThread.SetNodeState(Node: TTreeNode; st: integer);
begin
  try
    if(Node<>nil)then
    begin
    Nd:=Node;
    stt:=st;
    Synchronize(SetNodeState2);
    //Node.StateIndex:=st;
    end;
  except
  //
  end;
end;

function TFTPThread.ChangeDirectory(dir: string): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coChangeDirectory;
cc.dname:=dir;
QQ.Add(cc);
end;

function TFTPThread.ChangeToParentDirectory: boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coChangeToParentDirectory;
QQ.Add(cc);
end;

function TFTPThread.CreateDirectory(dir: string): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coCreateDirectory;
cc.dname:=dir;
QQ.Add(cc);
end;

function TFTPThread.DeleteDirectory(dir: string): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coDeleteDirectory;
cc.dname:=dir;
QQ.Add(cc);
end;

function TFTPThread.DeleteFile(dir: string): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coDeleteFile;
cc.dname:=dir;
QQ.Add(cc);
end;

procedure TFTPThread.Execute;
var
cc: ComRec;
rj: FTPJob;
i: integer;
begin
self.FreeOnTerminate:=true;
hLock:=windows.CreateEvent(nil,true,false,nil);
thlock:=false;
rj:=FTPJob(prj);
  while(not Terminated)do
  begin
    if(QQ = nil)then
    begin
    Terminate;
    exit;
    end;
    if(QQ.Count = 0)then
    begin
    Application.ProcessMessages;
    //sleep(100);
    continue;
    end;
    //ResetEvent(hLock);
    thlock:=true;
    cc:=ComRec(QQ.Items[0]);
    QQ.Delete(0);
    thlock:=false;
    //SetEvent(hLock);
    case cc.icomm of
      coExpand:
      begin
        if(rj.ChangeDir(IDRec(cc.prr).ilabel,true))then
        begin
        rj.EnumDir(cc.prr,IDRec(cc.prr).ilabel);
        if(IDRec(cc.prr).trr<>nil)then
        cc.tr.Expand(false);
        SetNodeState(cc.tr,-1);
        end else
        SetNodeState(cc.tr,1);
        rj.complete:=true;
      end;
      coExplore:
      begin
        if(rj.ChangeDir(IDRec(cc.prr).ilabel,true))then
        begin
        //rj.complete:=true;
        rj.ExploreFolder1(cc.prr);
        SetNodeState(cc.tr,-1);
        end else
        SetNodeState(cc.tr,1);
        rj.complete:=true;
      end;
      coAbort:
      begin
        ff.Abort;
        rj.complete:=true;
      end;
      coChangeDirectory:
      begin
        ff.ChangeDirectory(cc.dname);
      end;
      coChangeToParentDirectory:
      begin
        ff.ChangeToParentDirectory;
      end;
      coCreateDirectory:
      begin
        ff.CreateDirectory(cc.dname);
      end;
      coDeleteDirectory:
      begin
        ff.DeleteDirectory(cc.dname);
      end;
      coDeleteFile:
      begin
        ff.DeleteFile(cc.dname);
      end;
      coFileSetAttr:
      begin
       // ff.FileSetAttr(LC.dname,);
      end;
      coGetFile:
      begin
        cc.ms:=TMemoryStream(ff.GetFileStream(cc.dname));
      end;
      coLogin:
      begin
        ResetEvent(ff.hListDone);
        ff.Login;
        rj.WaitEvent(ff.hListDone,ff.TimeOut*1000);
        if(rj.pcrec<>nil)then
        begin
        rj.EnumDir(rj.pcrec,IDRec(rj.pcrec).ilabel);
        if(IDRec(rj.pcrec).trr <> nil)then IDRec(rj.pcrec).trr.Expand(false);
        end;
        rj.complete:=true;
      end;
      coPutFile:
      begin
        ff.PutFileStream(cc.dname);
      end;
      coQuit:
      begin
        for i:=0 to QQ.Count - 1 do
        ComRec(QQ.Items[i]).executed:=true;
        ff.Quit;
        rj.complete:=true;
      end;
      coRefresh:
      begin
        ff.Refresh;
        if(rj.CNode<>nil)then
        begin
        if(rj.ChangeDir(IDRec(rj.CNode).ilabel,true,false,true))then
        rj.EnumDir(IDRec(rj.CNode),IDRec(rj.CNode).ilabel);
        end;
        rj.complete:=true;
      end;
      coRenameFile:
      begin
        ff.RenameFile(cc.dname,cc.dnewname);
        rj.complete:=true;
      end;
      coGetPropTo:
      begin
        if(rj.ChangeDir(IDRec(cc.prr).ilabel,true))then
        begin
        rj.EnumDir(IDRec(cc.prr),IDRec(cc.prr).ilabel);
        SetNodeState(IDRec(cc.prr).trr,-1);
        end else
        SetNodeState(IDRec(cc.prr).trr,-1);
        rj.complete:=true;
      end;
      coPrepareEx:
      begin
        if(rj.ChangeDir(cc.dname,true))then
        begin
        rj.PrepareEx1(cc.dname,cc.LVEx,cc.LVAttr,cc.smask,cc.selall);
        cc.LVEx.Tag:=1;
        end;
        rj.complete:=true;
      end;
    end; //case cc.icomm of

    Dispose(cc);
  end;
CloseHandle(hLock);
end;

function TFTPThread.FileSetAttr(dir: string; attr: integer): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coFileSetAttr;
cc.dname:=dir;
cc.attr:=attr;
QQ.Add(cc);
end;

function TFTPThread.GetFile(dir: string): TStream;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=nil;
cc.icomm:=coGetFile;
cc.dname:=dir;
QQ.Add(cc);
end;

function TFTPThread.GetProp(var ddir: string; pIDRec: Pointer): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coGetPropTo;
cc.dname:=ddir;
cc.prr:=pIDRec;
QQ.Add(cc);
end;

function TFTPThread.Login: boolean;
var
cc: ComRec;
begin
Result:=false;
cc:=CreateComm;
cc.icomm:=coLogin;
QQ.Add(cc);
end;

function TFTPThread.PrepEx(dir: string; LVEx, LVAttr: TListView;
  smask: string; selall: boolean): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coPrepareEx;
cc.dname:=dir;
cc.LVEx:=LVEx;
cc.LVAttr:=LVAttr;
cc.smask:=smask;
cc.selall:=selall;
QQ.Add(cc);
end;

function TFTPThread.PutFile(ms: TMemoryStream): boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coPutFile;
QQ.Add(cc);
end;

procedure TFTPThread.Quit;
var
cc: ComRec;
begin
cc:=CreateComm;
cc.icomm:=coQuit;
QQ.Add(cc);
end;

function TFTPThread.Refresh: boolean;
var
cc: ComRec;
begin
cc:=CreateComm;
Result:=false;
cc.icomm:=coRefresh;
QQ.Add(cc);
end;

function TFTPThread.RenameFile(dir: string): boolean;
var
cc: ComRec;
begin
Result:=false;
cc:=CreateComm;
cc.icomm:=coRenameFile;
cc.dname:=dir;
QQ.Add(cc);
end;

function FTPJob.CreateI(ddir: string; isfile: boolean): boolean;
begin
Result:=false;
end;

function TFTPThread.CreateComm: ComRec;
var
cc: ComRec;
begin
New(cc);
Result:=cc;
cc.icomm:=-1;
cc.dname:='';
cc.dnewname:='';
cc.smask:='';
cc.attr:=0;
cc.async:=true;
cc.executed:=false;
cc.selall:=false;
cc.ms:=nil;
cc.tr:=nil;
cc.OnlyDir:=true;
cc.LVEx:=nil;
cc.LVAttr:=nil;
cc.prr:=nil;
end;

procedure TFTPThread.SetNodeState2;
begin
  try
    Nd.StateIndex:=stt;
  except
  //
  end;
end;

{ SysNode }



{ SysNode }

procedure SysNode.ClearItems;
begin

end;

procedure SysNode.CommandCompleted(Verb: String; Succeeded: Boolean);
begin

end;

constructor SysNode.Create(AOwner: TComponent);
var
  FileInfo: TSHFileInfo;
begin
  inherited Create(AOwner);
  FRootFolder := nil;
  FObjectTypes := [otFolders];
  FAutoContext := True;
  FUpdating := False;
  FImageListChanging := False;
  FUseShellImages := True;
  FImages := SHGetFileInfo('C:\',     { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);

  FNotifier := TShellChangeNotifier.Create(Self);
  //self.FNotifier.FComponentStyle := self.FNotifier.FComponentStyle + [ csSubComponent ];
  //FRoot := SRFDesktop;
  FLoadingRoot := False;
end;

procedure SysNode.CreateRoot;
begin

end;

procedure SysNode.Delete(Node: TTreeNode);
begin

end;

destructor SysNode.Destroy;
begin

inherited;
end;

procedure SysNode.ExecuteCommand(Verb: String; var Handled: Boolean);
begin

end;

function SysNode.FolderExists(FindID: PItemIDList;
  InNode: TTreeNode): TTreeNode;
begin
Result:=nil;
end;

function SysNode.GetFolder(Index: Integer): TShellFolder;
begin
Result:=nil;
end;

procedure SysNode.GetImageIndex(Node: TTreeNode);
begin
//
end;

function SysNode.GetPath: string;
begin

end;

procedure SysNode.GetSelectedIndex(Node: TTreeNode);
begin

end;

procedure SysNode.InitNode(NewNode: TTreeNode; ID: PItemIDList;
  ParentNode: TTreeNode);
begin
//
end;

function SysNode.NodeFromAbsoluteID(StartNode: TTreeNode;
  ID: PItemIDList): TTreeNode;
begin
Result:=nil;
end;

function SysNode.NodeFromRelativeID(ParentNode: TTreeNode;
  ID: PItemIDList): TTreeNode;
begin
Result:=nil;
end;

procedure SysNode.PopulateNode(Node: TTreeNode);
begin
//
end;

procedure SysNode.Refresh(Node: TTreeNode);
begin
//
end;

procedure SysNode.RefreshEvent;
begin
//
end;

procedure SysNode.RootChanged;
begin
//
end;

function SysNode.SelectedFolder: TShellFolder;
begin
Result:=nil;
end;

procedure SysNode.SetAutoRefresh(const Value: boolean);
begin
//
end;

procedure SysNode.SetPath(const Value: string);
begin
//
end;

procedure SysNode.SetPathFromID(ID: PItemIDList);
begin
//
end;

procedure SysNode.SetRoot(const Value: TRoot);
begin
//
end;

procedure SysNode.SetUseShellImages(const Value: Boolean);
begin
//
end;

procedure SysNode.WndProc(var Message: TMessage);
begin
//
end;

end.
